(**********************************************************************
 *                                                                    *
 *    Diese Datei wird unter der SOFTWARE-LIZENZVEREINBARUNG          *
 *    fr die Software "CODING" zur Verfgung gestellt                *
 *    (siehe die Datei FREE_PRIVATE_LICENSE.pdf).                     *
 *                                                                    *
 *  \ This file is distributed under the SOFTWARE LICENSE AGREEMENT   *
 *    for the Software "CODING"                                       *
 *    (see the file FREE_PRIVATE_LICENSE.pdf).                        *
 *                                                                    *
 *    Copyright SYSJM Jrgen Mller.                                  *
 *                                                                    *
 *    Alle Rechte vorbehalten. \ All rights reserved.                 *
 *                                                                    *
 **********************************************************************
structur:
---------
textname:
  'text'
  +'text'
  ...
  +'text';
 language: = 0         - English     (dataset 'MG00COD.PAS')
           = 1         - German      (dataset 'MG01COD.PAS')
           ...         ...
           = 'maxLanguage'
 textname:             - textstring-name ('MG[language].textname')
           = '...'     - common messages
           = '...Q...' - question messages (including: -> (Q))
           = '...Hd..' - 'MessageBox' head-messages (including: -> (Hd))
           = 'Stm...'  - status messages
           = 'Opn...'  - 'OpenDialog' messages
           = 'Out...'  - control dataset handling messages (Hd)
           = 'Opr...'  - operation button text
           = 'Mes...'  - output messages
           = 'Act...'  - action text
           = 'Key...'  - common key handling messages (Q,Hd)
           = 'IKey...' - initial key handling messages (Hd)
           = 'Cod...'  - messages of kind of coding
           = 'Dat...'  - messages of dataset handling (Hd)
           = 'IO...'   - common IO error messages
           = 'Dtn...'  - messages of datasets covering names (Q,Hd)
           = 'Ovl...'  - overlay handling messages (Q,Hd)
           = 'Pdat...' - messages handling parameter datasets (Hd)
           = 'OKey...' - opening key handling messages (Hd)
           = 'TLim...' - messages of time-out limit handling (Hd)
           = 'CKey...' - closing key handling messages (Hd)
 text:                 - message text with
                         - formating information for 'sysutils.Format'
                         - '%/' for 'linefeed' (using 'FormatLE')
                         The order of the arguments is  n o t  variable!
Use in form of:
---------------
(--> text with linefeed or arguments:)
  varname := FormatLE(MG[Sprache].textname,[varname1,varname2,...]);
  varname := FormatLE(MG[Sprache].textname);
(--> shorttext without linefeed and arguments:)
  varname := MG[Sprache].textname;
(--> 'MessageBox' calls:)
  Application.MessageBox(PChar(FormatLE(MG[Sprache].textname,
    [varname1,varname2,...])),MG[Sprache].Hdtextname,flags);
  Application.MessageBox(PChar(FormatLE(MG[Sprache].textname)),
    MG[Sprache].Hdtextname,flags);
*)
Language:
  'English';
LangLbl:
  'Language';
TimeSep: ':'; (* time separator *)
DateSep: '/'; (* date separator *)
DateOrd: 'MDY'; (* month ("M") / day ("D") / year ("Y") *)
DecimalSep: '.'; (* decimal separator *)
ThousandSep: ','; (* thousand separator *)
HelpDir: 'HelpDbE'; (* help directory *)
MainHead:
  ' - Program for en-/decoding datasets in place (%d-byte-groups)';
InfHead:
  ' - Information';
TOutHead:
  ' - Time-out';
ComHead:
  ' - Commitment';
ComAnswer:
  'Your answer:';
StmCurPos:
  'cursor before position %d';
StmCurRange:
  'selection of positions %d to %d';
StmRandomGen:
  '%d of %d key elements generated.';
StmHelp:
  'Help: F1 button / mouse double click';
ShowHideHint:
  'cursor movements                                          %/'
  +'    inside field: --> text is shown;                     %/'
  +'    slowly to outside field: --> text is hidden.';
OpnOutTit:
  'Open Control Dataset';
OpnOutFil:
  'Control Dataset {.out)|*.out';
OpnKeyTit:
  'Select Key Dataset';
OpnKeyFil:
  'Key dataset (*.*)|*.*';
OpnOvlTit:
  'Select Overlay Dataset';
OpnOvlFil:
  'Overlay dataset (*.*)|*.*';
OpnCodTit:
  'Select Dataset';
OpnDtnTit:
  'Select Dataset covering dataset names';
OpnDtnFil:
  'Dataset covering dataset names {.dtn)|*.dtn';
OpnExnTit:
  'Select Dataset covering dataset names';
OpnExnFil:
  'Dataset covering dataset names {.exn)|*.exn';
OpnParTit:
  'Select Parameter Dataset';
OpnParFil:
  'Parameter Dataset {.par)|*.par';
OpnDirTit:
  'Select Directory';
OpnDirSubTit:
  'Select Directory (+Subdirectories)';
OutLblC:
  'Control dataset:';
OutHLbl1:
  'silence - only error information +';
OutHLbl2:
  'necessary dialogue information';
OutEmpty:
  'Empty control dataset information invalide !%/';
OutHdErr:
  'Control Dataset Error';
OprClear:
  'Reset';
OprStart:
  'Start';
OprExit:
  'Exit';
MesLbl:
  'Program is running - don''t interrupt !';
MesMem:
  'Please enter all necessary information.';
MesIni:
  'Program is initializing ...';
ActHLbl:
  'Select what to do';
ActHB1Mem:
  '1. initialization  w i t h o u t  parameter dataset,%/'
  +'   1.1.  w i t h o u t  time-out limit;%/'
  +'2. en-/decode datasets.';
ActHB2Mem:
  '1. handle parameter dataset  n e w  generated;%/'
  +'   1.1. the parameter dataset is possibly protected%/'
  +'          by a separate key and saved.';
ActHB3Mem:
  '1. handle  e x i s t i n g  intermediate state%/'
  +'    in parameter dataset;%/'
  +'   1.1. if a key protecting the parameter dataset%/'
  +'          is used the program expects%/'
  +'          the securing parameters;%/'
  +'   1.2. the parameter dataset is possibly protected%/'
  +'          by a (/another) separate key and saved.';
ActHB4Mem:
  '1. handle parameter dataset  n e w  generated;%/'
  +'   1.1. the generated parameter dataset%/'
  +'          is saved but  n o t  protected;%/'
  +'2. en-/decode datasets.';
ActHB5Mem:
  '1. handle  e x i s t i n g  parameter dataset;%/'
  +'   1.1. a parameter dataset is saved but%/'
  +'          n o t  protected if being initialised;%/'
  +'   1.2. existing protection is preserved%/'
  +'          and for this the program expects%/'
  +'          the securing parameters;%/'
  +'2. en-/decode datasets.';
KeyHB1:
  'direct key';
KeyHB2:
  'key dataset';
KeyLblR0:
  '   Direct key:';
KeyLblR1:
  '   Key dataset:';
KeyHexLbl:
  'hexadecimal';
KeyHB3:
  'no key';
KeyConvErr:
  'Hexadecimal character ''00'' at position %d not convertible !';
KeyHdCErr:
  'Key Converting Error';
KeyHexErr:
  'Invalid hexadecimal character at position %d !';
KeyHdSErr:
  'Key Syntax Error';
KeyHNumErr:
  'Invalid number of hexadecimal characters !%/'
  +'After position %d  %d hexadecimal null-character(s) will be completed.';
KeyHdSWar:
  'Key Syntax Warning';
KeyNulCom:
  'Odd number of characters !%/'
  +'After position %d a character of value null will be completed.';
KeyQRep:
  'Do you want to repeat the direct key ?%/'
  +' --> It''s for  y o u r  safty !! <--';
KeyHdRep:
  'Repeat Key';
KeyLblR0rep:
  '  Repeat key:';
KeyDifErr:
  'Repeat key and origin direct key differ at position %d !%/'
  +'Original direct key restored.';
KeyHdRErr:
  'Repeat Key Error';
IKeyKLbl:
  'Initial key';
IKeyHB3:
  'random key';
IKeyTxtR2ok:
  '>> random key <<';
IKeyTxtR2clk:
  '<-- click here for >> random key <<';
IKeyOLbl:
  'with overlay information';
IKeyEmpty:
  'Empty initial key information invalide !%/';
IKeyHdErr:
  'Initial Key Error';
IKeyLenInv:
  'Initial key information length less than %d%/'
  +'without using overlay information invalide !';
IKeyNochk:
  'Initial key information not checked !%/';
IKeyHdWar:
  'Initial Key Warning';
IKeyDatnEmpty:
  'Empty initial key dataset information invalide !%/';
IKeyHdDatErr:
  'Initial Key Dataset Error';
IKeyDatMis:
  'Initial key dataset doesn''t exist !%/';
IKeyRLenErr:
  'Random key with less than %d key elements invalide !%/';
IKeyHdRanErr:
  'Random Key Error';
IKeyRCls:
  'Random key input closed !                    ';
IKeyHdRCls:
  'Close Random Key Input !';
IKeyTxtR2gen:
  '>> random key << generation ...';
IKeyRInp:
  '> For beginning and continuing the key generation process '
   +'you have to move the%/'
  +'   mouse pointer to the input field near the mouse symbol,'
   +' press and hold the left mouse button%/'
  +'   moving the mouse to the beginning position, '
   +'and strike any keyboard button%/'
  +'   (except ESC- and TAB- button).%/'
  +'%/'
  +'> To generate key elements move the mouse on the screen almost pressing%/'
  +'   the left mouse button.%/'
  +'> You can additionally manipulate the key generation process'
   +' by striking keyboard buttons%/'
  +'   (except ESC-, TAB- and blank- button) during the mouse movement.%/'
  +'%/'
  +'> You can stop the key generation process by let go of'
   +' the left mouse button and%/'
  +'   continue the process as described above.%/'
  +'> You can stop the key generation process too by striking the blank button.%/'
  +'   So you can move the mouse to another position'
   +' without generation of key elements,%/'
  +'   if the left mouse button is still pressed.%/'
  +'> This break of key generation can be removed by any keyboard button%/'
  +'   (except ESC- and TAB- button).%/'
  +'%/'
  +'> By pressing the ESC- button the key generation process is finished.%/'
  +'%/'
  +'> There is a counter at the status bar indicating the number'
   +' of key elements already generated.%/'
  +'> There isn''t any necessity to generate all elements of a random key.%/'
  +'   It''s even sufficient for example to generate nearly'
   +' %d (min. %d) elements !%/'
  +'%/'
  +'Start entering the random key after having the ''OK''-Button pressed :';
IKeyHdRInp:
  'Random Key Input';
CodAKLbl:
  'Kind of coding';
CodAHLblS:
  'stream cipher';
CodAHLbl1:
  'encoding:';
CodAHLbl2:
  '  decoding:';
CodAVLbl1:
  'single datasets:';
CodAVLbl2:
  'all datasets as one unit:';
CodStaLbl:
  'with result statistics';
DatKind:
  'Datasets being en-/decoded';
DatKindB1Mem:
  'one dataset and all datasets addressed%/'
  +'by wild card information respectively';
DatKindB2Mem:
  'all datasets (possibly addressed%/'
  +'by wild card information), which%/'
  +'names are listed in a given dataset';
DatKindB3Mem:
  'all datasets of a given directory';
DatKindB4Mem:
  'all datasets of a given directory  a n d%/'
  +'these of all subdirectories of lower levels';
DatCod:
  'Dataset(s) being en-/decoded:';
DatCovDat:
  'Dataset covering dataset names:';
DatDir:
  'Directory:';
DatDirSub:
  'Directory (+subdirectories):';
DatExpDat:
  'Dataset with names  n o t  being coded:';
DatCopyMem:
  'Yes, I have made backup copies%/'
  +'        e.g. on other storage media.%/'
  +'%/'
  +'  In success these copies can be%/'
  +'  replaced by the encoding results%/'
  +'  to get protection against%/'
  +'  troubles during decoding.';
DatEmpty:
  'Empty information for datasets being en-/decoded invalide !%/';
DatHdErr:
  'En-/decoded Dataset Error';
DatConf:
  'Please confirm that you have made backup copies !%/';
DatHdSErr:
  'Backup Copies Error';
DatInsLin:
  'Insert line ''';
DatNoLin:
  '%d. dataset line ''';
DatDupDats:
  '%s%s''%/'
  +' covers the same dataset(s) as the %d. namenlist entry !%/'
  +'Still insert the new line ?';
DatHdDup:
  'Duplicated namelist entries';
DatPDupDats:
  '%s%s''%/'
  +' possibly covers the same dataset(s) as the %d. namenlist entry !%/'
  +'Still insert the new line ?';
DatHdPDup:
  'Possibly duplicated namelist entries';
DatInsMod:
  'Information of dataset %s is inserted in modified form !';
DatHdMod:
  'Namelist changed';
IOOpnErr:
  'Error opening dataset %s !';
IOHdErr:
  'File error';
IOCreErr:
  'Error creating dataset %s !';
IOReaErr:
  'Error reading dataset %s !';
IOFomErr:
  'Format error reading dataset %s !%/'
  +'Line length > 255 !';
IOWriErr:
  'Error writing dataset %s !';
DtnEdtdat:
  'edited dataset:';
DtnOpn:
  'open dataset';
DtnClo:
  'close dataset';
DtnSav:
  'save namelist to dataset';
DtnIns:
  'insert';
DtnDel:
  'delete';
DtnPup:
  'place up';
DtnPdw:
  'place down';
DtnEdt:
  'Editing %s:';
DtnUnch:
  'Information of dataset %s is not changed !';
DtnHdUnch:
  'File unchanged';
DtnQSave:
  'Save namelist to dataset %s ?';
DtnHdQSave:
  'Save Namelist ?';
OvlKLbl:
  'Overlay information';
OvlLimPosLbl1:
  ' key overlay';
OvlLimPosLbl2:
  ' positions:';
OvlLimOValLbl1:
  'key overlay';
OvlLimOValLbl2:
  'values:';
OvlLimKValLbl1:
  '  key values to';
OvlLimKValLbl2:
  ' be changed:';
OvlLimVonLbl:
  'lower:';
OvlLimLbl:
  'limit';
OvlLimBisLbl:
  'upper:';
OvlSynB1:
  'in metasyntax';
OvlSynB2:
  'direct as a serial byte string';
OvlSynH1:
  'metasyntax:';
OvlSynH2:
  '"position:value,":';
OvlPosA:
  'positions as';
OvlPosAB1:
  'decimal numbers';
OvlPosAB2:
  'hexadecimal numbers';
OvlValA:
  'overlay values as';
OvlValAB1:
  'character strings';
OvlValAB2:
  'decimal values';
OvlValAB3:
  'hexadecimal values';
OvlInfH:
  'overlay dataset';
OvlInfS:
  'save after';
OvlInfS2:
  'overlay';
OvlItLbl:
  'iterations:';
OvlILblDat:
  'Overlay dataset:';
OvlILblInf:
  'Overlay information:';
OvlDatnEmpty:
  'Empty overlay dataset information invalide !%/';
OvlHdDatErr:
  'Overlay Dataset Error';
OvlDatMis:
  'Overlay dataset doesn''t exist !%/';
OvlDtnDatMis:
  'Dataset covering overlay datasets doesn''t exist !%/';
OvlDirMis:
  'Directory covering overlay datasets doesn''t exist !%/';
OvlEmpty:
  'Empty overlay information invalide !%/';
OvlHdErr:
  'Overlay Information Error';
OvlNochk:
  'Overlay information not checked !%/';
OvlHdWar:
  'Overlay Information Warning';
OvlUPosNErr:
  'Lower limit of positions in the key not numeric !';
OvlHdUPosErr:
  'Lower positions limit error';
OvlUPosRErr:
  'Lower limit of positions in the key out of range [%d,%d] !';
OvlOPosNErr:
  'Upper limit of positions in the key not numeric !';
OvlHdOPosErr:
  'Upper positions limit error';
OvlOPosRErr:
  'Upper limit of positions in the key out of range [%d,%d] !';
OvlUWertNErr:
  'Lower limit of values of overlay information%/'
   +'not numeric !';
OvlHdUWertErr:
  'Lower overlay values limit error';
OvlUWertRErr:
  'Lower limit of values of overlay information%/'
   +'out of range [%d,%d] !';
OvlOWertNErr:
  'Upper limit of values of overlay information%/'
   +'not numeric !';
OvlHdOWertErr:
  'Upper overlay values limit error';
OvlOWertRErr:
  'Upper limit of values of overlay information%/'
   +'out of range [%d,%d] !';
OvlUSWertNErr:
  'Lower limit of key values to be changed%/'
   +'not numeric !';
OvlHdUSWertErr:
  'Lower key values limit error';
OvlUSWertRErr:
  'Lower limit of key values to be changed%/'
   +'out of range [%d,%d] !';
OvlOSWertNErr:
  'Upper limit of key values to be changed%/'
   +'not numeric !';
OvlHdOSWertErr:
  'Upper key values limit error';
OvlOSWertRErr:
  'Upper limit of key values to be changed%/'
   +'out of range [%d,%d] !';
OvlQChk:
  'Do you want the overlay information to be checked ?%/'
  +' --> It''s for  y o u r  safty !! <--';
OvlHdChk:
  'Check Overlay Information';
OvlPosOLimErr:
  'The position value up to the %d. information character%/'
  +'is greater than the upper limit.';
OvlPosULimErr:
  'The position value up to the %d. information character%/'
  +'is less than the lower limit.';
OvlValOLimErr:
  'The value information up to the %d. information character%/'
  +'is greater than the upper limit.';
OvlValULimErr:
  'The value information up to the %d. information character%/'
  +'is less than the lower limit.';
OvlUndefWar:
  'Warning %d at position %d in length %d !';
OvlTermIgn:
  '%/Corresponding information term ignored.';
OvlHdSWar:
  'Overlay Syntax Warning';
OvlPosOErr:
  'The position value up to the %d. information character%/'
  +'is greater than %d.';
OvlPosUErr:
  'The position value up to the %d. information character%/'
  +'is less than 1.';
OvlPosHexErr:
  'Wrong information character as hexadecimal position value%/'
  +' / separate character at position %d';
OvlPosDecErr:
  'Wrong information character as decimal position value%/'
  +' / separate character at position %d';
OvlValMisAS:
  'Missing value information after seperat character at position %d.';
OvlInfErr:
  'Wrong overlay information up to the %d. information character.';
OvlValMis:
  'Missing value character after the %d. information character.';
OvlValOErr:
  'The value information up to the %d. information character%/'
  +'is greater than %d.';
OvlSepCErr:
  'Wrong information character as separate character at position %d.';
OvlValHexErr:
  'Wrong information character as hexadecimal value character%/'
  +' / separate character at position %d';
OvlValDecErr:
  'Wrong information character as decimal position value%/'
  +' / separate character at position %d';
OvlUndefErr:
  'Error %d at position %d in length %d !';
OvlHdSErr:
  'Overlay Syntax Error';
OvlQRep:
  'Do you want to repeat the overlay information ?%/'
  +' --> It''s for  y o u r  safty !! <--';
OvlHdRep:
  'Repeat Overlay Information';
OvlILblRep:
  'Repeat overlay information:';
OvlDifErr:
  'Repeat and origin overlay information differ at position %d !%/'
  +'Original overlay information restored.';
OvlHdRErr:
  'Repeat Overlay Information Error';
OvlItNumErr:
  'Iteration value not numeric !';
OvlHdItErr:
  'Iteration value error';
OvlItRanErr:
  'Iteration value out of range [%d,%d] !';
PdatCompLbl:
  'Component exchange parameter dataset';
PdatOnlyLbl:
  'stream cipher changing only this file';
PdatKLbl:
  'Parameter dataset handling';
PdatLbl:
  'Parameter dataset:';
PdatUse:
  'Parameter dataset reusage';
PdatUseB1Mem:
  'an existing parameter dataset is replaced';
PdatUseB2Mem:
  'the intermediate state of an%/'
  +'existing parameter dataset is used';
PdatOpKH:
  'Opening key';
PdatOpKHS:
  'Opening/closing key';
PdatKeyTxtR2:
  '>> no key <<';
PdatClsKH:
  'Closing key';
PdatClsInv:
  'invert stream usage value';
PdatEmpty:
  'Empty parameter dataset information invalide !%/';
PdatCEmpty:
  'Empty component exchange parameter dataset information invalide%/'
  +'using only this parameter dataset with steam cipher processing !%/';
PdatHdErr:
  'Parameter Dataset Error';
PdatMis:
  'Parameter dataset doesn''t exist !%/';
OKeyEmpty:
  'Empty opening key information invalide !%/';
OKeyHdErr:
  'Opening Key Error';
OKeyLenInv:
  'Opening key information length less than %d invalide !%/';
OKeyNochk:
  'Opening key information not checked !%/';
OKeyHdWar:
  'Opening Key Warning';
OKeyDatnEmpty:
  'Empty opening key dataset information invalide !%/';
OKeyHdDatErr:
  'Opening Key Dataset Error';
OKeyDatMis:
  'Opening key dataset doesn''t exist !%/';
TLimYear:
  'yyyy';
TLimMonth:
  'mm';
TLimDay:
  'dd';
TLimHour:
  'hh';
TLimMinut:
  'mm';
TLimUse:
  'Time-out limit';
TLimUseB1:
  '>now)';
TLimUseB2:
  'unlimited initialisation (=''';
TLimH:
  'Time-out handling';
TLimHB1:
  'terminate the program by exceeding%/the time-out limit';
TLimHB2:
  'ask at break point';
TLimGTCurr:
  'Time-out limit ''%s'' isn''t greater than ''%s'' !';
TLimHdErr:
  'Time-out limit error';
TLimLT:
  'Time-out in less than %d minutes !%/';
TLimHdWar:
  'Time-out Limit Warning';
TLimSepErr:
  'Time-out limit separator in ''%s'' not valid !%/'
  +'  -->  separator corrected.';
TLimInvTime:
  'Time value ''%s'' invalid !';
TLimInvDate:
  'Date value ''%s'' invalid !';
TLimNonTime:
  'Time value ''%s'' not numeric !';
TLimNonDate:
  'Date value ''%s'' not numeric !';
TLimMaskTit:
  'Time-out';
TLimUseNew:
  'new time-out limit';
TLimHNew:
  'new time-out handling';
TLimCan:
  'cancel program !';
CKeyEmpty:
  'Empty closing key information invalide !%/';
CKeyHdErr:
  'Closing Key Error';
CKeyLenInv:
  'Closing key information length less than %d invalide !%/';
CKeyNochk:
  'Closing key information not checked !%/';
CKeyHdWar:
  'Closing Key Warning';
CKeyDatnEmpty:
  'Empty closing key dataset information invalide !%/';
CKeyHdDatErr:
  'Closing Key Dataset Error';
CKeyDatMis:
  'Closing key dataset doesn''t exist !%/';
