(**********************************************************************
 *                                                                    *
 *    Diese Datei wird unter der SOFTWARE-LIZENZVEREINBARUNG          *
 *    fr die Software "CODING" zur Verfgung gestellt                *
 *    (siehe die Datei FREE_PRIVATE_LICENSE.pdf).                     *
 *                                                                    *
 *  \ This file is distributed under the SOFTWARE LICENSE AGREEMENT   *
 *    for the Software "CODING"                                       *
 *    (see the file FREE_PRIVATE_LICENSE.pdf).                        *
 *                                                                    *
 *    Copyright SYSJM Jrgen Mller.                                  *
 *                                                                    *
 *    Alle Rechte vorbehalten. \ All rights reserved.                 *
 *                                                                    *
 **********************************************************************
structur:
---------
textname:
  'text'
  +'text'
  ...
  +'text';
 language: = 0         - English     (dataset 'MG00COD.PAS')
           = 1         - German      (dataset 'MG01COD.PAS')
           ...         ...
           = 'maxLanguage'
 textname:             - textstring-name ('MG[language].textname')
           = '...'     - common messages
           = '...Q...' - question messages (including: -> (Q))
           = '...Hd..' - 'MessageBox' head-messages (including: -> (Hd))
           = 'Stm...'  - status messages
           = 'Opn...'  - 'OpenDialog' messages
           = 'Out...'  - control dataset handling messages (Hd)
           = 'Opr...'  - operation button text
           = 'Mes...'  - output messages
           = 'Key...'  - common key handling messages (Q,Hd)
           = 'IKey...' - initial key handling messages (Hd)
           = 'Cod...'  - messages of kind of coding
           = 'Dat...'  - messages of dataset handling (Hd)
           = 'Ovl...'  - overlay handling messages (Q,Hd)
 text:                 - message text with
                         - formating information for 'sysutils.Format'
                         - '%/' for 'linefeed' (using 'FormatLE')
                         The order of the arguments is  n o t  variable!
Use in form of:
---------------
(--> text with linefeed or arguments:)
  varname := FormatLE(MG[Sprache].textname,[varname1,varname2,...]);
  varname := FormatLE(MG[Sprache].textname);
(--> shorttext without linefeed and arguments:)
  varname := MG[Sprache].textname;
(--> 'MessageBox' calls:)
  Application.MessageBox(PChar(FormatLE(MG[Sprache].textname,
    [varname1,varname2,...])),MG[Sprache].Hdtextname,flags);
  Application.MessageBox(PChar(FormatLE(MG[Sprache].textname)),
    MG[Sprache].Hdtextname,flags);
*)
Language:
  'English';
LangLbl:
  'Language';
DecimalSep: '.'; (* decimal separator *)
ThousandSep: ','; (* thousand separator *)
HelpDir: 'HelpDbE'; (* help directory *)
MainHead:
  ' - Program for en-/decoding datasets in place (%d-byte-groups)';
InfHead:
  ' - Information';
ComHead:
  ' - Commitment';
ComAnswer:
  'Your answer:';
StmCurPos:
  'cursor before position %d';
StmCurRange:
  'selection of positions %d to %d';
StmHelp:
  'Help: F1 button / mouse double click';
ShowHideHint:
  'cursor movements                                          %/'
  +'    inside field: --> text is shown;                     %/'
  +'    slowly to outside field: --> text is hidden.';
OpnOutTit:
  'Open Control Dataset';
OpnOutFil:
  'Control Dataset {.out)|*.out';
OpnKeyTit:
  'Select Key Dataset';
OpnKeyFil:
  'Key dataset (*.*)|*.*';
OpnOvlTit:
  'Select Overlay Dataset';
OpnOvlFil:
  'Overlay dataset (*.*)|*.*';
OpnCodTit:
  'Select Dataset';
OpnDirTit:
  'Select Directory';
OpnDirSubTit:
  'Select Directory (+Subdirectories)';
OutLblC:
  'Control dataset:';
OutLblH:
  'Please enter the name of the dataset for control information.';
OutHLbl1:
  'silence - only error information +';
OutHLbl2:
  'necessary dialogue information';
OutEmpty:
  'Empty control dataset information invalide !%/';
OutHdErr:
  'Control Dataset Error';
OprClear:
  'Reset';
OprStart:
  'Start';
OprExit:
  'Exit';
MesLbl:
  'Program is running - don''t interrupt !';
MesMem:
  'Please enter all necessary information.';
MesIni:
  'Program is initializing ...';
KeyHB1:
  'direct key';
KeyHB2:
  'key dataset';
KeyLblR0:
  '   Direct key:';
KeyLblR1:
  '   Key dataset:';
KeyHexLbl:
  'hexadecimal';
KeyConvErr:
  'Hexadecimal character ''00'' at position %d not convertible !';
KeyHdCErr:
  'Key Converting Error';
KeyHexErr:
  'Invalid hexadecimal character at position %d !';
KeyHdSErr:
  'Key Syntax Error';
KeyHNumErr:
  'Invalid number of hexadecimal characters !%/'
  +'After position %d  %d hexadecimal null-character(s) will be completed.';
KeyHdSWar:
  'Key Syntax Warning';
KeyNulCom:
  'Odd number of characters !%/'
  +'After position %d a character of value null will be completed.';
KeyQRep:
  'Do you want to repeat the direct key ?%/'
  +' --> It''s for  y o u r  safty !! <--';
KeyHdRep:
  'Repeat Key';
KeyLblR0rep:
  '  Repeat key:';
KeyDifErr:
  'Repeat key and origin direct key differ at position %d !%/'
  +'Original direct key restored.';
KeyHdRErr:
  'Repeat Key Error';
IKeyKLbl:
  'Key information';
IKeyOLbl:
  'with overlay information';
IKeyEmpty:
  'Empty initial key information invalide !%/';
IKeyHdErr:
  'Initial Key Error';
IKeyLenInv:
  'Initial key information length less than %d%/'
  +'without using overlay information invalide !';
IKeyNochk:
  'Initial key information not checked !%/';
IKeyHdWar:
  'Initial Key Warning';
IKeyDatnEmpty:
  'Empty initial key dataset information invalide !%/';
IKeyHdDatErr:
  'Initial Key Dataset Error';
IKeyDatMis:
  'Initial key dataset doesn''t exist !%/';
CodAKLbl:
  'Kind of coding';
CodAHLbl1:
  'encoding:';
CodAHLbl2:
  '  decoding:';
CodAVLbl1:
  'single datasets:';
CodAVLbl2:
  'all datasets as one unit:';
CodStaLbl:
  'with result statistics';
DatKind:
  'Datasets being en-/decoded';
DatKindB1Mem:
  'one dataset and all datasets addressed%/'
  +'by wild card information respectively';
DatKindB3Mem:
  'all datasets of a given directory';
DatKindB4Mem:
  'all datasets of a given directory  a n d%/'
  +'these of all subdirectories of lower levels';
DatCod:
  'Dataset(s) being en-/decoded:';
DatDir:
  'Directory:';
DatDirSub:
  'Directory (+subdirectories):';
DatCopyMem:
  'Yes, I have made backup copies%/'
  +'        e.g. on other storage media.%/'
  +'%/'
  +'  In success these copies can be%/'
  +'  replaced by the encoding results%/'
  +'  to get protection against%/'
  +'  troubles during decoding.';
DatEmpty:
  'Empty information for datasets being en-/decoded invalide !%/';
DatHdErr:
  'En-/decoded Dataset Error';
DatConf:
  'Please confirm that you have made backup copies !%/';
DatHdSErr:
  'Backup Copies Error';
OvlItLbl:
  'iterations:';
OvlILblDat:
  'Overlay dataset:';
OvlDatnEmpty:
  'Empty overlay dataset information invalide !%/';
OvlHdDatErr:
  'Overlay Dataset Error';
OvlDatMis:
  'Overlay dataset doesn''t exist !%/';
OvlItNumErr:
  'Iteration value not numeric !';
OvlHdItErr:
  'Iteration value error';
OvlItRanErr:
  'Iteration value out of range [%d,%d] !';
