(* Kommentare in deutsch. \ Comments in English.
 **********************************************************************
 *                                                                    *
 *    Diese Datei wird unter der SOFTWARE-LIZENZVEREINBARUNG          *
 *    fr die Software "CODING" zur Verfgung gestellt                *
 *    (siehe die Datei FREE_PRIVATE_LICENSE.pdf).                     *
 *                                                                    *
 *  \ This file is distributed under the SOFTWARE LICENSE AGREEMENT   *
 *    for the Software "CODING"                                       *
 *    (see the file FREE_PRIVATE_LICENSE.pdf).                        *
 *                                                                    *
 *    Copyright SYSJM Jrgen Mller.                                  *
 *                                                                    *
 *    Alle Rechte vorbehalten. \ All rights reserved.                 *
 *                                                                    *
 *    Programm-Benutzung auf eigene Verantwortung.                    *
 *  \ The usage of this program is on own responsibility.             *
 *                                                                    *
 **********************************************************************)
{$Macro on}
{$define Gruppe:=1} (* =1  - CODING1 - 1-Byte-Gruppen \ 1 byte-groups
                       =2  - CODING2 - 2-Byte-Gruppen \ 2 byte-groups
                       =3  - CODING3 - 3-Byte-Gruppen \ 3 byte-groups *)
{$define Safety:=2} (* =0  - keine Stromchiffrierung
                            \no stream cipher
                       =1  - Stromchiffrierung mit einer Parameterdatei
                            \stream cipher using a parameter dataset
                       =2  - Stromchiffrierung auch mit einer
                             Komponentenwechsel-Parameterdatei
                            \stream cipher using a component exchange
                             parameter dataset too *)
{$IFDEF WINDOWS}
 {$R CodingIcon.res} (* nur\only Windows *)
{$ENDIF}
{$if Gruppe=1}
program coding1E;
{$elseif Gruppe=2}
program coding2E;
{$else Gruppe=3}
program coding3E;
{$endif Gruppe}
{$mode objfpc}{$H+}
uses
  Interfaces, Forms, LResources, ucoding, utimeout, uinfo, ucommit,
  urefresh;
(*---------------------*)
   {$I MGRECOD.PAS}  (* --> mit\with 'maxLanguage' *)
var
  MG: array [0..maxLanguage] of mldtext; cvar; export;
  MxG: array [0..maxLanguage] of mldtext = (
  ({$I MG00COD.PAS}), (* <== *) (*--------- englisch ---------*)
  ({$I MG01COD.PAS})  (* <== *) (*--------- deutsch ----------*)
   );
  TimeOutWarnLim: longint = 10; { Time-out-Warnlimit 10 Minuten }
  Sprache: byte; cvar; export;
  ProgName: string; cvar; export;
  I: longint;
begin
  Application.Title:='Coding';
  MG := MxG; { nur weil der Compiler 'export' bzgl. einer   }
             { initialisierten Variablen nicht will ! }
  Application.Initialize;
  Application.CreateForm(TFMain, FMain);
  Application.CreateForm(TFTimeOut, FTimeOut);
  Application.CreateForm(TFInfo, FInfo);
  Application.CreateForm(TFCommit, FCommit);
  Application.CreateForm(TFRefresh, FRefresh);
{$if Gruppe=1}
  ProgName := 'CODING1';
{$elseif Gruppe=2}
  ProgName := 'CODING2';
{$else Gruppe=3}
  ProgName := 'CODING3';
{$endif Gruppe}
{$if Safety=0}
  FMain.CodStreamLabel.Visible := false;
  FMain.CodStreamPanel.Visible := false;
{$endif Safety=0}
{$if Safety>1}
  FMain.CodDateiConf.Visible := false;
  FMain.CodDateiConfMemo.Visible := false;
{$else Safety<2}
  FMain.CompDateiGroup.Visible := false;
  FMain.ParDateiClsKeyStwLabel.Visible := false;
  FMain.ParDateiClsKeyStwPanel.Visible := false;
{$endif Safety}
  FMain.TOutWLim := TimeOutWarnLim; { Time-out-Warnlimit zuweisen }
  FMain.SprachBox.Items.Clear;
  for I := 0 to maxLanguage do  { die Sprachbox fllen }
    FMain.SprachBox.Items.Add(MG[I].Language);
  FMain.SprachBox.ItemIndex := 1; { voreingestellte Sprache 'deutsch' }
  FMain.SprachBoxCloseUp(FMain);{Texte auf voreingestell. Sprache setzn}
  FMain.ActionHandlingB1Change(FMain);{Images ausblenden wegen }
  Application.Run;                          {\ Systemproblemen!}
end.

