(* Kommentare in deutsch. \ Comments in English.
 **********************************************************************
 *                                                                    *
 *    Diese Datei wird unter der SOFTWARE-LIZENZVEREINBARUNG          *
 *    fr die Software "CODING" zur Verfgung gestellt                *
 *    (siehe die Datei FREE_PRIVATE_LICENSE.pdf).                     *
 *                                                                    *
 *  \ This file is distributed under the SOFTWARE LICENSE AGREEMENT   *
 *    for the Software "CODING"                                       *
 *    (see the file FREE_PRIVATE_LICENSE.pdf).                        *
 *                                                                    *
 *    Copyright SYSJM Jrgen Mller.                                  *
 *                                                                    *
 *    Alle Rechte vorbehalten. \ All rights reserved.                 *
 *                                                                    *
 *    Programm-Benutzung auf eigene Verantwortung.                    *
 *  \ The usage of this program is on own responsibility.             *
 *                                                                    *
 **********************************************************************)
{$Macro on}
{$define Gruppe:=3} (* =1  - CODING1 - 1-Byte-Gruppen \ 1 byte-groups
                       =2  - CODING2 - 2-Byte-Gruppen \ 2 byte-groups
                       =3  - CODING3 - 3-Byte-Gruppen \ 3 byte-groups *)
{$define System:=0} (* =0  - Windows
                       =1  - Unix    *)
(* {$define BSigRtL:=xx}  nicht verwendet \ not used *)
{$define Test:=0}   (* =0  - keine Test-Ausgabe im Status-Panel
                            \no test output on the status panel
                       =1  - Test-Ausgabe im Status-Panel
                            \test output on the status panel   *)
(* {$define Safety:=0}  fest \ fixed *)
unit ucoding;
{$Macro on}
{$mode objfpc}{$H+}
interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, ExtDlgs, EditBtn, LazHelpHTML,
  ActnList, Buttons, StrUtils, SynEdit, HelpIntfs;

type
  C1 =
   record
    Checked: boolean;
   end;
  T1 =
   record
    Text: ansistring;
   end;

  TFMain = class(TForm)
    ApplicationProperties1: TApplicationProperties;
    AusDateiHandling: TCheckBox;
    AusDateiHandlingLabel2: TLabel;
    CodArtHLabel2: TLabel;
    CodDateiArt: TRadioGroup;
    CodDateiArtB1Memo: TMemo;
    CodDateiArtB3Memo: TMemo;
    CodDateiArtB4Memo: TMemo;
    CodDateiArtB1: TRadioButton;
    CodDateiArtB3: TRadioButton;
    CodDateiArtB4: TRadioButton;
    InitialKeyCheck: TImage;
    InitialKeyOK: TImage;
    OpenDialogKey: TOpenDialog;
    OpenDialogOvl: TOpenDialog;
    OperStart: TButton;
    OperClear: TButton;
    OperExit: TButton;
    CodDateiConf: TCheckBox;
    InitialKeyOvl: TCheckBox;
    CodArt: TRadioGroup;
    CodArtHBox: TGroupBox;
    CodArtHLabel1: TLabel;
    CodArtVLabel1: TLabel;
    CodArtVLabel2: TLabel;
    CodDateiArtPanel: TPanel;
    sysjmLogo: TImage;
    MessageLabel: TLabel;
    InitialKeyOvlLabel: TLabel;
    CodDateiConfMemo: TMemo;
    MessageMemo: TMemo;
    OvlIterationLabel: TLabel;
    OvlIteration: TEdit;
    InitialKeyKopfBox: TGroupBox;
    InitialKeyKopfLabel: TLabel;
    InitialKeyPanel: TPanel;
    OvlInfo: TEdit;
    InitialKeyOvlPanel: TPanel;
    InitialKey: TEdit;
    InitialKeyDialog: TImage;
    InitialKeyHandling: TRadioGroup;
    InitialKeyHandlingB1: TRadioButton;
    InitialKeyHandlingB2: TRadioButton;
    OvlInfoDialog: TImage;
    OvlInfoLabel: TLabel;
    CodStats: TCheckBox;
    CodStatsLabel: TLabel;
    CodStatsPanel: TPanel;
    CodDateiPanel: TPanel;
    CodDateiDialog: TImage;
    CodDatei: TEdit;
    CodDateiLabel: TLabel;
    InitialKeyHex: TCheckBox;
    InitialKeyHexLabel: TLabel;
    InitialKeyHexPanel: TPanel;
    CodArtKopfBox: TGroupBox;
    CodArtKopfLabel: TLabel;
    AusDateiHandlingLabel1: TLabel;
    OpenDialogCod: TOpenDialog;
    OpenDialogDir: TSelectDirectoryDialog;
    AusDateiHandlingPanel: TPanel;
    InitialKeyLabel: TLabel;
    SprachBox: TComboBox;
    SprachBoxLabel: TLabel;
    OpenDialogAus: TOpenDialog;
    AusDateiDialog: TImage;
    AusDatei: TEdit;
    AusDateiLabel: TLabel;
    StatusBar: TStatusBar;
    HelpDb: THTMLHelpDatabase;
    HelpBrowser: THTMLBrowserHelpViewer;
    procedure AusDateiHandlingLabelDblClick(Sender: TObject);
    procedure AusDateiHandlingLabelClick(Sender: TObject);
    procedure AusDateiLabelDblClick(Sender: TObject);
    procedure CodArtHLabel1Click(Sender: TObject);
    procedure CodArtHLabel2Click(Sender: TObject);
    procedure CodArtKopfLabelClick(Sender: TObject);
    procedure CodArtVLabel1Click(Sender: TObject);
    procedure CodArtVLabel2Click(Sender: TObject);
    procedure CodDateiArtB1MemoEnter(Sender: TObject);
    procedure CodDateiArtB1MemoExit(Sender: TObject);
    procedure CodDateiArtB3MemoEnter(Sender: TObject);
    procedure CodDateiArtB3MemoExit(Sender: TObject);
    procedure CodDateiArtB4MemoEnter(Sender: TObject);
    procedure CodDateiArtB4MemoExit(Sender: TObject);
    procedure CodDateiArtClick(Sender: TObject);
    procedure CodDateiConfChange(Sender: TObject);
    procedure CodDateiConfMemoExit(Sender: TObject);
    procedure CodDateiDialogClick(Sender: TObject);
    procedure CodDateiLabelDblClick(Sender: TObject);
    procedure CodStatsLabelClick(Sender: TObject);
    procedure CodStatsLabelDblClick(Sender: TObject);
    procedure FormMouseUp(Sender: TOBject; Button: TMouseButton;
                          Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
    procedure InitialKeyChange(Sender: TObject);
    procedure InitialKeyCheckClick(Sender: TObject);
    procedure InitialKeyClick(Sender: TObject);
    procedure InitialKeyDialogClick(Sender: TObject);
    procedure InitialKeyEnter(Sender: TObject);
    procedure InitialKeyExit(Sender: TObject);
    procedure InitialKeyHandlingB1Change(Sender: TObject);
    procedure InitialKeyHandlingB2Change(Sender: TObject);
    procedure InitialKeyHexChange(Sender: TObject);
    procedure InitialKeyHexLabelClick(Sender: TObject);
    procedure InitialKeyHexLabelDblClick(Sender: TObject);
    procedure InitialKeyKeyDown(Sender: TObject; var Key: Word;
                                Shift: TShiftState);
    procedure InitialKeyKeyUp(Sender: TObject; var Key: Word;
                              Shift: TShiftState);
    procedure InitialKeyKopfLabelClick(Sender: TObject);
    procedure InitialKeyLabelDblClick(Sender: TObject);
    procedure InitialKeyMouseDown(Sender: TOBject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
    procedure InitialKeyMouseMove(Sender: TObject; Shift: TShiftState;
                                  X, Y: Integer);
    procedure InitialKeyMouseUp(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure InitialKeyOvlChange(Sender: TObject);
    procedure InitialKeyOvlLabelClick(Sender: TObject);
    procedure InitialKeyOvlLabelDblClick(Sender: TObject);
    procedure MessageMemoMouseEnter(Sender: TObject);
    procedure MessageMemoMouseLeave(Sender: TObject);
    procedure OperClearClick(Sender: TObject);
    procedure OperExitClick(Sender: TObject);
    procedure OperStartClick(Sender: TObject);
    procedure OvlInfoClick(Sender: TObject);
    procedure OvlInfoDialogClick(Sender: TObject);
    procedure OvlInfoEnter(Sender: TObject);
    procedure OvlInfoExit(Sender: TObject);
    procedure OvlInfoKeyDown(Sender: TObject; var Key: Word;
                             Shift: TShiftState);
    procedure OvlInfoKeyUp(Sender: TObject; var Key: Word;
                           Shift: TShiftState);
    procedure OvlInfoLabelClick(Sender: TObject);
    procedure OvlInfoMouseDown(Sender: TOBject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
    procedure OvlInfoMouseMove(Sender: TObject; Shift: TShiftState;
                               X, Y: Integer);
    procedure OvlInfoMouseUp(Sender: TOBject; Button: TMouseButton;
                             Shift: TShiftState; X, Y: Integer);
    procedure OvlIterationEnter(Sender: TObject);
    procedure OvlIterationExit(Sender: TObject);
    procedure OvlIterationLabelDblClick(Sender: TObject);
    procedure OvlIterationMouseDown(Sender:TOBject; Button:TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
    procedure OvlIterationMouseMove(Sender: TObject; Shift: TShiftState;
                                    X, Y: Integer);
    procedure OvlIterationMouseUp(Sender: TOBject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
    procedure SprachBoxCloseUp(Sender: TObject);
    procedure AusDateiDialogClick(Sender: TObject);
    procedure CodDateiArtB1Change(Sender: TObject);
    procedure CodDateiArtB3Change(Sender: TObject);
    procedure CodDateiArtB4Change(Sender: TObject);
    procedure SprachBoxLabelDblClick(Sender: TObject);
    procedure StatusBarDblClick(Sender: TObject);
    procedure sysjmLogoClick(Sender: TObject);
{}
    procedure ShowCursorPos(Feld: TEdit);
    procedure DelCursorPos();
    procedure EnterHidedField(Feld: TEdit; var Inhalt: string);
    procedure EnterHidedField(Feld: TEdit);
    procedure ShowHideContents(Feld: TEdit; ColorFeld: TLabel;
                               X,Y: integer);
    procedure ShowHideContents(Feld: TEdit; ColorFeld: TLabel;
                               X,Y, loX,hiX, loY,hiY: integer);
    procedure ExitHidedField(Feld: TEdit; ColorFeld: TLabel);
    procedure ExitHidedField(Feld: TEdit; ColorFeld: TLabel;
                             var Inhalt: string; fix: integer);
    procedure ClearMesBoxMouseDown(Feld: TEdit; ColorFeld: TLabel);
    procedure ClearMesBoxMouseUp(Feld: TEdit);
    procedure ShowHelpFile(const HKeyword: string);
{}
  private { private declarations }
  public { public declarations }
    { Definition der nicht in der reduzierten Oberflche
      vorhandenen Felder fr den eigentlichen CODING-Aufruf }
    ActionHandlingB1: C1;
    ActionHandlingB2: C1;
    ActionHandlingB3: C1;
    ActionHandlingB4: C1;
    CodDateiArtB2: C1;
    ExpDatei: T1;
    InitialKeyHandlingB3: C1;
    OvlInfoHandling: C1;
    OvlInfoSave: C1;
    OvlLimitKValBis: T1;
    OvlLimitKValVon: T1;
    OvlLimitOValBis: T1;
    OvlLimitOValVon: T1;
    OvlLimitPosBis: T1;
    OvlLimitPosVon: T1;
    OvlPosArtB2: C1;
    OvlSyntaxB1: C1;
    OvlValArtB2: C1;
    OvlValArtB3: C1;
    ParDatei: T1;
    ParDateiClsKey: T1;
    ParDateiClsKeyHandlingB1: C1;
    ParDateiClsKeyHandlingB2: C1;
    ParDateiClsKeyHandlingB3: C1;
    ParDateiClsKeyHex: C1;
    ParDateiOpKey: T1;
    ParDateiOpKeyHandlingB1: C1;
    ParDateiOpKeyHandlingB2: C1;
    ParDateiOpKeyHandlingB3: C1;
    ParDateiOpKeyHex: C1;
    TimeOutHandlingB2: C1;
    TimeOutUseB1Mask: T1;
  end; 

var
  FMain: TFMain;

implementation

uses
  dos, crt,
{$if Gruppe=1}
  coding1neu,
{$elseif Gruppe=2}
  coding2neu,
{$else Gruppe=3}
  coding3neu,
{$endif Gruppe}
  uinfo, ucommit, urefresh;

{ TFMain }
const
  d0 = 48; (* Bytewert von '0' ASCII *)
  d9 = 57; (* Bytewert von '9' ASCII *)
  cA = 65; (* Bytewert von 'A' ASCII *)
  cF = 70; (* Bytewert von 'F' ASCII *)
  cAS10 = 55; (* Differenz zwischen Bytewert und Wert fr 'A' bis'F' *)
{$if Gruppe=1}
  ElemBytes = 1;
  KeyAnzahl = 256;
  KeyAnzahlS1 = 255; (* = KeyAnzahl - 1 *)
{$elseif Gruppe=2}
  ElemBytes = 2;
  KeyAnzahl = 65536;
  KeyAnzahlS1 = 65535; (* = KeyAnzahl - 1 *)
{$else Gruppe=3}
  ElemBytes = 3;
  KeyAnzahl = 16777216;
  KeyAnzahlS1 = 16777215; (* = KeyAnzahl - 1 *)
{$endif Gruppe}
  FocusTag: longint = 1000;
  MessageBoxCall: boolean = false;
  DecimalSeparator: char = '.';
  ThousandSeparator: char = ',';
  InitialKeyHandlingReply: byte = 0;
  InitialKeyChecked: boolean = false;
  minInitialKey: longint = 8;
  ExitInitialKey: boolean = false;
  CodDateiArtReply: byte = 0;
  OvlIterationS: string = '0';
  MaxIteration: longint = 99999999;
  lgMI = 8; (* Ziffernanzahl von 'MaxIteration' *)
  ExitOvlInfo: boolean = false;
{$if Test=1}
(*AllEnterCount: longint = 0;*)
  EnterCount: longint = 0;
(*AllExitCount: longint = 0;*)
  ExitCount: longint = 0;
{$endif Test=1}
type
 paramblock =
  record
   OvlIteration, UPosi, OPosi, UWert, OWert, USWert, OSWert: longint;
  end;
const
  P: paramblock = (OvlIteration: 0; UPosi: 1; OPosi: KeyAnzahl;
         UWert: 0; OWert: KeyAnzahlS1; USWert: 0; OSWert: KeyAnzahlS1);
(*---------------------*)
  {$I MGRECOD.PAS}
var
  MG: array [0..maxLanguage] of mldtext; cvar; external;
  Sprache: byte; cvar; external;
  ProgName: string; cvar; external;
  InitialKeyCheckedS: boolean;
  InitialKeyOK_Visible: boolean;
  InitialKeyCheck_Visible: boolean;
  InitialKeyHexS: boolean;
  InitialKeyS: string;
(*---------------------*)
  {$I FormatLE.PAS}
(*---------------------*
 *     numLongint
 *---------------------*)
function numLongint(IStrV: string; var IntegerV: longint): boolean;
var
 Fehler: word;
begin
 IntegerV := 0;
 val(IStrV,IntegerV,Fehler);
 numLongint := (Fehler=0)
end;  (*--- numLongint ---*)
(*---------------------*
 *       numWord
 *---------------------*)
function numWord(IStrV: string; var IntegerV: word): boolean;
var
 Fehler: word;
begin
 IntegerV := 0;
 val(IStrV,IntegerV,Fehler);
 numWord := (Fehler=0)
end;  (*--- numWord ---*)

procedure TFMain.ShowCursorPos(Feld: TEdit);
begin
 with MG[Sprache] do
  if Feld.Tag>=FocusTag then {falls das Feld den Fokus hat}
   if Feld.SelLength=0 then
     FMain.StatusBar.Panels.Items[0].Text :=
       FormatLE(StmCurPos,[(Feld.SelStart+1)])
   else
     FMain.StatusBar.Panels.Items[0].Text := FormatLE(StmCurRange,
                    [(Feld.SelStart+1),(Feld.SelStart+Feld.SelLength)]);
end;

procedure TFMain.DelCursorPos();
begin
 StatusBar.Panels.Items[0].Text := ''; {Cursor-Anzeige lschen}
end;

procedure TFMain.EnterHidedField(Feld: TEdit; var Inhalt: string);
begin
  Feld.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
  Feld.Font.Color := Feld.Color; { Feldinhalt "unsichtbar" }
  Feld.Text := Inhalt; { Feldinhalt wieder herstellen }
  Feld.SelLength := 0; {sonst ist der Inhalt ggf. markiert und        }
  Feld.Hint := FormatLE(MG[Sprache].ShowHideHint); {\ damit sichtbar !}
  Feld.ShowHint := true;
end;

procedure TFMain.EnterHidedField(Feld: TEdit);
begin
  Feld.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
  Feld.Font.Color := Feld.Color; { Feldinhalt "unsichtbar" }
  Feld.EchoMode := emNormal; { Feldinhalt wieder herstellen }
  Feld.PasswordChar := #0;
  Feld.SelLength := 0; {sonst ist der Inhalt ggf. markiert und       }
  Feld.Hint := FormatLE(MG[Sprache].ShowHideHint);{\ damit sichtbar !}
  Feld.ShowHint := true;
end;

procedure TFMain.ShowHideContents(Feld: TEdit; ColorFeld: TLabel;
                                  X,Y: integer);
begin
  if (Feld.Tag>=FocusTag) then {falls das Feld den Fokus hat}
   if (X<=5) or (X>=Feld.Width-7) or{falls Cursor nicht im Kernbereich:}
      (Y<=5) or (Y>=Feld.Height-7) then
     Feld.Font.Color := Feld.Color { Feldinhalt "unsichtbar" }
   else                { falls Cursor im Kernbereich: }
     Feld.Font.Color := ColorFeld.Font.Color; {Feldinhalt und damit}
end;                                          {Inhalt "sichtbar"   }

procedure TFMain.ShowHideContents(Feld: TEdit; ColorFeld: TLabel;
                                  X,Y, loX,hiX, loY,hiY: integer);
begin
  if (Feld.Tag>=FocusTag) then {falls das Feld den Fokus hat}
   if (X<=loX) or (X>=Feld.Width-hiX) or { falls Cursor nicht im }
      (Y<=loY) or (Y>=Feld.Height-hiY) then       {\ Kernbereich:}
     Feld.Font.Color := Feld.Color { Feldinhalt "unsichtbar" }
   else                { falls Cursor im Kernbereich: }
     Feld.Font.Color := ColorFeld.Font.Color; {Feldinhalt und damit}
end;                                          {Inhalt "sichtbar"   }

procedure TFMain.ExitHidedField(Feld: TEdit; ColorFeld: TLabel);
begin
  if Feld.Tag>=FocusTag then {falls das Feld den Fokus hat}
   begin
    Feld.ShowHint := false;
    Feld.Font.Color := Feld.Color;  { Feldinhalt "unsichtbar": nur
    deshalb, weil sonst die Umschaltung in den Passwort-Modus ignoriert
    wird, falls 'Font.Color' unverndert bleibt !}
    Feld.EchoMode := emPassword; {Feldinhalt mit Sternen berschreiben}
    Feld.PasswordChar := '*';
    Feld.Font.Color := ColorFeld.Font.Color;{Stern-Feldinhalt"sichtbar"}
    Feld.Tag := 0;  {anzeigen, dass das Feld den Fokus nicht mehr hat}
   end;
end;

procedure TFMain.ExitHidedField(Feld: TEdit; ColorFeld: TLabel;
                                var Inhalt: string; fix: integer);
begin
  if Feld.Tag>=FocusTag then {falls das Feld den Fokus hat}
   begin
    Feld.ShowHint := false;
    Feld.Font.Color := Feld.Color;  { Feldinhalt "unsichtbar": nur
    deshalb, weil sonst die Umschaltung in den Passwort-Modus ignoriert
    wird, falls 'Font.Color' unverndert bleibt !}
    Inhalt := Feld.Text; {Feldinhalt sichern}
    Feld.Text := StringOfChar('*',fix); {Feld mit Sternen berschreiben}
    Feld.Font.Color := ColorFeld.Font.Color;{Stern-Feldinhalt"sichtbar"}
    Feld.Tag := 0;  {anzeigen, dass das Feld den Fokus nicht mehr hat}
   end;
end;

procedure TFMain.ClearMesBoxMouseDown(Feld: TEdit; ColorFeld: TLabel);
begin   {'ClearMesBoxMouseDown/Up' umgehen das 'MessageBox'-Problem}
 if MessageBoxCall then
  begin
   Feld.Font.Color := Feld.Color;
   Feld.EchoMode := emPassword; {Feldinhalt mit Sternen berschreiben}
   Feld.PasswordChar := '*';
   Feld.Font.Color := ColorFeld.Font.Color;
  end;
end;

procedure TFMain.ClearMesBoxMouseUp(Feld: TEdit);
begin   {'ClearMesBoxMouseDown/Up' umgehen das 'MessageBox'-Problem}
 if MessageBoxCall then
  begin
   Feld.Font.Color := Feld.Color; {Feldinhalt "unsichtbar"}
   Feld.EchoMode := emNormal; {Feldinhalt wieder herstellen}
   Feld.PasswordChar := #0;
   Feld.SelLength := 0; {hier nicht unbedingt notwendig}
   MessageBoxCall := false;
  end;
end;

procedure TFMain.ShowHelpFile(const HKeyword: string);
begin
  ShowHelpOrErrorForKeyword('',HKeyword);
end;

{======================================================================}

procedure TFMain.SprachBoxCloseUp(Sender: TObject);
begin
  StatusBar.Panels.Items[0].Text := '';
  Sprache := SprachBox.ItemIndex;
  with MG[Sprache] do
   begin
    FMain.Caption := ProgName+Format(MainHead,[ElemBytes]);
    DecimalSeparator := DecimalSep[1];
    ThousandSeparator := ThousandSep[1];
    HelpDb.BaseURL := 'file://'+HelpDir+'/';
    StatusBar.Panels.Items[1].Text := StmHelp;
    if Sprache=0 then
      SprachBoxLabel.Caption := LangLbl+':'
    else
      SprachBoxLabel.Caption := MG[0].LangLbl+'/'+LangLbl+':';
    OpenDialogAus.Title := FormatLE(OpnOutTit);
    OpenDialogAus.Filter := FormatLE(OpnOutFil);
    AusDateiLabel.Caption := FormatLE(OutLblC);
    AusDateiLabel.Hint := FormatLE(OutLblH);
    AusDateiHandlingLabel1.Caption := FormatLE(OutHLbl1);
    AusDateiHandlingLabel2.Caption := FormatLE(OutHLbl2);
    OperClear.Caption := FormatLE(OprClear);
    OperStart.Caption := FormatLE(OprStart);
    OperExit.Caption := FormatLE(OprExit);
    MessageLabel.Caption := FormatLE(MesLbl);
    if MessageMemo.Lines.Count<3 then
     begin
      MessageMemo.Lines.Clear;
      MessageMemo.Lines.Add(FormatLE(MesMem));
      MessageMemo.WordWrap := true;    { nur um die Zeile   }
        MessageMemo.WordWrap := false; { sichtbar zu machen }
     end;
    InitialKeyKopfLabel.Caption := FormatLE(IKeyKLbl);
    InitialKeyHandlingB1.Caption := FormatLE(KeyHB1);
    InitialKeyHandlingB2.Caption := FormatLE(KeyHB2);
    case InitialKeyHandlingReply of
     0: InitialKeyLabel.Caption := FormatLE(KeyLblR0);
     1: InitialKeyLabel.Caption := FormatLE(KeyLblR1);
    end;
    InitialKeyHexLabel.Caption := FormatLE(KeyHexLbl);
    InitialKeyOvlLabel.Caption := FormatLE(IKeyOLbl);
    OpenDialogKey.Title := FormatLE(OpnKeyTit);
    OpenDialogKey.Filter := FormatLE(OpnKeyFil);
    OpenDialogOvl.Title := FormatLE(OpnOvlTit);
    OpenDialogOvl.Filter := FormatLE(OpnOvlFil);
    CodArtKopfLabel.Caption := FormatLE(CodAKLbl);
    CodArtHLabel1.Caption := FormatLE(CodAHLbl1);
    CodArtHLabel2.Caption := FormatLE(CodAHLbl2);
    CodArtVLabel1.Caption := FormatLE(CodAVLbl1);
    CodArtVLabel2.Caption := FormatLE(CodAVLbl2);
    CodStatsLabel.Caption := FormatLE(CodStaLbl);
    CodDateiArtB1Memo.Lines.Clear;
    CodDateiArtB1Memo.Lines.Add(FormatLE(DatKindB1Mem));
    CodDateiArtB1Memo.Lines.Strings[0] := { nur um die Zeilen  }
      CodDateiArtB1Memo.Lines.Strings[0]; { sichtbar zu machen }
    CodDateiArtB3Memo.Lines.Clear;
    CodDateiArtB3Memo.Lines.Add(FormatLE(DatKindB3Mem));
    CodDateiArtB3Memo.WordWrap := true;    { nur um die Zeile   }
      CodDateiArtB3Memo.WordWrap := false; { sichtbar zu machen }
    CodDateiArtB4Memo.Lines.Clear;
    CodDateiArtB4Memo.Lines.Add(FormatLE(DatKindB4Mem));
    CodDateiArtB4Memo.Lines.Strings[0] := { nur um die Zeilen  }
      CodDateiArtB4Memo.Lines.Strings[0]; { sichtbar zu machen }
    OpenDialogCod.Title := FormatLE(OpnCodTit);
    case CodDateiArtReply of
     0: CodDateiLabel.Caption := FormatLE(DatCod);
     2: CodDateiLabel.Caption := FormatLE(DatDir);
     3: CodDateiLabel.Caption := FormatLE(DatDirSub);
    end;
    CodDateiConfMemo.Lines.Clear;
    CodDateiConfMemo.Lines.Add(FormatLE(DatCopyMem));
    CodDateiConfMemo.Lines.Strings[0] := { nur um die Zeilen  }
      CodDateiConfMemo.Lines.Strings[0]; { sichtbar zu machen }
    OvlIterationLabel.Caption := FormatLE(OvlItLbl);
    OvlInfoLabel.Caption := FormatLE(OvlILblDat);
   end
end;

procedure TFMain.AusDateiDialogClick(Sender: TObject);
begin
  OpenDialogAus.FileName := '*.out';
  if OpenDialogAus.Execute then
    AusDatei.Text := OpenDialogAus.FileName;
end;

procedure TFMain.OperClearClick(Sender: TObject);
begin
  AusDatei.Text := '';
  AusDateiHandling.Checked := false;
  MessageMemo.Lines.Clear;
  MessageMemo.Lines.Add(FormatLE(MG[Sprache].MesMem));
  MessageMemo.WordWrap := true;    { nur um die Zeile   }
    MessageMemo.WordWrap := false; { sichtbar zu machen }
  InitialKeyHandlingB1.Checked := true;
  InitialKey.Text := '';
  InitialKeyHex.Checked := false;
  InitialKeyOvl.Checked := false;
  CodArt.ItemIndex := 0;
  CodStats.Checked := false;
  CodDateiArtB1.Checked := true;
  CodDatei.Text := '';
  CodDateiConf.Checked := false;
  OvlInfo.Text := '';
  OvlIterationS := '0';
  P.OvlIteration := 0;
  {nur vorsorglich:}
  MessageBoxCall := false;
end;

procedure TFMain.OperExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFMain.OperStartClick(Sender: TObject);
var
  aw: longint;
begin
  { bergabe-Parameter berprfen }
  if AusDatei.Text='' then  {--- AusDatei ---}
   begin
    FMain.ActiveControl := AusDatei;
    with MG[Sprache] do
      Application.MessageBox(PChar(FormatLE(OutEmpty)),
                             PChar(OutHdErr),16);
    Exit;
   end;

  if InitialKeyPanel.Enabled then  {--- InitialKey ---}
   begin
    if InitialKeyHandlingB1.Checked then
     if InitialKey.Text='' then
      begin
       FMain.ActiveControl := InitialKey;
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(IKeyEmpty)),
                                PChar(IKeyHdErr),16);
       Exit;
      end
     else
      if (Length(InitialKey.Text)<minInitialKey) and
         (not InitialKeyOvl.Checked) then
       begin
        FMain.ActiveControl := InitialKey;
        with MG[Sprache] do
          Application.MessageBox(PChar(FormatLE(IKeyLenInv,
                                 [minInitialKey])),PChar(IKeyHdErr),16);
        Exit;
       end
      else
       if InitialKeyCheck.Visible then
        begin
         FMain.ActiveControl := InitialKey;{vorsorglich, falls 'Cancel'}
         with MG[Sprache] do
           aw := Application.MessageBox(PChar(FormatLE(IKeyNochk)),
                   PChar(IKeyHdWar),49);
         if aw=2 then  {'Cancel.'}
           Exit;
        end
       else
    else
     if InitialKeyHandlingB2.Checked then
      if InitialKey.Text='' then
       begin
        FMain.ActiveControl := InitialKey;
        with MG[Sprache] do
          Application.MessageBox(PChar(FormatLE(IKeyDatnEmpty)),
            PChar(IKeyHdDatErr),16);
        Exit;
       end
      else
       if not FileExists(ExpandFileName(InitialKey.Text)) then
        begin
         FMain.ActiveControl := InitialKey;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(IKeyDatMis)),
             PChar(IKeyHdDatErr),16);
         Exit;
        end;
    if InitialKeyOvl.Checked then
     if OvlInfo.Text='' then
      begin
       FMain.ActiveControl := OvlInfo;
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(OvlDatnEmpty)),
           PChar(OvlHdDatErr),16);
       Exit;
      end
     else
      if not FileExists(ExpandFileName(OvlInfo.Text)) then
       begin
        FMain.ActiveControl := OvlInfo;
        with MG[Sprache] do
          Application.MessageBox(PChar(FormatLE(OvlDatMis)),
            PChar(OvlHdDatErr),16);
        Exit;
       end;
   end;

  if CodDateiPanel.Enabled then  {--- CodDateiPanel ---}
   begin
    if CodDatei.Text='' then  {--- CodDatei ---}
     begin
      FMain.ActiveControl := CodDatei;
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(DatEmpty)),
                               PChar(DatHdErr),16);
      Exit;
     end;
    if not CodDateiConf.Checked then  {--- CodDateiConf ---}
     begin
      FMain.ActiveControl := CodDateiConf;
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(DatConf)),
                               PChar(DatHdSErr),16);
      Exit;
     end;
   end;
  { alle Elemente als nicht auswhlbar kennzeichnen }
  SprachBox.Enabled := false;
  AusDateiDialog.Enabled := false;
  AusDatei.Enabled := false;
  AusDateiHandling.Enabled := false;
  OperClear.Visible := false;
  OperStart.Visible := false;
  OperExit.Visible := false;
  InitialKeyPanel.Enabled := false;
  InitialKeyKopfLabel.Enabled := false;
  CodDateiPanel.Enabled := false;
  CodArtKopfLabel.Enabled := false;
  MessageLabel.Caption := FormatLE(MG[Sprache].MesIni);
  MessageLabel.Visible := true;
  FRefresh.ShowModal;  {nur um die nderungen sichtbar zu machen}
  { bergabe-Parameter bereitstellen }
  if MessageMemo.Lines.Count<3 then
    MessageMemo.Lines.Clear;
  if InitialKeyOvl.Checked then
   begin  {Overlay-Werte bereitstellen}
    EnterHidedField(OvlIteration,OvlIterationS);
   end;
  FMain.BorderIcons := [];

{==============================}
{--> CODING -Programmaufruf <--}
{==============================}
{$if Gruppe=1}
  Coding1Program;
{$elseif Gruppe=2}
  Coding2Program;
{$else Gruppe=3}
  Coding3Program;
{$endif Gruppe}

  FMain.BorderIcons := [biSystemMenu,biMinimize,biMaximize,biHelp];
  MessageLabel.Visible := false;
  if InitialKeyOvl.Checked then
   begin  {Overlay-Werte wieder mit Sternen berschreiben}
    ExitHidedField(OvlIteration,OvlIterationLabel,OvlIterationS,lgMI);
   end;
  { die Elemente wieder als auswhlbar kennzeichnen }
  SprachBox.Enabled := true;
  AusDateiDialog.Enabled := true;
  AusDatei.Enabled := true;
  AusDateiHandling.Enabled := true;
  OperClear.Visible := true;
  OperStart.Visible := true;
  OperExit.Visible := true;
  InitialKeyPanel.Enabled := true;
  InitialKeyKopfLabel.Enabled := true;
  CodDateiPanel.Enabled := true;
  CodArtKopfLabel.Enabled := true;
  CodDateiConf.Checked := false;
  FMain.WindowState := wsMaximized; (* nur damit die BorderIcons *)
  FMain.WindowState := wsNormal;    (* wieder sichbar werden !   *)
end;

procedure TFMain.MessageMemoMouseEnter(Sender: TObject);
begin
  if MessageMemo.Lines.Count>=3 then
   begin
    MessageMemo.Width := 696;
    MessageMemo.Height := 326;
   end;
end;

procedure TFMain.MessageMemoMouseLeave(Sender: TObject);
begin
  MessageMemo.Width := 371;
  MessageMemo.Height := 114;
end;

procedure TFMain.AusDateiHandlingLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(AusDateiHandling.HelpKeyword);
end;

procedure TFMain.AusDateiHandlingLabelClick(Sender: TObject);
begin
  if AusDateiHandling.Checked then
    AusDateiHandling.Checked := false
  else
    AusDateiHandling.Checked := true;
end;

procedure TFMain.AusDateiLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(AusDateiLabel.HelpKeyword);
end;

procedure TFMain.InitialKeyHandlingB1Change(Sender: TObject);
begin
 if InitialKeyHandlingB1.Checked then
  begin
   InitialKey.Text := '';
   InitialKey.HelpKeyword := 'COD/DirectKey.html';
   if InitialKeyHandlingReply=2 then
    begin
     InitialKey.Enabled := true;
     InitialKeyLabel.Visible := true;
     InitialKeyHexPanel.Visible := true;
     InitialKeyHexLabel.Visible := true;
    end;
   InitialKeyHandlingReply := 0;
   InitialKeyDialog.Visible := false;
   InitialKeyOK.Visible := false;
   InitialKeyCheck.Visible := true;
   InitialKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
   InitialKey.PasswordChar := '*';
   InitialKey.EchoMode := emPassword;
  end;
end;

procedure TFMain.InitialKeyHandlingB2Change(Sender: TObject);
begin
 if InitialKeyHandlingB2.Checked then
  begin
   InitialKey.Text := '';
   InitialKey.HelpKeyword := 'COD/KeyDatasetS.html';
   if InitialKeyHandlingReply=2 then
    begin
     InitialKey.Enabled := true;
     InitialKeyLabel.Visible := true;
     InitialKeyHexPanel.Visible := true;
     InitialKeyHexLabel.Visible := true;
    end;
   InitialKeyHandlingReply := 1;
   InitialKeyOK.Visible := false;
   InitialKeyCheck.Visible := false;
   InitialKeyDialog.Visible := true;
   InitialKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR1);
  {InitialKey.PasswordChar := #0;
   InitialKey.EchoMode := emNormal;}
  end;
end;

function HexCheck(Str: string): longint;
var
 I, J: longint;
 Zeichen: char;
 ZByte: byte absolute Zeichen;
begin
 J := 0;
 for I := 1 to Length(Str) do
  begin
   Zeichen := UpCase(Str[I]);
   if not ((ZByte in [d0..d9]) or (ZByte in [cA..cF])) then
    begin                                          {\ kein Hex-Zeichen}
     J := 1;
     break;
    end;
  end;
 if J=1 then
   HexCheck := I
 else
  begin
   I := Length(Str);
   if (I mod (ElemBytes shl 1))=0 then
     HexCheck := 0
   else
     HexCheck := (I mod (ElemBytes shl 1)) -(ElemBytes shl 1);
  end;                    { -(notwendige Hex(0)-Ergnzungen) }
end;

procedure CharToHex(var Str: string);
var
 H1, H2: byte;
 cH1: char absolute H1;
 cH2: char absolute H2;
 I: longint;
 rStr, IStr: string;
begin
 IStr := UTF8toANSI(Str);
 rStr := '';
 for I := 1 to Length(IStr) do
  begin
   H1 := Byte(IStr[I]) shr 4;
   H2 := Byte(IStr[I]) and 15;
   if H1<10 then
     H1 := H1 + d0
   else
     H1 := H1 + cAS10;
   if H2<10 then
     H2 := H2 + d0
   else
     H2 := H2 + cAS10;
   rStr := rStr + cH1 + cH2;
  end;
 Str := rStr;
end;

function HexToChar(var Str: string): longint;
var
 HexZeichen, CharZeichen: char;
 HByte: byte absolute HexZeichen;
 CByte: byte absolute CharZeichen;
 I, J: longint;
 rStr: string;
begin
 HexToChar := 0;
 if Str<>'' then
  begin
   rStr := '';
   J := (Length(Str) shr 1) - 1; {Schleifen-Durchlauf-Obergrenze}
   for I := 0 to J do
    begin
     HexZeichen := UpCase(Str[(I shl 1)+1]);
     if HByte in [d0..d9] then
       CByte := HByte - d0
     else {HByte in [cA..cF]}
       CByte := HByte - cAS10;
     HexZeichen := UpCase(Str[(I shl 1)+2]);
     if HByte in [d0..d9] then
       CByte := CByte*16 + HByte - d0
     else {HByte in [cA..cF]}
       CByte := CByte*16 + HByte - cAS10;
     if CByte>0 then
       rStr := rStr + CharZeichen
     else
      begin
       HexToChar := (I shl 1)+1;
       exit;
      end;
    end;
   if (Length(Str) and 1)=1 then {'Str' hat ungerade Zeichen-Anzahl}
    begin
     HexZeichen := UpCase(Str[Length(Str)]);
     if HByte in [d0..d9] then
       CByte := (HByte - d0)*16
     else {HByte in [cA..cF]}
       CByte := (HByte - cAS10)*16;
     if CByte>0 then
       rStr := rStr + CharZeichen
     else
      begin
       HexToChar := Length(Str);
       exit;
      end;
    end;
   Str := ANSItoUTF8(rStr);
  end;
end;

procedure TFMain.InitialKeyHexChange(Sender: TObject);
var
 aw: longint;
 IStr: string;
begin
 if InitialKeyHandlingB1.Checked and   {falls fr Direktkeys noch keine}
    (not ExitInitialKey) then  {Exit-Routine fr 'InitialKey' aktiv ist}
  begin{die Werte sichern,die durch 'InitialKeyChange' verndert werden}
   ExitInitialKey := true;
   InitialKeyCheckedS := InitialKeyChecked;
   InitialKeyOK_Visible := InitialKeyOK.Visible;
   InitialKeyCheck_Visible := InitialKeyCheck.Visible;
   if InitialKeyHex.Checked then
    begin
     IStr := InitialKey.Text;
     CharToHex(IStr); {Schlssel-Zeichen in Hex-Werte umwandeln}
     InitialKey.Text := IStr;{das fhrt zum 'InitialKeyChange'-Aufruf !}
     if InitialKey.Tag>=FocusTag then
      begin { verdoppeln }
       InitialKey.SetFocus; {'SelStart'/'SelLength' nur falls Focus }
       InitialKey.SelStart := InitialKey.SelStart shl 1; {\ gesetzt }
       InitialKey.SelLength := InitialKey.SelLength shl 1;
      end;
    end
   else
    begin
     IStr := InitialKey.Text;
     aw := HexToChar(IStr);
     if aw=0 then {Schlssel-Hex-Wert in Zeichen umwandeln, }
      begin       {         falls machbar (d.h. auer #00 !)}
       InitialKey.Text := IStr; { fhrt zum 'InitialKeyChange'-Aufruf! }
       if InitialKey.Tag>=FocusTag then
        begin { halbieren }
         InitialKey.SetFocus; {'SelStart'/'SelLength' nur falls Focus }
         InitialKey.SelStart := InitialKey.SelStart shr 1; {\ gesetzt }
         InitialKey.SelLength := (InitialKey.SelLength+1) shr 1;
        end;
      end
     else
      begin
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(KeyConvErr,[aw])),
           PChar(KeyHdCErr),16);
{      MessageBoxCall := true; }
       InitialKeyHex.Checked := true; {weiterer 'InitialKeyHexChange'}
      end                                                  {\ -Aufruf}
    end;
   InitialKeyChecked := InitialKeyCheckedS;   {'InitialKeyChange'-Werte}
   InitialKeyOK.Visible := InitialKeyOK_Visible;{          zurcksetzen}
   InitialKeyCheck.Visible := InitialKeyCheck_Visible;
   ExitInitialKey := false;
  end;
end;

procedure TFMain.InitialKeyHexLabelClick(Sender: TObject);
begin
  if InitialKeyHex.Checked then
    InitialKeyHex.Checked := false
  else
    InitialKeyHex.Checked := true;
end;

procedure TFMain.InitialKeyHexLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(InitialKeyHexLabel.HelpKeyword);
end;

procedure TFMain.InitialKeyDialogClick(Sender: TObject);
begin
  OpenDialogKey.FileName := '*.*';
  if OpenDialogKey.Execute then
    InitialKey.Text := OpenDialogKey.FileName;
end;

procedure TFMain.InitialKeyCheckClick(Sender: TObject);
begin
  InitialKey.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
  InitialKeyChecked := false;
  if not ExitInitialKey then
    InitialKeyExit(Sender);
end;

procedure TFMain.InitialKeyEnter(Sender: TObject);
begin
  InitialKey.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
(* {$if Test=1}
  AllEnterCount := AllEnterCount + 1;
  StatusBar.Panels.Items[0].Text :=
    'AllEnterCount='+Format('%D',[AllEnterCount]);
  StatusBar.Panels.Items[2].Text :=
    'AllExitCount='+Format('%D',[AllExitCount])+';'
    +Format('%D',[InitialKey.Tag]);
{$endif Test=1} *)
  if InitialKeyHandlingReply=1 then { falls im Datei-Modus }
   begin
{$if Test=1}
    EnterCount := EnterCount + 1;
    StatusBar.Panels.Items[1].Text :=
      'EnterCount='+Format('%D',[EnterCount]);
{$endif Test=1}
    EnterHidedField(InitialKey)
   end;
end;

procedure TFMain.InitialKeyChange(Sender: TObject);
begin
 if InitialKeyHandlingReply=0 then
  begin
   InitialKeyChecked := false;
   if not InitialKeyCheck.Visible then
    begin
     InitialKeyOK.Visible := false;
     InitialKeyCheck.Visible := true;
    end
  end
end;

procedure TFMain.InitialKeyClick(Sender: TObject);
begin
 if InitialKey.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   InitialKeyEnter(Sender);      { dann dies jetzt nachholen         }
 ShowCursorPos(InitialKey);
end;

procedure TFMain.InitialKeyKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if InitialKey.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   InitialKeyEnter(Sender);      { dann dies jetzt nachholen         }
 if InitialKeyHandlingB1.Checked then { falls im Direkt-Schlssel-Modus}
  if Key=13 then
    InitialKeyExit(Sender);  {"Return"-Taste als Feld-Exit annehmen}
end;

procedure TFMain.InitialKeyKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 ShowCursorPos(InitialKey);
end;

procedure TFMain.InitialKeyKopfLabelClick(Sender: TObject);
begin
  ShowHelpFile(InitialKeyKopfLabel.HelpKeyword);
end;

procedure TFMain.InitialKeyLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(InitialKey.HelpKeyword)
end;

procedure TFMain.InitialKeyExit(Sender: TObject);
var
  aw, I: longint;
  IStr: string;
begin
(* {$if Test=1}
  AllExitCount := AllExitCount + 1;
  StatusBar.Panels.Items[2].Text :=
    'AllExitCount='+Format('%D',[AllExitCount])+';'
    +Format('%D',[InitialKey.Tag]);
{$endif Test=1} *)
  DelCursorPos;
  if InitialKey.Tag>=FocusTag then {falls das Feld den Fokus hat}
   if InitialKeyHandlingReply=1 then { falls im Datei-Modus }
    begin
     MessageBoxCall := false;
     ExitHidedField(InitialKey,InitialKeyLabel);
(* {$if Test=1}
     StatusBar.Panels.Items[2].Text :=
       'AllExitCount='+Format('%D',[AllExitCount])+';'
       +Format('%D',[InitialKey.Tag]);
{$endif Test=1} *)
    end
   else
    if (not InitialKeyHex.Focused) and
       (not ExitInitialKey) and    {falls noch keine Exit-Routine fr }
       (not InitialKeyChecked) then    { dieses Feld aktiv ist  u n d }
     begin          { noch kein erfolgreicher Check durchgefhrt wurde}
      ExitInitialKey := true; {anzeigen, dass fr dieses Feld   }
                              {jetzt eine Exit-Routine aktiv ist}
      MessageBoxCall := false;
{$if Test=1}
      ExitCount := ExitCount + 1;
      StatusBar.Panels.Items[0].Text := 'ExitCount='+Format('%D',[ExitCount]);
      StatusBar.Panels.Items[1].Text :=
        'ExitInitialKey='+Format('%D',[integer(ExitInitialKey)]);
{$endif Test=1}
      if InitialKeyHandlingReply=0 then {falls im Direktschlssel-Modus}
       begin
        aw := 0;
        I := 0;
        if InitialKeyHex.Checked then {Hexzeichen}
         begin
          IStr := InitialKey.Text;
          aw := HexCheck(IStr);
          if aw<>0 then  {'HexCheck' hat ein Problem entdeckt}
           if aw>0 then {ein Zeichen ist kein Hexzeichen}
            begin
             I := aw;
             with MG[Sprache] do
               Application.MessageBox(PChar(FormatLE(KeyHexErr,[I])),
                 PChar(KeyHdSErr),16);
             MessageBoxCall := true;
            end
           else    {Hexzeichen-Anzahl nicht durch ElemBytes*2 teilbar}
            begin
             aw := -aw;  {Anzahl ergnzter Hexzeichen}
             I := Length(InitialKey.Text); {Stelle im Text}
             with MG[Sprache] do
               Application.MessageBox(PChar(FormatLE(KeyHNumErr,[I,aw]))
                                      ,PChar(KeyHdSWar),48);
             aw := 0;
             MessageBoxCall := true;
            end;
         end
        else      {keine Hexzeichen}
         begin
          I := Length(InitialKey.Text);
          if (I mod ElemBytes)<>0 then
           begin {Lnge ist nicht durch ElemBytes teilbar}
            with MG[Sprache] do
              Application.MessageBox(PChar(FormatLE(KeyNulCom,[I])),
                PChar(KeyHdSWar),48);
            MessageBoxCall := true;
           end
          else
            I := 0;
         end;
        if aw=0 then
         begin
          with MG[Sprache] do
            aw := Application.MessageBox(PChar(FormatLE(KeyQRep)),
                    PChar(KeyHdRep),36);
          if I>0 then {Markierung einer Stelle erst nach letzter}
           begin                                 {\ 'MessageBox'}
            InitialKey.SelStart := I-1;
            InitialKey.SelLength := 1;
           end
          else
            InitialKey.SelLength := 0;
          MessageBoxCall := true;
          if aw=6 then { Ja. --> Direktschlssel-Wiederholung }
           begin
            InitialKeyHandlingReply := 4;{Wiederholungs-Schlssel-Modus}
            InitialKeyLabel.Caption :=FormatLE(MG[Sprache].KeyLblR0rep);
            InitialKeyS := InitialKey.Text;
            InitialKeyHexS := InitialKeyHex.Checked;
            InitialKey.Text := '';
            InitialKeyHandling.Enabled := false;
            InitialKeyOvl.Enabled := false;
            OvlInfo.Enabled := false;
            OvlIteration.Enabled := false;
            OvlInfoDialog.Visible := false;
            { alle sonstigen Elemente als nicht auswhlbar kennzeichnen}
            SprachBox.Enabled := false;
            AusDateiDialog.Visible := false;
            AusDatei.Enabled := false;
            AusDateiHandling.Enabled := false;
            OperClear.Enabled := false;
            OperStart.Enabled := false;
            OperExit.Enabled := false;
            CodDateiPanel.Enabled := false;
            CodArtKopfLabel.Enabled := false;
            CodDateiDialog.Visible := false;
          { ActiveControl := InitialKey; }
           end
          else  { Nein. --> keine Direktschlssel-Wiederholung }
            InitialKeyChecked := true; {es hat eine Bearbeitung durch
                                        den Benutzer stattgefunden}
         end
        else  {'HexCheck'-Fehler, keine -Warnung}
         begin
          InitialKey.SetFocus;{'SelStart'/'SelLength' nur falls Focus}
          InitialKey.SelStart := I-1;                      {\ gesetzt}
          InitialKey.SelLength := 1;
          ShowCursorPos(InitialKey);
         end;
       end
      else { falls im Wiederholungs-Schlssel-Modus }
       begin
        ExitInitialKey := false; {lst ggf. 'InitialKeyHexChange' aus}
        InitialKeyHex.Checked := InitialKeyHexS;
        ExitInitialKey := true;  {knnte 'HexToChar'-Fehler ausgelst}
        if (InitialKeyHex.Checked=InitialKeyHexS) and        {\ haben}
           (InitialKeyS=InitialKey.Text) then
         begin  { Ausgangs- und Wiederholungs-Schlssel sind identisch }
          InitialKeyCheck.Visible := false;
          InitialKeyOK.Visible := true;
         end
        else
         begin
        { InitialKeyOK.Visible := false;
          InitialKeyCheck.Visible := true; }
          IStr := InitialKey.Text; {1. Unterschiedsstelle ermitteln}
          I := Length(IStr);
          if I<>Length(InitialKeyS) then
           if I>Length(InitialKeyS) then
             I := Length(InitialKeyS);
          for aw := 1 to I do  {Schleife ber gemeinsame Stellen}
           begin
            if InitialKeyS[aw]<>IStr[aw] then
              break;
           end;
          if (I>0) and
             ((aw<I) or
              (InitialKeyS[aw]<>IStr[aw])) then
            I := aw
          else  {gemeinsame Stellen sind identisch}
            I := I + 1;                                    {/ mglich}
          InitialKey.Text := ''; {damit ist kein 'HexToChar'-Fehler  }
          ExitInitialKey := false;{lst ggf.'ParDateiOpKeyHexChange'aus}
          InitialKeyHex.Checked := InitialKeyHexS;
          ExitInitialKey := true;
          InitialKey.Text := InitialKeyS;
          with MG[Sprache] do
            Application.MessageBox(PChar(FormatLE(KeyDifErr,[I])),
              PChar(KeyHdRErr),48);
          MessageBoxCall := true;
          InitialKey.SetFocus;
          if I<=Length(InitialKeyS) then
           begin {Falls die Differenzstelle im Ausgangs-Schlssel}
            InitialKey.SelStart := I-1;              {\ anzeigbar}
            InitialKey.SelLength := 1;
           end
          else
           begin  {sonst den gesamten Ausgangs-Schlssel markieren}
            InitialKey.SelStart := 0;
            InitialKey.SelLength := Length(InitialKeyS);
           end;
          ShowCursorPos(InitialKey);
         end;
        InitialKeyChecked := true; {es hat eine Bearbeitung durch
                                    den Benutzer stattgefunden}
        InitialKeyHandlingReply := 0; {Wiederholungskey-Modus aufheben}
        InitialKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
        {alle Felder "entsperren"}
        InitialKeyHandling.Enabled := true;
        InitialKeyOvl.Enabled := true;
        if InitialKeyOvl.Checked then
         begin
          OvlInfo.Enabled := true;
          OvlIteration.Enabled := true;
          OvlInfoDialog.Visible := true;
         end;
        { alle sonstigen Elemente }
        SprachBox.Enabled := true;
        AusDateiDialog.Visible := true;
        AusDatei.Enabled := true;
        AusDateiHandling.Enabled := true;
        OperClear.Enabled := true;
        OperStart.Enabled := true;
        OperExit.Enabled := true;
        CodDateiPanel.Enabled := true;
        CodArtKopfLabel.Enabled := true;
        CodDateiDialog.Visible := true;
       end;
      if not InitialKey.Focused then {falls das Feld keinen Fokus hat}
        InitialKey.Tag := 0
    { else
        ClearMessageQueue(Sender) } ;
      ExitInitialKey := false; {Exit-Routine nicht mehr aktiv}
{$if Test=1}
      StatusBar.Panels.Items[1].Text :=
        'ExitInitialKey='+Format('%D',[integer(ExitInitialKey)]);
{$endif Test=1}
     end
    else
     if not ExitInitialKey then  {keine Exit-Routine fr das Feld aktiv}
       InitialKey.Tag := 0;
(* {$if Test=1}
  StatusBar.Panels.Items[2].Text :=
    'AllExitCount='+Format('%D',[AllExitCount])+';'
    +Format('%D',[InitialKey.Tag]);
{$endif Test=1} *)
end;

procedure TFMain.InitialKeyMouseMove(Sender: TObject; Shift:TShiftState;
                                     X, Y: Integer);
begin
 if not InitialKeyHandlingB3.Checked then
  begin
   ShowCursorPos(InitialKey);
   if InitialKeyHandlingReply=1 then    { falls im Datei-Modus }
     ShowHideContents(InitialKey,InitialKeyLabel,X,Y);
  end
end;

procedure TFMain.InitialKeyMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if InitialKeyHandlingReply=1 then   { falls im Datei-Modus}
   ClearMesBoxMouseDown(InitialKey,InitialKeyLabel)
end;

procedure TFMain.InitialKeyMouseUp(Sender: TOBject; Button:TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
{var
  wI: word;}
begin
 if InitialKeyHandlingReply=1 then  { falls im Datei-Modus}
   ClearMesBoxMouseUp(InitialKey);
 MessageBoxCall := false;
end;

procedure TFMain.InitialKeyOvlChange(Sender: TObject);
begin
 if InitialKeyOvl.Checked then
  begin
   OvlInfoLabel.Visible := true;
   OvlInfo.Visible := true;
   OvlIterationLabel.Visible := true;
   OvlIteration.Visible := true;
   OvlInfoDialog.Visible := true;
  end
 else
  begin
   OvlInfoLabel.Visible := false;
   OvlInfo.Visible := false;
   OvlIterationLabel.Visible := false;
   OvlIteration.Visible := false;
   OvlInfoDialog.Visible := false;
  end;
end;

procedure TFMain.InitialKeyOvlLabelClick(Sender: TObject);
begin
 if InitialKeyHandlingReply<>4 then
  if InitialKeyOvl.Checked then
    InitialKeyOvl.Checked := false
  else
    InitialKeyOvl.Checked := true;
end;

procedure TFMain.InitialKeyOvlLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(InitialKeyOvlLabel.HelpKeyword);
end;

procedure TFMain.CodArtHLabel1Click(Sender: TObject);
begin
  case CodArt.ItemIndex of
  {0,1: nichts zu tun}
   2: CodArt.ItemIndex := 0;
   3: CodArt.ItemIndex := 1;
  end;
end;

procedure TFMain.CodArtHLabel2Click(Sender: TObject);
begin
  case CodArt.ItemIndex of
   0: CodArt.ItemIndex := 2;
   1: CodArt.ItemIndex := 3;
  {2,3: nichts zu tun}
  end;
end;

procedure TFMain.CodArtKopfLabelClick(Sender: TObject);
begin
  ShowHelpFile(CodArtKopfLabel.HelpKeyword);
end;

procedure TFMain.CodArtVLabel1Click(Sender: TObject);
begin
  case CodArt.ItemIndex of
  {0,2: nichts zu tun}
   1: CodArt.ItemIndex := 0;
   3: CodArt.ItemIndex := 2;
  end;
end;

procedure TFMain.CodArtVLabel2Click(Sender: TObject);
begin
  case CodArt.ItemIndex of
  {1,3: nichts zu tun}
   0: CodArt.ItemIndex := 1;
   2: CodArt.ItemIndex := 3;
  end;
end;

procedure TFMain.CodStatsLabelClick(Sender: TObject);
begin
  if CodStats.Checked then
    CodStats.Checked := false
  else
    CodStats.Checked := true;
end;

procedure TFMain.CodStatsLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(CodStatsLabel.HelpKeyword);
end;

procedure TFMain.FormMouseUp(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowHelpFile(FMain.HelpKeyword);
end;

procedure TFMain.FormShow(Sender: TObject);
begin {Initialisierung der nicht in der reduzierten Oberflche
       vorhandenen Felder fr den eigentlichen CODING-Aufruf  }
  ActionHandlingB1.Checked := true;
  ActionHandlingB2.Checked := false;
  ActionHandlingB3.Checked := false;
  ActionHandlingB4.Checked := false;
  CodDateiArtB2.Checked := false;
  ExpDatei.Text := '';
  InitialKeyHandlingB3.Checked := false;
  OvlInfoHandling.Checked := true;
  OvlInfoSave.Checked := false;
  OvlLimitPosVon.Text := '1';
  OvlLimitOValVon.Text := '0';
  OvlLimitKValVon.Text := '0';
  OvlLimitPosBis.Text:= Format('%d',[KeyAnzahl]);
  OvlLimitOValBis.Text:= Format('%d',[KeyAnzahlS1]);
  OvlLimitKValBis.Text:= Format('%d',[KeyAnzahlS1]);
  OvlPosArtB2.Checked := false;
  OvlSyntaxB1.Checked := false;
  OvlValArtB2.Checked := false;
  OvlValArtB3.Checked := false;
  ParDatei.Text := '';
  ParDateiClsKey.Text := '';
  ParDateiClsKeyHandlingB1.Checked := false;
  ParDateiClsKeyHandlingB2.Checked := false;
  ParDateiClsKeyHandlingB3.Checked := false;
  ParDateiClsKeyHex.Checked := false;
  ParDateiOpKey.Text := '';
  ParDateiOpKeyHandlingB1.Checked := false;
  ParDateiOpKeyHandlingB2.Checked := false;
  ParDateiOpKeyHandlingB3.Checked := false;
  ParDateiOpKeyHex.Checked := false;
  TimeOutHandlingB2.Checked := false;
  TimeOutUseB1Mask.Text := '';
end;

procedure TFMain.CodDateiArtB1Change(Sender: TObject);
begin
 if CodDateiArtB1.Checked then
  begin
   CodDateiArtReply := 0;
{$if Test=1}
   StatusBar.Panels.Items[1].Text :=
     'CodDateiArtReply ='+Format('%.0N',[int(CodDateiArtReply)]);
{$endif Test=1}
   CodDateiArtB1Memo.Color := clWindow;
   CodDateiLabel.Caption := FormatLE(MG[Sprache].DatCod);
   CodDatei.Text := '';
  end
 else
   CodDateiArtB1Memo.Color := clActiveBorder;
end;

procedure TFMain.CodDateiArtB3Change(Sender: TObject);
begin
 if CodDateiArtB3.Checked then
  begin
   if CodDateiArtReply<>3 then
     CodDatei.Text := '';
   CodDateiArtReply := 2;
{$if Test=1}
   StatusBar.Panels.Items[1].Text :=
     'CodDateiArtReply ='+Format('%.0N',[int(CodDateiArtReply)]);
{$endif Test=1}
   CodDateiArtB3Memo.Color := clWindow;
   CodDateiLabel.Caption := FormatLE(MG[Sprache].DatDir);
  end
 else
   CodDateiArtB3Memo.Color := clActiveBorder;
end;

procedure TFMain.CodDateiArtB4Change(Sender: TObject);
begin
 if CodDateiArtB4.Checked then
  begin
   if CodDateiArtReply<>2 then
     CodDatei.Text := '';
   CodDateiArtReply := 3;
{$if Test=1}
   StatusBar.Panels.Items[1].Text :=
     'CodDateiArtReply ='+Format('%.0N',[int(CodDateiArtReply)]);
{$endif Test=1}
   CodDateiArtB4Memo.Color := clWindow;
   CodDateiLabel.Caption := FormatLE(MG[Sprache].DatDirSub);
  end
 else
   CodDateiArtB4Memo.Color := clActiveBorder;
end;

procedure TFMain.SprachBoxLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(SprachBoxLabel.HelpKeyword);
end;

procedure TFMain.StatusBarDblClick(Sender: TObject);
begin
  ShowHelpFile(StatusBar.HelpKeyword);
end;

procedure TFMain.sysjmLogoClick(Sender: TObject);
begin
  ShowHelpFile(sysjmLogo.HelpKeyword);
end;

procedure TFMain.CodDateiArtB1MemoEnter(Sender: TObject);
begin
  CodDateiArtB1.Checked := true; {siehe 'CodDateiArtB1Change'}
end;

procedure TFMain.CodDateiArtB1MemoExit(Sender: TObject);
begin
  CodDateiArtB1Memo.Lines.Strings[0] := {um alle Zeilen wieder sichtbar}
    CodDateiArtB1Memo.Lines.Strings[0]; {   zu machen, falls verschoben}
end;

procedure TFMain.CodDateiArtB3MemoEnter(Sender: TObject);
begin
  CodDateiArtB3.Checked := true; {siehe 'CodDateiArtB3Change'}
end;

procedure TFMain.CodDateiArtB3MemoExit(Sender: TObject);
begin
  CodDateiArtB3Memo.WordWrap := true;    {um die Zeile wieder sichtbar}
    CodDateiArtB3Memo.WordWrap := false; { zu machen, falls verschoben}
end;

procedure TFMain.CodDateiArtB4MemoEnter(Sender: TObject);
begin
  CodDateiArtB4.Checked := true; {siehe 'CodDateiArtB4Change'}
end;

procedure TFMain.CodDateiArtB4MemoExit(Sender: TObject);
begin
  CodDateiArtB4Memo.Lines.Strings[0] := {um alle Zeilen wieder sichtbar}
    CodDateiArtB4Memo.Lines.Strings[0]; {   zu machen, falls verschoben}
end;

procedure TFMain.CodDateiArtClick(Sender: TObject);
begin
  ShowHelpFile(CodDateiArt.HelpKeyword);
end;

procedure TFMain.CodDateiDialogClick(Sender: TObject);
begin
  case CodDateiArtReply of
   0: begin
       OpenDialogCod.FileName := '*.*';
       if OpenDialogCod.Execute then
         CodDatei.Text := OpenDialogCod.FileName;
      end;
   2: begin
        OpenDialogDir.Title := FormatLE(MG[Sprache].OpnDirTit);
        if OpenDialogDir.Execute then
          CodDatei.Text := OpenDialogDir.FileName;
      end;
   3: begin
        OpenDialogDir.Title := FormatLE(MG[Sprache].OpnDirSubTit);
        if OpenDialogDir.Execute then
          CodDatei.Text := OpenDialogDir.FileName;
      end;
  end;
end;

procedure TFMain.CodDateiLabelDblClick(Sender: TObject);
begin
  case CodDateiArtReply of
   0: ShowHelpFile('COD/DirectCodDat.html');
   2: ShowHelpFile('COD/CodDir.html');
   3: ShowHelpFile('COD/CodDir.html');
  end;
end;

procedure TFMain.CodDateiConfChange(Sender: TObject);
begin
  if CodDateiConf.Checked then
   begin
    CodDateiConfMemo.Color := clActiveBorder;
    CodDateiConfMemo.Font.Color := clWindowText;
   end
  else
   begin
    CodDateiConfMemo.Color := clWindow;
    CodDateiConfMemo.Font.Color := clRed;
   end;
end;

procedure TFMain.CodDateiConfMemoExit(Sender: TObject);
begin
  CodDateiConfMemo.Lines.Strings[0] := {um alle Zeilen wieder sichtbar}
    CodDateiConfMemo.Lines.Strings[0]; {   zu machen, falls verschoben}
end;

procedure TFMain.FormWindowStateChange(Sender: TObject);
begin
  FRefresh.ShowModal;
end;

procedure TFMain.OvlInfoClick(Sender: TObject);
begin
 if OvlInfo.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   OvlInfoEnter(Sender);      { dann dies jetzt nachholen         }
 ShowCursorPos(OvlInfo);
end;

procedure TFMain.OvlInfoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if OvlInfo.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   OvlInfoEnter(Sender);      { dann dies jetzt nachholen         }
end;

procedure TFMain.OvlInfoKeyUp(Sender: TObject; var Key: Word;
                              Shift: TShiftState);
begin
  ShowCursorPos(OvlInfo);
end;

procedure TFMain.OvlInfoLabelClick(Sender: TObject);
begin
  ShowHelpFile(OvlInfo.HelpKeyword);
end;

procedure TFMain.OvlInfoDialogClick(Sender: TObject);
begin
  OpenDialogOvl.FileName := '*.*';
  if OpenDialogOvl.Execute then
    OvlInfo.Text := OpenDialogOvl.FileName;
end;

procedure TFMain.OvlInfoEnter(Sender: TObject);
begin
 OvlInfo.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
 EnterHidedField(OvlInfo);
end;

procedure TFMain.OvlInfoExit(Sender: TObject);
begin
 DelCursorPos;
 if OvlInfo.Tag>=FocusTag then {falls das Feld den Fokus hat}
  if (not ExitOvlInfo) and    {keine Exit-Routine fr dieses Feld aktiv}
     (not OvlInfo.Focused) then { u n d  das Feld hat keinen Fokus     }
    ExitHidedField(OvlInfo,OvlInfoLabel);
end;

procedure TFMain.OvlInfoMouseMove(Sender: TObject; Shift: TShiftState;
                                  X, Y: Integer);
begin
  ShowCursorPos(OvlInfo);
  ShowHideContents(OvlInfo,OvlInfoLabel,X,Y);
  if OvlIteration.Tag>=FocusTag then { falls dieses Feld den Fokus hat }
    OvlIteration.Font.Color := OvlIteration.Color; { Feldinhalt   }
end;                                               {\ "unsichtbar"}

procedure TFMain.OvlInfoMouseDown(Sender: TOBject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
begin
  ClearMesBoxMouseDown(OvlInfo,OvlInfoLabel);
end;

procedure TFMain.OvlInfoMouseUp(Sender: TOBject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
begin
  ClearMesBoxMouseUp(OvlInfo);
  MessageBoxCall := false;
end;

procedure TFMain.OvlIterationEnter(Sender: TObject);
begin
  EnterHidedField(OvlIteration,OvlIterationS);
end;

procedure TFMain.OvlIterationExit(Sender: TObject);
var
 I: longint;
begin
 if OvlIteration.Tag>=FocusTag then {falls das Feld den Fokus hat}
  begin
   I := 0;
   if (not numLongint(OvlIteration.Text,P.OvlIteration)) or
      ((P.OvlIteration<I) or (P.OvlIteration>MaxIteration)) then
    begin
     with MG[Sprache] do
      if not numLongint(OvlIteration.Text,P.OvlIteration) then
        Application.MessageBox(PChar(FormatLE(OvlItNumErr)),
          PChar(OvlHdItErr),16)
      else
        Application.MessageBox(PChar(FormatLE(OvlItRanErr,
          [I,MaxIteration])),PChar(OvlHdItErr),16);
     P.OvlIteration  := I;
     OvlIteration.Text := Format('%.0D',[I]);
     MessageBoxCall := true;
    end
   else
     ExitHidedField(OvlIteration,OvlIterationLabel,OvlIterationS,lgMI);
  end;
end;

procedure TFMain.OvlIterationLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(OvlIterationLabel.HelpKeyword);
end;

procedure TFMain.OvlIterationMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
  ShowHideContents(OvlIteration,OvlIterationLabel,X,Y,5,7,5,1);
end;

procedure TFMain.OvlIterationMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseDown(OvlIteration,OvlIterationLabel);
end;

procedure TFMain.OvlIterationMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseUp(OvlIteration);
end;

initialization
  {$I ucoding.lrs}
end.

