(**********************************************************************
 *                                                                    *
 *    Diese Datei wird unter der SOFTWARE-LIZENZVEREINBARUNG          *
 *    fr die Software "CODING" zur Verfgung gestellt                *
 *    (siehe die Datei FREE_PRIVATE_LICENSE.pdf).                     *
 *                                                                    *
 *  \ This file is distributed under the SOFTWARE LICENSE AGREEMENT   *
 *    for the Software "CODING"                                       *
 *    (see the file FREE_PRIVATE_LICENSE.pdf).                        *
 *                                                                    *
 *    Copyright SYSJM Jrgen Mller.                                  *
 *                                                                    *
 *    Alle Rechte vorbehalten. \ All rights reserved.                 *
 *                                                                    *
 *    Programm-Benutzung auf eigene Verantwortung.                    *
 *  \ The usage of this program is on own responsibility.             *
 *                                                                    *
 **********************************************************************)
unit utimeout;
{$Macro on}
{$mode objfpc}{$H+}
interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  MaskEdit, ExtCtrls, StdCtrls, DateUtils, Buttons;

type
  TFTimeOut = class(TForm)
    OKButton: TButton;
    CancelBox: TCheckBox;
    CancelLabel: TLabel;
    TimeOutHandling: TRadioGroup;
    TimeOutHandlingB1: TRadioButton;
    TimeOutHandlingB2: TRadioButton;
    TimeOutUse: TRadioGroup;
    TimeOutUseB1: TRadioButton;
    TimeOutUseB1Mask: TMaskEdit;
    TimeOutUseB2: TRadioButton;
    procedure CancelBoxChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure TimeOutUseB1Change(Sender: TObject);
    procedure TimeOutUseB1MaskExit(Sender: TObject);
    procedure TimeOutUseB2Change(Sender: TObject);
    procedure TimeOutUseDblClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FTimeOut: TFTimeOut;

implementation

uses
  dos, StrUtils, ucoding;

const
  ExitTimeOutMask: boolean = false;
  TimeSeparator: char = ':';
  DateSeparator: char = '/';
  DateOrder: string = 'MDY';
  DecimalSeparator: char = '.';
  ThousandSeparator: char = ',';
  TimeOutMaskGap: string = '                              ';
(*---------------------*)
  {$I MGRECOD.PAS}
var
 MG: array [0..maxLanguage] of mldtext; cvar; external;
 TimeOutWarnLim: longint;
 Sprache: byte; cvar; external;
 ProgName: string; cvar; external;
(*---------------------*)
  {$I GETTIME.PAS}
  {$I GETDATEL.PAS}
  {$I FormatLE.PAS}
(*---------------------*
 *       numWord
 *---------------------*)
function numWord(IStrV: string; var IntegerV: word): boolean;
var
 Fehler: word;
begin
 IntegerV := 0;
 val(IStrV,IntegerV,Fehler);
 numWord := (Fehler=0)
end;  (*--- numWord ---*)

procedure TFTimeOut.FormShow(Sender: TObject);
begin
  TimeOutWarnLim := FMain.TOutWLim; { Time-out-Warnlimit zuweisen }
  with MG[Sprache] do
   begin
    FTimeOut.Caption := ProgName+TOutHead;
    TimeSeparator := TimeSep[1];
    DateSeparator := DateSep[1];
    DateOrder := DateOrd;
    DecimalSeparator := DecimalSep[1];
    ThousandSeparator := ThousandSep[1];
    FTimeOut.Caption := TLimMaskTit;
    TimeOutUse.Caption := FormatLE(TLimUseNew);
    TimeOutUseB1.Caption := TimeOutMaskGap+'('
      +makeDateS(TLimYear,TLimMonth,TLimDay)+','
      +makeTimeS(TLimHour,TLimMinut)+FormatLE(TLimUseB1);
    TimeOutUseB2.Caption := FormatLE(TLimUseB2)
      +makeDateS('9999','99','99')+','+makeTimeS('99','99')+''')';
    TimeOutHandling.Caption := FormatLE(TLimHNew);
    TimeOutHandlingB1.Caption := FormatLE(TLimHB1);
    TimeOutHandlingB2.Caption := FormatLE(TLimHB2);
    CancelLabel.Caption := TLimCan;
   end;
  if TimeOutUseB1.Checked then
    FMain.SetTimeOut(TimeOutUseB1Mask,TimeOutWarnLim);
end;

procedure TFTimeOut.OKButtonClick(Sender: TObject);
var
  Jetzt, Limit: TDateTime;
  Jahr, Monat, WTag, Stunde, Minute, Sekunde, Millisekunde: word;
  SJahr, SMonat, STag, SStunde, SMinute,
    Sep1, Sep2, SepDZ, SepSM,
    SJetzt, SLimit: string;
  aw: longint;
begin
 if TimeOutUse.Enabled then  {--- TimeOutUseB1Mask ---}
  if TimeOutUseB1.Checked then
   begin
    SLimit := TimeOutUseB1Mask.Text;
    getDateS(SLimit,SJahr,SMonat,STag,Sep1,Sep2);
    SepDZ := Copy(SLimit,11,1);
    getTimeS(Copy(SLimit,12,5),SStunde,SMinute,SepSM);
    Jetzt := now;
    DecodeDateTime(Jetzt,Jahr,Monat,WTag,Stunde,Minute,Sekunde,
                   Millisekunde);
    SJetzt := makeDateN(Jahr,Monat,WTag)+','+makeTimeN(Stunde,Minute);
    Sekunde := 0;
    Millisekunde := 0;
    numWord(STag,WTag);
    numWord(SMonat,Monat);
    numWord(SJahr,Jahr);
    numWord(SStunde,Stunde);
    numWord(SMinute,Minute);
    TryEncodeDateTime(Jahr,Monat,WTag,
                      Stunde,Minute,Sekunde,Millisekunde,Limit);
    if CompareDateTime(Jetzt,Limit)>=0 then   {Limit < Jetzt}
     begin
      FTimeOut.ActiveControl := TimeOutUseB1Mask;
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(TLimGTCurr,
          [SLimit,SJetzt])),PChar(TLimHdErr),16);
      Exit;
     end
    else
     begin
      Jetzt := IncMinute(now,TimeOutWarnLim); {aktuelle Zeit + x Min.}
      if CompareDateTime(Jetzt,Limit)>0 then  {    als Vergleichszeit}
       begin
        with MG[Sprache] do
          aw := Application.MessageBox(PChar(FormatLE(TLimLT,
                  [TimeOutWarnLim])),PChar(TLimHdWar),49);
        if aw=2 then  {'Cancel.'}
         begin
          FTimeOut.ActiveControl := TimeOutUseB1Mask;
          Exit;
         end
       end;
     end
   end;
  FTimeOut.Close;
end;

procedure TFTimeOut.TimeOutUseB1Change(Sender: TObject);
begin
  if TimeOutUseB1.Checked then
   begin
    TimeOutUseB1Mask.Color := clWindow;
    TimeOutUseB1Mask.Enabled := true;
    FMain.SetTimeOut(TimeOutUseB1Mask,TimeOutWarnLim);
    TimeOutHandling.Enabled := true;
   end;
end;

procedure TFTimeOut.TimeOutUseB1MaskExit(Sender: TObject);
begin
 if (not ExitTimeOutMask) and   {falls noch keine Exit-Routine}
     TimeOutUseB1.Checked then  {fr dieses Feld aktiv ist    }
  begin
   ExitTimeOutMask := true; {anzeigen, dass fr dieses Feld   }
                            {jetzt eine Exit-Routine aktiv ist}
   FMain.ChkTimeOut(TimeOutUseB1Mask,TimeOutWarnLim);
   ExitTimeOutMask := false;
  end;
end;

procedure TFTimeOut.TimeOutUseB2Change(Sender: TObject);
begin
 if TimeOutUseB2.Checked then
  begin
   TimeOutUseB1Mask.Color := clActiveBorder;
   TimeOutUseB1Mask.Enabled := false;
   TimeOutUseB1Mask.Text :=makeDateS('9999','99','99')
                                     +','+makeTimeS('99','99');
   TimeOutHandling.Enabled := false;
  end;
end;

procedure TFTimeOut.TimeOutUseDblClick(Sender: TObject);
begin
  FMain.ShowHelpFile(TimeOutUse.HelpKeyword);
end;

procedure TFTimeOut.CancelBoxChange(Sender: TObject);
begin
 if CancelBox.Checked then
  begin
   TimeOutUse.Enabled := false;
   TimeOutUseB1Mask.Enabled := false;
   TimeOutHandling.Enabled := false;
  end
 else
  begin
   TimeOutUse.Enabled := true;
   TimeOutUseB1Mask.Enabled := true;
   TimeOutHandling.Enabled := true;
  end;
end;

initialization
  {$I utimeout.lrs}

end.

