(* Kommentare in deutsch. \ Comments in English.
 **********************************************************************
 *                                                                    *
 *    Diese Datei wird unter der SOFTWARE-LIZENZVEREINBARUNG          *
 *    fr die Software "CODING" zur Verfgung gestellt                *
 *    (siehe die Datei FREE_PRIVATE_LICENSE.pdf).                     *
 *                                                                    *
 *  \ This file is distributed under the SOFTWARE LICENSE AGREEMENT   *
 *    for the Software "CODING"                                       *
 *    (see the file FREE_PRIVATE_LICENSE.pdf).                        *
 *                                                                    *
 *    Copyright SYSJM Jrgen Mller.                                  *
 *                                                                    *
 *    Alle Rechte vorbehalten. \ All rights reserved.                 *
 *                                                                    *
 *    Programm-Benutzung auf eigene Verantwortung.                    *
 *  \ The usage of this program is on own responsibility.             *
 *                                                                    *
 **********************************************************************)
{$Macro on}
{$define Gruppe:=1} (* =1  - CODING1 - 1-Byte-Gruppen \ 1 byte-groups
                       =2  - CODING2 - 2-Byte-Gruppen \ 2 byte-groups
                       =3  - CODING3 - 3-Byte-Gruppen \ 3 byte-groups *)
{$define System:=0} (* =0  - Windows
                       =1  - Unix    *)
{$define BSigRtL:=0}(* Werte-Signifikanz von Integer-Bytes zunehmend
                      \value significance of integer bytes increasing
                       =0  - von links nach rechts (zB. Intel-Prozessor)
                            \from left to right (e.g. Intel CPU)
                       =1  - von rechts nach links(zB. Grorechner-CPU)
                            \from right to left (e.g. mainframe CPU) *)
{$define Test:=0}   (* =0  - keine Test-Ausgabe im Status-Panel
                            \no test output on the status panel
                       =1  - Test-Ausgabe im Status-Panel
                            \test output on the status panel *)
{$define Safety:=2} (* =0  - keine Stromchiffrierung
                            \no stream cipher
                       =1  - Stromchiffrierung mit einer Parameterdatei
                            \stream cipher using a parameter dataset
                       =2  - Stromchiffrierung auch mit einer
                             Komponentenwechsel-Parameterdatei
                            \stream cipher using a component exchange
                             parameter dataset too *)
unit ucoding;
{$Macro on}
{$mode objfpc}{$H+}
interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, ExtDlgs, EditBtn, LazHelpHTML,
  MaskEdit, ActnList, Buttons, StrUtils, DateUtils, SynEdit, HelpIntfs;

type
  TFMain = class(TForm)
    ActionHandling: TRadioGroup;
    ActionHandlingB1: TRadioButton;
    ActionHandlingB1Memo: TMemo;
    ActionHandlingB2: TRadioButton;
    ActionHandlingB2Memo: TMemo;
    ActionHandlingB3: TRadioButton;
    ActionHandlingB3Memo: TMemo;
    ActionHandlingB4: TRadioButton;
    ActionHandlingB4Memo: TMemo;
    ActionHandlingB5: TRadioButton;
    ActionHandlingB5Memo: TMemo;
    ActionHandlingBox: TGroupBox;
    ActionHandlingLabel: TLabel;
    ActionPanel: TPanel;
    ApplicationProperties1: TApplicationProperties;
    AusDatei: TEdit;
    AusDateiDialog: TImage;
    AusDateiHandling: TCheckBox;
    AusDateiHandlingLabel1: TLabel;
    AusDateiHandlingLabel2: TLabel;
    AusDateiHandlingPanel: TPanel;
    AusDateiLabel: TLabel;
    CodArt: TRadioGroup;
    CodArtHBox: TGroupBox;
    CodArtHLabel1: TLabel;
    CodArtHLabel2: TLabel;
    CodArtKopfBox: TGroupBox;
    CodArtKopfLabel: TLabel;
    CodArtVLabel1: TLabel;
    CodArtVLabel2: TLabel;
    CodDatei: TEdit;
    CodDateiArt: TRadioGroup;
    CodDateiArtB1: TRadioButton;
    CodDateiArtB1Memo: TMemo;
    CodDateiArtB2: TRadioButton;
    CodDateiArtB2Memo: TMemo;
    CodDateiArtB3: TRadioButton;
    CodDateiArtB3Memo: TMemo;
    CodDateiArtB4: TRadioButton;
    CodDateiArtB4Memo: TMemo;
    CodDateiArtPanel: TPanel;
(*{$if Safety<2}*)
 {Da die Initialisierungs-Informationen nicht parametrisiert werden
  knnen (!), mssen alle Steuerelemente aller Programmvarianten und
  die zugehrigen Prozeduren definiert bleiben, sonst beschwert sich
  das Laufzeitsystem (die Alternative "per Hand" wurde vom Autor nicht
  in Erwgung gezogen).
    Die nicht bentigten Steuerelemente mssen daher am Anfang gem
  der gewnschten Programmvariante auf 'invisible' gesetzt werden.
  --> coding.lpr }
    CodDateiConf: TCheckBox;
    CodDateiConfMemo: TMemo;
(*{$endif Safety<2}*)
    CodDateiDialog: TImage;
    CodDateiLabel: TLabel;
    CodDateiPanel: TPanel;
    CodStats: TCheckBox;
    CodStatsLabel: TLabel;
    CodStatsPanel: TPanel;
(*{$if Safety>0}*)
    CodStream: TCheckBox;
    CodStreamLabel: TLabel;
    CodStreamPanel: TPanel;
(*{$endif Safety>0}*)
(*{$if Safety>1}*)
    CompDatei: TEdit;
    CompDateiDialog: TImage;
    CompDateiGroup: TGroupBox;
    CompDateiKey: TEdit;
    CompDateiKeyCheck: TImage;
    CompDateiKeyDialog: TImage;
    CompDateiKeyHandling: TRadioGroup;
    CompDateiKeyHandlingB1: TRadioButton;
    CompDateiKeyHandlingB2: TRadioButton;
    CompDateiKeyHandlingB3: TRadioButton;
    CompDateiKeyHex: TCheckBox;
    CompDateiKeyHexLabel: TLabel;
    CompDateiKeyHexPanel: TPanel;
    CompDateiKeyLabel: TLabel;
    CompDateiKeyOK: TImage;
    CompDateiLabel: TLabel;
    CompDateiOnly: TCheckBox;
    CompDateiOnlyLabel: TLabel;
    CompDateiOnlyPanel: TPanel;
(*{$endif Safety>1}*)
    DtnClose: TButton;
    DtnDelete: TButton;
    DtnInsert: TButton;
    DtnListe: TListBox;
    DtnOpen: TButton;
    DtnPlaceDown: TButton;
    DtnPlaceUp: TButton;
    DtnSave: TButton;
    ExpClose: TButton;
    ExpDatei: TEdit;
    ExpDateiDialog: TImage;
    ExpDateiLabel: TLabel;
    ExpDelete: TButton;
    ExpInsert: TButton;
    ExpListe: TListBox;
    ExpOpen: TButton;
    ExpPlaceDown: TButton;
    ExpPlaceUp: TButton;
    ExpSave: TButton;
    HelpBrowser: THTMLBrowserHelpViewer;
    HelpDb: THTMLHelpDatabase;
    InitialKey: TEdit;
    InitialKeyCheck: TImage;
    InitialKeyDialog: TImage;
    InitialKeyHandling: TRadioGroup;
    InitialKeyHandlingB1: TRadioButton;
    InitialKeyHandlingB2: TRadioButton;
    InitialKeyHandlingB3: TRadioButton;
    InitialKeyHex: TCheckBox;
    InitialKeyHexLabel: TLabel;
    InitialKeyHexPanel: TPanel;
    InitialKeyKopfBox: TGroupBox;
    InitialKeyKopfLabel: TLabel;
    InitialKeyLabel: TLabel;
    InitialKeyMaus: TImage;
    InitialKeyOK: TImage;
    InitialKeyOvl: TCheckBox;
    InitialKeyOvlLabel: TLabel;
    InitialKeyOvlPanel: TPanel;
    InitialKeyPanel: TPanel;
    TimeOutHandlingB2Memo: TMemo;
    TimeOutHandlingB1Memo: TMemo;
    OvlInfoSLbl: TLabel;
    MessageLabel: TLabel;
    MessageMemo: TMemo;
    OpenDialogAus: TOpenDialog;
    OpenDialogCod: TOpenDialog;
    OpenDialogDir: TSelectDirectoryDialog;
    OpenDialogDtn: TOpenDialog;
    OpenDialogExn: TOpenDialog;
    OpenDialogKey: TOpenDialog;
    OpenDialogOvl: TOpenDialog;
    OpenDialogPar: TOpenDialog;
    OperClear: TButton;
    OperExit: TButton;
    OperStart: TButton;
    OverlayPanel: TPanel;
    OvlInfo: TEdit;
    OvlInfoCheck: TImage;
    OvlInfoDialog: TImage;
    OvlInfoHandling: TCheckBox;
    OvlInfoSave: TCheckBox;
    OvlInfoLabel: TLabel;
    OvlInfoOK: TImage;
    OvlIteration: TEdit;
    OvlIterationLabel: TLabel;
    OvlKopfBox: TGroupBox;
    OvlKopfLabel: TLabel;
    OvlLimitBisLabel: TLabel;
    OvlLimitBox: TGroupBox;
    OvlLimitKValBis: TEdit;
    OvlLimitKValLabel1: TLabel;
    OvlLimitKValLabel2: TLabel;
    OvlLimitKValVon: TEdit;
    OvlLimitLabel: TLabel;
    OvlLimitOValBis: TEdit;
    OvlLimitOValLabel1: TLabel;
    OvlLimitOValLabel2: TLabel;
    OvlLimitOValVon: TEdit;
    OvlLimitPosBis: TEdit;
    OvlLimitPosLabel1: TLabel;
    OvlLimitPosLabel2: TLabel;
    OvlLimitPosVon: TEdit;
    OvlLimitVonLabel: TLabel;
    OvlPosArt: TRadioGroup;
    OvlPosArtB1: TRadioButton;
    OvlPosArtB2: TRadioButton;
    OvlSyntax: TRadioGroup;
    OvlSyntaxB1: TRadioButton;
    OvlSyntaxB2: TRadioButton;
    OvlSyntaxHinweis1: TLabel;
    OvlSyntaxHinweis2: TLabel;
    OvlTrennBox: TGroupBox;
    OvlValArt: TRadioGroup;
    OvlValArtB1: TRadioButton;
    OvlValArtB2: TRadioButton;
    OvlValArtB3: TRadioButton;
    ParDatei: TEdit;
    ParDateiClsKey: TEdit;
    ParDateiClsKeyCheck: TImage;
    ParDateiClsKeyDialog: TImage;
    ParDateiClsKeyGroup: TGroupBox;
    ParDateiClsKeyHandling: TRadioGroup;
    ParDateiClsKeyHandlingB1: TRadioButton;
    ParDateiClsKeyHandlingB2: TRadioButton;
    ParDateiClsKeyHandlingB3: TRadioButton;
    ParDateiClsKeyHex: TCheckBox;
    ParDateiClsKeyHexLabel: TLabel;
    ParDateiClsKeyHexPanel: TPanel;
    ParDateiClsKeyLabel: TLabel;
    ParDateiClsKeyOK: TImage;
(*{$if Safety>1}*)
    ParDateiClsKeyStw: TCheckBox;
    ParDateiClsKeyStwLabel: TLabel;
    ParDateiClsKeyStwPanel: TPanel;
(*{$endif Safety>1}*)
    ParDateiDialog: TImage;
    ParDateiKopfBox: TGroupBox;
    ParDateiKopfLabel: TLabel;
    ParDateiLabel: TLabel;
    ParDateiOpKey: TEdit;
    ParDateiOpKeyCheck: TImage;
    ParDateiOpKeyDialog: TImage;
    ParDateiOpKeyGroup: TGroupBox;
    ParDateiOpKeyHandling: TRadioGroup;
    ParDateiOpKeyHandlingB1: TRadioButton;
    ParDateiOpKeyHandlingB2: TRadioButton;
    ParDateiOpKeyHandlingB3: TRadioButton;
    ParDateiOpKeyHex: TCheckBox;
    ParDateiOpKeyHexLabel: TLabel;
    ParDateiOpKeyHexPanel: TPanel;
    ParDateiOpKeyLabel: TLabel;
    ParDateiOpKeyOK: TImage;
    ParDateiPanel: TPanel;
    ParDateiUse: TRadioGroup;
    ParDateiUseB1: TRadioButton;
    ParDateiUseB1Memo: TMemo;
    ParDateiUseB2: TRadioButton;
    ParDateiUseB2Memo: TMemo;
    ParDateiUseBox: TGroupBox;
    SprachBox: TComboBox;
    SprachBoxLabel: TLabel;
    StatusBar: TStatusBar;
    sysjmLogo: TImage;
    TimeOutHandling: TRadioGroup;
    TimeOutHandlingB1: TRadioButton;
    TimeOutHandlingB2: TRadioButton;
    TimeOutUse: TRadioGroup;
    TimeOutUseB1: TRadioButton;
    TimeOutUseB1Mask: TMaskEdit;
    TimeOutUseB2: TRadioButton;
    procedure ActionHandlingB1Change(Sender: TObject);
    procedure ActionHandlingB1MemoEnter(Sender: TObject);
    procedure ActionHandlingB1MemoExit(Sender: TObject);
    procedure ActionHandlingB2Change(Sender: TObject);
    procedure ActionHandlingB2MemoEnter(Sender: TObject);
    procedure ActionHandlingB2MemoExit(Sender: TObject);
    procedure ActionHandlingB3Change(Sender: TObject);
    procedure ActionHandlingB3MemoEnter(Sender: TObject);
    procedure ActionHandlingB3MemoExit(Sender: TObject);
    procedure ActionHandlingB4Change(Sender: TObject);
    procedure ActionHandlingB4MemoEnter(Sender: TObject);
    procedure ActionHandlingB4MemoExit(Sender: TObject);
    procedure ActionHandlingB5Change(Sender: TObject);
    procedure ActionHandlingB5MemoEnter(Sender: TObject);
    procedure ActionHandlingB5MemoExit(Sender: TObject);
    procedure ActionHandlingLabelClick(Sender: TObject);
    procedure AusDateiDialogClick(Sender: TObject);
    procedure AusDateiHandlingLabelDblClick(Sender: TObject);
    procedure AusDateiHandlingLabelClick(Sender: TObject);
    procedure AusDateiLabelDblClick(Sender: TObject);
    procedure CodArtHLabel1Click(Sender: TObject);
    procedure CodArtHLabel2Click(Sender: TObject);
    procedure CodArtKopfLabelClick(Sender: TObject);
    procedure CodArtVLabel1Click(Sender: TObject);
    procedure CodArtVLabel2Click(Sender: TObject);
    procedure CodDateiArtB1Change(Sender: TObject);
    procedure CodDateiArtB1MemoEnter(Sender: TObject);
    procedure CodDateiArtB1MemoExit(Sender: TObject);
    procedure CodDateiArtB2Change(Sender: TObject);
    procedure CodDateiArtB2MemoEnter(Sender: TObject);
    procedure CodDateiArtB2MemoExit(Sender: TObject);
    procedure CodDateiArtB3Change(Sender: TObject);
    procedure CodDateiArtB3MemoEnter(Sender: TObject);
    procedure CodDateiArtB3MemoExit(Sender: TObject);
    procedure CodDateiArtB4Change(Sender: TObject);
    procedure CodDateiArtB4MemoEnter(Sender: TObject);
    procedure CodDateiArtB4MemoExit(Sender: TObject);
    procedure CodDateiArtClick(Sender: TObject);
    procedure CodDateiChange(Sender: TObject);
(*{$if Safety<2}*)
    procedure CodDateiConfChange(Sender: TObject);
    procedure CodDateiConfMemoExit(Sender: TObject);
(*{$endif Safety<2}*)
    procedure CodDateiDialogClick(Sender: TObject);
    procedure CodDateiLabelDblClick(Sender: TObject);
(*{$if Safety>0}*)
    procedure CodStreamChange(Sender: TObject);
    procedure CodStreamLabelClick(Sender: TObject);
    procedure CodStreamLabelDblClick(Sender: TObject);
    procedure CodStreamPanelDblClick(Sender: TObject);
(*{$endif Safety>0}*)
    procedure CodStatsLabelClick(Sender: TObject);
    procedure CodStatsLabelDblClick(Sender: TObject);
(*{$if Safety>1}*)
    procedure CompDateiClick(Sender: TObject);
    procedure CompDateiDialogClick(Sender: TObject);
    procedure CompDateiGroupDblClick(Sender: TObject);
    procedure CompDateiEnter(Sender: TObject);
    procedure CompDateiExit(Sender: TObject);
    procedure CompDateiKeyDown(Sender: TObject; var Key: Word;
                               Shift: TShiftState);
    procedure CompDateiKeyUp(Sender: TObject; var Key: Word;
                             Shift: TShiftState);
    procedure CompDateiMouseDown(Sender: TOBject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
    procedure CompDateiMouseMove(Sender: TObject; Shift: TShiftState;
                                 X, Y: Integer);
    procedure CompDateiMouseUp(Sender: TOBject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
    procedure CompDateiOnlyLabelClick(Sender: TObject);
    procedure CompDateiOnlyLabelDblClick(Sender: TObject);
    procedure CompDateiKeyChange(Sender: TObject);
    procedure CompDateiKeyCheckClick(Sender: TObject);
    procedure CompDateiKeyClick(Sender: TObject);
    procedure CompDateiKeyDialogClick(Sender: TObject);
    procedure CompDateiKeyEnter(Sender: TObject);
    procedure CompDateiKeyExit(Sender: TObject);
    procedure CompDateiKeyHandlingB1Change(Sender: TObject);
    procedure CompDateiKeyHandlingB2Change(Sender: TObject);
    procedure CompDateiKeyHandlingB3Change(Sender: TObject);
    procedure CompDateiKeyHandlingDblClick(Sender: TObject);
    procedure CompDateiKeyHexChange(Sender: TObject);
    procedure CompDateiKeyHexLabelClick(Sender: TObject);
    procedure CompDateiKeyKeyDown(Sender: TObject; var Key: Word;
                                  Shift: TShiftState);
    procedure CompDateiKeyKeyUp(Sender: TObject; var Key: Word;
                                Shift: TShiftState);
    procedure CompDateiKeyLabelDblClick(Sender: TObject);
    procedure CompDateiKeyMouseDown(Sender:TOBject; Button:TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
    procedure CompDateiKeyMouseMove(Sender: TObject; Shift: TShiftState;
                                    X, Y: Integer);
    procedure CompDateiKeyMouseUp(Sender: TOBject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
(*{$endif Safety>1}*)
    procedure DtnCloseClick(Sender: TObject);
    procedure DtnDeleteClick(Sender: TObject);
    procedure DtnInsertClick(Sender: TObject);
    procedure DtnListeClick(Sender: TObject);
    procedure DtnOpenClick(Sender: TObject);
    procedure DtnPlaceDownClick(Sender: TObject);
    procedure DtnPlaceUpClick(Sender: TObject);
    procedure DtnSaveClick(Sender: TObject);
    procedure ExpCloseClick(Sender: TObject);
    procedure ExpDateiChange(Sender: TObject);
    procedure ExpDateiDialogClick(Sender: TObject);
    procedure ExpDateiLabelClick(Sender: TObject);
    procedure ExpDeleteClick(Sender: TObject);
    procedure ExpInsertClick(Sender: TObject);
    procedure ExpListeClick(Sender: TObject);
    procedure ExpOpenClick(Sender: TObject);
    procedure ExpPlaceDownClick(Sender: TObject);
    procedure ExpPlaceUpClick(Sender: TObject);
    procedure ExpSaveClick(Sender: TObject);
    procedure FormMouseUp(Sender: TOBject; Button: TMouseButton;
                          Shift: TShiftState; X, Y: Integer);
    procedure FormWindowStateChange(Sender: TObject);
    procedure InitialKeyChange(Sender: TObject);
    procedure InitialKeyCheckClick(Sender: TObject);
    procedure InitialKeyClick(Sender: TObject);
    procedure InitialKeyDialogClick(Sender: TObject);
    procedure InitialKeyEnter(Sender: TObject);
    procedure InitialKeyExit(Sender: TObject);
    procedure InitialKeyHandlingB1Change(Sender: TObject);
    procedure InitialKeyHandlingB2Change(Sender: TObject);
    procedure InitialKeyHandlingB3Change(Sender: TObject);
    procedure InitialKeyHexChange(Sender: TObject);
    procedure InitialKeyHexLabelClick(Sender: TObject);
    procedure InitialKeyHexLabelDblClick(Sender: TObject);
    procedure InitialKeyKeyDown(Sender: TObject; var Key: Word;
                                Shift: TShiftState);
    procedure InitialKeyKeyUp(Sender: TObject; var Key: Word;
                              Shift: TShiftState);
    procedure InitialKeyKopfLabelClick(Sender: TObject);
    procedure InitialKeyLabelDblClick(Sender: TObject);
    procedure InitialKeyMausClick(Sender: TObject);
    procedure InitialKeyMouseDown(Sender: TOBject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
    procedure InitialKeyMouseMove(Sender: TObject; Shift: TShiftState;
                                  X, Y: Integer);
    procedure InitialKeyMouseUp(Sender: TOBject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
    procedure InitialKeyOKClick(Sender: TObject);
    procedure InitialKeyOvlChange(Sender: TObject);
    procedure InitialKeyOvlLabelClick(Sender: TObject);
    procedure InitialKeyOvlLabelDblClick(Sender: TObject);
    procedure MessageMemoMouseEnter(Sender: TObject);
    procedure MessageMemoMouseLeave(Sender: TObject);
    procedure OperClearClick(Sender: TObject);
    procedure OperExitClick(Sender: TObject);
    procedure OperStartClick(Sender: TObject);
    procedure OvlInfoChange(Sender: TObject);
    procedure OvlInfoCheckClick(Sender: TObject);
    procedure OvlInfoClick(Sender: TObject);
    procedure OvlInfoDialogClick(Sender: TObject);
    procedure OvlInfoEnter(Sender: TObject);
    procedure OvlInfoExit(Sender: TObject);
    procedure OvlInfoHandlingChange(Sender: TObject);
    procedure OvlInfoKeyDown(Sender: TObject; var Key: Word;
                             Shift: TShiftState);
    procedure OvlInfoKeyUp(Sender: TObject; var Key: Word;
                           Shift: TShiftState);
    procedure OvlInfoLabelClick(Sender: TObject);
    procedure OvlInfoMouseDown(Sender: TOBject; Button: TMouseButton;
                               Shift: TShiftState; X, Y: Integer);
    procedure OvlInfoMouseMove(Sender: TObject; Shift: TShiftState;
                               X, Y: Integer);
    procedure OvlInfoMouseUp(Sender: TOBject; Button: TMouseButton;
                             Shift: TShiftState; X, Y: Integer);
    procedure OvlInfoSLblClick(Sender: TObject);
    procedure OvlInfoSLblDblClick(Sender: TObject);
    procedure OvlIterationEnter(Sender: TObject);
    procedure OvlIterationExit(Sender: TObject);
    procedure OvlIterationLabelDblClick(Sender: TObject);
    procedure OvlIterationMouseDown(Sender:TOBject; Button:TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
    procedure OvlIterationMouseMove(Sender: TObject; Shift: TShiftState;
                                    X, Y: Integer);
    procedure OvlIterationMouseUp(Sender: TOBject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
    procedure OvlKopfLabelClick(Sender: TObject);
    procedure OvlLimitBoxDblClick(Sender: TObject);
    procedure OvlLimitKValBisEnter(Sender: TObject);
    procedure OvlLimitKValBisExit(Sender: TObject);
    procedure OvlLimitKValBisMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitKValBisMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitKValBisMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitKValVonEnter(Sender: TObject);
    procedure OvlLimitKValVonExit(Sender: TObject);
    procedure OvlLimitKValVonMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitKValVonMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitKValVonMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitOValBisEnter(Sender: TObject);
    procedure OvlLimitOValBisExit(Sender: TObject);
    procedure OvlLimitOValBisMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitOValBisMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitOValBisMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitOValVonEnter(Sender: TObject);
    procedure OvlLimitOValVonExit(Sender: TObject);
    procedure OvlLimitOValVonMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitOValVonMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitOValVonMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitPosBisEnter(Sender: TObject);
    procedure OvlLimitPosBisExit(Sender: TObject);
    procedure OvlLimitPosBisMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitPosBisMouseMove(Sender:TObject; Shift:TShiftState;
                                      X, Y: Integer);
    procedure OvlLimitPosBisMouseUp(Sender:TOBject; Button:TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitPosVonChange(Sender: TObject);
    procedure OvlLimitPosVonEnter(Sender: TObject);
    procedure OvlLimitPosVonExit(Sender: TObject);
    procedure OvlLimitPosVonMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure OvlLimitPosVonMouseMove(Sender:TObject; Shift:TShiftState;
                                      X, Y: Integer);
    procedure OvlLimitPosVonMouseUp(Sender:TOBject; Button:TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
    procedure OvlSyntaxB1Change(Sender: TObject);
    procedure OvlSyntaxB2Change(Sender: TObject);
    procedure OvlSyntaxDblClick(Sender: TObject);
    procedure ParDateiClick(Sender: TObject);
    procedure ParDateiClsKeyChange(Sender: TObject);
    procedure ParDateiClsKeyCheckClick(Sender: TObject);
    procedure ParDateiClsKeyClick(Sender: TObject);
    procedure ParDateiClsKeyDialogClick(Sender: TObject);
    procedure ParDateiClsKeyEnter(Sender: TObject);
    procedure ParDateiClsKeyExit(Sender: TObject);
    procedure ParDateiClsKeyHandlingB1Change(Sender: TObject);
    procedure ParDateiClsKeyHandlingB2Change(Sender: TObject);
    procedure ParDateiClsKeyHandlingB3Change(Sender: TObject);
    procedure ParDateiClsKeyHexChange(Sender: TObject);
    procedure ParDateiClsKeyHexLabelClick(Sender: TObject);
    procedure ParDateiClsKeyKeyDown(Sender: TObject; var Key: Word;
                                    Shift: TShiftState);
    procedure ParDateiClsKeyKeyUp(Sender: TObject; var Key: Word;
                                  Shift: TShiftState);
    procedure ParDateiClsKeyMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ParDateiClsKeyMouseMove(Sender:TObject; Shift:TShiftState;
                                      X, Y: Integer);
    procedure ParDateiClsKeyMouseUp(Sender:TOBject; Button:TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
(*{$if Safety>1}*)
    procedure ParDateiClsKeyStwChange(Sender: TObject);
    procedure ParDateiClsKeyStwLabelClick(Sender: TObject);
    procedure ParDateiClsKeyStwLabelDblClick(Sender: TObject);
(*{$endif Safety>1}*)
    procedure ParDateiDialogClick(Sender: TObject);
    procedure ParDateiEnter(Sender: TObject);
    procedure ParDateiExit(Sender: TObject);
    procedure ParDateiKeyDown(Sender: TObject; var Key: Word;
                              Shift: TShiftState);
    procedure ParDateiKeyUp(Sender: TObject; var Key: Word;
                            Shift: TShiftState);
    procedure ParDateiKopfLabelClick(Sender: TObject);
    procedure ParDateiLabelClick(Sender: TObject);
    procedure ParDateiMouseDown(Sender: TOBject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
    procedure ParDateiMouseMove(Sender: TObject; Shift: TShiftState;
                                X, Y: Integer);
    procedure ParDateiMouseUp(Sender: TOBject; Button: TMouseButton;
                              Shift: TShiftState; X, Y: Integer);
    procedure ParDateiOpKeyChange(Sender: TObject);
    procedure ParDateiOpKeyCheckClick(Sender: TObject);
    procedure ParDateiOpKeyClick(Sender: TObject);
    procedure ParDateiOpKeyDialogClick(Sender: TObject);
    procedure ParDateiOpKeyEnter(Sender: TObject);
    procedure ParDateiOpKeyExit(Sender: TObject);
    procedure ParDateiOpKeyHandlingB1Change(Sender: TObject);
    procedure ParDateiOpKeyHandlingB2Change(Sender: TObject);
    procedure ParDateiOpKeyHandlingB3Change(Sender: TObject);
    procedure ParDateiOpKeyHandlingDblClick(Sender: TObject);
    procedure ParDateiOpKeyHexChange(Sender: TObject);
    procedure ParDateiOpKeyHexLabelClick(Sender: TObject);
    procedure ParDateiOpKeyKeyDown(Sender: TObject; var Key: Word;
                                   Shift: TShiftState);
    procedure ParDateiOpKeyKeyUp(Sender: TObject; var Key: Word;
                                 Shift: TShiftState);
    procedure ParDateiOpKeyLabelDblClick(Sender: TObject);
    procedure ParDateiOpKeyMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ParDateiOpKeyMouseMove(Sender: TObject; Shift:TShiftState;
                                     X, Y: Integer);
    procedure ParDateiOpKeyMouseUp(Sender: TOBject; Button:TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
    procedure ParDateiUseB1Change(Sender: TObject);
    procedure ParDateiUseB1MemoEnter(Sender: TObject);
    procedure ParDateiUseB1MemoExit(Sender: TObject);
    procedure ParDateiUseB2Change(Sender: TObject);
    procedure ParDateiUseB2MemoEnter(Sender: TObject);
    procedure ParDateiUseB2MemoExit(Sender: TObject);
    procedure SprachBoxCloseUp(Sender: TObject);
    procedure SprachBoxLabelDblClick(Sender: TObject);
    procedure StatusBarDblClick(Sender: TObject);
    procedure sysjmLogoClick(Sender: TObject);
    procedure TimeOutHandlingB1Change(Sender: TObject);
    procedure TimeOutHandlingB1MemoEnter(Sender: TObject);
    procedure TimeOutHandlingB1MemoExit(Sender: TObject);
    procedure TimeOutHandlingB2Change(Sender: TObject);
    procedure TimeOutHandlingB2MemoEnter(Sender: TObject);
    procedure TimeOutHandlingB2MemoExit(Sender: TObject);
    procedure TimeOutUseB1Change(Sender: TObject);
    procedure TimeOutUseB1MaskExit(Sender: TObject);
    procedure TimeOutUseB2Change(Sender: TObject);
{}
    procedure SetTimeOut(Feld: TMaskEdit; const deltaMin: int64);
    procedure ChkTimeOut(Feld: TMaskEdit; const deltaMin: int64);
    procedure ShowCursorPos(Feld: TEdit);
    procedure DelCursorPos();
    procedure EnterHidedField(Feld: TEdit; var Inhalt: string);
    procedure EnterHidedField(Feld: TEdit);
    procedure ShowHideContents(Feld: TEdit; ColorFeld: TLabel;
                               X,Y: integer);
    procedure ShowHideContents(Feld: TEdit; ColorFeld: TLabel;
                               X,Y, loX,hiX, loY,hiY: integer);
    procedure ExitHidedField(Feld: TEdit; ColorFeld: TLabel);
    procedure ExitHidedField(Feld: TEdit; ColorFeld: TLabel;
                             var Inhalt: string; fix: integer);
    procedure ClearMesBoxMouseDown(Feld: TEdit; ColorFeld: TLabel);
    procedure ClearMesBoxMouseUp(Feld: TEdit);
    procedure ShowHelpFile(const HKeyword: string);
    procedure TimeOutUseClick(Sender: TObject);
{}
  private
    { private declarations }
  public
    { public declarations }
    TOutWLim: longint;  { Time-out-Warnlimit }
  end; 

 EOpenError = Class(Exception);
 ECreateError = Class(Exception);
 ERdError = Class(Exception);
 EFormError = Class(Exception);
 EWrError = Class(Exception);

var
  FMain: TFMain;

implementation

uses
  Windows, dos, crt,
{$if Gruppe=1}
  coding1neu,
{$elseif Gruppe=2}
  coding2neu,
{$else Gruppe=3}
  coding3neu,
{$endif Gruppe}
  utimeout, uinfo, ucommit, urefresh;

const
  d0 = 48; (* Bytewert von '0' ASCII *)
  d9 = 57; (* Bytewert von '9' ASCII *)
  cA = 65; (* Bytewert von 'A' ASCII *)
  cF = 70; (* Bytewert von 'F' ASCII *)
  cAS10 = 55; (* Differenz zwischen Bytewert und Wert fr 'A' bis'F' *)
{$if Gruppe=1}
  ElemBytes = 1;
  KeyAnzahl = 256;
  KeyAnzahlS1 = 255; (* = KeyAnzahl - 1 *)
  KeyFaktor = 113; (* = Primzahl als Schlsselwert-Erhhungsfaktor
                        mit  KeyLaengeS1 * (KeyFaktor + 2) < 2**15 *)
  minRandomAnz: longint = 25;
(*lgKA = 3;[* Ziffernanzahl von 'KeyAnzahl' *] -> OvlLim_.MaxLength:=3*)
{$elseif Gruppe=2}
  ElemBytes = 2;
  KeyAnzahl = 65536;
  KeyAnzahlS1 = 65535; (* = KeyAnzahl - 1 *)
  KeyFaktor = 30781; (* = Primzahl als Schlsselwert-Erhhungsfaktor
                          mit  KeyAnzahlS1 * (KeyFaktor+2) < 2**31 *)
  minRandomAnz: longint = 50;
(*lgKA = 5;[* Ziffernanzahl von 'KeyAnzahl' *] -> OvlLim_.MaxLength:=5*)
{$else Gruppe=3}
  ElemBytes = 3;
  KeyAnzahl = 16777216;
  KeyAnzahlS1 = 16777215; (* = KeyAnzahl - 1 *)
  KeyFaktor = 100000000019;(*=Primzahl als Schlsselwert-Erhhungsfaktor
                              mit  KeyAnzahlS1*(KeyFaktor+2) < 2**63  *)
  minRandomAnz: longint = 500;
(* lgKA = 8; [* Ziffernanzahl von 'KeyAnzahl' *] *)
{$endif Gruppe}
  lgKA = 8;
  maxPuffer: longint = 4095;
  maxPufferP1 = 4096;
  FocusTag: longint = 1000;
  MessageBoxCall: boolean = false;
  TimeSeparator: char = ':';
  DateSeparator: char = '/';
  DateOrder: string = 'MDY';
  DecimalSeparator: char = '.';
  ThousandSeparator: char = ',';
  Aktion: byte = 0;
  InitialKeyHandlingReply: byte = 0;
  InitialKeyImage: byte = 0; (* 0=Lupe/Check, 1=Aktenmappe/Dialog,
                                2=Hkchen/OK, 3=Maus              *)
  InitialKeyChecked: boolean = false;
  minInitialKey: longint = 8;
  RandomKeyOperation: boolean = false;
  ExitInitialKey: boolean = false;
  CodDateiArtReply: byte = 0;
  CodStatus: byte = 0;
  ExpDateiArt: byte = 1;
  ExpStatus: byte = 0;
{$if Safety>1}
  CompDateiKeyHandlingReply: byte = 0;
  CompDateiKeyImage: byte = 0; (* 0=Lupe/Check, 1=Aktenmappe/Dialog,
                                  2=Hkchen/OK, 3=sonst              *)
  CompDateiKeyS: string = '';
  CompDateiKeyChecked: boolean = false;
  ExitCompDateiKey: boolean = false;
  Exit2CompDateiKey: boolean = false;
  ClickCompDateiKey: boolean = false;
{$endif Safety>1}
  OvlLimitPosVonS: string = '1';
  OvlLimitOValVonS: string = '0';
  OvlLimitKValVonS: string = '0';
{$if Gruppe=1}
  OvlLimitPosBisS: string = '256';
  OvlLimitOValBisS: string = '255';
  OvlLimitKValBisS: string = '255';
{$elseif Gruppe=2}
  OvlLimitPosBisS: string = '65536';
  OvlLimitOValBisS: string = '65535';
  OvlLimitKValBisS: string = '65535';
{$else Gruppe=3}
  OvlLimitPosBisS: string = '16777216';
  OvlLimitOValBisS: string = '16777215';
  OvlLimitKValBisS: string = '16777215';
{$endif Gruppe}
  ExitOvlLimitPos: boolean = false;
  ExitOvlLimitOVal: boolean = false;
  ExitOvlLimitKVal: boolean = false;
  OvlIterationS: string = '0';
  MaxIteration: longint = 99999999;
  lgMI = 8; (* Ziffernanzahl von 'MaxIteration' *)
  OvlInfoHandlingReply: byte = 0;
  OvlInfoImage: byte = 0; (* 0=Lupe/Check, 1=Aktenmappe/Dialog,*)
  OvlInfoS: string = '';               (*\ 2=Hkchen/OK        *)
  OvlInfoChecked: boolean = false;
  OvlInfoArtReply: byte = 0;
  ExitOvlInfo: boolean = false;
  ParDateiUseReply: byte = 0;
  ParDateiOpKeyHandlingReply: byte = 0;
  ParDateiOpKeyImage: byte = 0; (* 0=Lupe/Check, 1=Aktenmappe/Dialog,*)
  ParDateiOpKeyS: string = ''; (*\ 2=Hkchen/OK, 3=sonst             *)
  ParDateiOpKeyChecked: boolean = false;
  ExitParDateiOpKey: boolean = false;
  Exit2ParDateiOpKey: boolean = false;
  ClickParDateiOpKey: boolean = false;
  TimeOutHandlingReply: byte = 0;
  TimeOutMaskGap: string = '                              ';
  ExitTimeOutMask: boolean = false;
  ParDateiClsKeyHandlingReply: byte = 0;
  ParDateiClsKeyImage: byte = 0; (* 0=Lupe/Check, 1=Aktenmappe/Dialog,*)
  ParDateiClsKeyS: string = ''; (*\ 2=Hkchen/OK, 3=sonst             *)
  ParDateiClsKeyChecked: boolean = false;
  ExitParDateiClsKey: boolean = false;
  Exit2ParDateiClsKey: boolean = false;
  ClickParDateiClsKey: boolean = false;
(*minParDateiKey: longint = 8;*)
{$if Test=1}
  AllEnterCount: longint = 0;
  EnterCount: longint = 0;
  AllExitCount: longint = 0;
  ExitCount: longint = 0;
{$endif Test=1}
type
 paramblock =
  record
   OvlIteration, UPosi, OPosi, UWert, OWert, USWert, OSWert: longint;
  end;
const
  P: paramblock = (OvlIteration: 0; UPosi: 1; OPosi: KeyAnzahl;
         UWert: 0; OWert: KeyAnzahlS1; USWert: 0; OSWert: KeyAnzahlS1);
(*---------------------*)
  {$I MGRECOD.PAS}
var
  MG: array [0..maxLanguage] of mldtext; cvar; external;
  TimeOutWarnLim: longint;
  Sprache: byte; cvar; external;
  ProgName: string; cvar; external;
  InitialKeyCheckedS: boolean;
  InitialKeyOK_Visible: boolean;
  InitialKeyCheck_Visible: boolean;
  InitialKeyImageS: byte;
  InitialKeyHexS: boolean;
  InitialKeyS: string;
  RandomKey: longint;
  RandomKeyE1: longint;
  RandomKeyE2: longint;
{$if Gruppe=2}
  RandomModus: byte;
  X1, Y1, T1, T2: longint;
{$elseif Gruppe=3}
  RandomModus: byte;
  PaarXY: byte;
  X1, Y1, X2, Y2, T1, T2, sX, sY: longint;
{$endif Gruppe}
  Random_angehalten: boolean;
  RandomMouseDown: boolean;
  RandomAnz: longint;
{$if Safety>1}
  CompDateiKeyCheckedS: boolean;
  CompDateiKeyOK_Visible: boolean;
  CompDateiKeyCheck_Visible: boolean;
  CompDateiKeyImageS: byte;
  CompDateiKeyHexS: boolean;
{$endif Safety>1}
  ParDateiOpKeyCheckedS: boolean;
  ParDateiOpKeyOK_Visible: boolean;
  ParDateiOpKeyCheck_Visible: boolean;
  ParDateiOpKeyImageS: byte;
  ParDateiOpKeyHexS: boolean;
  ParDateiClsKeyCheckedS: boolean;
  ParDateiClsKeyOK_Visible: boolean;
  ParDateiClsKeyCheck_Visible: boolean;
  ParDateiClsKeyImageS: byte;
  ParDateiClsKeyHexS: boolean;
  eolStr: string;
  DtnHandle: longint;
  saveDatei: boolean;
  DateiSName, Zeile: string;
  BlockPos: longint;
{$if Test=1}
  Ausg: text;
{$endif Test=1}
(*---------------------*)
  {$I GETTIME.PAS}
  {$I GETDATEL.PAS}
  {$I FormatLE.PAS}
(*---------------------*
 *     numLongint
 *---------------------*)
function numLongint(IStrV: string; var IntegerV: longint): boolean;
var
 Fehler: word;
begin
 IntegerV := 0;
 val(IStrV,IntegerV,Fehler);
 numLongint := (Fehler=0)
end;  (*--- numLongint ---*)
(*---------------------*
 *       numWord
 *---------------------*)
function numWord(IStrV: string; var IntegerV: word): boolean;
var
 Fehler: word;
begin
 IntegerV := 0;
 val(IStrV,IntegerV,Fehler);
 numWord := (Fehler=0)
end;  (*--- numWord ---*)
(*---------------------*
 *      SetTimeOut
 *---------------------*)
procedure TFMain.SetTimeOut(Feld: TMaskEdit; const deltaMin: int64);
var
  Jetzt: TDateTime;
  Jahr, Monat, WTag, Stunde, Minute, Sekunde, Millisekunde: word;
begin
  Jetzt := IncMinute(now,deltaMin);{akt. Zeit + n Minuten als neue Zeit}
  DecodeDateTime(Jetzt,Jahr,Monat,WTag,Stunde,Minute,Sekunde,
                 Millisekunde);
  Feld.Text := makeDateN(Jahr,Monat,WTag)+','+makeTimeN(Stunde,Minute);
                                               {die neue Zeit zuweisen}
end;  (*--- SetTimeOut ---*)
(*---------------------*
 *      ChkTimeOut
 *---------------------*)
procedure TFMain.ChkTimeOut(Feld: TMaskEdit; const deltaMin: int64);
var
  OK: byte;
  Jetzt, Limit: TDateTime;
  Jahr, Monat, WTag, Stunde, Minute, Sekunde, Millisekunde,
    JJahr: word;
  SJahr, SMonat, STag, SStunde, SMinute,
    Sep1, Sep2, SepDZ, SepSM,
    SJetzt, SLimit: string;
begin
  SLimit := Feld.Text;
  getDateS(SLimit,SJahr,SMonat,STag,Sep1,Sep2);
  SepDZ := Copy(SLimit,11,1);
  getTimeS(Copy(SLimit,12,5),SStunde,SMinute,SepSM);
  Jetzt := now;
  DecodeDateTime(Jetzt,Jahr,Monat,WTag,Stunde,Minute,Sekunde,
                 Millisekunde);
  JJahr := Jahr;
  SJetzt := makeDateN(Jahr,Monat,WTag)+','+makeTimeN(Stunde,Minute);
  Sekunde := 0;
  Millisekunde := 0;
  OK := 0;  {='Zeitangabe ungltig'}
  if numWord(STag,WTag) and
     numWord(SMonat,Monat) and
     numWord(SJahr,Jahr) then
   if numWord(SStunde,Stunde) and
      numWord(SMinute,Minute) then
    if TryEncodeDate(Jahr,Monat,WTag,Limit) then
     if TryEncodeTime(Stunde,Minute,Sekunde,Millisekunde,Limit) then
      begin
       TryEncodeDateTime(Jahr,Monat,WTag,
                         Stunde,Minute,Sekunde,Millisekunde,Limit);
       if (JJahr<=Jahr) and            {'CompareDateTime' tut nur fr }
          (CompareDateTime(Jetzt,Limit)<0) then {  Jahresangaben>1899 }
        begin
         if (Sep1<>DateSeparator) or (Sep2<>DateSeparator) or
            (SepDZ<>',') or (SepSM<>TimeSeparator) then
          begin {Trennzeichen ungltig}
           with MG[Sprache] do
             Application.MessageBox(PChar(FormatLE(TLimSepErr,[SLimit]))
               ,PChar(TLimHdErr),48);
         { MessageBoxCall := true; }
           SLimit := makeDateS(SJahr,SMonat,STag)
                     +','+makeTimeS(SStunde,SMinute);
           Feld.Text := SLimit;
          end;
         OK := 1;  {='Zeitangabe gltig'}
        end
       else {Limit < Jetzt}
        begin
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(TLimGTCurr,
             [SLimit,SJetzt])),PChar(TLimHdErr),16);
       { MessageBoxCall := true; }
        end;
      end
     else {falsche Zeitangabe}
      begin
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(TLimInvTime,
           [Copy(SLimit,12,5)])),PChar(TLimHdErr),16);
     { MessageBoxCall := true; }
      end
    else {falsche Datumsangabe}
     begin
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(TLimInvDate,
          [Copy(SLimit,1,10)])),PChar(TLimHdErr),16);
    { MessageBoxCall := true; }
     end
   else {Zeitangabe nicht numerisch}
    begin
     with MG[Sprache] do
       Application.MessageBox(PChar(FormatLE(TLimNonTime,
         [Copy(SLimit,12,5)])),PChar(TLimHdErr),16);
   { MessageBoxCall := true; }
    end
  else {Datumsangabe nicht numerisch}
   begin
    with MG[Sprache] do
      Application.MessageBox(PChar(FormatLE(TLimNonDate,
        [Copy(SLimit,1,10)])),PChar(TLimHdErr),16);
  { MessageBoxCall := true; }
   end;
  if OK=0 then
    SetTimeOut(Feld,deltaMin);
end;  (*--- ChkTimeOut ---*)

procedure TFMain.ShowCursorPos(Feld: TEdit);
begin
 with MG[Sprache] do
  if Feld.Tag>=FocusTag then {falls das Feld den Fokus hat}
   if Feld.SelLength=0 then
     FMain.StatusBar.Panels.Items[0].Text :=
       FormatLE(StmCurPos,[(Feld.SelStart+1)])
   else
     FMain.StatusBar.Panels.Items[0].Text := FormatLE(StmCurRange,
                    [(Feld.SelStart+1),(Feld.SelStart+Feld.SelLength)]);
end;

procedure TFMain.DelCursorPos();
begin
 StatusBar.Panels.Items[0].Text := ''; {Cursor-Anzeige lschen}
end;

procedure TFMain.EnterHidedField(Feld: TEdit; var Inhalt: string);
begin
  Feld.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
  Feld.Font.Color := Feld.Color; { Feldinhalt "unsichtbar" }
  Feld.Text := Inhalt; { Feldinhalt wieder herstellen }
  Feld.SelLength := 0; {sonst ist der Inhalt ggf. markiert und        }
  Feld.Hint := FormatLE(MG[Sprache].ShowHideHint); {\ damit sichtbar !}
  Feld.ShowHint := true;
end;

procedure TFMain.EnterHidedField(Feld: TEdit);
begin
  Feld.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
  Feld.Font.Color := Feld.Color; { Feldinhalt "unsichtbar" }
  Feld.EchoMode := emNormal; { Feldinhalt wieder herstellen }
  Feld.PasswordChar := #0;
  Feld.SelLength := 0; {sonst ist der Inhalt ggf. markiert und       }
  Feld.Hint := FormatLE(MG[Sprache].ShowHideHint);{\ damit sichtbar !}
  Feld.ShowHint := true;
end;

procedure TFMain.ShowHideContents(Feld: TEdit; ColorFeld: TLabel;
                                  X,Y: integer);
begin
  if (Feld.Tag>=FocusTag) then {falls das Feld den Fokus hat}
   if (X<=5) or (X>=Feld.Width-7) or{falls Cursor nicht im Kernbereich:}
      (Y<=5) or (Y>=Feld.Height-7) then
     Feld.Font.Color := Feld.Color { Feldinhalt "unsichtbar" }
   else                { falls Cursor im Kernbereich: }
     Feld.Font.Color := ColorFeld.Font.Color; {Feldinhalt und damit}
end;                                          {Inhalt "sichtbar"   }

procedure TFMain.ShowHideContents(Feld: TEdit; ColorFeld: TLabel;
                                  X,Y, loX,hiX, loY,hiY: integer);
begin
  if (Feld.Tag>=FocusTag) then {falls das Feld den Fokus hat}
   if (X<=loX) or (X>=Feld.Width-hiX) or { falls Cursor nicht im }
      (Y<=loY) or (Y>=Feld.Height-hiY) then       {\ Kernbereich:}
     Feld.Font.Color := Feld.Color { Feldinhalt "unsichtbar" }
   else                { falls Cursor im Kernbereich: }
     Feld.Font.Color := ColorFeld.Font.Color; {Feldinhalt und damit}
end;                                          {Inhalt "sichtbar"   }

procedure TFMain.ExitHidedField(Feld: TEdit; ColorFeld: TLabel);
begin
  if Feld.Tag>=FocusTag then {falls das Feld den Fokus hat}
   begin
    Feld.ShowHint := false;
    Feld.Font.Color := Feld.Color;  { Feldinhalt "unsichtbar": nur
    deshalb, weil sonst die Umschaltung in den Passwort-Modus ignoriert
    wird, falls 'Font.Color' unverndert bleibt !}
    Feld.EchoMode := emPassword; {Feldinhalt mit Sternen berschreiben}
    Feld.PasswordChar := '*';
    Feld.Font.Color := ColorFeld.Font.Color;{Stern-Feldinhalt"sichtbar"}
    Feld.Tag := 0;  {anzeigen, dass das Feld den Fokus nicht mehr hat}
   end;
end;

procedure TFMain.ExitHidedField(Feld: TEdit; ColorFeld: TLabel;
                                var Inhalt: string; fix: integer);
begin
  if Feld.Tag>=FocusTag then {falls das Feld den Fokus hat}
   begin
    Feld.ShowHint := false;
    Feld.Font.Color := Feld.Color;  { Feldinhalt "unsichtbar": nur
    deshalb, weil sonst die Umschaltung in den Passwort-Modus ignoriert
    wird, falls 'Font.Color' unverndert bleibt !}
    Inhalt := Feld.Text; {Feldinhalt sichern}
    Feld.Text := StringOfChar('*',fix); {Feld mit Sternen berschreiben}
    Feld.Font.Color := ColorFeld.Font.Color;{Stern-Feldinhalt"sichtbar"}
    Feld.Tag := 0;  {anzeigen, dass das Feld den Fokus nicht mehr hat}
   end;
end;

procedure TFMain.ClearMesBoxMouseDown(Feld: TEdit; ColorFeld: TLabel);
begin   {'ClearMesBoxMouseDown/Up' umgehen das 'MessageBox'-Problem}
 if MessageBoxCall then
  begin
   Feld.Font.Color := Feld.Color;
   Feld.EchoMode := emPassword; {Feldinhalt mit Sternen berschreiben}
   Feld.PasswordChar := '*';
   Feld.Font.Color := ColorFeld.Font.Color;
  end;
end;

procedure TFMain.ClearMesBoxMouseUp(Feld: TEdit);
begin   {'ClearMesBoxMouseDown/Up' umgehen das 'MessageBox'-Problem}
 if MessageBoxCall then
  begin
   Feld.Font.Color := Feld.Color; {Feldinhalt "unsichtbar"}
   Feld.EchoMode := emNormal; {Feldinhalt wieder herstellen}
   Feld.PasswordChar := #0;
   Feld.SelLength := 0; {hier nicht unbedingt notwendig}
   MessageBoxCall := false;
  end;
end;

procedure TFMain.ShowHelpFile(const HKeyword: string);
begin
  ShowHelpOrErrorForKeyword('',HKeyword);
end; (*
var
 Browser, Params: string;
begin
{$if System=0} [* nur wegen Geschwindigkeits-Problemen beim Aufruf !! *]
  Browser := 'C:\Windows\explorer.exe';
  Params := GetCurrentDir;
  if Params[Length(Params)]=SetDirSeparators('\') then
    Params := Copy(Params,1,Length(Params)-1);
  Params :=
    Params+AnsiUpperCase(SetDirSeparators('\'+MG[Sprache].HelpDir+'\')
    +Copy(HKeyword,5,255));
[*  +Copy(HKeyword,Length(HelpDb.KeywordPrefix)+1,255)); *]
{$else System=1}
  HelpBrowser.FindDefaultBrowser(Browser,Params);
  Params := Format(Params,[HelpDb.BaseURL+Copy(HKeyword,5,255)]);
[*          +Copy(HKeyword,Length(HelpDb.KeywordPrefix)+1,255)]); *]
{$endif System}
{$if Test=1}
  StatusBar.Panels.Items[0].Text := 'Browser='+Browser;
  StatusBar.Panels.Items[1].Text := 'Params='+Params;
{$endif Test=1}
  ExecuteProcess(Browser,Params);
end; *)

procedure TFMain.TimeOutUseClick(Sender: TObject);
begin
  ShowHelpFile(TimeOutUse.HelpKeyword);
end;

{======================================================================}

procedure TFMain.SprachBoxCloseUp(Sender: TObject);
var
  SLimit, SJahr, SMonat, STag, SStunde, SMinute, SepDZ: string;
begin
  TimeOutWarnLim := FMain.TOutWLim; { Time-out-Warnlimit zuweisen }
  if TimeOutUseB1Mask.Text<>'' then
   begin
    SLimit := TimeOutUseB1Mask.Text;
    getDateS(SLimit,SJahr,SMonat,STag);
    SepDZ := Copy(SLimit,11,1);
    getTimeS(Copy(SLimit,12,5),SStunde,SMinute);
   end;
  StatusBar.Panels.Items[0].Text := '';
  Sprache := SprachBox.ItemIndex;
  with MG[Sprache] do
   begin
    FMain.Caption := ProgName+Format(MainHead,[ElemBytes]);
    TimeSeparator := TimeSep[1];
    DateSeparator := DateSep[1];
    DateOrder := DateOrd;
    DecimalSeparator := DecimalSep[1];
    ThousandSeparator := ThousandSep[1];
    HelpDb.BaseURL := 'file://'+HelpDir+'/';
    StatusBar.Panels.Items[1].Text := StmHelp;
    if Sprache=0 then
      SprachBoxLabel.Caption := LangLbl+':'
    else
      SprachBoxLabel.Caption := MG[0].LangLbl+'/'+LangLbl+':';
    OpenDialogAus.Title := FormatLE(OpnOutTit);
    OpenDialogAus.Filter := FormatLE(OpnOutFil);
    AusDateiLabel.Caption := FormatLE(OutLblC);
    AusDateiHandlingLabel1.Caption := FormatLE(OutHLbl1);
    AusDateiHandlingLabel2.Caption := FormatLE(OutHLbl2);
    OperClear.Caption := FormatLE(OprClear);
    OperStart.Caption := FormatLE(OprStart);
    OperExit.Caption := FormatLE(OprExit);
    MessageLabel.Caption := FormatLE(MesLbl);
    if MessageMemo.Lines.Count<3 then
     begin
      MessageMemo.Lines.Clear;
      MessageMemo.Lines.Add(FormatLE(MesMem));
      MessageMemo.WordWrap := true;    { nur um die Zeile   }
        MessageMemo.WordWrap := false; { sichtbar zu machen }
     end;
    ActionHandlingLabel.Caption := FormatLE(ActHLbl);
    ActionHandlingB1Memo.Lines.Clear;
    ActionHandlingB1Memo.Lines.Add(FormatLE(ActHB1Mem));
    ActionHandlingB1Memo.Lines.Strings[0] := { nur um die Zeilen  }
      ActionHandlingB1Memo.Lines.Strings[0]; { sichtbar zu machen }
    ActionHandlingB2Memo.Lines.Clear;
    ActionHandlingB2Memo.Lines.Add(FormatLE(ActHB2Mem));
    ActionHandlingB2Memo.Lines.Strings[0] := { nur um die Zeilen  }
      ActionHandlingB2Memo.Lines.Strings[0]; { sichtbar zu machen }
    ActionHandlingB3Memo.Lines.Clear;
    ActionHandlingB3Memo.Lines.Add(FormatLE(ActHB3Mem));
    ActionHandlingB3Memo.Lines.Strings[0] := { nur um die Zeilen  }
      ActionHandlingB3Memo.Lines.Strings[0]; { sichtbar zu machen }
    ActionHandlingB4Memo.Lines.Clear;
    ActionHandlingB4Memo.Lines.Add(FormatLE(ActHB4Mem));
    ActionHandlingB4Memo.Lines.Strings[0] := { nur um die Zeilen  }
      ActionHandlingB4Memo.Lines.Strings[0]; { sichtbar zu machen }
    ActionHandlingB5Memo.Lines.Clear;
    ActionHandlingB5Memo.Lines.Add(FormatLE(ActHB5Mem));
    ActionHandlingB5Memo.Lines.Strings[0] := { nur um die Zeilen  }
      ActionHandlingB5Memo.Lines.Strings[0]; { sichtbar zu machen }
    InitialKeyKopfLabel.Caption := FormatLE(IKeyKLbl);
    InitialKeyHandlingB1.Caption := FormatLE(KeyHB1);
    InitialKeyHandlingB2.Caption := FormatLE(KeyHB2);
    InitialKeyHandlingB3.Caption := FormatLE(IKeyHB3);
    case InitialKeyHandlingReply of
     0: InitialKeyLabel.Caption := FormatLE(KeyLblR0);
     1: InitialKeyLabel.Caption := FormatLE(KeyLblR1);
     2:begin
        InitialKeyLabel.Caption := '';
        if InitialKeyOK.Visible then
          InitialKey.Text := FormatLE(IKeyTxtR2ok)
        else
          InitialKey.Text := FormatLE(IKeyTxtR2clk);
       end;
    end;
    InitialKeyHexLabel.Caption := FormatLE(KeyHexLbl);
    InitialKeyOvlLabel.Caption := FormatLE(IKeyOLbl);
    OpenDialogKey.Title := FormatLE(OpnKeyTit);
    OpenDialogKey.Filter := FormatLE(OpnKeyFil);
    OpenDialogOvl.Title := FormatLE(OpnOvlTit);
    OpenDialogOvl.Filter := FormatLE(OpnOvlFil);
    CodArtKopfLabel.Caption := FormatLE(CodAKLbl);
{$if Safety>0}
    CodStreamLabel.Caption := FormatLE(CodAHLblS);
{$endif Safety>0}
    CodArtHLabel1.Caption := FormatLE(CodAHLbl1);
    CodArtHLabel2.Caption := FormatLE(CodAHLbl2);
    CodArtVLabel1.Caption := FormatLE(CodAVLbl1);
    CodArtVLabel2.Caption := FormatLE(CodAVLbl2);
    CodStatsLabel.Caption := FormatLE(CodStaLbl);
    CodDateiArt.Caption := FormatLE(DatKind);
    CodDateiArtB1Memo.Lines.Clear;
    CodDateiArtB1Memo.Lines.Add(FormatLE(DatKindB1Mem));
    CodDateiArtB1Memo.Lines.Strings[0] := { nur um die Zeilen  }
      CodDateiArtB1Memo.Lines.Strings[0]; { sichtbar zu machen }
    CodDateiArtB2Memo.Lines.Clear;
    CodDateiArtB2Memo.Lines.Add(FormatLE(DatKindB2Mem));
    CodDateiArtB2Memo.Lines.Strings[0] := { nur um die Zeilen  }
      CodDateiArtB2Memo.Lines.Strings[0]; { sichtbar zu machen }
    CodDateiArtB3Memo.Lines.Clear;
    CodDateiArtB3Memo.Lines.Add(FormatLE(DatKindB3Mem));
    CodDateiArtB3Memo.WordWrap := true;    { nur um die Zeile   }
      CodDateiArtB3Memo.WordWrap := false; { sichtbar zu machen }
    if not CodDateiPanel.Enabled then {Systemfehler-Korrektur:}
     begin    {Text wird danach sonst 'unenabled' dargestellt!}
      CodDateiPanel.Enabled := true;
      CodDateiPanel.Enabled := false;
     end
    else
     if not CodDateiArtPanel.Enabled then
      begin
       CodDateiArtPanel.Enabled := true;
       CodDateiArtPanel.Enabled := false;
      end
     else
      if not CodDateiArt.Enabled then
       begin
        CodDateiArt.Enabled := true;
        CodDateiArt.Enabled := false;
       end;
    CodDateiArtB4Memo.Lines.Clear;
    CodDateiArtB4Memo.Lines.Add(FormatLE(DatKindB4Mem));
    CodDateiArtB4Memo.Lines.Strings[0] := { nur um die Zeilen  }
      CodDateiArtB4Memo.Lines.Strings[0]; { sichtbar zu machen }
    OpenDialogCod.Title := FormatLE(OpnCodTit);
    OpenDialogDtn.Title := FormatLE(OpnDtnTit);
    OpenDialogDtn.Filter := FormatLE(OpnDtnFil);
    case CodDateiArtReply of
     0: CodDateiLabel.Caption := FormatLE(DatCod);
     1: case CodStatus of
         0: CodDateiLabel.Caption := FormatLE(DatCovDat);
         1: CodDateiLabel.Caption := FormatLE(DtnEdtdat);
        end;
     2: CodDateiLabel.Caption := FormatLE(DatDir);
     3: CodDateiLabel.Caption := FormatLE(DatDirSub);
    end;
    DtnOpen.Caption := FormatLE(DtnOpn);
    DtnClose.Caption := FormatLE(DtnClo);
    DtnSave.Caption := FormatLE(DtnSav);
    DtnInsert.Caption := FormatLE(DtnIns);
    DtnDelete.Caption := FormatLE(DtnDel);
    DtnPlaceUp.Caption := FormatLE(DtnPup);
    DtnPlaceDown.Caption := FormatLE(DtnPdw);
    OpenDialogExn.Title := FormatLE(OpnExnTit);
    OpenDialogExn.Filter := FormatLE(OpnExnFil);
    case ExpStatus of
     0: ExpDateiLabel.Caption := FormatLE(DatExpDat);
     1: ExpDateiLabel.Caption := FormatLE(DtnEdtdat);
    end;
    ExpOpen.Caption := FormatLE(DtnOpn);
    ExpClose.Caption := FormatLE(DtnClo);
    ExpSave.Caption := FormatLE(DtnSav);
    ExpInsert.Caption := FormatLE(DtnIns);
    ExpDelete.Caption := FormatLE(DtnDel);
    ExpPlaceUp.Caption := FormatLE(DtnPup);
    ExpPlaceDown.Caption := FormatLE(DtnPdw);
{$if Safety<2}
    CodDateiConfMemo.Lines.Clear;
    CodDateiConfMemo.Lines.Add(FormatLE(DatCopyMem));
    CodDateiConfMemo.Lines.Strings[0] := { nur um die Zeilen  }
      CodDateiConfMemo.Lines.Strings[0]; { sichtbar zu machen }
{$else Safety>1}
    CompDateiGroup.Caption := FormatLE(PdatCompLbl);
    CompDateiOnlyLabel.Caption := FormatLE(PdatOnlyLbl);
    CompDateiKeyHandling.Caption := FormatLE(PdatOpKHS);
    CompDateiKeyHandlingB1.Caption := FormatLE(KeyHB1);
    CompDateiKeyHandlingB2.Caption := FormatLE(KeyHB2);
    CompDateiKeyHandlingB3.Caption := FormatLE(KeyHB3);
    case CompDateiKeyHandlingReply of
     0: CompDateiKeyLabel.Caption := FormatLE(KeyLblR0);
     1: CompDateiKeyLabel.Caption := FormatLE(KeyLblR1);
     2:begin
        CompDateiKeyLabel.Caption := '';
        CompDateiKey.Text := FormatLE(PdatKeyTxtR2);
       end;
    end;
    CompDateiKeyHexLabel.Caption := FormatLE(KeyHexLbl);
{$endif Safety}
    OvlKopfLabel.Caption := FormatLE(OvlKLbl);
    OvlLimitPosLabel1.Caption := FormatLE(OvlLimPosLbl1);
    OvlLimitPosLabel2.Caption := FormatLE(OvlLimPosLbl2);
    OvlLimitOValLabel1.Caption := FormatLE(OvlLimOValLbl1);
    OvlLimitOValLabel2.Caption := FormatLE(OvlLimOValLbl2);
    OvlLimitKValLabel1.Caption := FormatLE(OvlLimKValLbl1);
    OvlLimitKValLabel2.Caption := FormatLE(OvlLimKValLbl2);
    OvlLimitVonLabel.Caption := FormatLE(OvlLimVonLbl);
    OvlLimitLabel.Caption := FormatLE(OvlLimLbl);
    OvlLimitBisLabel.Caption := FormatLE(OvlLimBisLbl);
    OvlSyntaxB1.Caption := FormatLE(OvlSynB1);
    OvlSyntaxB2.Caption := FormatLE(OvlSynB2);
    OvlSyntaxHinweis1.Caption := FormatLE(OvlSynH1);
    OvlSyntaxHinweis2.Caption := FormatLE(OvlSynH2);
    OvlPosArt.Caption := FormatLE(OvlPosA);
    OvlPosArtB1.Caption := FormatLE(OvlPosAB1);
    OvlPosArtB2.Caption := FormatLE(OvlPosAB2);
    OvlValArt.Caption := FormatLE(OvlValA);
    OvlValArtB1.Caption := FormatLE(OvlValAB1);
    OvlValArtB2.Caption := FormatLE(OvlValAB2);
    OvlValArtB3.Caption := FormatLE(OvlValAB3);
    OvlInfoHandling.Caption := FormatLE(OvlInfH);
    if OvlIteration.Visible then
     begin
      OvlInfoSave.Caption := FormatLE(OvlInfS);
      OvlInfoSLbl.Caption := '\'+FormatLE(OvlInfS2);
     end
    else
     begin
      OvlInfoSave.Caption := FormatLE(OvlInfS+' '+OvlInfS2);
      OvlInfoSLbl.Caption := '';
     end;
    OvlIterationLabel.Caption := FormatLE(OvlItLbl);
    if OvlInfoHandling.Checked then
      OvlInfoLabel.Caption := FormatLE(OvlILblDat)
    else
      OvlInfoLabel.Caption := FormatLE(OvlILblInf);
    ParDateiKopfLabel.Caption := FormatLE(PdatKLbl);
    OpenDialogPar.Title := FormatLE(OpnParTit);
    OpenDialogPar.Filter := FormatLE(OpnParFil);
    ParDateiLabel.Caption := FormatLE(PdatLbl);
    ParDateiUse.Caption := FormatLE(PdatUse);
    ParDateiUseB1Memo.Lines.Clear;
    ParDateiUseB1Memo.Lines.Add(FormatLE(PdatUseB1Mem));
    ParDateiUseB1Memo.WordWrap := true;    { nur um die Zeile   }
      ParDateiUseB1Memo.WordWrap := false; { sichtbar zu machen }
    if not ParDateiPanel.Enabled then {Systemfehler-Korrektur:}
     begin    {Text wird danach sonst 'unenabled' dargestellt!}
      ParDateiPanel.Enabled := true;
      ParDateiPanel.Enabled := false;
     end
    else
     if not ParDateiUseBox.Enabled then
      begin
       ParDateiUseBox.Enabled := true;
       ParDateiUseBox.Enabled := false;
      end;
    ParDateiUseB2Memo.Lines.Clear;
    ParDateiUseB2Memo.Lines.Add(FormatLE(PdatUseB2Mem));
    ParDateiUseB2Memo.Lines.Strings[0] := { nur um die Zeilen  }
      ParDateiUseB2Memo.Lines.Strings[0]; { sichtbar zu machen }
{$if Safety>0}
    if (Aktion=4) and CodStream.Checked then
      ParDateiOpKeyHandling.Caption := FormatLE(PdatOpKHS)
    else
{$endif Safety>0}
      ParDateiOpKeyHandling.Caption := FormatLE(PdatOpKH);
    ParDateiOpKeyHandlingB1.Caption := FormatLE(KeyHB1);
    ParDateiOpKeyHandlingB2.Caption := FormatLE(KeyHB2);
    ParDateiOpKeyHandlingB3.Caption := FormatLE(KeyHB3);
    case ParDateiOpKeyHandlingReply of
     0: ParDateiOpKeyLabel.Caption := FormatLE(KeyLblR0);
     1: ParDateiOpKeyLabel.Caption := FormatLE(KeyLblR1);
     2:begin
        ParDateiOpKeyLabel.Caption := '';
        ParDateiOpKey.Text := FormatLE(PdatKeyTxtR2);
       end;
    end;
    ParDateiOpKeyHexLabel.Caption := FormatLE(KeyHexLbl);
    TimeOutUse.Caption := FormatLE(TLimUse);
    TimeOutUseB1.Caption := TimeOutMaskGap+'('
      +makeDateS(TLimYear,TLimMonth,TLimDay)+','
      +makeTimeS(TLimHour,TLimMinut)+FormatLE(TLimUseB1);
    TimeOutUseB2.Caption := FormatLE(TLimUseB2)
      +makeDateS('9999','99','99')+','+makeTimeS('99','99')+''')';
    TimeOutHandling.Caption := FormatLE(TLimH);
    TimeOutHandlingB1Memo.Lines.Clear;
    TimeOutHandlingB1Memo.Lines.Add(FormatLE(TLimHB1));
    TimeOutHandlingB1Memo.Lines.Strings[0] := { nur um die Zeilen  }
      TimeOutHandlingB1Memo.Lines.Strings[0]; { sichtbar zu machen }
    TimeOutHandlingB2Memo.Lines.Clear;
    TimeOutHandlingB2Memo.Lines.Add(FormatLE(TLimHB2));
    TimeOutHandlingB2Memo.WordWrap := true;    { nur um die Zeile   }
      TimeOutHandlingB2Memo.WordWrap := false; { sichtbar zu machen }
    if not ParDateiPanel.Enabled then {Systemfehler-Korrektur:}
     begin    {Text wird danach sonst 'unenabled' dargestellt!}
      ParDateiPanel.Enabled := true;
      ParDateiPanel.Enabled := false;
     end
    else
     if not TimeOutHandling.Enabled then
      begin
       TimeOutHandling.Enabled := true;
       TimeOutHandling.Enabled := false;
      end;
    ParDateiClsKeyHandling.Caption := FormatLE(PdatClsKH);
{$if Safety>1}
    ParDateiClsKeyStwLabel.Caption := FormatLE(PdatClsInv);
{$endif Safety>1}
    ParDateiClsKeyHandlingB1.Caption := FormatLE(KeyHB1);
    ParDateiClsKeyHandlingB2.Caption := FormatLE(KeyHB2);
    ParDateiClsKeyHandlingB3.Caption := FormatLE(KeyHB3);
    case ParDateiClsKeyHandlingReply of
     0: ParDateiClsKeyLabel.Caption := FormatLE(KeyLblR0);
     1: ParDateiClsKeyLabel.Caption := FormatLE(KeyLblR1);
     2:begin
        ParDateiClsKeyLabel.Caption := '';
        ParDateiClsKey.Text := FormatLE(PdatKeyTxtR2);
       end;
    end;
    ParDateiClsKeyHexLabel.Caption := FormatLE(KeyHexLbl);
    if TimeOutUseB1Mask.Text<>'' then
      TimeOutUseB1Mask.Text :=
        makeDateS(SJahr,SMonat,STag)+SepDZ+makeTimeS(SStunde,SMinute);
   end
end;

procedure TFMain.AusDateiDialogClick(Sender: TObject);
begin
  OpenDialogAus.FileName := '*.out';
  if OpenDialogAus.Execute then
    AusDatei.Text := OpenDialogAus.FileName;
end;

procedure TFMain.OperClearClick(Sender: TObject);
begin
  AusDatei.Text := '';
  AusDateiHandling.Checked := false;
  MessageMemo.Lines.Clear;
  MessageMemo.Lines.Add(FormatLE(MG[Sprache].MesMem));
  MessageMemo.WordWrap := true;    { nur um die Zeile   }
    MessageMemo.WordWrap := false; { sichtbar zu machen }
  ActionHandlingB1.Checked := true;
  InitialKeyHandlingB1.Checked := true;
  InitialKey.Text := '';
  InitialKeyHex.Checked := false;
  InitialKeyOvl.Checked := false;
  CodArt.ItemIndex := 0;
  CodStats.Checked := false;
{$if Safety>0}
  CodStream.Checked := false;
{$endif Safety>0}
  CodDateiArtB1.Checked := true;
  CodDatei.Text := '';
  CodStatus := 0; {nur vorsorglich}
  ExpDatei.Text := '';
  ExpStatus := 0; {nur vorsorglich}
{$if Safety<2}
  CodDateiConf.Checked := false;
{$else Safety>1}
  CompDatei.Text := '';
  CompDateiOnly.Checked := false;
  CompDateiKeyHandlingB1.Checked := true;
  CompDateiKey.Text := '';
  CompDateiKeyS := '';
  CompDateiKeyHex.Checked := false;
{$endif Safety}
  OvlLimitPosVonS := '1';
  OvlLimitPosBisS := Format('%D',[KeyAnzahl]);
  OvlLimitOValVonS := '0';
  OvlLimitOValBisS := Format('%D',[KeyAnzahlS1]);
  OvlLimitKValVonS := '0';
  OvlLimitKValBisS := Format('%D',[KeyAnzahlS1]);
  P.UPosi := 1;
  P.OPosi := KeyAnzahl;
  P.UWert := 0;
  P.OWert := KeyAnzahlS1;
  P.USWert := 0;
  P.OSWert := KeyAnzahlS1;
  OvlSyntaxB2.Checked := true;
  OvlPosArtB1.Checked := true;
  OvlValArtB1.Checked := true;
  OvlInfoHandling.Checked := false;
  OvlInfo.Text := '';
  OvlInfoArtReply := 0;
  OvlIterationS := '0';
  P.OvlIteration := 0;
  ParDatei.Text := '';
  ParDateiUseB1.Checked := true;
  ParDateiOpKeyHandlingB1.Checked := true;
  ParDateiOpKey.Text := '';
  ParDateiOpKeyS := '';
  ParDateiOpKeyHex.Checked := false;
  TimeOutUseB1Mask.Text := '';
  TimeOutUseB1.Checked := true;
  TimeOutHandlingB1.Checked := true;
{$if Safety>1}
  ParDateiClsKeyStw.Checked := false;
{$endif Safety>1}
  ParDateiClsKeyHandlingB1.Checked := true;
  ParDateiClsKey.Text := '';
  ParDateiClsKeyS := '';
  ParDateiClsKeyHex.Checked := false;
  {nur vorsorglich:}
  ExitTimeOutMask := false;
  ExitOvlLimitPos := false;
  ExitOvlLimitOVal := false;
  ExitOvlLimitKVal := false;
  ExitParDateiOpKey := false;
  ExitParDateiClsKey := false;
{$if Safety>1}
  ExitCompDateiKey := false;
{$endif Safety>1}
  MessageBoxCall := false;
end;

procedure TFMain.OperExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFMain.OperStartClick(Sender: TObject);
var
  Jetzt, Limit: TDateTime;
  Jahr, Monat, WTag, Stunde, Minute, Sekunde, Millisekunde: word;
  SJahr, SMonat, STag, SStunde, SMinute,
    Sep1, Sep2, SepSM,
    SJetzt, SLimit: string;
  aw: longint;
begin
  { bergabe-Parameter berprfen }
  if AusDatei.Text='' then  {--- AusDatei ---}
   begin
    FMain.ActiveControl := AusDatei;
    with MG[Sprache] do
      Application.MessageBox(PChar(FormatLE(OutEmpty)),
                             PChar(OutHdErr),16);
    Exit;
   end;

  if InitialKeyPanel.Enabled then  {--- InitialKey ---}
   if InitialKeyHandlingB1.Checked then
    if InitialKey.Text='' then
     begin
      FMain.ActiveControl := InitialKey;
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(IKeyEmpty)),
                               PChar(IKeyHdErr),16);
      Exit;
     end
    else
     if (Length(InitialKey.Text)<minInitialKey) and
        (not InitialKeyOvl.Checked) then
      begin
       FMain.ActiveControl := InitialKey;
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(IKeyLenInv,
                                 [minInitialKey])),PChar(IKeyHdErr),16);
       Exit;
      end
     else
      if InitialKeyCheck.Visible then
       begin
        FMain.ActiveControl := InitialKey; {vorsorglich, falls 'Cancel'}
        with MG[Sprache] do
          aw := Application.MessageBox(PChar(FormatLE(IKeyNochk)),
                  PChar(IKeyHdWar),49);
        if aw=2 then  {'Cancel.'}
          Exit;
       end
      else
   else
    if InitialKeyHandlingB2.Checked then
     if InitialKey.Text='' then
      begin
       FMain.ActiveControl := InitialKey;
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(IKeyDatnEmpty)),
           PChar(IKeyHdDatErr),16);
       Exit;
      end
     else
      if not FileExists(ExpandFileName(InitialKey.Text)) then
       begin
        FMain.ActiveControl := InitialKey;
        with MG[Sprache] do
          Application.MessageBox(PChar(FormatLE(IKeyDatMis)),
            PChar(IKeyHdDatErr),16);
        Exit;
       end
      else
    else  {InitialKeyHandlingB3.Checked}
     if RandomAnz<minRandomAnz then
      begin
     { FMain.ActiveControl := InitialKey; }
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(IKeyRLenErr,
                               [minRandomAnz])),PChar(IKeyHdRanErr),16);
       Exit;
      end;

  if CodDateiPanel.Enabled then  {--- CodDateiPanel ---}
   begin
    if CodDatei.Text='' then  {--- CodDatei ---}
     begin
      FMain.ActiveControl := CodDatei;
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(DatEmpty)),
                               PChar(DatHdErr),16);
      Exit;
     end;
{$if Safety<2}
    if not CodDateiConf.Checked then  {--- CodDateiConf ---}
     begin
      FMain.ActiveControl := CodDateiConf;
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(DatConf)),
                               PChar(DatHdSErr),16);
      Exit;
     end;
{$else Safety>1}
    if CompDateiGroup.Enabled then  {--- CompDateiGroup ---}
     if CompDatei.Text<>'' then  {--- CompDatei ---}
      begin
       if not FileExists(ExpandFileName(CompDatei.Text)) then
        begin
         FMain.ActiveControl := CompDatei;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(PdatMis)),
             PChar(PdatHdErr),16);
         Exit;
        end;
       if CompDateiKeyHandlingB1.Checked then  {--- CompDateiKey ---}
    (*  if CompDateiKey.Text='' then
         begin
          FMain.ActiveControl := CompDateiKey;
          with MG[Sprache] do
            Application.MessageBox(PChar(FormatLE(OKeyEmpty)),
              PChar(OKeyHdErr),16);
          Exit;
         end
        else
         if Length(CompDateiKey.Text)<minParDateiKey then
          begin
           FMain.ActiveControl := CompDateiKey;
           with MG[Sprache] do
             Application.MessageBox(PChar(FormatLE(OKeyLenInv,
               [minParDateiKey])),PChar(OKeyHdErr),16);
           Exit;
          end
         else *)
          if CompDateiKeyCheck.Visible then
           begin
            FMain.ActiveControl := CompDateiKey;{vorsorglich,if'Cancel'}
            with MG[Sprache] do
              aw := Application.MessageBox(PChar(FormatLE(OKeyNochk)),
                      PChar(OKeyHdWar),49);
            if aw=2 then  {'Cancel.'}
              Exit;
           end
          else
       else
        if CompDateiKeyHandlingB2.Checked then
         if CompDateiKey.Text='' then
          begin
           FMain.ActiveControl := CompDateiKey;
           with MG[Sprache] do
             Application.MessageBox(PChar(FormatLE(OKeyDatnEmpty)),
               PChar(OKeyHdDatErr),16);
           Exit;
          end
         else
          if not FileExists(ExpandFileName(CompDateiKey.Text)) then
           begin
            FMain.ActiveControl := CompDateiKey;
            with MG[Sprache] do
              Application.MessageBox(PChar(FormatLE(OKeyDatMis)),
                PChar(OKeyHdDatErr),16);
            Exit;
           end
      end
     else  { CompDatei.Text='':     --- CompDatei ---}
      if CodStream.Checked and
         ((not ParDateiPanel.Enabled) or CompDateiOnly.Checked) then
       begin
        FMain.ActiveControl := CompDatei;
        with MG[Sprache] do
          Application.MessageBox(PChar(FormatLE(PdatCEmpty)),
            PChar(PdatHdErr),16);
        Exit;
       end;
{$endif Safety}
   end;

  if OverlayPanel.Enabled then  {--- OverlayPanel ---}
   if OvlInfoHandling.Checked then
    if OvlInfo.Text='' then
     begin
      FMain.ActiveControl := OvlInfo;
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(OvlDatnEmpty)),
          PChar(OvlHdDatErr),16);
      Exit;
     end
    else
     if OvlInfoArtReply=0 then {berladedatei}
      if not FileExists(ExpandFileName(OvlInfo.Text)) then
       begin
        FMain.ActiveControl := OvlInfo;
        with MG[Sprache] do
          Application.MessageBox(PChar(FormatLE(OvlDatMis)),
            PChar(OvlHdDatErr),16);
        Exit;
       end
      else
     else
      if OvlInfoArtReply=1 then {Dateinamen-Datei}
       begin
        if OvlInfo.Text[Length(OvlInfo.Text)]<>')' then
          OvlInfo.Text := OvlInfo.Text+')';
        if not FileExists(ExpandFileName(
                      Copy(OvlInfo.Text,2,Length(OvlInfo.Text)-2))) then
         begin
          FMain.ActiveControl := OvlInfo;
          with MG[Sprache] do
            Application.MessageBox(PChar(FormatLE(OvlDtnDatMis)),
              PChar(OvlHdDatErr),16);
          Exit;
         end
       end
      else {OvlInfoArtReply=2,3 --> Directory}
       begin
        if OvlInfoArtReply=2 then
         if OvlInfo.Text[Length(OvlInfo.Text)]<>']' then
           OvlInfo.Text := OvlInfo.Text+']'
         else
        else {OvlInfoArtReply=3}
         if OvlInfo.Text[Length(OvlInfo.Text)]<>'}' then
           OvlInfo.Text := OvlInfo.Text+'}';
        if not DirectoryExists(SetDirSeparators(OvlInfo.Text)) then
         begin
          FMain.ActiveControl := OvlInfo;
          with MG[Sprache] do
            Application.MessageBox(PChar(FormatLE(OvlDirMis)),
              PChar(OvlHdDatErr),16);
          Exit;
         end
       end
   else  {not OvlInfoHandling.Checked}
    if OvlInfo.Text='' then
     if Aktion<>2 then {fr eine bestehende Parameterdatei OK}
      begin
       FMain.ActiveControl := OvlInfo;
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(OvlEmpty)),
                                PChar(OvlHdErr),16);
       Exit;
      end
     else
    else
     if OvlInfoCheck.Visible then
      begin
       FMain.ActiveControl := OvlInfo; {vorsorglich, falls 'Cancel'}
       with MG[Sprache] do
         aw := Application.MessageBox(PChar(FormatLE(OvlNochk)),
                 PChar(OvlHdWar),49);
       if aw=2 then  {'Cancel.'}
         Exit;
      end;

  if ParDateiPanel.Enabled then  {--- ParDateiPanel ---}
   begin
    if ParDatei.Text='' then  {--- ParDatei ---}
     begin
      FMain.ActiveControl := ParDatei;
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(PdatEmpty)),
                               PChar(PdatHdErr),16);
      Exit;
     end
    else
     if ParDateiUseB2.Checked then
      if not FileExists(ExpandFileName(ParDatei.Text)) then
       begin
        FMain.ActiveControl := ParDatei;
        with MG[Sprache] do
          Application.MessageBox(PChar(FormatLE(PdatMis)),
            PChar(PdatHdErr),16);
        Exit;
       end;

    if ParDateiOpKeyGroup.Enabled then  {--- ParDateiOpKey ---}
     if ParDateiOpKeyHandlingB1.Checked then
  (*  if ParDateiOpKey.Text='' then
       begin
        FMain.ActiveControl := ParDateiOpKey;
        with MG[Sprache] do
          Application.MessageBox(PChar(FormatLE(OKeyEmpty)),
            PChar(OKeyHdErr),16);
        Exit;
       end
      else
       if Length(ParDateiOpKey.Text)<minParDateiKey then
        begin
         FMain.ActiveControl := ParDateiOpKey;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(OKeyLenInv,
             [minParDateiKey])),PChar(OKeyHdErr),16);
         Exit;
        end
       else *)
        if ParDateiOpKeyCheck.Visible then
         begin
          FMain.ActiveControl := ParDateiOpKey;{vorsorglich,if 'Cancel'}
          with MG[Sprache] do
            aw := Application.MessageBox(PChar(FormatLE(OKeyNochk)),
                    PChar(OKeyHdWar),49);
          if aw=2 then  {'Cancel.'}
            Exit;
         end
        else
     else
      if ParDateiOpKeyHandlingB2.Checked then
       if ParDateiOpKey.Text='' then
        begin
         FMain.ActiveControl := ParDateiOpKey;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(OKeyDatnEmpty)),
             PChar(OKeyHdDatErr),16);
         Exit;
        end
       else
        if not FileExists(ExpandFileName(ParDateiOpKey.Text)) then
         begin
          FMain.ActiveControl := ParDateiOpKey;
          with MG[Sprache] do
            Application.MessageBox(PChar(FormatLE(OKeyDatMis)),
              PChar(OKeyHdDatErr),16);
          Exit;
         end;

    if TimeOutUse.Enabled then  {--- TimeOutUseB1Mask ---}
     if TimeOutUseB1.Checked then
      begin
       SLimit := TimeOutUseB1Mask.Text;
       getDateS(SLimit,SJahr,SMonat,STag,Sep1,Sep2);
       getTimeS(Copy(SLimit,12,5),SStunde,SMinute,SepSM);
       Jetzt := now;
       DecodeDateTime(Jetzt,Jahr,Monat,WTag,Stunde,Minute,Sekunde,
                      Millisekunde);
       SJetzt :=makeDateN(Jahr,Monat,WTag)+','+makeTimeN(Stunde,Minute);
       Sekunde := 0;
       Millisekunde := 0;
       numWord(STag,WTag);
       numWord(SMonat,Monat);
       numWord(SJahr,Jahr);
       numWord(SStunde,Stunde);
       numWord(SMinute,Minute);
       TryEncodeDateTime(Jahr,Monat,WTag,
                         Stunde,Minute,Sekunde,Millisekunde,Limit);
       if CompareDateTime(Jetzt,Limit)>=0 then   {Limit < Jetzt}
        begin
         FMain.ActiveControl := TimeOutUseB1Mask;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(TLimGTCurr,
             [SLimit,SJetzt])),PChar(TLimHdErr),16);
         Exit;
        end
       else
        begin
         Jetzt := IncMinute(now,TimeOutWarnLim);{aktuelle Zeit + x Min.}
         if CompareDateTime(Jetzt,Limit)>0 then {    als Vergleichszeit}
          begin
           FMain.ActiveControl := TimeOutUseB1Mask;{vorsorgl,if'Cancel'}
           with MG[Sprache] do
             aw := Application.MessageBox(PChar(FormatLE(TLimLT,
                     [TimeOutWarnLim])),PChar(TLimHdWar),49);
           if aw=2 then  {'Cancel.'}
             Exit;
          end;
        end
      end;

    if ParDateiClsKeyGroup.Enabled then  {--- ParDateiClsKey ---}
     if ParDateiClsKeyHandlingB1.Checked then
   (* if ParDateiClsKey.Text='' then
       begin
        FMain.ActiveControl := ParDateiClsKey;
        with MG[Sprache] do
          Application.MessageBox(PChar(FormatLE(CKeyEmpty)),
            PChar(CKeyHdErr),16);
        Exit;
       end
      else
       if Length(ParDateiClsKey.Text)<minParDateiKey then
        begin
         FMain.ActiveControl := ParDateiClsKey;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(CKeyLenInv,
             [minParDateiKey])),PChar(CKeyHdErr),16);
         Exit;
        end
       else *)
        if ParDateiClsKeyCheck.Visible then
         begin
          FMain.ActiveControl := ParDateiClsKey;{vorsorglich,if'Cancel'}
          with MG[Sprache] do
            aw := Application.MessageBox(PChar(FormatLE(CKeyNochk)),
                    PChar(CKeyHdWar),49);
          if aw=2 then  {'Cancel.'}
            Exit;
         end
        else
     else
      if ParDateiClsKeyHandlingB2.Checked then
       if ParDateiClsKey.Text='' then
        begin
         FMain.ActiveControl := ParDateiClsKey;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(CKeyDatnEmpty)),
             PChar(CKeyHdDatErr),16);
         Exit;
        end
       else
        if not FileExists(ExpandFileName(ParDateiClsKey.Text)) then
         begin
          FMain.ActiveControl := ParDateiClsKey;
          with MG[Sprache] do
            Application.MessageBox(PChar(FormatLE(CKeyDatMis)),
              PChar(CKeyHdDatErr),16);
          Exit;
         end;
   end;
  { alle Elemente als nicht auswhlbar kennzeichnen }
  SprachBox.Enabled := false;
  AusDateiDialog.Enabled := false;
  AusDatei.Enabled := false;
  AusDateiHandling.Enabled := false;
  OperClear.Visible := false;
  OperStart.Visible := false;
  OperExit.Visible := false;
  ActionPanel.Enabled := false;
  ActionHandlingLabel.Enabled := false;
  InitialKeyPanel.Enabled := false;
  InitialKeyKopfLabel.Enabled := false;
  CodDateiPanel.Enabled := false;
  CodArtKopfLabel.Enabled := false;
  OverlayPanel.Enabled := false;
  OvlKopfLabel.Enabled := false;
  ParDateiPanel.Enabled := false;
  ParDateiKopfLabel.Enabled := false;
  MessageLabel.Caption := FormatLE(MG[Sprache].MesIni);
  MessageLabel.Visible := true;
  FRefresh.ShowModal;  {nur um die nderungen sichtbar zu machen}

  { bergabe-Parameter bereitstellen }
  if MessageMemo.Lines.Count<3 then
    MessageMemo.Lines.Clear;
  if InitialKeyHandlingB3.Checked then
   begin
    InitialKey.Enabled := true;      { den Zufallsschlssel }
    EnterHidedField(InitialKey,InitialKeyS);{  bereitstellen}
   end;
  if InitialKeyOvl.Checked then
   begin  {Overlay-Werte bereitstellen}
    EnterHidedField(OvlLimitPosVon,OvlLimitPosVonS);
    EnterHidedField(OvlLimitPosBis,OvlLimitPosBisS);
    EnterHidedField(OvlLimitOValVon,OvlLimitOValVonS);
    EnterHidedField(OvlLimitOValBis,OvlLimitOValBisS);
    EnterHidedField(OvlLimitKValVon,OvlLimitKValVonS);
    EnterHidedField(OvlLimitKValBis,OvlLimitKValBisS);
    EnterHidedField(OvlIteration,OvlIterationS);
   end;
  FMain.BorderIcons := [];

{==============================}
{--> CODING -Programmaufruf <--}
{==============================}
{$if Gruppe=1}
  Coding1Program;
{$elseif Gruppe=2}
  Coding2Program;
{$else Gruppe=3}
  Coding3Program;
{$endif Gruppe}

  FMain.BorderIcons := [biSystemMenu,biMinimize,biMaximize,biHelp];
  MessageLabel.Visible := false;
  if InitialKeyHandlingB3.Checked then
   begin {Zufallsschlssel-Text wieder herstellen}
    InitialKey.Text := FormatLE(MG[Sprache].IKeyTxtR2ok);
    ExitHidedField(InitialKey,InitialKeyLabel);
    InitialKey.PasswordChar := #0;
    InitialKey.EchoMode := emNormal;
    InitialKey.Enabled := false;
   end;
  if InitialKeyOvl.Checked then
   begin  {Overlay-Werte wieder mit Sternen berschreiben}
    ExitHidedField(OvlLimitPosVon,OvlLimitVonLabel,
                   OvlLimitPosVonS,lgKA);
    ExitHidedField(OvlLimitPosBis,OvlLimitBisLabel,
                   OvlLimitPosBisS,lgKA);
    ExitHidedField(OvlLimitOValVon,OvlLimitVonLabel,
                   OvlLimitOValVonS,lgKA);
    ExitHidedField(OvlLimitOValBis,OvlLimitBisLabel,
                   OvlLimitOValBisS,lgKA);
    ExitHidedField(OvlLimitKValVon,OvlLimitVonLabel,
                   OvlLimitKValVonS,lgKA);
    ExitHidedField(OvlLimitKValBis,OvlLimitBisLabel,
                   OvlLimitKValBisS,lgKA);
    ExitHidedField(OvlIteration,OvlIterationLabel,OvlIterationS,lgMI);
   end;
  { die Elemente wieder als auswhlbar kennzeichnen }
  SprachBox.Enabled := true;
  AusDateiDialog.Enabled := true;
  AusDatei.Enabled := true;
  AusDateiHandling.Enabled := true;
  OperClear.Visible := true;
  OperStart.Visible := true;
  OperExit.Visible := true;
  ActionPanel.Enabled := true;
  ActionHandlingLabel.Enabled := true;
  if (Aktion=0) or (Aktion=1) or (Aktion=3) then
   begin
    InitialKeyPanel.Enabled := true;
    InitialKeyKopfLabel.Enabled := true;
    if InitialKeyOvl.Checked then
     begin
      OverlayPanel.Enabled := true;
      OvlKopfLabel.Enabled := true;
     end;
   end;
  if (Aktion=0) or (Aktion=3) or (Aktion=4) then
   begin
    CodDateiPanel.Enabled := true;
    CodArtKopfLabel.Enabled := true;
{$if Safety<2}
    CodDateiConf.Checked := false;
{$endif Safety<2}
   end;
  if Aktion>0 then
   begin
    ParDateiPanel.Enabled := true;
    ParDateiKopfLabel.Enabled := true;
   end;
  FMain.WindowState := wsMaximized; (* nur damit die BorderIcons *)
  FMain.WindowState := wsNormal;    (* wieder sichbar werden !   *)
end;

procedure TFMain.MessageMemoMouseEnter(Sender: TObject);
begin
  if (MessageMemo.Lines.Count>=3) and
     (CodStatus=0) and
     (ExpStatus=0) then
   begin
    MessageMemo.Width := 1010;
    MessageMemo.Height := 630;
   end;
end;

procedure TFMain.MessageMemoMouseLeave(Sender: TObject);
begin
  MessageMemo.Width := 371;
  MessageMemo.Height := 94;
end;

procedure TFMain.ActionHandlingB1Change(Sender: TObject);
begin
 if ActionHandlingB1.Checked then
  begin
   Aktion := 0;
{$if Test=1}
   StatusBar.Panels.Items[0].Text :=
     'Aktion ='+Format('%.0N',[int(Aktion)]);
{$endif Test=1}
   ActionHandlingB1Memo.Color := clWindow;
   InitialKeyPanel.Enabled := true;
   InitialKeyKopfLabel.Enabled := true;
   case InitialKeyImage of
    0: InitialKeyCheck.Visible := true;
    1: InitialKeyDialog.Visible := true;
    2: InitialKeyOK.Visible := true;
    3: InitialKeyMaus.Visible := true;
   end;
   if InitialKeyHandlingReply=2 then
     InitialKeyHandlingB1.Checked := true;
   InitialKeyHandlingB3.Enabled := false;{'random key' nur      }
   CodDateiPanel.Enabled := true;       {\ falls Parameterdatei }
   CodArtKopfLabel.Enabled := true;
{$if Safety=1}
   CodStreamPanel.Enabled := false;
   CodStreamLabel.Enabled := false;
{$elseif Safety>1}
   CompDateiOnlyPanel.Enabled := false;
   CompDateiOnlyLabel.Enabled := false;
   CodStreamPanel.Enabled := true;
   CodStreamLabel.Enabled := true;
   if CodStream.Checked then
     CodStreamLabel.Font.Color := clRed
   else
     CodStreamLabel.Font.Color := clWindowText;
{$endif Safety>0}
   CodDateiDialog.Visible := true;
   ExpDateiDialog.Visible := true;
   case CodDateiArtReply of
    0: CodDateiArtB1Memo.Color := clWindow;
    1: CodDateiArtB2Memo.Color := clWindow;
    2: CodDateiArtB3Memo.Color := clWindow;
    3: CodDateiArtB4Memo.Color := clWindow;
   end;
   CodDatei.Color := clWindow;
   ExpDatei.Color := clWindow;
{$if Safety<2}
   if not CodDateiConf.Checked then
     CodDateiConfMemo.Color := clWindow;
{$else Safety>1}
   if CodStream.Checked then
    begin
     CompDateiDialog.Visible := true;
     case CompDateiKeyImage of
      0: CompDateiKeyCheck.Visible := true;
      1: CompDateiKeyDialog.Visible := true;
      2: CompDateiKeyOK.Visible := true;
     end
    end
   else                                  { nur wegen Systemproblemen }
     CompDateiKeyCheck.Visible := false; { beim Initialisieren !     }
{$endif Safety}
   if InitialKeyOvl.Checked then
    begin
     OverlayPanel.Enabled := true;
     OvlKopfLabel.Enabled := true;
     case OvlInfoImage of
      0: OvlInfoCheck.Visible := true;
      1: OvlInfoDialog.Visible := true;
      2: OvlInfoOK.Visible := true;
     end;
    end
   else
    begin
     OverlayPanel.Enabled := false;
     OvlKopfLabel.Enabled := false;
     case OvlInfoImage of
      0: OvlInfoCheck.Visible := false;
      1: OvlInfoDialog.Visible := false;
      2: OvlInfoOK.Visible := false;
     end;
    end;
   OvlInfoSave.Visible := false;
   OvlInfoSLbl.Visible := false;
{$if Safety>0}
   ParDateiOpKeyHandling.Caption := FormatLE(MG[Sprache].PdatOpKH);
{$endif Safety>0}
   ParDateiPanel.Enabled := false;
   ParDateiKopfLabel.Enabled := false;
   ParDateiDialog.Visible := false;
   case ParDateiOpKeyImage of
    0: ParDateiOpKeyCheck.Visible := false;
    1: ParDateiOpKeyDialog.Visible := false;
    2: ParDateiOpKeyOK.Visible := false;
   end;
   ParDateiClsKeyStwPanel.Visible := false;
   case ParDateiClsKeyImage of
    0: ParDateiClsKeyCheck.Visible := false;
    1: ParDateiClsKeyDialog.Visible := false;
    2: ParDateiClsKeyOK.Visible := false;
   end;
   case ParDateiUseReply of
    0: ParDateiUseB1Memo.Color := clActiveBorder;
    1: ParDateiUseB2Memo.Color := clActiveBorder;
   end;
   TimeOutUseB1Mask.Color := clActiveBorder;
   case TimeOutHandlingReply of
    0: TimeOutHandlingB1Memo.Color := clActiveBorder;
    1: TimeOutHandlingB2Memo.Color := clActiveBorder;
   end;
  end
 else
   ActionHandlingB1Memo.Color := clActiveBorder;
end;

procedure TFMain.ActionHandlingB2Change(Sender: TObject);
begin
 if ActionHandlingB2.Checked then
  begin
   Aktion := 1;
{$if Test=1}
   StatusBar.Panels.Items[0].Text :=
     'Aktion ='+Format('%.0N',[int(Aktion)]);
{$endif Test=1}
   ActionHandlingB2Memo.Color := clWindow;
   InitialKeyPanel.Enabled := true;
   InitialKeyKopfLabel.Enabled := true;
   case InitialKeyImage of
    0: InitialKeyCheck.Visible := true;
    1: InitialKeyDialog.Visible := true;
    2: InitialKeyOK.Visible := true;
    3: InitialKeyMaus.Visible := true;
   end;
   InitialKeyHandlingB3.Enabled := true;
{$if Safety>0}
   CodStreamPanel.Enabled := false;
   CodStreamLabel.Enabled := false;
{$endif Safety>0}
   CodDateiPanel.Enabled := false;
   CodArtKopfLabel.Enabled := false;
   CodDateiDialog.Visible := false;
   ExpDateiDialog.Visible := false;
   case CodDateiArtReply of
    0: CodDateiArtB1Memo.Color := clActiveBorder;
    1: CodDateiArtB2Memo.Color := clActiveBorder;
    2: CodDateiArtB3Memo.Color := clActiveBorder;
    3: CodDateiArtB4Memo.Color := clActiveBorder;
   end;
   CodDatei.Color := clActiveBorder;
   ExpDatei.Color := clActiveBorder;
{$if Safety<2}
   CodDateiConfMemo.Color := clActiveBorder;
{$else Safety>1}
   CompDateiDialog.Visible := false;
   case CompDateiKeyImage of
    0: CompDateiKeyCheck.Visible := false;
    1: CompDateiKeyDialog.Visible := false;
    2: CompDateiKeyOK.Visible := false;
   end;
{$endif Safety}
   if InitialKeyOvl.Checked then
    begin
     OverlayPanel.Enabled := true;
     OvlKopfLabel.Enabled := true;
     case OvlInfoImage of
      0: OvlInfoCheck.Visible := true;
      1: OvlInfoDialog.Visible := true;
      2: OvlInfoOK.Visible := true;
     end;
    end
   else
    begin
     OverlayPanel.Enabled := false;
     OvlKopfLabel.Enabled := false;
     case OvlInfoImage of
      0: OvlInfoCheck.Visible := false;
      1: OvlInfoDialog.Visible := false;
      2: OvlInfoOK.Visible := false;
     end;
    end;
   OvlInfoSave.Visible := true;
   OvlInfoSLbl.Visible := true;
   ParDateiPanel.Enabled := true;
{$if Safety>0}
   ParDateiOpKeyHandling.Caption := FormatLE(MG[Sprache].PdatOpKH);
{$endif Safety>0}
   ParDateiKopfLabel.Enabled := true;
   ParDateiDialog.Visible := true;
   ParDateiUseB1.Checked := true;
   ParDateiUseB1Memo.Color := clWindow;
   ParDateiOpKeyGroup.Enabled := false;
   ParDateiOpKeyHandling.Enabled := false;
   case ParDateiOpKeyImage of
    0: ParDateiOpKeyCheck.Visible := false;
    1: ParDateiOpKeyDialog.Visible := false;
    2: ParDateiOpKeyOK.Visible := false;
   end;
   if TimeOutUseB1.Checked then
     TimeOutUseB1Mask.Color := clWindow;
   if TimeOutUseB1Mask.Text='' then
     SetTimeOut(TimeOutUseB1Mask,TimeOutWarnLim);
   TimeOutHandlingB1.Enabled := true;
   case TimeOutHandlingReply of
    0: TimeOutHandlingB1Memo.Color := clWindow;
    1: TimeOutHandlingB2Memo.Color := clWindow;
   end;
   ParDateiClsKeyGroup.Enabled := true;
   ParDateiClsKeyHandling.Enabled := true;
{$if Safety>1}
   ParDateiClsKeyStwPanel.Visible := true;
{$endif Safety>1}
   case ParDateiClsKeyImage of
    0: ParDateiClsKeyCheck.Visible := true;
    1: ParDateiClsKeyDialog.Visible := true;
    2: ParDateiClsKeyOK.Visible := true;
   end;
  end
 else
   ActionHandlingB2Memo.Color := clActiveBorder;
end;

procedure TFMain.ActionHandlingB3Change(Sender: TObject);
begin
 if ActionHandlingB3.Checked then
  begin
   Aktion := 2;
{$if Test=1}
   StatusBar.Panels.Items[0].Text :=
     'Aktion ='+Format('%.0N',[int(Aktion)]);
{$endif Test=1}
   ActionHandlingB3Memo.Color := clWindow;
   InitialKeyPanel.Enabled := false;
   InitialKeyKopfLabel.Enabled := false;
   case InitialKeyImage of
    0: InitialKeyCheck.Visible := false;
    1: InitialKeyDialog.Visible := false;
    2: InitialKeyOK.Visible := false;
    3: InitialKeyMaus.Visible := false;
   end;
{$if Safety>0}
   CodStreamPanel.Enabled := false;
   CodStreamLabel.Enabled := false;
{$endif Safety>0}
   CodDateiPanel.Enabled := false;
   CodArtKopfLabel.Enabled := false;
   CodDateiDialog.Visible := false;
   ExpDateiDialog.Visible := false;
   case CodDateiArtReply of
    0: CodDateiArtB1Memo.Color := clActiveBorder;
    1: CodDateiArtB2Memo.Color := clActiveBorder;
    2: CodDateiArtB3Memo.Color := clActiveBorder;
    3: CodDateiArtB4Memo.Color := clActiveBorder;
   end;
   CodDatei.Color := clActiveBorder;
   ExpDatei.Color := clActiveBorder;
{$if Safety<2}
   CodDateiConfMemo.Color := clActiveBorder;
{$else Safety>1}
   CompDateiDialog.Visible := false;
   case CompDateiKeyImage of
    0: CompDateiKeyCheck.Visible := false;
    1: CompDateiKeyDialog.Visible := false;
    2: CompDateiKeyOK.Visible := false;
   end;
{$endif Safety}
   OverlayPanel.Enabled := true;
   OvlKopfLabel.Enabled := true;
   case OvlInfoImage of
    0: OvlInfoCheck.Visible := true;
    1: OvlInfoDialog.Visible := true;
    2: OvlInfoOK.Visible := true;
   end;
   OvlInfoSave.Visible := true;
   OvlInfoSLbl.Visible := true;
   ParDateiPanel.Enabled := true;
   ParDateiKopfLabel.Enabled := true;
   ParDateiDialog.Visible := true;
   ParDateiUseB2.Checked := true;
   ParDateiUseB2Memo.Color := clWindow;
   ParDateiOpKeyGroup.Enabled := true;
   ParDateiOpKeyHandling.Enabled := true;
{$if Safety>0}
   ParDateiOpKeyHandling.Caption := FormatLE(MG[Sprache].PdatOpKH);
{$endif Safety>0}
   case ParDateiOpKeyImage of
    0: ParDateiOpKeyCheck.Visible := true;
    1: ParDateiOpKeyDialog.Visible := true;
    2: ParDateiOpKeyOK.Visible := true;
   end;
   if TimeOutUseB1.Checked then
     TimeOutUseB1Mask.Color := clWindow;
   if TimeOutUseB1Mask.Text='' then
     SetTimeOut(TimeOutUseB1Mask,TimeOutWarnLim);
   TimeOutHandlingB1.Enabled := true;
   case TimeOutHandlingReply of
    0: TimeOutHandlingB1Memo.Color := clWindow;
    1: TimeOutHandlingB2Memo.Color := clWindow;
   end;
   ParDateiClsKeyGroup.Enabled := true;
   ParDateiClsKeyHandling.Enabled := true;
{$if Safety>1}
   ParDateiClsKeyStwPanel.Visible := true;
{$endif Safety>1}
   case ParDateiClsKeyImage of
    0: ParDateiClsKeyCheck.Visible := true;
    1: ParDateiClsKeyDialog.Visible := true;
    2: ParDateiClsKeyOK.Visible := true;
   end;
  end
 else
   ActionHandlingB3Memo.Color := clActiveBorder;
end;

procedure TFMain.ActionHandlingB4Change(Sender: TObject);
begin
 if ActionHandlingB4.Checked then
  begin
   Aktion := 3;
{$if Test=1}
   StatusBar.Panels.Items[0].Text :=
     'Aktion ='+Format('%.0N',[int(Aktion)]);
{$endif Test=1}
   ActionHandlingB4Memo.Color := clWindow;
   InitialKeyPanel.Enabled := true;
   InitialKeyKopfLabel.Enabled := true;
   case InitialKeyImage of
    0: InitialKeyCheck.Visible := true;
    1: InitialKeyDialog.Visible := true;
    2: InitialKeyOK.Visible := true;
    3: InitialKeyMaus.Visible := true;
   end;
   InitialKeyHandlingB3.Enabled := true;
   CodDateiPanel.Enabled := true;
   CodArtKopfLabel.Enabled := true;
{$if Safety>0}
   CodStreamPanel.Enabled := true;
   CodStreamLabel.Enabled := true;
   if CodStream.Checked then
     CodStreamLabel.Font.Color := clRed
   else
     CodStreamLabel.Font.Color := clWindowText;
{$endif Safety>0}
   CodDateiDialog.Visible := true;
   ExpDateiDialog.Visible := true;
   case CodDateiArtReply of
    0: CodDateiArtB1Memo.Color := clWindow;
    1: CodDateiArtB2Memo.Color := clWindow;
    2: CodDateiArtB3Memo.Color := clWindow;
    3: CodDateiArtB4Memo.Color := clWindow;
   end;
   CodDatei.Color := clWindow;
   ExpDatei.Color := clWindow;
{$if Safety<2}
   if not CodDateiConf.Checked then
     CodDateiConfMemo.Color := clWindow;
{$else Safety>1}
   CompDateiOnlyPanel.Enabled := true;
   CompDateiOnlyLabel.Enabled := true;
   if CodStream.Checked then
    begin
     CompDateiDialog.Visible := true;
     case CompDateiKeyImage of
      0: CompDateiKeyCheck.Visible := true;
      1: CompDateiKeyDialog.Visible := true;
      2: CompDateiKeyOK.Visible := true;
     end
    end;
{$endif Safety}
   if InitialKeyOvl.Checked then
    begin
     OverlayPanel.Enabled := true;
     OvlKopfLabel.Enabled := true;
     case OvlInfoImage of
      0: OvlInfoCheck.Visible := true;
      1: OvlInfoDialog.Visible := true;
      2: OvlInfoOK.Visible := true;
     end;
    end
   else
    begin
     OverlayPanel.Enabled := false;
     OvlKopfLabel.Enabled := false;
     case OvlInfoImage of
      0: OvlInfoCheck.Visible := false;
      1: OvlInfoDialog.Visible := false;
      2: OvlInfoOK.Visible := false;
     end;
    end;
   OvlInfoSave.Visible := false;
   OvlInfoSLbl.Visible := false;
   ParDateiPanel.Enabled := true;
{$if Safety>0}
   ParDateiOpKeyHandling.Caption := FormatLE(MG[Sprache].PdatOpKH);
{$endif Safety>0}
   ParDateiKopfLabel.Enabled := true;
   ParDateiDialog.Visible := true;
   ParDateiUseB1.Checked := true;
   ParDateiUseB1Memo.Color := clWindow;
   ParDateiOpKeyGroup.Enabled := false;
   ParDateiOpKeyHandling.Enabled := false;
   case ParDateiOpKeyImage of
    0: ParDateiOpKeyCheck.Visible := false;
    1: ParDateiOpKeyDialog.Visible := false;
    2: ParDateiOpKeyOK.Visible := false;
   end;
   if TimeOutUseB1.Checked then
     TimeOutUseB1Mask.Color := clWindow;
   TimeOutHandlingB2.Checked := true;
   TimeOutHandlingB1.Enabled := false;
   case TimeOutHandlingReply of
    0: TimeOutHandlingB1Memo.Color := clWindow;
    1: TimeOutHandlingB2Memo.Color := clWindow;
   end;
   FTimeOut.TimeOutHandlingB2.Checked := true;
   FTimeOut.TimeOutHandlingB1.Enabled := false;
   ParDateiClsKeyGroup.Enabled := false;
   ParDateiClsKeyHandling.Enabled := false;
   ParDateiClsKeyStwPanel.Visible := false;
   case ParDateiClsKeyImage of
    0: ParDateiClsKeyCheck.Visible := false;
    1: ParDateiClsKeyDialog.Visible := false;
    2: ParDateiClsKeyOK.Visible := false;
   end;
  end
 else
   ActionHandlingB4Memo.Color := clActiveBorder;
end;

procedure TFMain.ActionHandlingB5Change(Sender: TObject);
begin
 if ActionHandlingB5.Checked then
  begin
   Aktion := 4;
{$if Test=1}
   StatusBar.Panels.Items[0].Text :=
     'Aktion ='+Format('%.0N',[int(Aktion)]);
{$endif Test=1}
   ActionHandlingB5Memo.Color := clWindow;
   InitialKeyPanel.Enabled := false;
   InitialKeyKopfLabel.Enabled := false;
   case InitialKeyImage of
    0: InitialKeyCheck.Visible := false;
    1: InitialKeyDialog.Visible := false;
    2: InitialKeyOK.Visible := false;
    3: InitialKeyMaus.Visible := false;
   end;
   CodDateiPanel.Enabled := true;
   CodArtKopfLabel.Enabled := true;
{$if Safety>0}
   CodStreamPanel.Enabled := true;
   CodStreamLabel.Enabled := true;
   if CodStream.Checked then
     CodStreamLabel.Font.Color := clRed
   else
     CodStreamLabel.Font.Color := clWindowText;
{$endif Safety>0}
   CodDateiDialog.Visible := true;
   ExpDateiDialog.Visible := true;
   case CodDateiArtReply of
    0: CodDateiArtB1Memo.Color := clWindow;
    1: CodDateiArtB2Memo.Color := clWindow;
    2: CodDateiArtB3Memo.Color := clWindow;
    3: CodDateiArtB4Memo.Color := clWindow;
   end;
   CodDatei.Color := clWindow;
   ExpDatei.Color := clWindow;
{$if Safety<2}
   if not CodDateiConf.Checked then
     CodDateiConfMemo.Color := clWindow;
{$else Safety>1}
   CompDateiOnlyPanel.Enabled := true;
   CompDateiOnlyLabel.Enabled := true;
   if CodStream.Checked then
    begin
     CompDateiDialog.Visible := true;
     case CompDateiKeyImage of
      0: CompDateiKeyCheck.Visible := true;
      1: CompDateiKeyDialog.Visible := true;
      2: CompDateiKeyOK.Visible := true;
     end
    end;
{$endif Safety}
   OverlayPanel.Enabled := false;
   OvlKopfLabel.Enabled := false;
   case OvlInfoImage of
    0: OvlInfoCheck.Visible := false;
    1: OvlInfoDialog.Visible := false;
    2: OvlInfoOK.Visible := false;
   end;
   OvlInfoSave.Visible := false;
   OvlInfoSLbl.Visible := false;
   ParDateiPanel.Enabled := true;
   ParDateiKopfLabel.Enabled := true;
   ParDateiDialog.Visible := true;
   ParDateiUseB2.Checked := true;
   ParDateiUseB2Memo.Color := clWindow;
   ParDateiOpKeyGroup.Enabled := true;
   ParDateiOpKeyHandling.Enabled := true;
{$if Safety>0}
   if CodStream.Checked then
     ParDateiOpKeyHandling.Caption := FormatLE(MG[Sprache].PdatOpKHS);
{$endif Safety>0}
   case ParDateiOpKeyImage of
    0: ParDateiOpKeyCheck.Visible := true;
    1: ParDateiOpKeyDialog.Visible := true;
    2: ParDateiOpKeyOK.Visible := true;
   end;
   if TimeOutUseB1.Checked then
     TimeOutUseB1Mask.Color := clWindow;
   TimeOutHandlingB2.Checked := true;
   TimeOutHandlingB1.Enabled := false;
   case TimeOutHandlingReply of
    0: TimeOutHandlingB1Memo.Color := clWindow;
    1: TimeOutHandlingB2Memo.Color := clWindow;
   end;
   ParDateiClsKeyGroup.Enabled := false;
   ParDateiClsKeyHandling.Enabled := false;
   ParDateiClsKeyStwPanel.Visible := false;
   case ParDateiClsKeyImage of
    0: ParDateiClsKeyCheck.Visible := false;
    1: ParDateiClsKeyDialog.Visible := false;
    2: ParDateiClsKeyOK.Visible := false;
   end;
  end
 else
   ActionHandlingB5Memo.Color := clActiveBorder;
end;

procedure TFMain.ActionHandlingB1MemoEnter(Sender: TObject);
begin
  ActionHandlingB1.Checked := true; {siehe 'ActionHandlingB1Change'}
end;

procedure TFMain.ActionHandlingB1MemoExit(Sender: TObject);
begin
 ActionHandlingB1Memo.Lines.Strings[0]:={um alle Zeilen wieder sichtbar}
   ActionHandlingB1Memo.Lines.Strings[0]; { zu machen, falls verschoben}
end;

procedure TFMain.ActionHandlingB2MemoEnter(Sender: TObject);
begin
  ActionHandlingB2.Checked := true; {siehe 'ActionHandlingB2Change'}
end;

procedure TFMain.ActionHandlingB2MemoExit(Sender: TObject);
begin
 ActionHandlingB2Memo.Lines.Strings[0]:={um alle Zeilen wieder sichtbar}
   ActionHandlingB2Memo.Lines.Strings[0];{  zu machen, falls verschoben}
end;

procedure TFMain.ActionHandlingB3MemoEnter(Sender: TObject);
begin
  ActionHandlingB3.Checked := true; {siehe 'ActionHandlingB3Change'}
end;

procedure TFMain.ActionHandlingB3MemoExit(Sender: TObject);
begin
 ActionHandlingB3Memo.Lines.Strings[0]:={um alle Zeilen wieder sichtbar}
   ActionHandlingB3Memo.Lines.Strings[0];{  zu machen, falls verschoben}
end;

procedure TFMain.ActionHandlingB4MemoEnter(Sender: TObject);
begin
  ActionHandlingB4.Checked := true; {siehe 'ActionHandlingB4Change'}
end;

procedure TFMain.ActionHandlingB4MemoExit(Sender: TObject);
begin
 ActionHandlingB4Memo.Lines.Strings[0]:={um alle Zeilen wieder sichtbar}
   ActionHandlingB4Memo.Lines.Strings[0];{  zu machen, falls verschoben}
end;

procedure TFMain.ActionHandlingB5MemoEnter(Sender: TObject);
begin
  ActionHandlingB5.Checked := true; {siehe 'ActionHandlingB5Change'}
end;

procedure TFMain.ActionHandlingB5MemoExit(Sender: TObject);
begin
 ActionHandlingB5Memo.Lines.Strings[0]:={um alle Zeilen wieder sichtbar}
   ActionHandlingB5Memo.Lines.Strings[0];{  zu machen, falls verschoben}
end;

procedure TFMain.ActionHandlingLabelClick(Sender: TObject);
begin
  ShowHelpFile(ActionHandlingLabel.HelpKeyword);
end;

procedure TFMain.AusDateiHandlingLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(AusDateiHandling.HelpKeyword);
end;

procedure TFMain.AusDateiHandlingLabelClick(Sender: TObject);
begin
  if AusDateiHandling.Checked then
    AusDateiHandling.Checked := false
  else
    AusDateiHandling.Checked := true;
end;

procedure TFMain.AusDateiLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(AusDateiLabel.HelpKeyword);
end;

procedure TFMain.InitialKeyHandlingB1Change(Sender: TObject);
begin
 if InitialKeyHandlingB1.Checked then
  begin
   InitialKey.Text := '';
   InitialKey.HelpKeyword := 'COD/DirectKey.html';
   if InitialKeyHandlingReply=2 then
    begin
     InitialKey.Enabled := true;
     InitialKeyLabel.Visible := true;
     InitialKeyHexPanel.Visible := true;
     InitialKeyHexLabel.Visible := true;
    end;
   InitialKeyHandlingReply := 0;
   InitialKeyDialog.Visible := false;
   InitialKeyOK.Visible := false;
   InitialKeyMaus.Visible := false;
   InitialKeyCheck.Visible := true;
   InitialKeyImage := 0;
   InitialKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
   InitialKey.PasswordChar := '*';
   InitialKey.EchoMode := emPassword;
  end;
end;

procedure TFMain.InitialKeyHandlingB2Change(Sender: TObject);
begin
 if InitialKeyHandlingB2.Checked then
  begin
   InitialKey.Text := '';
   InitialKey.HelpKeyword := 'COD/KeyDataset.html';
   if InitialKeyHandlingReply=2 then
    begin
     InitialKey.Enabled := true;
     InitialKeyLabel.Visible := true;
     InitialKeyHexPanel.Visible := true;
     InitialKeyHexLabel.Visible := true;
    end;
   InitialKeyHandlingReply := 1;
   InitialKeyOK.Visible := false;
   InitialKeyMaus.Visible := false;
   InitialKeyCheck.Visible := false;
   InitialKeyDialog.Visible := true;
   InitialKeyImage := 1;
   InitialKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR1);
  {InitialKey.PasswordChar := #0;
   InitialKey.EchoMode := emNormal;}
  end;
end;

procedure TFMain.InitialKeyHandlingB3Change(Sender: TObject);
begin
 if InitialKeyHandlingB3.Checked then
  begin
   InitialKey.Text := FormatLE(MG[Sprache].IKeyTxtR2clk);
   InitialKey.HelpKeyword := 'COD/RandomKey.html';
   InitialKey.PasswordChar := #0;
   InitialKey.EchoMode := emNormal;
   InitialKeyHandlingReply := 2;
   InitialKeyDialog.Visible := false;
   InitialKeyCheck.Visible := false;
   InitialKeyOK.Visible := false;
   InitialKeyMaus.Visible := true;
   InitialKeyImage := 3;
   InitialKey.Enabled := false;
   InitialKeyLabel.Visible := false;
   InitialKeyHexPanel.Visible := false;
   InitialKeyHexLabel.Visible := false;
  end;
end;

function HexCheck(Str: string): longint;
var
 I, J: longint;
 Zeichen: char;
 ZByte: byte absolute Zeichen;
begin
 J := 0;
 for I := 1 to Length(Str) do
  begin
   Zeichen := UpCase(Str[I]);
   if not ((ZByte in [d0..d9]) or (ZByte in [cA..cF])) then
    begin                                          {\ kein Hex-Zeichen}
     J := 1;
     break;
    end;
  end;
 if J=1 then
   HexCheck := I
 else
  begin
   I := Length(Str);
   if (I mod (ElemBytes shl 1))=0 then
     HexCheck := 0
   else
     HexCheck := (I mod (ElemBytes shl 1)) -(ElemBytes shl 1);
  end;                    { -(notwendige Hex(0)-Ergnzungen) }
end;

procedure CharToHex(var Str: string);
var
 H1, H2: byte;
 cH1: char absolute H1;
 cH2: char absolute H2;
 I: longint;
 rStr, IStr: string;
begin
 IStr := UTF8toANSI(Str);
 rStr := '';
 for I := 1 to Length(IStr) do
  begin
   H1 := Byte(IStr[I]) shr 4;
   H2 := Byte(IStr[I]) and 15;
   if H1<10 then
     H1 := H1 + d0
   else
     H1 := H1 + cAS10;
   if H2<10 then
     H2 := H2 + d0
   else
     H2 := H2 + cAS10;
   rStr := rStr + cH1 + cH2;
  end;
 Str := rStr;
end;

function HexToChar(var Str: string): longint;
var
 HexZeichen, CharZeichen: char;
 HByte: byte absolute HexZeichen;
 CByte: byte absolute CharZeichen;
 I, J: longint;
 rStr: string;
begin
 HexToChar := 0;
 if Str<>'' then
  begin
   rStr := '';
   J := (Length(Str) shr 1) - 1; {Schleifen-Durchlauf-Obergrenze}
   for I := 0 to J do
    begin
     HexZeichen := UpCase(Str[(I shl 1)+1]);
     if HByte in [d0..d9] then
       CByte := HByte - d0
     else {HByte in [cA..cF]}
       CByte := HByte - cAS10;
     HexZeichen := UpCase(Str[(I shl 1)+2]);
     if HByte in [d0..d9] then
       CByte := CByte*16 + HByte - d0
     else {HByte in [cA..cF]}
       CByte := CByte*16 + HByte - cAS10;
     if CByte>0 then
       rStr := rStr + CharZeichen
     else
      begin
       HexToChar := (I shl 1)+1;
       exit;
      end;
    end;
   if (Length(Str) and 1)=1 then {'Str' hat ungerade Zeichen-Anzahl}
    begin
     HexZeichen := UpCase(Str[Length(Str)]);
     if HByte in [d0..d9] then
       CByte := (HByte - d0)*16
     else {HByte in [cA..cF]}
       CByte := (HByte - cAS10)*16;
     if CByte>0 then
       rStr := rStr + CharZeichen
     else
      begin
       HexToChar := Length(Str);
       exit;
      end;
    end;
   Str := ANSItoUTF8(rStr);
  end;
end;

procedure TFMain.InitialKeyHexChange(Sender: TObject);
var
 aw: longint;
 IStr: string;
begin
 if InitialKeyHandlingB1.Checked and   {falls fr Direktkeys noch keine}
    (not ExitInitialKey) then  {Exit-Routine fr 'InitialKey' aktiv ist}
  begin{die Werte sichern,die durch 'InitialKeyChange' verndert werden}
   ExitInitialKey := true;
   InitialKeyCheckedS := InitialKeyChecked;
   InitialKeyOK_Visible := InitialKeyOK.Visible;
   InitialKeyCheck_Visible := InitialKeyCheck.Visible;
   InitialKeyImageS := InitialKeyImage;
   if InitialKeyHex.Checked then
    begin
     IStr := InitialKey.Text;
     CharToHex(IStr); {Schlssel-Zeichen in Hex-Werte umwandeln}
     InitialKey.Text := IStr;{das fhrt zum 'InitialKeyChange'-Aufruf !}
     if InitialKey.Tag>=FocusTag then
      begin { verdoppeln }
       InitialKey.SetFocus; {'SelStart'/'SelLength' nur falls Focus }
       InitialKey.SelStart := InitialKey.SelStart shl 1; {\ gesetzt }
       InitialKey.SelLength := InitialKey.SelLength shl 1;
      end;
    end
   else
    begin
     IStr := InitialKey.Text;
     aw := HexToChar(IStr);
     if aw=0 then {Schlssel-Hex-Wert in Zeichen umwandeln, }
      begin       {         falls machbar (d.h. auer #00 !)}
       InitialKey.Text := IStr; { fhrt zum 'InitialKeyChange'-Aufruf! }
       if InitialKey.Tag>=FocusTag then
        begin { halbieren }
         InitialKey.SetFocus; {'SelStart'/'SelLength' nur falls Focus }
         InitialKey.SelStart := InitialKey.SelStart shr 1; {\ gesetzt }
         InitialKey.SelLength := (InitialKey.SelLength+1) shr 1;
        end;
      end
     else
      begin
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(KeyConvErr,[aw])),
           PChar(KeyHdCErr),16);
{      MessageBoxCall := true; }
       InitialKeyHex.Checked := true; {weiterer 'InitialKeyHexChange'}
      end                                                  {\ -Aufruf}
    end;
   InitialKeyChecked := InitialKeyCheckedS;   {'InitialKeyChange'-Werte}
   InitialKeyOK.Visible := InitialKeyOK_Visible;{          zurcksetzen}
   InitialKeyCheck.Visible := InitialKeyCheck_Visible;
   InitialKeyImage := InitialKeyImageS;
   ExitInitialKey := false;
  end;
end;

procedure TFMain.InitialKeyHexLabelClick(Sender: TObject);
begin
  if InitialKeyHex.Checked then
    InitialKeyHex.Checked := false
  else
    InitialKeyHex.Checked := true;
end;

procedure TFMain.InitialKeyHexLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(InitialKeyHexLabel.HelpKeyword);
end;

procedure TFMain.InitialKeyDialogClick(Sender: TObject);
begin
  OpenDialogKey.FileName := '*.*';
  if OpenDialogKey.Execute then
    InitialKey.Text := OpenDialogKey.FileName;
end;

procedure TFMain.InitialKeyCheckClick(Sender: TObject);
begin
  InitialKey.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
  InitialKeyChecked := false;
  if not ExitInitialKey then
    InitialKeyExit(Sender);
end;

procedure TFMain.InitialKeyEnter(Sender: TObject);
begin
 if not InitialKeyHandlingB3.Checked then
  begin
   InitialKey.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
{$if Test=1}
   AllEnterCount := AllEnterCount + 1;
   StatusBar.Panels.Items[0].Text :=
     'AllEnterCount='+Format('%D',[AllEnterCount]);
   StatusBar.Panels.Items[2].Text :=
     'AllExitCount='+Format('%D',[AllExitCount])+';'
     +Format('%D',[InitialKey.Tag]);
{$endif Test=1}
   if InitialKeyHandlingReply=1 then { falls im Datei-Modus }
    begin
{$if Test=1}
     EnterCount := EnterCount + 1;
     StatusBar.Panels.Items[1].Text :=
       'EnterCount='+Format('%D',[EnterCount]);
{$endif Test=1}
     EnterHidedField(InitialKey)
    end;
  end;
end;

procedure TFMain.InitialKeyChange(Sender: TObject);
begin
 if InitialKeyHandlingReply=0 then
  begin
   InitialKeyChecked := false;
   if not InitialKeyCheck.Visible then
    begin
     InitialKeyOK.Visible := false;
     InitialKeyCheck.Visible := true;
     InitialKeyImage := 0;
    end
  end
end;

procedure TFMain.InitialKeyClick(Sender: TObject);
begin
 if not InitialKeyHandlingB3.Checked then
  begin
   if InitialKey.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
     InitialKeyEnter(Sender);      { dann dies jetzt nachholen         }
   ShowCursorPos(InitialKey);
  end
{else
   InitialKeyMausClick(Sender); }
end;

procedure TFMain.InitialKeyKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if not InitialKeyHandlingB3.Checked then
  begin
   if InitialKey.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
     InitialKeyEnter(Sender);      { dann dies jetzt nachholen         }
   if InitialKeyHandlingB1.Checked then{falls im Direkt-Schlssel-Modus}
    if Key=13 then
      InitialKeyExit(Sender);  {"Return"-Taste als Feld-Exit annehmen}
  end
 else
  begin
{$if Test=1}
   StatusBar.Panels.Items[2].Text := 'Key = '+Format('%.0N',[int(Key)]);
{$endif Test=1}
   if (Key=27) or (Key=9) then {ESC- oder TAB-Taste}
    begin
     ExitInitialKey := true;
     RandomKeyOperation := false;
     with MG[Sprache] do
       Application.MessageBox(PChar(FormatLE(IKeyRCls)),
                              PChar(IKeyHdRCls),0);
     if RandomAnz>0 then
      begin
       InitialKeyMaus.Visible := false;
       InitialKeyOK.Visible := true;
       InitialKeyImage := 2;
       InitialKey.Text := FormatLE(MG[Sprache].IKeyTxtR2ok);
      end
     else
      begin
     { InitialKeyOK.Visible := false;
       InitialKeyMaus.Visible := true;
       InitialKeyImage := 3; }
       InitialKey.Text := FormatLE(MG[Sprache].IKeyTxtR2clk);
      end;
     InitialKey.Enabled := false;
     InitialKey.ReadOnly := false;
     StatusBar.Panels.Items[0].Text := '';
     ExitInitialKey := false;
    end
   else
    begin
     if RandomMouseDown then
      if Key=32 then {Leertaste}
       if Random_angehalten then
         Random_angehalten := false
       else
         Random_angehalten := true
      else  {sonstige Taste}
       begin
        Random_angehalten := false;
{$if Gruppe=2}
        RandomModus := Key and 7; {Key mod 8}
{$endif Gruppe=2}
{$if Gruppe=3}
        RandomModus := Key mod 96;
{$endif Gruppe=3}
        RandomKey := Key;
       end
     else
       InitialKey.Text := FormatLE(MG[Sprache].IKeyTxtR2gen);
    end;
  end;
end;

procedure TFMain.InitialKeyKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if not InitialKeyHandlingB3.Checked then
   ShowCursorPos(InitialKey);
end;

procedure TFMain.InitialKeyKopfLabelClick(Sender: TObject);
begin
  ShowHelpFile(InitialKeyKopfLabel.HelpKeyword);
end;

procedure TFMain.InitialKeyLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(InitialKey.HelpKeyword)
end;

procedure TFMain.InitialKeyMausClick(Sender: TObject);
var
  aw: longint;
begin
 if (not RandomKeyOperation) and
    (not ExitInitialKey) then
  begin
   RandomKeyOperation := true;
   RandomMouseDown := false;
   Random_angehalten := true;
{$if Gruppe>1}
   RandomModus := 1;
 {$if Gruppe=3}
   PaarXY := 1;
 {$endif Gruppe=3}
{$endif Gruppe>1}
   RandomKey := 0;
   RandomKeyE1 := 0;
   RandomAnz := 0;
   InitialKeyS := '';
   InitialKey.Text := FormatLE(MG[Sprache].IKeyTxtR2gen);
   InitialKey.Enabled := true;
   InitialKey.ReadOnly := true;
   FMain.ActiveControl := InitialKey;
   with MG[Sprache] do
     aw := Application.MessageBox(PChar(FormatLE(IKeyRInp,
             [(minRandomAnz*2),minRandomAnz])),PChar(IKeyHdRInp),49);
{  MessageBoxCall := true; }
   if aw=2 then
    begin
     RandomKeyOperation := false;
     InitialKey.Text := FormatLE(MG[Sprache].IKeyTxtR2clk);
     InitialKey.Enabled := false;
     InitialKey.ReadOnly := false;
    end;
  end;
end;

{$if Test=1}
function WordToHex(Wert: word): string;
var
 bWert: array [1..2] of byte absolute wert;
 H1, H2: byte;
 cH1: char absolute H1;
 cH2: char absolute H2;
 I: longint;
begin
 WordToHex := '';
 {$if BSigRtL=0}
 for I := 2 downto 1 do
 {$else BSigRtL=1}
 for I := 3 to 4 do
 {$endif BSigRtL}
  begin
   H1 := bWert[I] shr 4;
   H2 := bWert[I] and 15;
   if H1<10 then
     H1 := H1 + d0
   else
     H1 := H1 + cAS10;
   if H2<10 then
     H2 := H2 + d0
   else
     H2 := H2 + cAS10;
   WordToHex := WordToHex + cH1 + cH2;
  end;
end;
{$endif Test=1}

procedure ClearMessageQueue(Sender: TObject);
{>>>>>>>>>>>>> tut so nicht !!!!!! <<<<<<<<<<<}
{type
 point =
  record
   X: longint; (* =long *)
   Y: longint; (* =long *)
  end;
 tagMSG = (* =MSG *)
  record
   hwnd: longword; (* windows handle (HWND=windows.HANDLE
                                          =system.THandle=DWord) *)
   message: word; (* message number (UINT=cardinal) *)
   wParam: longint; (* 1. message parameter (WPARAM) *)
   lParam: longint; (* 2. message parameter (LPARAM) *)
   time: longword; (* time at which the message was posted (DWORD) *)
   pt: point;
  end;}
var
 MesG: windows.tagMSG;
 Null_lword: longword;
 Null_word: word;
 success: longbool;
{$if Test=1}
 sucword: array[0..1] of word absolute success;
 AusName: string;
{$endif Test=1}
 count: longint;
begin
 Null_lword := 0;
 Null_word := 0;
{$if Test=1}
 EnterCount := EnterCount+1;
 AusName := 'PeekMessage'+Format('%D',[EnterCount])+'.out';
 system.assign(Ausg,AusName);
 system.rewrite(Ausg);
 system.writeln(Ausg);
{$endif Test=1}
 success := Windows.PeekMessage(MesG,Null_lword,Windows.WM_MOUSEFIRST,
                                Windows.WM_MOUSELAST,windows.PM_REMOVE);
 count := 0;
 while success and (count<10) do
  if MesG.hwnd<>0 then
  begin
   count := count + 1;
{$if Test=1}
   system.writeln(Ausg,'InitialKey.Handle:'+Format('%D',
                                            [FMain.InitialKey.Handle]));
   system.writeln(Ausg,'MesG.hwnd:'+Format('%D',[MesG.hwnd]));
   system.writeln(Ausg,'MesG.message:'+Format('%D',[MesG.message]));
   system.writeln(Ausg,'MesG.wParam:'+Format('%D',[MesG.wParam]));
   system.writeln(Ausg,'MesG.lParam:'+Format('%D',[MesG.lParam]));
   system.writeln(Ausg,'MesG.time:'+Format('%D',[MesG.time]));
   system.writeln(Ausg,'MesG.pt.X:'+Format('%D',[MesG.pt.X])+
                  ', MesG.pt.Y:'+Format('%D',[MesG.pt.Y]));
   system.writeln(Ausg);
{$endif Test=1}
   success := Windows.PeekMessage(MesG,Null_lword,Windows.WM_MOUSEFIRST,
                                Windows.WM_MOUSELAST,windows.PM_REMOVE);
  end;
{$if Test=1}
 system.close(Ausg);
 FMain.StatusBar.Panels.Items[1].Text :=
              'success='+WordToHex(sucword[0])+WordToHex(sucword[1])+';'
              +Format('%D',[count]);
{$endif Test=1}
end;

procedure TFMain.InitialKeyExit(Sender: TObject);
var
  aw, I: longint;
  IStr: string;
begin
 { Die Variablen 'ExitInitialKey','Exit...' helfen nur bei jeweils
   ge"stack"ten EXIT-Events (weiteres dazu beim 'OvlLimitPosVonExit'-
   Aufruf weiter unten) gegen wiederholte Fehlermeldungen.
      Es  k a n n  durch einen 'MassegeBox'-Aufruf weiter zu einer
   doppelten Fehlermeldung kommen, wenn das dadurch verursachte EXIT-
   Event ge"queued" wird. Ein solches EXIT-Event kann nicht mehr von ei-
   nem "normalen" EXIT-Event z.B. durch Maus-Klick unterschieden werden!
      Da diese Routine durch 'InitialKeyCheckClick' ebenfalls aufgerufen
   wird, kommt es auch hier zur doppelten Fehlermeldung, falls ein
   zustzliches EXIT-Event durch das fokusierte Feld verursacht wird.
   (--> Es fehlt eine Clearing-Mglichkeit der Event-Queue !! <--).
      Da das Feld aber nur fehlerfrei verlassen werden darf,der Benutzer
   aber jedesmal auf's neue ber die Ursache des nicht Verlassens
   informiert werden soll, muss das z.Zt. in Kauf genommen werden !
      Des weiteren wird 'SetFocus' bzw. die Zuweisung zu 'ActiveControl'
   nicht ausgefhrt,falls es sich um den Aufruf der Routine anhand eines
   entsprechenden EXIT-Events handelt (!), 'Focused' ist und bleibt in
   diesen Fllen auf 'false'.Bei einem Aufruf via 'InitialKeyCheckClick'
   wird 'SetFocus' jedoch ausgefhrt. Der 'MessageBox'-Aufruf in der
   'EXIT'-Routine setzt interessanterweise den Focus wieder auf das
   Ausgangsfeld zurck (!).
      'SelStart'- und 'SelLength'-Zuweisungen werden nur ausgefhrt,
   falls der Focus zuvor gesetzt wurde. }
 if not InitialKeyHandlingB3.Checked then
  begin
{$if Test=1}
   AllExitCount := AllExitCount + 1;
   StatusBar.Panels.Items[2].Text :=
     'AllExitCount='+Format('%D',[AllExitCount])+';'
     +Format('%D',[InitialKey.Tag]);
{$endif Test=1}
   DelCursorPos;
   if InitialKey.Tag>=FocusTag then {falls das Feld den Fokus hat}
    if InitialKeyHandlingReply=1 then { falls im Datei-Modus }
     begin
      MessageBoxCall := false;
      ExitHidedField(InitialKey,InitialKeyLabel);
{$if Test=1}
      StatusBar.Panels.Items[2].Text :=
        'AllExitCount='+Format('%D',[AllExitCount])+';'
        +Format('%D',[InitialKey.Tag]);
{$endif Test=1}
     end
    else
     if (not InitialKeyHex.Focused) and
        (not ExitInitialKey) and    {falls noch keine Exit-Routine fr }
        (not InitialKeyChecked) then    { dieses Feld aktiv ist  u n d }
      begin          { noch kein erfolgreicher Check durchgefhrt wurde}
       ExitInitialKey := true; {anzeigen, dass fr dieses Feld   }
                               {jetzt eine Exit-Routine aktiv ist}
       MessageBoxCall := false;
{$if Test=1}
       ExitCount := ExitCount + 1;
       StatusBar.Panels.Items[3].Text :=
         'ExitCount='+Format('%D',[ExitCount]);
       StatusBar.Panels.Items[1].Text :=
         'ExitInitialKey='+Format('%D',[integer(ExitInitialKey)]);
{$endif Test=1}
       if InitialKeyHandlingReply=0 then{falls im Direktschlssel-Modus}
        begin
         aw := 0;
         I := 0;
         if InitialKeyHex.Checked then {Hexzeichen}
          begin
           IStr := InitialKey.Text;
           aw := HexCheck(IStr);
           if aw<>0 then  {'HexCheck' hat ein Problem entdeckt}
            if aw>0 then {ein Zeichen ist kein Hexzeichen}
             begin
              I := aw;
              with MG[Sprache] do
                Application.MessageBox(PChar(FormatLE(KeyHexErr,[I])),
                  PChar(KeyHdSErr),16);
              MessageBoxCall := true;
             end
            else    {Hexzeichen-Anzahl nicht durch ElemBytes*2 teilbar}
             begin
              aw := -aw;  {Anzahl ergnzter Hexzeichen}
              I := Length(InitialKey.Text); {Stelle im Text}
              with MG[Sprache] do
                Application.MessageBox(PChar(FormatLE(KeyHNumErr,[I,aw])
                                       ),PChar(KeyHdSWar),48);
              aw := 0;
              MessageBoxCall := true;
             end;
          end
         else      {keine Hexzeichen}
          begin
           I := Length(InitialKey.Text);
           if (I mod ElemBytes)<>0 then
            begin {Lnge ist nicht durch ElemBytes teilbar}
             with MG[Sprache] do
               Application.MessageBox(PChar(FormatLE(KeyNulCom,[I])),
                 PChar(KeyHdSWar),48);
             MessageBoxCall := true;
            end
           else
             I := 0;
          end;
         if aw=0 then
          begin
           with MG[Sprache] do
             aw := Application.MessageBox(PChar(FormatLE(KeyQRep)),
                     PChar(KeyHdRep),36);
           if I>0 then {Markierung einer Stelle erst nach letzter}
            begin                                 {\ 'MessageBox'}
             InitialKey.SelStart := I-1;
             InitialKey.SelLength := 1;
            end
           else
             InitialKey.SelLength := 0;
           MessageBoxCall := true;
           if aw=6 then { Ja. --> Direktschlssel-Wiederholung }
            begin
             InitialKeyHandlingReply := 4;{Wiederholungsschlssel-Modus}
             InitialKeyLabel.Caption:=FormatLE(MG[Sprache].KeyLblR0rep);
             InitialKeyS := InitialKey.Text;
             InitialKeyHexS := InitialKeyHex.Checked;
             InitialKey.Text := '';
             InitialKeyHandling.Enabled := false;
             InitialKeyOvl.Enabled := false;
             {alle sonstigen Elemente als nicht auswhlbar kennzeichnen}
             SprachBox.Enabled := false;
             AusDateiDialog.Visible := false;
             AusDatei.Enabled := false;
             AusDateiHandling.Enabled := false;
             OperClear.Enabled := false;
             OperStart.Enabled := false;
             OperExit.Enabled := false;
             ActionPanel.Enabled := false;
             ActionHandlingLabel.Enabled := false;
             CodDateiPanel.Enabled := false;
             CodArtKopfLabel.Enabled := false;
             CodDateiDialog.Visible := false;
             ExpDateiDialog.Visible := false;
{$if Safety>1}
             if CodStream.Checked then
              begin
               CompDateiDialog.Visible := false;
               case CompDateiKeyImage of
                0: CompDateiKeyCheck.Visible := false;
                1: CompDateiKeyDialog.Visible := false;
                2: CompDateiKeyOK.Visible := false;
               end
              end;
{$endif Safety>1}
             OverlayPanel.Enabled := false;
             OvlKopfLabel.Enabled := false;
             case OvlInfoImage of
              0: OvlInfoCheck.Visible := false;
              1: OvlInfoDialog.Visible := false;
              2: OvlInfoOK.Visible := false;
             end;
             ParDateiPanel.Enabled := false;
             ParDateiKopfLabel.Enabled := false;
             ParDateiDialog.Visible := false;
             case ParDateiOpKeyImage of
              0: ParDateiOpKeyCheck.Visible := false;
              1: ParDateiOpKeyDialog.Visible := false;
              2: ParDateiOpKeyOK.Visible := false;
             end;
             case ParDateiClsKeyImage of
              0: ParDateiClsKeyCheck.Visible := false;
              1: ParDateiClsKeyDialog.Visible := false;
              2: ParDateiClsKeyOK.Visible := false;
             end;
           { ActiveControl := InitialKey; }
            end
           else  { Nein. --> keine Direktschlssel-Wiederholung }
             InitialKeyChecked := true; {es hat eine Bearbeitung durch
                                         den Benutzer stattgefunden}
          end
         else  {'HexCheck'-Fehler, keine -Warnung}
          begin
           InitialKey.SetFocus;{'SelStart'/'SelLength' nur falls Focus}
           InitialKey.SelStart := I-1;                      {\ gesetzt}
           InitialKey.SelLength := 1;
           ShowCursorPos(InitialKey);
          end;
        end
       else { falls im Wiederholungs-Schlssel-Modus }
        begin
         ExitInitialKey := false; {lst ggf. 'InitialKeyHexChange' aus}
         InitialKeyHex.Checked := InitialKeyHexS;
         ExitInitialKey := true;  {knnte 'HexToChar'-Fehler ausgelst}
         if (InitialKeyHex.Checked=InitialKeyHexS) and        {\ haben}
            (InitialKeyS=InitialKey.Text) then
          begin { Ausgangs- und Wiederholungs-Schlssel sind identisch }
           InitialKeyCheck.Visible := false;
           InitialKeyOK.Visible := true;
           InitialKeyImage := 2;
          end
         else
          begin
         { InitialKeyOK.Visible := false;
           InitialKeyCheck.Visible := true;
           InitialKeyImage := 0; }
           IStr := InitialKey.Text; {1. Unterschiedsstelle ermitteln}
           I := Length(IStr);
           if I<>Length(InitialKeyS) then
            if I>Length(InitialKeyS) then
              I := Length(InitialKeyS);
           for aw := 1 to I do  {Schleife ber gemeinsame Stellen}
            begin
             if InitialKeyS[aw]<>IStr[aw] then
               break;
            end;
           if (I>0) and
              ((aw<I) or
               (InitialKeyS[aw]<>IStr[aw])) then
             I := aw
           else  {gemeinsame Stellen sind identisch}
             I := I + 1;                                    {/ mglich}
           InitialKey.Text := ''; {damit ist kein 'HexToChar'-Fehler  }
           ExitInitialKey := false; {--> ggf.'ParDateiOpKeyHexChange'}
           InitialKeyHex.Checked := InitialKeyHexS;
           ExitInitialKey := true;
           InitialKey.Text := InitialKeyS;
           with MG[Sprache] do
             Application.MessageBox(PChar(FormatLE(KeyDifErr,[I])),
               PChar(KeyHdRErr),48);
           MessageBoxCall := true;
           InitialKey.SetFocus;
           if I<=Length(InitialKeyS) then
            begin {Falls die Differenzstelle im Ausgangs-Schlssel}
             InitialKey.SelStart := I-1;              {\ anzeigbar}
             InitialKey.SelLength := 1;
            end
           else
            begin  {sonst den gesamten Ausgangs-Schlssel markieren}
             InitialKey.SelStart := 0;
             InitialKey.SelLength := Length(InitialKeyS);
            end;
           ShowCursorPos(InitialKey);
          end;
         InitialKeyChecked := true; {es hat eine Bearbeitung durch
                                     den Benutzer stattgefunden}
         InitialKeyHandlingReply := 0; {Wiederholungskey-Modus aufheben}
         InitialKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
         {alle Felder "entsperren"}
         InitialKeyHandling.Enabled := true;
         InitialKeyOvl.Enabled := true;
         { alle sonstigen Elemente }
         SprachBox.Enabled := true;
         AusDateiDialog.Visible := true;
         AusDatei.Enabled := true;
         AusDateiHandling.Enabled := true;
         OperClear.Enabled := true;
         OperStart.Enabled := true;
         OperExit.Enabled := true;
         ActionPanel.Enabled := true;
         ActionHandlingLabel.Enabled := true;
         if (Aktion=0) or (Aktion=3) then  {Aktion=4 nicht mglich}
          begin
           CodDateiPanel.Enabled := true;
           CodArtKopfLabel.Enabled := true;
           CodDateiDialog.Visible := true;
           ExpDateiDialog.Visible := true;
{$if Safety>1}
           if CodStream.Checked then
            begin
             CompDateiDialog.Visible := true;
             case CompDateiKeyImage of
              0: CompDateiKeyCheck.Visible := true;
              1: CompDateiKeyDialog.Visible := true;
              2: CompDateiKeyOK.Visible := true;
             end
            end;
{$endif Safety>1}
          end;
         if InitialKeyOvl.Checked then
          begin
           OverlayPanel.Enabled := true;
           OvlKopfLabel.Enabled := true;
           case OvlInfoImage of
            0: OvlInfoCheck.Visible := true;
            1: OvlInfoDialog.Visible := true;
            2: OvlInfoOK.Visible := true;
           end;
          end;
         if Aktion<>0 then
          begin
           ParDateiPanel.Enabled := true;
           ParDateiKopfLabel.Enabled := true;
           ParDateiDialog.Visible := true;
           if ParDateiOpKeyHandling.Enabled then
             case ParDateiOpKeyImage of
              0: ParDateiOpKeyCheck.Visible := true;
              1: ParDateiOpKeyDialog.Visible := true;
              2: ParDateiOpKeyOK.Visible := true;
             end;
           if ParDateiClsKeyHandling.Enabled then
             case ParDateiClsKeyImage of
              0: ParDateiClsKeyCheck.Visible := true;
              1: ParDateiClsKeyDialog.Visible := true;
              2: ParDateiClsKeyOK.Visible := true;
             end;
          end;
        end;
       if not InitialKey.Focused then {falls das Feld keinen Fokus hat}
         InitialKey.Tag := 0
     { else
         ClearMessageQueue(Sender) } ;
       ExitInitialKey := false; {Exit-Routine nicht mehr aktiv}
{$if Test=1}
       StatusBar.Panels.Items[1].Text :=
         'ExitInitialKey='+Format('%D',[integer(ExitInitialKey)]);
{$endif Test=1}
      end
     else
      if not ExitInitialKey then {keine Exit-Routine fr Feld aktiv}
        InitialKey.Tag := 0;
{$if Test=1}
   StatusBar.Panels.Items[2].Text :=
     'AllExitCount='+Format('%D',[AllExitCount])+';'
     +Format('%D',[InitialKey.Tag]);
{$endif Test=1}
  end;
end;

function ElemToHex(Wert: longint): string;
var
 bWert: array [1..4] of byte absolute wert;
 H1, H2: byte;
 cH1: char absolute H1;
 cH2: char absolute H2;
 I: longint;
begin
 ElemToHex := '';
{$if BSigRtL=0}
 for I := ElemBytes downto 1 do
{$else BSigRtL=1}
 for I := 5-ElemBytes to 4 do
{$endif BSigRtL}
  begin
   H1 := bWert[I] shr 4;
   H2 := bWert[I] and 15;
   if H1<10 then
     H1 := H1 + d0
   else
     H1 := H1 + cAS10;
   if H2<10 then
     H2 := H2 + d0
   else
     H2 := H2 + cAS10;
   ElemToHex := ElemToHex + cH1 + cH2;
  end;
end;

procedure TFMain.InitialKeyMouseMove(Sender: TObject; Shift:TShiftState;
                                     X, Y: Integer);
var
  wI: word;
{$if Gruppe=3}
  I: longint;
{$endif Gruppe=3}
begin
 if not InitialKeyHandlingB3.Checked then
  begin
   ShowCursorPos(InitialKey);
   if InitialKeyHandlingReply=1 then    { falls im Datei-Modus }
     ShowHideContents(InitialKey,InitialKeyLabel,X,Y);
  end
 else
  begin
{$if Test=1}
   StatusBar.Panels.Items[1].Text := 'X = '+Format('%.0N',[int(X)]);
   StatusBar.Panels.Items[2].Text := 'Y = '+Format('%.0N',[int(Y)]);
{$endif Test=1}
   if RandomKeyOperation and
      (not Random_angehalten) then
    begin
{$if Gruppe=1} (*
 A1 = (X and 255)+(Y and 255)
 A2 = (A1*KeyFaktor) and 255
    = (((X and 255)+(Y and 255))*KeyFaktor) and 255
 RandomKeyE2 := (A2*KeyFaktor+RandomKeyE1) and KeyAnzahlS1; *)
     RandomAnz := RandomAnz + 1;
     RandomKeyE2 := (((((X and 255)+(Y and 255))*KeyFaktor) and 255)
                     *KeyFaktor+RandomKeyE1) and KeyAnzahlS1;
{$endif Gruppe=1}
{$if Gruppe=2} (*
 B1 = (X1 and 255)+T1               A1 = (Y1 and 255)+T2
 B2 = (B1*KeyFaktor) and 255        A2 = (A1*KeyFaktor) and 255
 B3 = B2*256**1                     A3 = A2*256**0
    B3 = ((((X1 and 255)+ T1)*KeyFaktor) and 255)*256**1
    A3 = ((((Y1 and 255)+ T2)*KeyFaktor) and 255)*256**0
 B3+A3 = ((((X1 and 255)+T1)*KeyFaktor) and 255)*256
         +(((Y1 and 255)+T2)*KeyFaktor) and 255
 RandomKeyE2 := ((B3+A3)*KeyFaktor+RandomKeyE1) and KeyAnzahlS1; *)
     RandomAnz := RandomAnz + 1;
     RandomModus := (RandomModus + 1) and 7;
     if (RandomModus and 1)=0 then  {X und Y fr oberen/unteren Bereich}
      begin
       X1 := X;
       Y1 := Y;
      end
     else
      begin
       X1 := Y;
       Y1 := X;
      end;
     if (RandomModus and 2)=0 then{mit/ohne Tastenwert f. obern Bereich}
       T1 := 0
     else
       T1 := RandomKey;
     if RandomModus<4 then  {mit/ohne Tastenwert fr unteren Bereich}
       T2 := RandomKey
     else
       T2 := 0;
     RandomKeyE2 := ((((((X1 and 255)+T1)*KeyFaktor) and 255)*256
                     +((((Y1 and 255)+T2)*KeyFaktor) and 255))*KeyFaktor
                     +RandomKeyE1) and KeyAnzahlS1;
{$endif Gruppe=2}
{$if Gruppe=3}
(* 0 bzw. 1     G1-G2-Vert.   G1-G2-Vert.  G1-G2-Vert.
  G1-G2-Vert.   + G1-Vert.    + G2-Vert.   +G1- +G2-Vert.
 X1,Y1, X2,Y2   Y1,X1, X2,Y2  X1,Y1, Y2,X2  Y1,X1, Y2,X2
 X1,X2, Y1,Y2   X2,X1, Y1,Y2  X1,X2, Y2,Y1  X2,X1, Y2,Y1
 X1,Y2, X2,Y1   Y2,X1, X2,Y1  X1,Y2, Y1,X2  Y2,X1, Y1,X2
 X2,Y1, X1,Y2   Y1,X2, X1,Y2  X2,Y1, Y2,X1  Y1,X2, Y2,X1
 Y2,Y1, X2,X1   Y1,Y2, X2,X1  Y2,Y1, X1,X2  Y1,Y2, X1,X2
 2 G1-G2-Vert.
 X2,Y2, X1,Y1   Y2,X2, X1,Y1
 Y2,X2, Y1,X1   X2,Y2, Y1,X1
==> maximal 3 Vertauschungen
1. a.            b.            c.            d.            e.           
   +       +     +-------+     +       +     +-----------+ +           +
   I   +       + I   +       + I   +-------+ I   +   +   I I   +---+   I
   X1,Y1, X2,Y2  X2,Y1, X1,Y2  X1,Y2, X2,Y1  Y2,Y1, X2,X1  X1,X2, Y1,Y2 
2. a.            b.            c.            d.           
   +   +   +   + +---+   +   + +   +   +---+ +---+   +---+
   a1,b1, a2,b2  b1,a1, a2,b2  a1,b1, b2,a2  b1,a1, b2,a2 
3. a.            b.            
   +-------+     +-----------+ 
   I   +-------+ I   +---+   I 
   X2,Y2, X1,Y1  Y2,X2, Y1,X1  
4. a.            b.           
   +   +   +   + +---+   +   +
   a1,b1, a2,b2  b1,a1, a2,b2 
   v  v   v  v
   X1,Y1, X2,Y2,   T1,T2
   4* 3*  2* 1  =24  = 00011000 binr
                   *2 *2 = 96  = 01100000 binr
   +-v-+  +-v-+
     G1-    G2-Gruppe

 1(a,b,c,d,e) X 2(a,b,c,d)  und  3(a,b) X 4(a,b)
        5 * 4 = 20                2 * 2 = 4
   4  + 4  + 4  + 4   + 4     + 2   + 2              :Kombinationsanteil
  1a   1b   1c   1d    1e      3a    3b                :Vertauschung
 0-3  4-7  8-11 12-15 16-19   20-21 22-23              :Index
      2a           2b          2c            2d        :Vertauschung
 0,4,8,12,16  1,5,9,13,17  2,6,10,14,18  3,7,11,15,19  :Index
 i mod 4 =0   i mod 4 =1   i mod 4 =2    i mod 4 =3  und  i<20
   4a     4b                                           :Vertauschung
 20,22  21,23                                          :Index

 C1 = (X2 and 255)+(Y2 and 255)
 C2 = (C1*KeyFaktor) and 255
 C3 = C2*256**2

 B1 = (X1 and 255)+T1
 B2 = (B1*KeyFaktor) and 255
 B3 = B2*256**1

 A1 = (Y1 and 255)+T2
 A2 = (A1*KeyFaktor) and 255
 A3 = A2*256**0

 C3 = ((((X2 and 255)+(Y2 and 255))*KeyFaktor) and 255)*256**2
 B3 = ((((X1 and 255)+ T1         )*KeyFaktor) and 255)*256**1
 A3 = ((((Y1 and 255)+ T2         )*KeyFaktor) and 255)*256**0

 C3+B3+A3 = (((((X2 and 255)+(Y2 and 255))*KeyFaktor) and 255)*256
             +(((X1 and 255)+T1)*KeyFaktor) and 255)*256
             +(((Y1 and 255)+T2)*KeyFaktor) and 255
 RandomKeyE2 := ((C3+B3+A3)*KeyFaktor+RandomKeyE1) and KeyAnzahlS1; *)
     if PaarXY=2 then
      begin
       PaarXY := 1;
       RandomAnz := RandomAnz + 1;
       RandomModus := (RandomModus + 1) mod 96;
       I := RandomModus mod 24;
       case I of
        0,1,2,3:
         begin
          X1 := sX;
          Y1 := sY;
          X2 := X;
          Y2 := Y;
         end;
        4,5,6,7:
         begin
          X1 := X;
          Y1 := sY;
          X2 := sX;
          Y2 := Y;
         end;
        8,9,10,11:
         begin
          X1 := sX;
          Y1 := Y;
          X2 := X;
          Y2 := sY;
         end;
       12,13,14,15:
         begin
          X1 := Y;
          Y1 := sY;
          X2 := X;
          Y2 := sX;
         end;
       16,17,18,19:
         begin
          X1 := sX;
          Y1 := X;
          X2 := sY;
          Y2 := Y;
         end;
       20,21:
         begin
          X1 := X;
          Y1 := Y;
          X2 := sX;
          Y2 := sY;
         end;
       22,23:
         begin
          X1 := Y;
          Y1 := X;
          X2 := sY;
          Y2 := sX;
         end;
       end;
       if I<20 then
        case I mod 4 of
      (* 0: nichts weiter zu tun *)
         1:begin
            sX := X1;
            X1 := Y1;
            Y1 := sX;
           end;
         2:begin
            sX := X2;
            X2 := Y2;
            Y2 := sX;
           end;
         3:begin
            sX := X1;
            X1 := Y1;
            Y1 := sX;
            sX := X2;
            X2 := Y2;
            Y2 := sX;
           end;
        end
       else
        case I of
     (* 20,22: nichts weiter zu tun *)
        21,23:
           begin
            sX := X1;
            X1 := Y1;
            Y1 := sX;
           end;
        end;
       if (RandomModus and 32)=0 then {mit/ohne Tastenwert fr}
         T1 := 0                          {\ mittleren Bereich}
       else
         T1 := RandomKey;
       if (RandomModus and 64)=0 then {mit/ohne Tastenwert fr}
         T2 := RandomKey                    {\ unteren Bereich}
       else
         T2 := 0;
       RandomKeyE2 := 
           (((((((X2 and 255)+(Y2 and 255))*KeyFaktor) and 255)*256
              +(((X1 and 255)+T1)*KeyFaktor) and 255)*256
              +(((Y1 and 255)+T2)*KeyFaktor) and 255)*KeyFaktor
              +RandomKeyE1) and KeyAnzahlS1;
{$endif Gruppe=3}
     InitialKeyS := InitialKeyS + ElemToHex(RandomKeyE2);
     StatusBar.Panels.Items[0].Text :=
       FormatLE(MG[Sprache].StmRandomGen,[RandomAnz,KeyAnzahl]);
{$if Test=1}
     StatusBar.Panels.Items[3].Text := 'new = '+ElemToHex(RandomKeyE2);
{$endif Test=1}
     RandomKeyE1 := RandomKeyE2;
     if RandomAnz=KeyAnzahl then  {alle Schlsselelemente erzeugt}
      begin
       wI := 27;
       InitialKeyKeyDown(Sender,wI,Shift);
      end
{$if Gruppe=3}
      end
     else (* PaarXY=1 *)
      begin
       sX := X;
       sY := Y;
       PaarXY := 2;
      end;
{$endif Gruppe=3}
    end;
  end;
end;

procedure TFMain.InitialKeyMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if not InitialKeyHandlingB3.Checked then
  if InitialKeyHandlingReply=1 then   { falls im Datei-Modus}
    ClearMesBoxMouseDown(InitialKey,InitialKeyLabel)
  else
 else
  if RandomKeyOperation then
    RandomMouseDown := true;
end;

procedure TFMain.InitialKeyMouseUp(Sender: TOBject; Button:TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
{var
  wI: word;}
begin
 if not InitialKeyHandlingB3.Checked then
  begin
   if InitialKeyHandlingReply=1 then  { falls im Datei-Modus}
     ClearMesBoxMouseUp(InitialKey);
   MessageBoxCall := false;
  end
 else
  begin
   if not ExitInitialKey then
    if RandomKeyOperation then
     begin
   {  wI := 27;
      InitialKeyKeyDown(Sender,wI,Shift); }
      RandomMouseDown := false;
      Random_angehalten := true;
     end;
  end;
end;

procedure TFMain.InitialKeyOKClick(Sender: TObject);
begin
 if InitialKeyHandlingB3.Checked then
   InitialKeyHandlingB3Change(Sender);
end;

procedure TFMain.InitialKeyOvlChange(Sender: TObject);
begin
 if InitialKeyOvl.Checked then
 {if (Aktion=0) or (Aktion=1) or (Aktion=3) then}
  begin
   OverlayPanel.Enabled := true;
   OvlKopfLabel.Enabled := true;
   case OvlInfoImage of
    0: OvlInfoCheck.Visible := true;
    1: OvlInfoDialog.Visible := true;
    2: OvlInfoOK.Visible := true;
   end;
  end
 else
  begin
   OverlayPanel.Enabled := false;
   OvlKopfLabel.Enabled := false;
   case OvlInfoImage of
    0: OvlInfoCheck.Visible := false;
    1: OvlInfoDialog.Visible := false;
    2: OvlInfoOK.Visible := false;
   end;
  end;
end;

procedure TFMain.InitialKeyOvlLabelClick(Sender: TObject);
begin
 if InitialKeyHandlingReply<>4 then
  if InitialKeyOvl.Checked then
    InitialKeyOvl.Checked := false
  else
    InitialKeyOvl.Checked := true;
end;

procedure TFMain.InitialKeyOvlLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(InitialKeyOvlLabel.HelpKeyword);
end;

procedure TFMain.CodArtHLabel1Click(Sender: TObject);
begin
  case CodArt.ItemIndex of
  {0,1: nichts zu tun}
   2: CodArt.ItemIndex := 0;
   3: CodArt.ItemIndex := 1;
  end;
end;

procedure TFMain.CodArtHLabel2Click(Sender: TObject);
begin
  case CodArt.ItemIndex of
   0: CodArt.ItemIndex := 2;
   1: CodArt.ItemIndex := 3;
  {2,3: nichts zu tun}
  end;
end;

procedure TFMain.CodArtKopfLabelClick(Sender: TObject);
begin
  ShowHelpFile(CodArtKopfLabel.HelpKeyword);
end;

procedure TFMain.CodArtVLabel1Click(Sender: TObject);
begin
  case CodArt.ItemIndex of
  {0,2: nichts zu tun}
   1: CodArt.ItemIndex := 0;
   3: CodArt.ItemIndex := 2;
  end;
end;

procedure TFMain.CodArtVLabel2Click(Sender: TObject);
begin
  case CodArt.ItemIndex of
  {1,3: nichts zu tun}
   0: CodArt.ItemIndex := 1;
   2: CodArt.ItemIndex := 3;
  end;
end;

procedure TFMain.CodStatsLabelClick(Sender: TObject);
begin
  if CodStats.Checked then
    CodStats.Checked := false
  else
    CodStats.Checked := true;
end;

procedure TFMain.CodStatsLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(CodStatsLabel.HelpKeyword);
end;

(*{$if Safety>1}*)
procedure TFMain.CompDateiGroupDblClick(Sender: TObject);
begin
{$if Safety>1}
  ShowHelpFile(CompDateiGroup.HelpKeyword);
{$endif Safety>1}
end;

procedure TFMain.CompDateiDialogClick(Sender: TObject);
begin
{$if Safety>1}
  OpenDialogPar.FileName := '*.par';
  if OpenDialogPar.Execute then
    CompDatei.Text := OpenDialogPar.FileName;
{$endif Safety>1}
end;

procedure TFMain.CompDateiEnter(Sender: TObject);
begin
{$if Safety>1}
  EnterHidedField(CompDatei);
{$endif Safety>1}
end;

procedure TFMain.CompDateiClick(Sender: TObject);
begin
{$if Safety>1}
 if CompDatei.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   CompDateiEnter(Sender);      { dann dies jetzt nachholen         }
 ShowCursorPos(CompDatei);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyUp(Sender: TObject; var Key: Word;
                                Shift: TShiftState);
begin
{$if Safety>1}
  ShowCursorPos(CompDatei);
{$endif Safety>1}
end;

procedure TFMain.CompDateiExit(Sender: TObject);
begin
{$if Safety>1}
  DelCursorPos;
  ExitHidedField(CompDatei,CompDateiLabel);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyDown(Sender: TObject; var Key: Word;
                                  Shift: TShiftState);
begin
{$if Safety>1}
 if CompDatei.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   CompDateiEnter(Sender);      { dann dies jetzt nachholen         }
{$endif Safety>1}
end;

procedure TFMain.CompDateiMouseMove(Sender: TObject; Shift: TShiftState;
                                    X, Y: Integer);
begin
{$if Safety>1}
  ShowCursorPos(CompDatei);
  ShowHideContents(CompDatei,CompDateiLabel,X,Y);
{$endif Safety>1}
end;

procedure TFMain.CompDateiMouseDown(Sender:TOBject; Button:TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
begin
{$if Safety>1}
  ClearMesBoxMouseDown(CompDatei,CompDateiLabel);
{$endif Safety>1}
end;

procedure TFMain.CompDateiMouseUp(Sender: TOBject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
begin
{$if Safety>1}
  ClearMesBoxMouseUp(CompDatei);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyHandlingB1Change(Sender: TObject);
begin
{$if Safety>1}
 if CompDateiKeyHandlingB1.Checked then
  begin
   CompDateiKey.Text := '';
   CompDateiKey.HelpKeyword := 'COD/DirectKey.html';
   if CompDateiKeyHandlingReply=2 then
    begin
     CompDateiKey.Enabled := true;
     CompDateiKeyLabel.Visible := true;
     CompDateiKeyHexPanel.Visible := true;
     CompDateiKeyHexLabel.Visible := true;
    end;
   CompDateiKeyHandlingReply := 0;
   CompDateiKeyDialog.Visible := false;
   CompDateiKeyOK.Visible := false;
   CompDateiKeyCheck.Visible := true;
   CompDateiKeyImage := 0;
   CompDateiKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
   CompDateiKey.PasswordChar := '*';
   CompDateiKey.EchoMode := emPassword;
  end;
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyHandlingB2Change(Sender: TObject);
begin
{$if Safety>1}
 if CompDateiKeyHandlingB2.Checked then
  begin
   CompDateiKey.Text := '';
   CompDateiKey.HelpKeyword := 'COD/KeyDataset.html';
   if CompDateiKeyHandlingReply=2 then
    begin
     CompDateiKey.Enabled := true;
     CompDateiKeyLabel.Visible := true;
     CompDateiKeyHexPanel.Visible := true;
     CompDateiKeyHexLabel.Visible := true;
    end;
   CompDateiKeyHandlingReply := 1;
   CompDateiKeyOK.Visible := false;
   CompDateiKeyCheck.Visible := false;
   CompDateiKeyDialog.Visible := true;
   CompDateiKeyImage := 1;
   CompDateiKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR1);
  {CompDateiKey.PasswordChar := #0;
   CompDateiKey.EchoMode := emNormal;}
  end;
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyHandlingB3Change(Sender: TObject);
begin
{$if Safety>1}
 if CompDateiKeyHandlingB3.Checked then
  begin
   CompDateiKey.Text := FormatLE(MG[Sprache].PdatKeyTxtR2);
   CompDateiKey.PasswordChar := #0;
   CompDateiKey.EchoMode := emNormal;
   CompDateiKeyHandlingReply := 2;
   CompDateiKeyDialog.Visible := false;
   CompDateiKeyCheck.Visible := false;
   CompDateiKeyOK.Visible := false;
   CompDateiKeyImage := 3;
   CompDateiKey.Enabled := false;
   CompDateiKeyLabel.Visible := false;
   CompDateiKeyHexPanel.Visible := false;
   CompDateiKeyHexLabel.Visible := false;
  end;
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyHandlingDblClick(Sender: TObject);
begin
{$if Safety>1}
  ShowHelpFile(CompDateiKeyHandling.HelpKeyword);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyHexChange(Sender: TObject);
var
 aw: longint;
 IStr: string;
begin
{$if Safety>1}
 if CompDateiKeyHandlingB1.Checked and  {falls fr Direktkey noch keine}
    (not ExitCompDateiKey) then { Exit-Routine fr 'CompDateiKey' aktiv}
  begin {Werte sichern, die durch 'CompDateiKeyChange' verndert werden}
   ExitCompDateiKey := true;
   CompDateiKeyCheckedS := CompDateiKeyChecked;
   CompDateiKeyOK_Visible := CompDateiKeyOK.Visible;
   CompDateiKeyCheck_Visible := CompDateiKeyCheck.Visible;
   CompDateiKeyImageS := CompDateiKeyImage;
   if CompDateiKeyHex.Checked then
    begin
     IStr := CompDateiKey.Text;
     CharToHex(IStr); {Schlssel-Zeichen in Hex-Werte umwandeln}
     CompDateiKey.Text := IStr;{fhrt zum 'CompDateiKeyChange'-Aufruf !}
     if CompDateiKey.Tag>=FocusTag then
      begin { verdoppeln }
       CompDateiKey.SetFocus;   {'SelStart'/'SelLength' nur falls Focus}
       CompDateiKey.SelStart := CompDateiKey.SelStart shl 1; {\ gesetzt}
       CompDateiKey.SelLength := CompDateiKey.SelLength shl 1;
      end;
    end
   else
    begin
     IStr := CompDateiKey.Text;
     aw := HexToChar(IStr);
     if aw=0 then {Schlssel-Hex-Wert in Zeichen umwandeln, }
      begin       {         falls machbar (d.h. auer #00 !)}
       CompDateiKey.Text := IStr;{fhrt zum'CompDateiKeyChange'-Aufruf!}
       if CompDateiKey.Tag>=FocusTag then
        begin { halbieren }
         CompDateiKey.SetFocus; {'SelStart'/'SelLength' nur falls Focus}
         CompDateiKey.SelStart := CompDateiKey.SelStart shr 1;{\gesetzt}
         CompDateiKey.SelLength := (CompDateiKey.SelLength+1) shr 1;
        end;
      end
     else
      begin
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(KeyConvErr,[aw])),
           PChar(KeyHdCErr),16);
     { MessageBoxCall := true; }
       CompDateiKeyHex.Checked:=true; {weiterer 'CompDateiKeyHexChange'}
      end                                                     {\-Aufruf}
    end;
   CompDateiKeyChecked := CompDateiKeyCheckedS;  {'CompDateiKeyChange'-}
   CompDateiKeyOK.Visible := CompDateiKeyOK_Visible;{Werte zurcksetzen}
   CompDateiKeyCheck.Visible := CompDateiKeyCheck_Visible;
   CompDateiKeyImage := CompDateiKeyImageS;
   ExitCompDateiKey := false;
  end;
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyHexLabelClick(Sender: TObject);
begin
{$if Safety>1}
  if CompDateiKeyHex.Checked then
    CompDateiKeyHex.Checked := false
  else
    CompDateiKeyHex.Checked := true;
{$endif Safety>1}
end;

procedure TFMain.CompDateiOnlyLabelClick(Sender: TObject);
begin
{$if Safety>1}
  if CompDateiOnly.Checked then
    CompDateiOnly.Checked := false
  else
    CompDateiOnly.Checked := true;
{$endif Safety>1}
end;

procedure TFMain.CompDateiOnlyLabelDblClick(Sender: TObject);
begin
{$if Safety>1}
  ShowHelpFile(CompDateiOnlyLabel.HelpKeyword);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyDialogClick(Sender: TObject);
begin
{$if Safety>1}
  OpenDialogKey.FileName := '*.*';
  if OpenDialogKey.Execute then
    CompDateiKey.Text := OpenDialogKey.FileName;
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyCheckClick(Sender: TObject);
begin
{$if Safety>1}
  CompDateiKey.Tag := FocusTag;{ anzeigen, dass das Feld den Fokus hat }
  CompDateiKeyChecked := false;
  Exit2CompDateiKey := false;
  ClickCompDateiKey := true; { nachtrgliche berprfung -Flag setzen }
  CompDateiKeyExit(Sender);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyEnter(Sender: TObject);
begin
{$if Safety>1}
  CompDateiKey.Tag := FocusTag;{ anzeigen, dass das Feld den Fokus hat }
  if CompDateiKeyHandlingReply=1 then { falls im Datei-Modus }
    EnterHidedField(CompDateiKey)
  else
    Exit2CompDateiKey := false;
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyChange(Sender: TObject);
begin
{$if Safety>1}
 if CompDateiKeyHandlingB1.Checked then
  begin
   CompDateiKeyChecked := false;
   if not CompDateiKeyCheck.Visible then
    begin
     CompDateiKeyOK.Visible := false;
     CompDateiKeyCheck.Visible := true;
     CompDateiKeyImage := 0;
    end
  end
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyClick(Sender: TObject);
begin
{$if Safety>1}
 if CompDateiKey.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   CompDateiKeyEnter(Sender);      { dann dies jetzt nachholen         }
 ShowCursorPos(CompDateiKey);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyKeyDown(Sender: TObject; var Key: Word;
                                     Shift: TShiftState);
begin
{$if Safety>1}
 if CompDateiKey.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   CompDateiKeyEnter(Sender);      { dann dies jetzt nachholen         }
 if CompDateiKeyHandlingB1.Checked then {falls im Direktschlssel-Modus}
  if Key=13 then
    CompDateiKeyExit(Sender);  {"Return"-Taste als Feld-Exit annehmen}
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyKeyUp(Sender: TObject; var Key: Word;
                                   Shift: TShiftState);
begin
{$if Safety>1}
  ShowCursorPos(CompDateiKey);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyLabelDblClick(Sender: TObject);
begin
{$if Safety>1}
 if CompDateiKeyHandlingB1.Checked then
   ShowHelpFile('COD/DirectKey.html')
 else
  if CompDateiKeyHandlingB2.Checked then
    ShowHelpFile('COD/KeyDataset.html')
  else
    ShowHelpFile('COD/ParKey.html');
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyExit(Sender: TObject);
{$if Safety>1}
var
  aw, I: longint;
  IStr: string;
{$endif Safety>1}
begin
{$if Safety>1}
 DelCursorPos;
 if CompDateiKey.Tag>=FocusTag then {falls das Feld den Fokus hat}
  if CompDateiKeyHandlingReply=1 then { falls im Datei-Modus }
   begin
    MessageBoxCall := false;
    ExitHidedField(CompDateiKey,CompDateiKeyLabel)
   end
  else
   if (not CompDateiKeyHex.Focused) and
      (not ExitCompDateiKey) and  {falls noch keine Exit-Routine fr}
      (not CompDateiKeyChecked) then  { dieses Feld aktiv ist  u n d}
    begin         { noch kein erfolgreicher Check durchgefhrt wurde}
     ExitCompDateiKey := true; {anzeigen, dass fr dieses Feld   }
                               {jetzt eine Exit-Routine aktiv ist}
     MessageBoxCall := false;
     if CompDateiKeyHandlingReply=0 then{falls im Direktschlssel-Modus}
      begin
       aw := 0;
       I := 0;
       if CompDateiKeyHex.Checked then {Hexzeichen}
        begin
         IStr := CompDateiKey.Text;
         aw := HexCheck(IStr);
         if aw<>0 then  {'HexCheck' hat ein Problem entdeckt}
          if aw>0 then {ein Zeichen ist kein Hexzeichen}
           begin
            I := aw;
            with MG[Sprache] do
              Application.MessageBox(PChar(FormatLE(KeyHexErr,[I])),
                PChar(KeyHdSErr),16);
            MessageBoxCall := true;
           end
          else    {Hexzeichen-Anzahl nicht durch ElemBytes*2 teilbar}
           begin
            aw := -aw;  {Anzahl ergnzter Hexzeichen}
            I := Length(CompDateiKey.Text); {Stelle im Text}
            with MG[Sprache] do
              Application.MessageBox(PChar(FormatLE(KeyHNumErr,[I,aw])),
                PChar(KeyHdSWar),48);
            aw := 0;
            MessageBoxCall := true;
           end;
        end
       else      {keine Hexzeichen}
        begin
         I := Length(CompDateiKey.Text);
         if (I mod ElemBytes)<>0 then
          begin {Lnge ist nicht durch ElemBytes teilbar}
           with MG[Sprache] do
             Application.MessageBox(PChar(FormatLE(KeyNulCom,[I])),
               PChar(KeyHdSWar),48);
           MessageBoxCall := true;
          end
         else
           I := 0;
        end;
       if aw=0 then
        begin
         with MG[Sprache] do
           aw := Application.MessageBox(PChar(FormatLE(KeyQRep)),
                   PChar(KeyHdRep),36);
         if I>0 then {Markierung einer Stelle erst nach letzter}
          begin                                 {\ 'MessageBox'}
           CompDateiKey.SelStart := I-1;
           CompDateiKey.SelLength := 1;
          end
         else
           CompDateiKey.SelLength := 0;
         MessageBoxCall := true;
         if aw=6 then { Ja. --> Direktschlssel-Wiederholung }
          begin
         { Fr den Fall, dass der 'MessageBox'-Aufruf ggf. ein zweites
           ge"queue"tes 'CompDateiKeyExit'-Ereignis verursacht hat: }
           if not ClickCompDateiKey then {keine nachtrgl. berprfung}
             Exit2CompDateiKey := true;
           CompDateiKeyHandlingReply := 4;{Wiederholungsschlssel-Modus}
           CompDateiKeyLabel.Caption:=FormatLE(MG[Sprache].KeyLblR0rep);
           CompDateiKeyS := CompDateiKey.Text;
           CompDateiKeyHexS := CompDateiKeyHex.Checked;
           CompDateiKey.Text := '';
           CompDateiKeyHandling.Enabled := false;
           { alle sonstigen Elemente als nicht auswhlbar kennzeichnen }
           SprachBox.Enabled := false;
           AusDateiDialog.Visible := false;
           AusDatei.Enabled := false;
           AusDateiHandling.Enabled := false;
           OperClear.Enabled := false;
           OperStart.Enabled := false;
           OperExit.Enabled := false;
           ActionPanel.Enabled := false;
           ActionHandlingLabel.Enabled := false;
           InitialKeyPanel.Enabled := false;
           InitialKeyKopfLabel.Enabled := false;
           case InitialKeyImage of
            0: InitialKeyCheck.Visible := false;
            1: InitialKeyDialog.Visible := false;
            2: InitialKeyOK.Visible := false;
            3: InitialKeyMaus.Visible := false;
           end;
           CodArtHBox.Enabled := false;
           CodArt.Enabled := false;
           CodStats.Enabled := false;
           CodDateiArtPanel.Enabled := false;
           CodDateiDialog.Visible := false;
           CodDatei.Enabled := false;
           ExpDateiDialog.Visible := false;
           ExpDatei.Enabled := false;
           CompDatei.Enabled := false;
           CompDateiDialog.Enabled := false;
           CompDateiOnly.Enabled := false;
           ParDateiPanel.Enabled := false;
           ParDateiKopfLabel.Enabled := false;
           ParDateiDialog.Visible := false;
           case ParDateiOpKeyImage of
            0: ParDateiOpKeyCheck.Visible := false;
            1: ParDateiOpKeyDialog.Visible := false;
            2: ParDateiOpKeyOK.Visible := false;
           end;
           case ParDateiClsKeyImage of
            0: ParDateiClsKeyCheck.Visible := false;
            1: ParDateiClsKeyDialog.Visible := false;
            2: ParDateiClsKeyOK.Visible := false;
           end;
         { ActiveControl := CompDateiKey; }
          end
         else  { Nein. --> keine Direktschlssel-Wiederholung }
           CompDateiKeyChecked := true;  {es hat eine Bearbeitung durch}
        end                              {  den Benutzer stattgefunden }
       else  {'HexCheck'-Fehler, keine -Warnung}
        begin
         CompDateiKey.SetFocus;
         CompDateiKey.SelStart := I-1;
         CompDateiKey.SelLength := 1;
         ShowCursorPos(CompDateiKey);
        end;
      end
     else { falls im Wiederholungs-Schlssel-Modus }
      begin
       ExitCompDateiKey := false; {lst ggf.'CompDateiKeyHexChange' aus}
       CompDateiKeyHex.Checked := CompDateiKeyHexS;
       ExitCompDateiKey := true;  {knnte 'HexToChar'-Fehler ausgelst}
       if (CompDateiKeyHex.Checked=CompDateiKeyHexS) and      {\ haben}
          (CompDateiKeyS=CompDateiKey.Text) then
        begin  { Ausgangs- und Wiederholungs-Schlssel sind identisch }
         CompDateiKeyCheck.Visible := false;
         CompDateiKeyOK.Visible := true;
         CompDateiKeyImage := 2;
        end
       else
        begin
       { CompDateiKeyOK.Visible := false;
         CompDateiKeyCheck.Visible := true;
         CompDateiKeyImage := 0; }
         IStr := CompDateiKey.Text; {1. Unterschiedsstelle ermitteln}
         I := Length(IStr);
         if I<>Length(CompDateiKeyS) then
          if I>Length(CompDateiKeyS) then
            I := Length(CompDateiKeyS);
         for aw := 1 to I do  {Schleife ber gemeinsame Stellen}
          begin
           if CompDateiKeyS[aw]<>IStr[aw] then
             break;
          end;
         if (I>0) and
            ((aw<I) or
             (CompDateiKeyS[aw]<>IStr[aw])) then
           I := aw
         else  {gemeinsame Stellen sind identisch}
           I := I + 1;
         CompDateiKey.Text := '';{damit kein 'HexToChar'-Fehler mglich}
         ExitCompDateiKey := false;{lst ggf.'CompDateiKeyHexChange'aus}
         CompDateiKeyHex.Checked := CompDateiKeyHexS;
         ExitCompDateiKey := true;
         CompDateiKey.Text := CompDateiKeyS;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(KeyDifErr,[I])),
             PChar(KeyHdRErr),48);
         MessageBoxCall := true;
         CompDateiKey.SetFocus;
         if I<=Length(CompDateiKeyS) then
          begin  {falls Differenzstelle im Ausgangsschlssel anzeigbar}
           CompDateiKey.SelStart := I-1;
           CompDateiKey.SelLength := 1;
          end
         else
          begin  {sonst den gesamten Ausgangs-Schlssel markieren}
           CompDateiKey.SelStart := 0;
           CompDateiKey.SelLength := Length(CompDateiKeyS);
          end;
         ShowCursorPos(CompDateiKey);
        end;
       CompDateiKeyChecked := true; {es hat eine Bearbeitung durch
                                      den Benutzer stattgefunden}
       CompDateiKeyHandlingReply := 0; {Wiederholungskey-Modus aufheben}
       CompDateiKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
       {alle Felder "entsperren"}
       CompDateiKeyHandling.Enabled := true;
       { alle sonstigen Elemente }
       SprachBox.Enabled := true;
       AusDateiDialog.Visible := true;
       AusDatei.Enabled := true;
       AusDateiHandling.Enabled := true;
       OperClear.Enabled := true;
       OperStart.Enabled := true;
       OperExit.Enabled := true;
       ActionPanel.Enabled := true;
       ActionHandlingLabel.Enabled := true;
       InitialKeyPanel.Enabled := true;
       InitialKeyKopfLabel.Enabled := true;
       case InitialKeyImage of
        0: InitialKeyCheck.Visible := true;
        1: InitialKeyDialog.Visible := true;
        2: InitialKeyOK.Visible := true;
        3: InitialKeyMaus.Visible := true;
       end;
       CodArtHBox.Enabled := true;
       CodArt.Enabled := true;
       CodStats.Enabled := true;
       CodDateiArtPanel.Enabled := true;
       CodDateiDialog.Visible := true;
       CodDatei.Enabled := true;
       ExpDateiDialog.Visible := true;
       ExpDatei.Enabled := true;
       CompDatei.Enabled := true;
       CompDateiDialog.Enabled := true;
       CompDateiOnly.Enabled := true;
       if Aktion<>0 then
        begin
         ParDateiPanel.Enabled := true;
         ParDateiKopfLabel.Enabled := true;
         ParDateiDialog.Visible := true;
         if ParDateiOpKeyHandling.Enabled then
           case ParDateiOpKeyImage of
            0: ParDateiOpKeyCheck.Visible := true;
            1: ParDateiOpKeyDialog.Visible := true;
            2: ParDateiOpKeyOK.Visible := true;
           end;
         if ParDateiClsKeyHandling.Enabled then
           case ParDateiClsKeyImage of
            0: ParDateiClsKeyCheck.Visible := true;
            1: ParDateiClsKeyDialog.Visible := true;
            2: ParDateiClsKeyOK.Visible := true;
           end;
        end;
      end;
     if not CompDateiKey.Focused then {falls das Feld keinen Fokus hat}
       CompDateiKey.Tag := 0
   { else
       ClearMessageQueue(Sender) } ;
     if not Exit2CompDateiKey then
      begin
       ExitCompDateiKey := false; {Exit-Routine nicht mehr aktiv}
       ClickCompDateiKey := false;{nachtrgliche berprfung-Flag}
      end                                         {\ zurcksetzen}
    end
   else
    if not ExitCompDateiKey then  {keine Exit-Routine fr Feld aktiv}
      CompDateiKey.Tag := 0
    else
     if Exit2CompDateiKey then  {ge"queue"te Exit-Routine berlesen}
      begin
       ExitCompDateiKey := false;
       Exit2CompDateiKey := false;
       if not CompDateiKey.Focused then{falls das Feld keinen Fokus hat}
         CompDateiKey.Tag := 0
      end;
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
{$if Safety>1}
  ShowCursorPos(CompDateiKey);
  if CompDateiKeyHandlingReply=1 then    { falls im Datei-Modus }
    ShowHideContents(CompDateiKey,CompDateiKeyLabel,X,Y);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
{$if Safety>1}
 if CompDateiKeyHandlingReply=1 then  { falls im Datei-Modus}
   ClearMesBoxMouseDown(CompDateiKey,CompDateiKeyLabel);
{$endif Safety>1}
end;

procedure TFMain.CompDateiKeyMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
{$if Safety>1}
 if CompDateiKeyHandlingReply=1 then  { falls im Datei-Modus}
   ClearMesBoxMouseUp(CompDateiKey);
 MessageBoxCall := false;
{$endif Safety>1}
end;
(*{$endif Safety>1}*)

procedure TFMain.CodDateiArtB1Change(Sender: TObject);
begin
 if CodDateiArtB1.Checked then
  begin
   if CodDateiArtReply=1 then
    begin
     DtnOpen.Enabled := false;
     DtnOpen.Visible := false;
     DtnClose.Visible := false;
     DtnSave.Visible := false;
    end;
   CodDateiArtReply := 0;
{$if Test=1}
   StatusBar.Panels.Items[1].Text :=
     'CodDateiArtReply ='+Format('%.0N',[int(CodDateiArtReply)]);
{$endif Test=1}
   CodDatei.HelpKeyword := 'COD/DirectCodDat.html';
   CodDateiArtB1Memo.Color := clWindow;
   CodDateiLabel.Caption := FormatLE(MG[Sprache].DatCod);
   CodDatei.Text := '';
  end
 else
   CodDateiArtB1Memo.Color := clActiveBorder;
end;

procedure TFMain.CodDateiArtB2Change(Sender: TObject);
begin
 if CodDateiArtB2.Checked then
  begin
   CodDateiArtReply := 1;
{$if Test=1}
   StatusBar.Panels.Items[1].Text :=
     'CodDateiArtReply ='+Format('%.0N',[int(CodDateiArtReply)]);
{$endif Test=1}
   CodDatei.HelpKeyword := 'COD/DtnFile.html';
   CodDateiArtB2Memo.Color := clWindow;
   CodDateiLabel.Caption := FormatLE(MG[Sprache].DatCovDat);
   CodDatei.Text := '';
   DtnOpen.Visible := true;
   DtnClose.Visible := true;
   DtnSave.Visible := true;
  end
 else
   CodDateiArtB2Memo.Color := clActiveBorder;
end;

procedure TFMain.CodDateiArtB3Change(Sender: TObject);
begin
 if CodDateiArtB3.Checked then
  begin
   if CodDateiArtReply=1 then
    begin
     DtnOpen.Enabled := false;
     DtnOpen.Visible := false;
     DtnClose.Visible := false;
     DtnSave.Visible := false;
    end;
   if CodDateiArtReply<>3 then
     CodDatei.Text := '';
   CodDateiArtReply := 2;
{$if Test=1}
   StatusBar.Panels.Items[1].Text :=
     'CodDateiArtReply ='+Format('%.0N',[int(CodDateiArtReply)]);
{$endif Test=1}
   CodDatei.HelpKeyword := 'COD/CodDir.html';
   CodDateiArtB3Memo.Color := clWindow;
   CodDateiLabel.Caption := FormatLE(MG[Sprache].DatDir);
  end
 else
   CodDateiArtB3Memo.Color := clActiveBorder;
end;

procedure TFMain.CodDateiArtB4Change(Sender: TObject);
begin
 if CodDateiArtB4.Checked then
  begin
   if CodDateiArtReply=1 then
    begin
     DtnOpen.Enabled := false;
     DtnOpen.Visible := false;
     DtnClose.Visible := false;
     DtnSave.Visible := false;
    end;
   if CodDateiArtReply<>2 then
     CodDatei.Text := '';
   CodDateiArtReply := 3;
{$if Test=1}
   StatusBar.Panels.Items[1].Text :=
     'CodDateiArtReply ='+Format('%.0N',[int(CodDateiArtReply)]);
{$endif Test=1}
   CodDatei.HelpKeyword := 'COD/CodDir.html';
   CodDateiArtB4Memo.Color := clWindow;
   CodDateiLabel.Caption := FormatLE(MG[Sprache].DatDirSub);
  end
 else
   CodDateiArtB4Memo.Color := clActiveBorder;
end;

procedure TFMain.SprachBoxLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(SprachBoxLabel.HelpKeyword);
end;

procedure TFMain.StatusBarDblClick(Sender: TObject);
begin
  ShowHelpFile(StatusBar.HelpKeyword);
end;

procedure TFMain.sysjmLogoClick(Sender: TObject);
begin
  ShowHelpFile(sysjmLogo.HelpKeyword);
end;

procedure TFMain.TimeOutHandlingB1Change(Sender: TObject);
begin
 if TimeOutHandlingB1.Checked then
  begin
   TimeOutHandlingReply := 0;
   TimeOutHandlingB1Memo.Color := clWindow;
  end
 else
   TimeOutHandlingB1Memo.Color := clActiveBorder;
end;

procedure TFMain.TimeOutHandlingB1MemoEnter(Sender: TObject);
begin
  TimeOutHandlingB1.Checked := true; {siehe 'TimeOutHandlingB1Change'}
end;

procedure TFMain.TimeOutHandlingB1MemoExit(Sender: TObject);
begin {um alle Zeilen wieder sichtbar zu machen, falls verschoben:}
  TimeOutHandlingB1Memo.Lines.Strings[0] :=
    TimeOutHandlingB1Memo.Lines.Strings[0];
end;

procedure TFMain.TimeOutHandlingB2Change(Sender: TObject);
begin
 if TimeOutHandlingB2.Checked then
  begin
   TimeOutHandlingReply := 1;
   TimeOutHandlingB2Memo.Color := clWindow;
  end
 else
   TimeOutHandlingB2Memo.Color := clActiveBorder;
end;

procedure TFMain.TimeOutHandlingB2MemoEnter(Sender: TObject);
begin
  TimeOutHandlingB2.Checked := true; {siehe 'TimeOutHandlingB2Change'}
end;

procedure TFMain.TimeOutHandlingB2MemoExit(Sender: TObject);
begin
  TimeOutHandlingB2Memo.WordWrap := true; {um die Zeile wieder sichtbar}
    TimeOutHandlingB2Memo.WordWrap := false;{zu machen,falls verschoben}
end;

procedure TFMain.CodDateiArtB1MemoEnter(Sender: TObject);
begin
  CodDateiArtB1.Checked := true; {siehe 'CodDateiArtB1Change'}
end;

procedure TFMain.CodDateiArtB1MemoExit(Sender: TObject);
begin
  CodDateiArtB1Memo.Lines.Strings[0] := {um alle Zeilen wieder sichtbar}
    CodDateiArtB1Memo.Lines.Strings[0]; {   zu machen, falls verschoben}
end;

procedure TFMain.CodDateiArtB2MemoEnter(Sender: TObject);
begin
  CodDateiArtB2.Checked := true; {siehe 'CodDateiArtB2Change'}
end;

procedure TFMain.CodDateiArtB2MemoExit(Sender: TObject);
begin
  CodDateiArtB2Memo.Lines.Strings[0] := {um alle Zeilen wieder sichtbar}
    CodDateiArtB2Memo.Lines.Strings[0]; {   zu machen, falls verschoben}
end;

procedure TFMain.CodDateiArtB3MemoEnter(Sender: TObject);
begin
  CodDateiArtB3.Checked := true; {siehe 'CodDateiArtB3Change'}
end;

procedure TFMain.CodDateiArtB3MemoExit(Sender: TObject);
begin
  CodDateiArtB3Memo.WordWrap := true;    {um die Zeile wieder sichtbar}
    CodDateiArtB3Memo.WordWrap := false; { zu machen, falls verschoben}
end;

procedure TFMain.CodDateiArtB4MemoEnter(Sender: TObject);
begin
  CodDateiArtB4.Checked := true; {siehe 'CodDateiArtB4Change'}
end;

procedure TFMain.CodDateiArtB4MemoExit(Sender: TObject);
begin
  CodDateiArtB4Memo.Lines.Strings[0] := {um alle Zeilen wieder sichtbar}
    CodDateiArtB4Memo.Lines.Strings[0]; {   zu machen, falls verschoben}
end;

procedure TFMain.CodDateiArtClick(Sender: TObject);
begin
  ShowHelpFile(CodDateiArt.HelpKeyword);
end;

procedure TFMain.CodDateiDialogClick(Sender: TObject);
begin
  case CodDateiArtReply of
   0: begin
       OpenDialogCod.FileName := '*.*';
       if OpenDialogCod.Execute then
         CodDatei.Text := OpenDialogCod.FileName;
      end;
   1: begin
       OpenDialogDtn.FileName := '*.dtn';
       if OpenDialogDtn.Execute then
         CodDatei.Text := OpenDialogDtn.FileName;
       if CodStatus=0 then
        if CodDatei.Text='' then
          DtnOpen.Enabled := false
        else
          DtnOpen.Enabled := true;
      end;
   2: begin
        OpenDialogDir.Title := FormatLE(MG[Sprache].OpnDirTit);
        if OpenDialogDir.Execute then
          CodDatei.Text := OpenDialogDir.FileName;
      end;
   3: begin
        OpenDialogDir.Title := FormatLE(MG[Sprache].OpnDirSubTit);
        if OpenDialogDir.Execute then
          CodDatei.Text := OpenDialogDir.FileName;
      end;
  end;
end;

procedure TFMain.CodDateiLabelDblClick(Sender: TObject);
begin
  case CodDateiArtReply of
   0: ShowHelpFile('COD/DirectCodDat.html');
   1: ShowHelpFile('COD/DtnFile.html');
   2: ShowHelpFile('COD/CodDir.html');
   3: ShowHelpFile('COD/CodDir.html');
  end;
end;

procedure TFMain.CodDateiChange(Sender: TObject);
begin
  if CodStatus=0 then
   if CodDatei.Text='' then
     DtnOpen.Enabled := false
   else
     DtnOpen.Enabled := true;
end;

(*{$if Safety>0}*)
procedure TFMain.CodStreamChange(Sender: TObject);
begin
{$if Safety>0}
  if CodStream.Checked then
   begin
    CodStreamLabel.Font.Color := clRed;
    if Aktion=4 then
      ParDateiOpKeyHandling.Caption := FormatLE(MG[Sprache].PdatOpKHS);
 {$if Safety>1}
    CompDateiGroup.Enabled := true;
    CompDateiDialog.Visible := true;
    case CompDateiKeyImage of
     0: CompDateiKeyCheck.Visible := true;
     1: CompDateiKeyDialog.Visible := true;
     2: CompDateiKeyOK.Visible := true;
    end;
 {$endif Safety>1}
   end
  else
   begin
    CodStreamLabel.Font.Color := clWindowText;
    ParDateiOpKeyHandling.Caption := FormatLE(MG[Sprache].PdatOpKH);
 {$if Safety>1}
    CompDateiGroup.Enabled := false;
    CompDateiDialog.Visible := false;
    case CompDateiKeyImage of
     0: CompDateiKeyCheck.Visible := false;
     1: CompDateiKeyDialog.Visible := false;
     2: CompDateiKeyOK.Visible := false;
    end;
 {$endif Safety>1}
   end;
{$endif Safety>0}
end;

procedure TFMain.CodStreamLabelClick(Sender: TObject);
begin
{$if Safety>0}
  if CodStream.Checked then
    CodStream.Checked := false
  else
    CodStream.Checked := true;
{$endif Safety>0}
end;

procedure TFMain.CodStreamLabelDblClick(Sender: TObject);
begin
{$if Safety>0}
  ShowHelpFile(CodStreamLabel.HelpKeyword);
{$endif Safety>0}
end;

procedure TFMain.CodStreamPanelDblClick(Sender: TObject);
begin
{$if Safety>0}
  ShowHelpFile(CodStreamLabel.HelpKeyword);
{$endif Safety>0}
end;
(*{$endif Safety>0}*)

(*{$if Safety<2}*)
procedure TFMain.CodDateiConfChange(Sender: TObject);
begin
{$if Safety<2}
  if CodDateiConf.Checked then
   begin
    CodDateiConfMemo.Color := clActiveBorder;
    CodDateiConfMemo.Font.Color := clWindowText;
   end
  else
   begin
    CodDateiConfMemo.Color := clWindow;
    CodDateiConfMemo.Font.Color := clRed;
   end;
{$endif Safety<2}
end;

procedure TFMain.CodDateiConfMemoExit(Sender: TObject);
begin
{$if Safety<2}
  CodDateiConfMemo.Lines.Strings[0] := {um alle Zeilen wieder sichtbar}
    CodDateiConfMemo.Lines.Strings[0]; {   zu machen, falls verschoben}
{$endif Safety<2}
end;
(*{$endif Safety<2}*)

procedure CloseDtnDatei;
begin
  FileClose(DtnHandle);
  if CodStatus=1 then
   begin
    FMain.DtnListe.Clear;
    CodStatus := 0;
    FMain.CodDateiLabel.Caption := FormatLE(MG[Sprache].DatCovDat);
    FMain.CodDatei.Text := DateiSName;
    { DtnListe und Button zurcksetzen }
    FMain.DtnInsert.Visible := false;
    FMain.DtnDelete.Visible := false;
    FMain.DtnPlaceUp.Visible := false;
    FMain.DtnPlaceDown.Visible := false;
    FMain.DtnListe.Visible := false;
    { ExpDatei-Button zurcksetzen }
    FMain.ExpDateiDialog.Visible := true;
    FMain.ExpDatei.Enabled := true;
    if FMain.ExpDatei.Text<>'' then
      FMain.ExpOpen.Enabled := true;
    { DtnDatei-Button zurcksetzen }
    FMain.DtnOpen.Enabled := true;
    FMain.DtnClose.Enabled := false;
    FMain.DtnSave.Enabled := false;
   end
  else { ExpStatus=1 }
   begin
    FMain.ExpListe.Clear;
    ExpStatus := 0;
    FMain.ExpDateiLabel.Caption := FormatLE(MG[Sprache].DatExpDat);
    FMain.ExpDatei.Text := DateiSName;
    { ExpListe und Button zurcksetzen }
    FMain.ExpInsert.Visible := false;
    FMain.ExpDelete.Visible := false;
    FMain.ExpPlaceUp.Visible := false;
    FMain.ExpPlaceDown.Visible := false;
    FMain.ExpListe.Visible := false;
    { CodDatei-Button zurcksetzen }
    FMain.CodDateiDialog.Visible := true;
    FMain.CodDatei.Enabled := true;
    if (CodDateiArtReply=1) and (FMain.CodDatei.Text<>'') then
      FMain.DtnOpen.Enabled := true;
    { ExpDatei-Button zurcksetzen }
    FMain.ExpOpen.Enabled := true;
    FMain.ExpClose.Enabled := false;
    FMain.ExpSave.Enabled := false;
   end;
  { alle sonstigen Elemente wieder als auswhlbar kennzeichnen }
  FMain.SprachBox.Enabled := true;
  FMain.AusDateiDialog.Visible := true;
  FMain.AusDatei.Enabled := true;
  FMain.AusDateiHandling.Enabled := true;
  FMain.OperClear.Enabled := true;
  FMain.OperStart.Enabled := true;
  FMain.OperExit.Enabled := true;
  FMain.ActionPanel.Enabled := true;
  FMain.ActionHandlingLabel.Enabled := true;
  case Aktion of {'InitialKey'-, 'Overlay'- und 'ParDatei'-Bereiche}
   0:begin       { werden von 'ActionHandlingB_Change' erledigt    }
      FMain.ActionHandlingB1.Checked := false;
      FMain.ActionHandlingB1.Checked := true;
     end;
  {1:; 2:; nicht mglich, da keine Dateikodierung}
   3:begin
      FMain.ActionHandlingB4.Checked := false;
      FMain.ActionHandlingB4.Checked := true;
     end;
   4:begin
      FMain.ActionHandlingB5.Checked := false;
      FMain.ActionHandlingB5.Checked := true;
     end;
  end;
  FMain.CodDateiArtPanel.Enabled := true;
  FMain.CodDateiArt.Enabled := true;
{$if Safety<2}
  FMain.CodDateiConf.Visible := true;
{$else Safety>1}
  FMain.CompDateiGroup.Visible := true;
{$endif Safety}
end;

function CheckZeile(var DtnListe: TListBox;
                    var Zeile: string; ZNr: longint): boolean;
                       { 'ZNr' = Zeilennummer; 'true' = Zeile einfgen }
{ Wie kann geklrt werden, ob zwei mit '*' und '?' versehene Ausdrcke
  theoretisch einen nicht leeren Schnitt haben ?
  1. Separierung durch den Anfang bis zum ersten '*'-Zeichen:
     - Beide Anfangs-Teile (ohne den ersten '*') werden nur bis zum
       krzeren Anfangs-Teil der beiden betrachtet.
     - Ein '?' im einen Anfangs-Teil wird durch ein '?' im anderen
       Anfangs-Teil ersetzt und umgekehrt.
  2. Separierung durch das Ende von rechts bis zum ersten '*'-Zeichen:
     - Beide End-Teile (ohne den letzten '*') werden nur bis zum
       krzeren End-Teil der beiden betrachtet.
     - Ein '?' im einen End-Teil wird durch ein '?' im anderen
       End-Teil ersetzt und umgekehrt.
  3. Sind Anfangs- und End-Teil (jeweils der krzere von beiden) dann
     identisch, so liegt eine theoretische berschneidung vor.
       D.h. es lt sich mindestens ein Dateiname finden, der beiden
     Ausdrcken gengen wrde. Mithin ist eine Warnung auszugeben, dass
     eine Datei zu beiden Ausdrcken gehren knnte (mu aber nicht !).
     Ggf. ist die Frage zu stellen, ob der zweite Eintrag dennoch
     bernommen werden soll (-> 'Ja','Nein'), was ggf. zu einer
     doppelten Bearbeitung gemeinsamer Dateien fhren wrde.
  4. Fr einfache Dateinamen (d.h. ohne '*'-Zeichen) wird eine
     Warnung auf identische Eintrge ausgegeben mit der Frage, ob der
     zweite Eintrag dennoch bernommen werden soll (-> 'Ja','Nein'),
     was  d e   f a c t o  zu einer doppelten Bearbeitung fhrt.
  5. Bei einer oder zwei  V e r z e i c h n i s b a u m -Angaben werden
     zunchst die Verzeichnisnamen-Anteile separiert und verglichen.
       Ist der Verzeichnisnamen-Anteil einer Verzeichnisbaum-Angabe der
     fordere Teil des anderen Verzeichnisnamen-Anteils(egal ob ebenfalls
     Verzeichnisbaum- oder Datei-Ausdruck), so sind die separierten
     Dateinamen-Anteile gem dem zuvor gesagten zu berprfen. Ist dies
     nicht der Fall, so sind keine berschneidungen mglich. }
var
 sameSet, sameSetmaybe, ohneStern, IdirTree, ZdirTree: boolean;
 aw: byte;
 I, J: longint;
 IDirName, ItemAnf, ItemEnd, ItemRand,
   ZDirName, ZDatName, ZAnf, ZEnd, ZRand, MText: string;
begin
  if Length(Zeile)=0 then
   begin
    CheckZeile := false;
    Exit;
   end;
  CheckZeile := true;
  sameSet := false;
  sameSetmaybe := false;
  if ZNr=0 then
    MText := FormatLE(MG[Sprache].DatInsLin)
  else
    MText := FormatLE(MG[Sprache].DatNoLin,[ZNr]);
  if Zeile[1]='<' then
   begin
    ZdirTree := true;
    if Zeile[Length(Zeile)]<>'>' then
     begin
      ZRand := AnsiUpperCase(Copy(Zeile,2,Length(Zeile)-1));
      if Length(Zeile)<255 then
        Zeile := Zeile + '>';
     end
    else
      ZRand := AnsiUpperCase(Copy(Zeile,2,Length(Zeile)-2));
    if Length(ZRand)>0 then
     if (ZRand[Length(ZRand)]=':') and (Length(ZRand)<253) then
       ZRand := ZRand + '*.*';(*sonst falsche Werte fr 'Dir' + 'Dat'!*)
   end                        (* ==> 'ExpandFileName'-Problem !! *)
  else
   begin
    ZdirTree := false;
    ZRand := AnsiUpperCase(Zeile);
   end;
  ZRand := ExpandFileName(ZRand);
  ZDirName := AnsiUpperCase(ExtractFilePath(ZRand));
  ZDatName := AnsiUpperCase(ExtractFileName(ZRand));
  if ZDatName='' then
    ZDatName := '*.*';
  ohneStern := Pos('*',ZDatName)=0;
  if not ohneStern then
   begin
    ZAnf := StrUtils.Copy2Symb(ZDatName,'*');
    ZEnd := StrUtils.Copy2Symb(StrUtils.ReverseString(ZDatName),'*');
   end;
  for I := 0 to DtnListe.Items.Count-1 do
   begin
{$if Test=1}
    Application.MessageBox(PChar('Index I:>'+Format('%.0N',[int(I)])
     +'<, Length(Items.Strings[I]):'
     +Format('%.0N',[int(Length(DtnListe.Items.Strings[I]))])
     +'<,'+eolStr+' Length(Zeile):'+Format('%.0N',[int(Length(Zeile))])
     +'<, DtnListe.Items.Strings:>'+DtnListe.Items.Strings[I]+'<'
      ),'TEST',0);
{$endif Test=1}
    ItemRand := AnsiUpperCase(DtnListe.Items.Strings[I]);
    if ItemRand[1]='<' then
     begin
      IdirTree := true;
      if ItemRand[Length(ItemRand)]<>'>' then
        ItemRand := Copy(ItemRand,2,Length(ItemRand)-1)
      else
        ItemRand := Copy(ItemRand,2,Length(ItemRand)-2);
      if Length(ItemRand)>0 then
       if (ItemRand[Length(ItemRand)]=':') and
          (Length(ItemRand)<253) then
         ItemRand := ItemRand+'*.*';(* sonst falsche Werte fr*)
     end                            (*\     'Dir' und 'Dat' ! *)
    else
      IdirTree := false;
    ItemRand := ExpandFileName(ItemRand);
    IDirName := AnsiUpperCase(ExtractFilePath(ItemRand));
    ItemRand := AnsiUpperCase(ExtractFileName(ItemRand));
    if ItemRand='' then
      ItemRand := '*.*';
    if ((not ZdirTree) and (not IdirTree) and
        (ZDirName<>IDirName)) or
       ((not ZdirTree) and IdirTree and
        (Copy(ZDirName,1,Length(IDirName))<>IDirName)) or
       (ZdirTree and (not IdirTree) and
        (Copy(IDirName,1,Length(ZDirName))<>ZDirName)) or
       (ZdirTree and IdirTree and
        (Copy(ZDirName,1,Length(IDirName))<>IDirName) and
        (Copy(IDirName,1,Length(ZDirName))<>ZDirName)) then
      sameSet := false
    else
     if ohneStern then  (*------ Zeile ohne '*' ------*)
      begin
       sameSet := true;
       ZRand := ZDatName;
       if Pos('*',ItemRand)=0 then
            (*--- beide ohne '*' ---*)
        if Length(ZRand)=Length(ItemRand) then
         for J := 1 to Length(ZRand) do
          if (ZRand[J]<>'?') and
             (ItemRand[J]<>'?') and
             (ZRand[J]<>ItemRand[J]) then
           begin
            sameSet := false;
            break;
           end
          else
        else
          sameSet := false
       else (*--- Item mit '*' ---*)
        begin
         ItemAnf := StrUtils.Copy2Symb(ItemRand,'*');
         ItemEnd :=
           StrUtils.Copy2Symb(StrUtils.ReverseString(ItemRand),'*');
         if Length(ItemAnf)+Length(ItemEnd)>Length(ZRand) then
           sameSet := false
         else (* '<=' *)
          begin
           ZAnf := Copy(ZRand,1,Length(ItemAnf));
           ZEnd :=Copy(StrUtils.ReverseString(ZRand),1,Length(ItemEnd));
           ZRand := ZAnf+ZEnd;
           ItemRand := ItemAnf+ItemEnd;
           for J := 1 to Length(ZRand) do
            if (ZRand[J]<>'?') and
               (ItemRand[J]<>'?') and
               (ZRand[J]<>ItemRand[J]) then
             begin
              sameSet := false;
              break;
             end
          end
        end
      end
     else  (*------ Zeile mit '*' ------*)
      begin
       ZRand := ZAnf+ZEnd;
       if Pos('*',ItemRand)=0 then
        begin (*--- Item ohne '*' ---*)
         sameSet := true;
         if Length(ZAnf)+Length(ZEnd)>Length(ItemRand) then
           sameSet := false
         else (* '<=' *)
          begin
           ItemAnf := Copy(ItemRand,1,Length(ZAnf));
           ItemEnd :=
             Copy(StrUtils.ReverseString(ItemRand),1,Length(ZEnd));
           ItemRand := ItemAnf+ItemEnd;
           for J := 1 to Length(ZRand) do
            if (ZRand[J]<>'?') and
               (ItemRand[J]<>'?') and
               (ZRand[J]<>ItemRand[J]) then
             begin
              sameSet := false;
              break;
             end
          end
        end
       else (*--- beide mit '*' ---*)
        begin
         ItemAnf := StrUtils.Copy2Symb(ItemRand,'*');
         ItemEnd :=
           StrUtils.Copy2Symb(StrUtils.ReverseString(ItemRand),'*');
         if Length(ZAnf)>Length(ItemAnf) then
          begin
           ZRand := Copy(ZAnf,1,Length(ItemAnf));
           ItemRand := ItemAnf;
          end
         else
          begin
           ZRand := ZAnf;
           ItemRand := Copy(ItemAnf,1,Length(ZAnf));
          end;
         if Length(ZEnd)>Length(ItemEnd) then
          begin
           ZRand := ZRand+Copy(ZEnd,1,Length(ItemEnd));
           ItemRand := ItemRand+ItemEnd;
          end
         else
          begin
           ZRand := ZRand+ZEnd;
           ItemRand := ItemRand+Copy(ItemEnd,1,Length(ZEnd));
          end;
         sameSet := false;
         sameSetmaybe := true;
         for J := 1 to Length(ZRand) do
          if (ZRand[J]<>'?') and
             (ItemRand[J]<>'?') and
             (ZRand[J]<>ItemRand[J]) then
           begin
            sameSetmaybe := false;
            break;
           end
        end;
      end;  (*------  ------*)
    if sameSet then
     begin
      sameSet := false;
      DtnListe.Selected[I] := true;
      with MG[Sprache] do
        aw := Application.MessageBox(PChar(FormatLE(DatDupDats,
                              [MText,Zeile,(I+1)])),PChar(DatHdDup),52);
      DtnListe.Selected[I] := false;
      if aw=7 then (* 'No' *)
       begin
        CheckZeile := false;
        exit;
       end
     end
    else
     if sameSetmaybe then
      begin
       sameSetmaybe := false;
       DtnListe.Selected[I] := true;
       with MG[Sprache] do
         aw := Application.MessageBox(PChar(FormatLE(DatPDupDats,
                             [MText,Zeile,(I+1)])),PChar(DatHdPDup),52);
       DtnListe.Selected[I] := false;
       if aw=7 then (* 'No' *)
        begin
         CheckZeile := false;
         exit;
        end
      end
   end
end;

function ReadDtnExnDatei(var DtnListe: TListBox; Extension: string;
                         nocheck: boolean): boolean;
var
 ReadAnz, SelStart, EndInd, I, ZNr: longint;
 Puffer: array [0..maxPufferP1] of byte;
 PPuffer: pointer;
 Addr: ^char;
begin
 try
  ReadDtnExnDatei := false;
  if LowerCase(Copy(DateiSName,Length(DateiSName)-3,4))
      <>('.'+Extension) then
   if DateiSName[Length(DateiSName)]<>'.' then
     DateiSName := DateiSName+'.'+Extension
   else
     DateiSName := DateiSName+Extension;
  saveDatei := false;
  DtnListe.Visible := true;
  if FileExists(ExpandFileName(DateiSName)) then
   begin
    DtnHandle := FileOpen(ExpandFileName(DateiSName),fmOpenReadWrite);
    if DtnHandle=(-1) then
      raise EOpenError.Create('');
    BlockPos := FileSeek(DtnHandle,0,fsFromBeginning);
    if BlockPos=(-1) then
      raise ERdError.Create('');
    { Einlesen der Zeilen }
    ReadAnz := FileRead(DtnHandle,Puffer,maxPufferP1);
    if ReadAnz=(-1) then
      raise ERdError.Create('');
    Puffer[ReadAnz] := 0; { aus 'Puffer' ein 'PChar'-Feld machen }
    if DefaultTextLineBreakStyle=tlbsCRLF then
      eolStr := LineEnding
    else
      if DefaultTextLineBreakStyle=tlbsCR then
        eolStr := #13
      else
        eolStr := #10;
    Zeile := '';
    ZNr := 0;
    while ReadAnz<>0 do
     begin
      SelStart := 0;
      while ReadAnz>0 do
       begin
        PPuffer := @Puffer[0];
        Addr := StrUtils.SearchBuf(PPuffer,ReadAnz,SelStart,0,eolStr);
        if Addr<>nil then
          EndInd := Addr - PPuffer - 1
        else
          EndInd := (-1);
{$if Test=1}
          Application.MessageBox(PChar('ReadAnz:>'
            +Format('%.0N',[int(ReadAnz)])
            +'<, SelStart:'+Format('%.0N',[int(SelStart)])
            +'<,'+eolStr+'<, PPuffer:'+HexStr(PPuffer)+'<, Addr:'
            +HexStr(Addr)+'<, EndInd:'+Format('%.0N',[int(EndInd)])
             ),'TEST',0);
{$endif Test=1}
        if (Length(Zeile)+(EndInd-SelStart+1))>255 then
          raise EFormError.Create('');
        if EndInd>=0 then
         begin
          ZNr := ZNr + 1;
          for I := SelStart to EndInd do
            Zeile := Zeile+Char(Puffer[I]);
          if Length(Zeile)>0 then
           begin
            if nocheck or CheckZeile(DtnListe,Zeile,ZNr) then
              DtnListe.Items.Add(Zeile)
            else
              saveDatei := true;
            Zeile := '';
           end
          else
            saveDatei := true;
          SelStart := EndInd + Length(eolStr) + 1;
         end
        else { kein Zeilenende mehr vorhanden }
         begin
          for I := SelStart to ReadAnz-1 do
            Zeile := Zeile+Char(Puffer[I]);
          if ReadAnz<maxPuffer then { keine weiteren Zeichen zu lesen }
           begin
            ZNr := ZNr + 1;
            if Length(Zeile)>0 then
             if nocheck or CheckZeile(DtnListe,Zeile,ZNr) then
               DtnListe.Items.Add(Zeile)
             else
               saveDatei := true;
            ReadAnz := 0;
           end;
         end;
       end;
      BlockPos := FileRead(DtnHandle,Puffer[ReadAnz],maxPuffer-ReadAnz);
      if BlockPos=(-1) then
        raise ERdError.Create('');
      ReadAnz := ReadAnz + BlockPos;
      Puffer[ReadAnz] := 0; { aus 'Puffer' ein 'PChar'-Feld machen }
     end;
    if saveDatei then
     with MG[Sprache] do
       Application.MessageBox(PChar(FormatLE(DatInsMod,
                     [ExpandFileName(DateiSName)])),PChar(DatHdMod),48);
   end
  else
   begin
    DtnHandle := FileCreate(ExpandFileName(DateiSName),fmOpenReadWrite);
    if DtnHandle=(-1) then
      raise ECreateError.Create('');
   end;
  ReadDtnExnDatei := true;
 except
  on EOpenError do
   begin
    with MG[Sprache] do
      Application.MessageBox(PChar(FormatLE(IOOpnErr,
                      [ExpandFileName(DateiSName)])),PChar(IOHdErr),16);
    CloseDtnDatei;
   end;
  on ECreateError do
   begin
    with MG[Sprache] do
      Application.MessageBox(PChar(FormatLE(IOCreErr,
                      [ExpandFileName(DateiSName)])),PChar(IOHdErr),16);
    CloseDtnDatei;
   end;
  on ERdError do
   begin
    with MG[Sprache] do
      Application.MessageBox(PChar(FormatLE(IOReaErr,
                      [ExpandFileName(DateiSName)])),PChar(IOHdErr),16);
    CloseDtnDatei;
   end;
  on EFormError do
   begin
    with MG[Sprache] do
      Application.MessageBox(PChar(FormatLE(IOFomErr,
                      [ExpandFileName(DateiSName)])),PChar(IOHdErr),16);
    CloseDtnDatei;
   end;
 end;
end;

procedure TFMain.DtnOpenClick(Sender: TObject);
begin
  CodStatus := 1;
  DateiSName := CodDatei.Text;
  if ReadDtnExnDatei(DtnListe,'dtn',false) then
   begin
    CodDateiLabel.Caption := FormatLE(MG[Sprache].DtnEdt,[DateiSName]);
    CodDatei.Text := '';
    { alle sonstigen Elemente als nicht auswhlbar kennzeichnen }
    SprachBox.Enabled := false;
    AusDateiDialog.Visible := false;
    AusDatei.Enabled := false;
    AusDateiHandling.Enabled := false;
    OperClear.Enabled := false;
    OperStart.Enabled := false;
    OperExit.Enabled := false;
    ActionPanel.Enabled := false;
    ActionHandlingLabel.Enabled := false;
    InitialKeyPanel.Enabled := false;
    InitialKeyKopfLabel.Enabled := false;
    case InitialKeyImage of
     0: InitialKeyCheck.Visible := false;
     1: InitialKeyDialog.Visible := false;
     2: InitialKeyOK.Visible := false;
     3: InitialKeyMaus.Visible := false;
    end;
    OverlayPanel.Enabled := false;
    OvlKopfLabel.Enabled := false;
    case OvlInfoImage of
     0: OvlInfoCheck.Visible := false;
     1: OvlInfoDialog.Visible := false;
     2: OvlInfoOK.Visible := false;
    end;
    ParDateiPanel.Enabled := false;
    ParDateiKopfLabel.Enabled := false;
    ParDateiDialog.Visible := false;
    case ParDateiOpKeyImage of
     0: ParDateiOpKeyCheck.Visible := false;
     1: ParDateiOpKeyDialog.Visible := false;
     2: ParDateiOpKeyOK.Visible := false;
    end;
    case ParDateiClsKeyImage of
     0: ParDateiClsKeyCheck.Visible := false;
     1: ParDateiClsKeyDialog.Visible := false;
     2: ParDateiClsKeyOK.Visible := false;
    end;
    CodDateiArtPanel.Enabled := false;
    CodDateiArt.Enabled := false;
{$if Safety<2}
    CodDateiConf.Visible := false;
{$else Safety>1}
    CompDateiGroup.Visible := false;
{$endif Safety}
    ExpDateiDialog.Visible := false;
    ExpDatei.Enabled := false;
    ExpOpen.Enabled := false;
    { DtnListe zeigen und Zeiger auf erstes Element, falls vorhanden }
    DtnOpen.Enabled := false;
    DtnClose.Enabled := true;
    DtnSave.Enabled := true;
    DtnListe.Enabled := true;
    DtnInsert.Visible := true;
    DtnInsert.Enabled := true;
    DtnDelete.Visible := true;
    DtnDelete.Enabled := false;
    DtnPlaceUp.Visible := true;
    DtnPlaceUp.Enabled := false;
    DtnPlaceDown.Visible := true;
    DtnPlaceDown.Enabled := false;
    if DtnListe.Items.Count>0 then
     begin
      DtnDelete.Enabled := true;
      DtnListe.Selected[0] := true;
      if DtnListe.Items.Count>1 then
        DtnPlaceDown.Enabled := true;
     end;
    CodDateiArtReply := 0;
   end;
end;

procedure TFMain.DtnInsertClick(Sender: TObject);
var
 I: longint;
 Zeile: string;
begin
  Zeile := CodDatei.Text;
  I := DtnListe.ItemIndex;
  if I<0 then
    I := 0;
  if CodDatei.Text<>'' then
   if CheckZeile(DtnListe,Zeile,0) then
    begin
     saveDatei := true;
     DtnListe.Items.Insert(I,CodDatei.Text);
     DtnListe.Selected[I] := true;
     DtnDelete.Enabled := true;
     if DtnListe.ItemIndex<>(DtnListe.Items.Count-1) then
       DtnPlaceDown.Enabled := true;
    end
   else  {Zeile nicht integrieren}
     DtnListe.Selected[I] := true;  {Fokus neu setzen}
end;

procedure TFMain.DtnDeleteClick(Sender: TObject);
var
 I: longint;
begin
  I := DtnListe.ItemIndex;
  if I>=0 then
   begin
    saveDatei := true;
    CodDatei.Text := DtnListe.Items.Strings[I];
    DtnListe.Items.Delete(I);
    if DtnListe.Items.Count>1 then
     begin
      if I>=DtnListe.Items.Count then
        I := I - 1;
      DtnListe.Selected[I] := true;
      if DtnListe.ItemIndex=(DtnListe.Items.Count-1) then
        DtnPlaceDown.Enabled := false;
     end
    else
     begin
      DtnPlaceUp.Enabled := false;
      DtnPlaceDown.Enabled := false;
      if DtnListe.Items.Count<1 then
        DtnDelete.Enabled := false
      else
        DtnListe.Selected[0] := true;
     end;
   end;
end;

procedure TFMain.DtnPlaceUpClick(Sender: TObject);
begin
  if DtnListe.ItemIndex>=0 then
   begin
    saveDatei := true;
    DtnListe.Items.Exchange(DtnListe.ItemIndex,DtnListe.ItemIndex-1);
    DtnListe.Selected[DtnListe.ItemIndex-1] := true;
    if DtnListe.ItemIndex=0 then
      DtnPlaceUp.Enabled := false;
    DtnPlaceDown.Enabled := true;
   end;
end;

procedure TFMain.DtnPlaceDownClick(Sender: TObject);
begin
  if DtnListe.ItemIndex>=0 then
   begin
    saveDatei := true;
    DtnListe.Items.Exchange(DtnListe.ItemIndex,DtnListe.ItemIndex+1);
    DtnListe.Selected[DtnListe.ItemIndex+1] := true;
    if DtnListe.ItemIndex=(DtnListe.Items.Count-1) then
      DtnPlaceDown.Enabled := false;
    DtnPlaceUp.Enabled := true;
   end;
end;

procedure TFMain.DtnListeClick(Sender: TObject);
begin
  if DtnListe.ItemIndex=0 then
    DtnPlaceUp.Enabled := false
  else
    DtnPlaceUp.Enabled := true;
  if DtnListe.ItemIndex=(DtnListe.Items.Count-1) then
    DtnPlaceDown.Enabled := false
  else
    DtnPlaceDown.Enabled := true;
end;

function SaveDtnDatei(var DtnExnListe: TListBox): boolean;
var
 WriteAnz, I: longint;
begin
  SaveDtnDatei := false;
  if saveDatei then
   try
    BlockPos := FileSeek(DtnHandle,0,fsFromBeginning);
    if BlockPos=(-1) then
      raise ERdError.Create('');
    for I := 0 to DtnExnListe.Items.Count-1 do
     begin
      Zeile := DtnExnListe.Items.Strings[I]+eolStr;
      WriteAnz := FileWrite(DtnHandle,Zeile[1],Length(Zeile));
      if WriteAnz<>Length(Zeile) then
        raise EWrError.Create('');
     end;
    if not FileTruncate(DtnHandle,FileSeek(DtnHandle,0,fsFromCurrent))
                                                                    then
      raise EWrError.Create('');
    saveDatei := false;
   except
    on ERdError do
     begin
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(IOReaErr,
                      [ExpandFileName(DateiSName)])),PChar(IOHdErr),16);
      CloseDtnDatei;
     end;
    on EWrError do
     begin
      with MG[Sprache] do
        Application.MessageBox(PChar(FormatLE(IOWriErr,
                      [ExpandFileName(DateiSName)])),PChar(IOHdErr),16);
      CloseDtnDatei;
     end;
   end
  else
   with MG[Sprache] do
     Application.MessageBox(PChar(FormatLE(DtnUnch,
                     [ExpandFileName(DateiSName)])),PChar(DtnHdUnch),0);
  SaveDtnDatei := true;
end;

procedure TFMain.DtnCloseClick(Sender: TObject);
var
  I: longint;
begin
  CodDateiArtReply := 1;
  if saveDatei then
   begin
    with MG[Sprache] do
      I := Application.MessageBox(PChar(FormatLE(DtnQSave,
             [ExpandFileName(DateiSName)])),PChar(DtnHdQSave),36);
    if I=6 then {'ja'}
     if SaveDtnDatei(DtnListe) then
       CloseDtnDatei
     else
    else
      CloseDtnDatei
   end
  else
    CloseDtnDatei;
  saveDatei := false;
end;

procedure TFMain.DtnSaveClick(Sender: TObject);
begin
  SaveDtnDatei(DtnListe);
end;

procedure TFMain.ExpDateiDialogClick(Sender: TObject);
begin
  case ExpDateiArt of
   0: begin
       OpenDialogCod.FileName := '*.*';
       if OpenDialogCod.Execute then
         ExpDatei.Text := OpenDialogCod.FileName;
      end;
   1: begin
       OpenDialogExn.FileName := '*.exn';
       if OpenDialogExn.Execute then
         ExpDatei.Text := OpenDialogExn.FileName;
       if ExpStatus=0 then
        if ExpDatei.Text='' then
          ExpOpen.Enabled := false
        else
          ExpOpen.Enabled := true;
      end;
  end;
end;

procedure TFMain.ExpDateiLabelClick(Sender: TObject);
begin
  ShowHelpFile(ExpDateiLabel.HelpKeyword);
end;

procedure TFMain.ExpDeleteClick(Sender: TObject);
var
 I: longint;
begin
  I := ExpListe.ItemIndex;
  if I>=0 then
   begin
    saveDatei := true;
    ExpDatei.Text := ExpListe.Items.Strings[I];
    ExpListe.Items.Delete(I);
    if ExpListe.Items.Count>1 then
     begin
      if I>=ExpListe.Items.Count then
        I := I - 1;
      ExpListe.Selected[I] := true;
      if ExpListe.ItemIndex=(ExpListe.Items.Count-1) then
        ExpPlaceDown.Enabled := false;
     end
    else
     begin
      ExpPlaceUp.Enabled := false;
      ExpPlaceDown.Enabled := false;
      if ExpListe.Items.Count<1 then
        ExpDelete.Enabled := false
      else
        ExpListe.Selected[0] := true;
     end;
   end;
end;

procedure TFMain.ExpInsertClick(Sender: TObject);
var
 I: longint;
begin
  I := ExpListe.ItemIndex;
  if I<0 then
    I := 0;
  if ExpDatei.Text<>'' then
   begin
    saveDatei := true;
    ExpListe.Items.Insert(I,ExpDatei.Text);
    ExpListe.Selected[I] := true;
    ExpDelete.Enabled := true;
    if ExpListe.ItemIndex<>(ExpListe.Items.Count-1) then
      ExpPlaceDown.Enabled := true;
   end;
end;

procedure TFMain.ExpDateiChange(Sender: TObject);
begin
  if ExpStatus=0 then
   if ExpDatei.Text='' then
     ExpOpen.Enabled := false
   else
     ExpOpen.Enabled := true;
end;

procedure TFMain.ExpOpenClick(Sender: TObject);
begin
  ExpStatus := 1;
  DateiSName := ExpDatei.Text;
  if ReadDtnExnDatei(ExpListe,'exn',true) then
   begin
    ExpDateiLabel.Caption := FormatLE(MG[Sprache].DtnEdt,[DateiSName]);
    ExpDatei.Text := '';
    { alle sonstigen Elemente als nicht auswhlbar kennzeichnen }
    SprachBox.Enabled := false;
    AusDateiDialog.Visible := false;
    AusDatei.Enabled := false;
    AusDateiHandling.Enabled := false;
    OperClear.Enabled := false;
    OperStart.Enabled := false;
    OperExit.Enabled := false;
    ActionPanel.Enabled := false;
    ActionHandlingLabel.Enabled := false;
    InitialKeyPanel.Enabled := false;
    InitialKeyKopfLabel.Enabled := false;
    case InitialKeyImage of
     0: InitialKeyCheck.Visible := false;
     1: InitialKeyDialog.Visible := false;
     2: InitialKeyOK.Visible := false;
     3: InitialKeyMaus.Visible := false;
    end;
    OverlayPanel.Enabled := false;
    OvlKopfLabel.Enabled := false;
    case OvlInfoImage of
     0: OvlInfoCheck.Visible := false;
     1: OvlInfoDialog.Visible := false;
     2: OvlInfoOK.Visible := false;
    end;
    ParDateiPanel.Enabled := false;
    ParDateiKopfLabel.Enabled := false;
    ParDateiDialog.Visible := false;
    case ParDateiOpKeyImage of
     0: ParDateiOpKeyCheck.Visible := false;
     1: ParDateiOpKeyDialog.Visible := false;
     2: ParDateiOpKeyOK.Visible := false;
    end;
    case ParDateiClsKeyImage of
     0: ParDateiClsKeyCheck.Visible := false;
     1: ParDateiClsKeyDialog.Visible := false;
     2: ParDateiClsKeyOK.Visible := false;
    end;
    CodDateiArtPanel.Enabled := false;
    CodDateiArt.Enabled := false;
    CodDateiDialog.Visible := false;
    CodDatei.Enabled := false;
    if CodDateiArtReply=1 then
      DtnOpen.Enabled := false;
{$if Safety<2}
    CodDateiConf.Visible := false;
{$else Safety>1}
    CompDateiGroup.Visible := false;
{$endif Safety}
    { DtnListe zeigen und Zeiger auf erstes Element, falls vorhanden }
    ExpOpen.Enabled := false;
    ExpClose.Enabled := true;
    ExpSave.Enabled := true;
    ExpListe.Enabled := true;
    ExpInsert.Visible := true;
    ExpInsert.Enabled := true;
    ExpDelete.Visible := true;
    ExpDelete.Enabled := false;
    ExpPlaceUp.Visible := true;
    ExpPlaceUp.Enabled := false;
    ExpPlaceDown.Visible := true;
    ExpPlaceDown.Enabled := false;
    if ExpListe.Items.Count>0 then
     begin
      ExpDelete.Enabled := true;
      ExpListe.Selected[0] := true;
      if ExpListe.Items.Count>1 then
        ExpPlaceDown.Enabled := true;
     end;
    ExpDateiArt := 0;
   end;
end;

procedure TFMain.ExpPlaceDownClick(Sender: TObject);
begin
  if ExpListe.ItemIndex>=0 then
   begin
    saveDatei := true;
    ExpListe.Items.Exchange(ExpListe.ItemIndex,ExpListe.ItemIndex+1);
    ExpListe.Selected[ExpListe.ItemIndex+1] := true;
    if ExpListe.ItemIndex=(ExpListe.Items.Count-1) then
      ExpPlaceDown.Enabled := false;
    ExpPlaceUp.Enabled := true;
   end;
end;

procedure TFMain.ExpPlaceUpClick(Sender: TObject);
begin
  if ExpListe.ItemIndex>=0 then
   begin
    saveDatei := true;
    ExpListe.Items.Exchange(ExpListe.ItemIndex,ExpListe.ItemIndex-1);
    ExpListe.Selected[ExpListe.ItemIndex-1] := true;
    if ExpListe.ItemIndex=0 then
      ExpPlaceUp.Enabled := false;
    ExpPlaceDown.Enabled := true;
   end;
end;

procedure TFMain.ExpListeClick(Sender: TObject);
begin
  if ExpListe.ItemIndex=0 then
    ExpPlaceUp.Enabled := false
  else
    ExpPlaceUp.Enabled := true;
  if ExpListe.ItemIndex=(ExpListe.Items.Count-1) then
    ExpPlaceDown.Enabled := false
  else
    ExpPlaceDown.Enabled := true;
end;

procedure TFMain.ExpCloseClick(Sender: TObject);
var
  I: longint;
begin
  ExpDateiArt := 1;
  if saveDatei then
   begin
    with MG[Sprache] do
      I := Application.MessageBox(PChar(FormatLE(DtnQSave,
             [ExpandFileName(DateiSName)])),PChar(DtnHdQSave),36);
    if I=6 then {'ja'}
     if SaveDtnDatei(ExpListe) then
       CloseDtnDatei
     else
    else
      CloseDtnDatei
   end
  else
    CloseDtnDatei;
  saveDatei := false;
end;

procedure TFMain.ExpSaveClick(Sender: TObject);
begin
  SaveDtnDatei(ExpListe);
end;

procedure TFMain.FormMouseUp(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowHelpFile(FMain.HelpKeyword);
end;

procedure TFMain.FormWindowStateChange(Sender: TObject);
begin
  FRefresh.ShowModal;
end;

procedure TFMain.OvlLimitPosVonEnter(Sender: TObject);
begin
  EnterHidedField(OvlLimitPosVon,OvlLimitPosVonS);
end;

procedure TFMain.OvlLimitPosBisEnter(Sender: TObject);
begin
  EnterHidedField(OvlLimitPosBis,OvlLimitPosBisS);
end;

procedure TFMain.OvlLimitPosVonExit(Sender: TObject);
var
 I: longint;
begin
 { Da dieser Routinen-Aufruf auch durch die Bearbeitung der Exit-Routine
   des 'Von'-Feldes ausgelst worden sein kann, z.B. durch den
   'MessageBox'-Aufruf der Exit-Routine des 'Von'-Feldes(!), da Exit-
   Routinen des einen Feldes erst  n a c h  Fokusierung des nchsten
   Feldes ausgelst werden(!), muss das hier abgefangen werden, um nicht
   2 Fehlermeldungen (noch dazu in der umgekehrten Reihenfolge wegen des
   LIFO-Prinzips!) zu bekommen.
     Weiter kann die Exit-Routine ausgelst werden,  b e v o r (!)  die
   Enter-Routine angesprungen worden ist(das geht wohl deshalb, weil der
   MessageBox-Aufruf der Exit-Routine des verlassenden Feldes zum ver-
   lassen des neu angeklickten Feldes fhrt, was wiederum dessen Exit-
   Routine auslst,  o h n e  das zuvor die Enter-Routine des neuen
   Feldes aktiviert wurde) !!!}
 if (not ExitOvlLimitPos) and  {falls noch keine Exit-Routine fr diese
                                Feld-Gruppe aktiv ist  u n d   }
    (OvlLimitPosVon.Tag>=FocusTag) then { das Feld den Fokus hat}
  begin
   ExitOvlLimitPos := true; {anzeigen, dass fr diese Feld-Gruppe}
   I := 1;                  {jetzt eine Exit-Routine aktiv ist   }
   if (not numLongint(OvlLimitPosVon.Text,P.UPosi)) or
      ((P.UPosi<I) or (P.UPosi>P.OPosi)) then
    begin
     with MG[Sprache] do
      if not numLongint(OvlLimitPosVon.Text,P.UPosi) then
        Application.MessageBox(PChar(FormatLE(OvlUPosNErr)),
          PChar(OvlHdUPosErr),16)
      else
        Application.MessageBox(PChar(FormatLE(OvlUPosRErr,
          [I,P.OPosi])),PChar(OvlHdUPosErr),16);
     P.UPosi  := I;
     OvlLimitPosVon.Text := Format('%.0D',[I]);
     MessageBoxCall := true; {unmotiviertes 'MouseDown'-Ereignis !}
     {Durch das Vertauschen von 'Enter'- u. 'Exit'-Reihenfolge durch die
     'MessageBox'-Bearbeitung darf hier keine weitere 'Exit'-Bearbeitung
      Stattfinden !!}
    end
   else
     ExitHidedField(OvlLimitPosVon,OvlLimitVonLabel,
                    OvlLimitPosVonS,lgKA);
   ExitOvlLimitPos := false;
  end;
end;

procedure TFMain.OvlLimitPosBisExit(Sender: TObject);
begin
 if (not ExitOvlLimitPos) and  {falls noch keine Exit-Routine fr diese
                                Feld-Gruppe aktiv ist  u n d   }
    (OvlLimitPosBis.Tag>=FocusTag) then { das Feld den Fokus hat}
  begin
   ExitOvlLimitPos := true; {anzeigen, dass fr diese Feld-Gruppe}
                            {jetzt eine Exit-Routine aktiv ist   }
   if (not numLongint(OvlLimitPosBis.Text,P.OPosi)) or
      ((P.OPosi<P.UPosi) or (P.OPosi>KeyAnzahl)) then
    begin
     with MG[Sprache] do
      if not numLongint(OvlLimitPosBis.Text,P.OPosi) then
        Application.MessageBox(PChar(FormatLE(OvlOPosNErr)),
          PChar(OvlHdOPosErr),16)
      else
        Application.MessageBox(PChar(FormatLE(OvlOPosRErr,
          [P.UPosi,KeyAnzahl])),PChar(OvlHdOPosErr),16);
     P.OPosi  := KeyAnzahl;
     OvlLimitPosBis.Text := Format('%.0D',[KeyAnzahl]);
     MessageBoxCall := true;
    end
   else
     ExitHidedField(OvlLimitPosBis,OvlLimitBisLabel,OvlLimitPosBisS,lgKA);
   ExitOvlLimitPos := false;
  end;
end;

procedure TFMain.OvlLimitPosVonMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
 { Der X- und Y-Wert stellen Point-Angaben relativ zur oberen linken
   Ecke des jeweiligen Feldes dar.
     Falls die linke Maus-Taste  n i c h t  gedrckt ist,kann der X-Wert
   nur zwischen Null und der Breite des Feldes liegen, der Y-Wert nur
   zwischen Null und der Tiefe des Feldes. D.h. das 'MouseMove'-Ereignis
   wird nur innerhalb des jeweiligen Feldes ausgelst.
     Ist die linke Maus-Taste jedoch gedrckt, so wird das 'MouseMove'-
   Ereignis auch von auerhalb des Feldes ausgelst (!), d.h. auf dem
   gesamten Bildschirm, und die Werte knnen sowohl negativ als auch
   ggf. grer als die Feld-Grenzen sein.
     Weiter gibt es das Problem, dass eine gedrckte linke Maus-Taste
   angenommen wird (!), wenn das System von einer MessageBox, die aus
   einer Exit-Routine aufgerufen wurde, zurckkehrt unabhngig davon, ob
   die MessageBox-Auswahl/-Besttigung mit der Maus oder via Tastatur
   vorgenommen wurde (!). Das bedeutet, dass nach der Rckkehr innerhalb
   des zuletzt angeklickten Feldes der Text soweit markiert wird,wie das
   bei gedrckter linker Maus-Taste auch passiert wre. Erklrt werden
   kann das damit, dass zwar das 'MouseDown'-Ereignis mit dem neu
   anzuspringenden Feld verbunden wird, dann aber die Exit-Routine des
   verlassenen Feldes angesprungen wird und das 'MouseUp'-Ereignis der
   darin aufgerufenen MessageBox zugeordnet wird und damit fr das
   'FMain'-Window nicht existent ist [Beweis: Setze einen fehlerhaften
   Wert in das Ausgangsfeld, klicke in ein anderes Feld.Drcke die linke
   Maustaste in der MessageBox ohne die Maustaste wieder los zu lassen,
   besttige die Message-Box mit der 'Return'-Taste. Falls danach die
   Maus-Taste im 'FMain'-Window, d.h. mit Maus-Zeiger im 'FMain'-Window,
   losgelassen wird, wird das 'MouseUp'-Ereignis wahrgenommen, falls die
   Maus-Taste auerhalb des 'FMain'-Window losgelassen wird, wird das
   'MouseUp'-Ereignis  n i c h t  wahrgenommen, d.h. Maus-Bewegungen
   markieren und demarkieren weiterhin den Text !]. Das erneute Klicken
   mit der Maus behebt das Problem !!}
 if OvlLimitPosVon.Tag>=FocusTag then { falls das Feld den Fokus hat }
   ShowHideContents(OvlLimitPosVon,OvlLimitVonLabel,X,Y,5,1,5,1)
 else
  if OvlLimitPosBis.Tag>=FocusTag then { falls Feld den Fokus hat }
    OvlLimitPosBis.Font.Color := OvlLimitPosBis.Color { Feldinhalt   }
  else                                                {\ "unsichtbar"}
  if OvlLimitOValVon.Tag>=FocusTag then { falls Feld den Fokus hat }
    OvlLimitOValVon.Font.Color := OvlLimitOValVon.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitOValBis.Tag>=FocusTag then { falls Feld den Fokus hat }
    OvlLimitOValBis.Font.Color := OvlLimitOValBis.Color;{ Feldinhalt   }
end;                                                    {\ "unsichtbar"}

procedure TFMain.OvlLimitPosVonMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseDown(OvlLimitPosVon,OvlLimitVonLabel);
end;

procedure TFMain.OvlLimitPosVonMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseUp(OvlLimitPosVon);
end;

procedure TFMain.OvlLimitPosBisMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
 if OvlLimitPosBis.Tag>=FocusTag then { falls das Feld den Fokus hat }
   ShowHideContents(OvlLimitPosBis,OvlLimitBisLabel,X,Y,5,1,1,7)
 else
  if OvlLimitPosVon.Tag>=FocusTag then {falls dieses Feld den Fokus hat}
    OvlLimitPosVon.Font.Color := OvlLimitPosVon.Color { Feldinhalt   }
  else                                                {\ "unsichtbar"}
  if OvlLimitOValVon.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitOValVon.Font.Color := OvlLimitOValVon.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitOValBis.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitOValBis.Font.Color := OvlLimitOValBis.Color;{ Feldinhalt   }
end;                                                    {\ "unsichtbar"}

procedure TFMain.OvlLimitPosBisMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseDown(OvlLimitPosBis,OvlLimitBisLabel);
end;

procedure TFMain.OvlLimitPosBisMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseUp(OvlLimitPosBis);
end;

procedure TFMain.OvlLimitPosVonChange(Sender: TObject);
begin
  if OvlInfoOK.Visible then
   begin
    OvlInfoOK.Visible := false;
    OvlInfoCheck.Visible := true;
    OvlInfoImage := 0;
   end;
end;

procedure TFMain.OvlLimitOValVonEnter(Sender: TObject);
begin
  EnterHidedField(OvlLimitOValVon,OvlLimitOValVonS);
end;

procedure TFMain.OvlLimitOValBisEnter(Sender: TObject);
begin
  EnterHidedField(OvlLimitOValBis,OvlLimitOValBisS);
end;

procedure TFMain.OvlLimitOValVonExit(Sender: TObject);
var
 I: longint;
begin
 if (not ExitOvlLimitOVal) and {falls noch keine Exit-Routine fr diese
                                Feld-Gruppe aktiv ist  u n d   }
    (OvlLimitOValVon.Tag>=FocusTag) then {das Feld den Fokus hat}
  begin
   ExitOvlLimitOVal := true; {anzeigen, dass fr diese Feld-Gruppe}
   I := 0;                   {jetzt eine Exit-Routine aktiv ist   }
   if (not numLongint(OvlLimitOValVon.Text,P.UWert)) or
      ((P.UWert<I) or (P.UWert>P.OWert)) then
    begin
     with MG[Sprache] do
      if not numLongint(OvlLimitOValVon.Text,P.UWert) then
        Application.MessageBox(PChar(FormatLE(OvlUWertNErr)),
          PChar(OvlHdUWertErr),16)
      else
        Application.MessageBox(PChar(FormatLE(OvlUWertRErr,
          [I,P.OWert])),PChar(OvlHdUWertErr),16);
     P.UWert  := I;
     OvlLimitOValVon.Text := Format('%.0D',[I]);
     MessageBoxCall := true;
    end
   else
     ExitHidedField(OvlLimitOValVon,OvlLimitVonLabel,
                    OvlLimitOValVonS,lgKA);
   ExitOvlLimitOVal := false;
  end;
end;

procedure TFMain.OvlLimitOValBisExit(Sender: TObject);
begin
 if (not ExitOvlLimitOVal) and {falls noch keine Exit-Routine fr diese
                                Feld-Gruppe aktiv ist  u n d   }
    (OvlLimitOValBis.Tag>=FocusTag) then {das Feld den Fokus hat}
  begin
   ExitOvlLimitOVal := true; {anzeigen, dass fr diese Feld-Gruppe}
                             {jetzt eine Exit-Routine aktiv ist   }
   if (not numLongint(OvlLimitOValBis.Text,P.OWert)) or
      ((P.OWert<P.UWert) or (P.OWert>KeyAnzahlS1)) then
    begin
     with MG[Sprache] do
      if not numLongint(OvlLimitOValBis.Text,P.OWert) then
        Application.MessageBox(PChar(FormatLE(OvlOWertNErr)),
          PChar(OvlHdOWertErr),16)
      else
        Application.MessageBox(PChar(FormatLE(OvlOWertRErr,
          [P.UWert,KeyAnzahlS1])),PChar(OvlHdOWertErr),16);
     P.OWert  := KeyAnzahl;
     OvlLimitOValBis.Text := Format('%.0D',[KeyAnzahlS1]);
     MessageBoxCall := true;
    end
   else
     ExitHidedField(OvlLimitOValBis,OvlLimitBisLabel,
                    OvlLimitOValBisS,lgKA);
   ExitOvlLimitOVal := false;
  end;
end;

procedure TFMain.OvlLimitOValVonMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
 if OvlLimitOValVon.Tag>=FocusTag then { falls das Feld den Fokus hat }
   ShowHideContents(OvlLimitOValVon,OvlLimitVonLabel,X,Y,1,1,5,1)
 else
  if OvlLimitOValBis.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitOValBis.Font.Color := OvlLimitOValBis.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitPosVon.Tag>=FocusTag then {falls dieses Feld den Fokus hat}
    OvlLimitPosVon.Font.Color := OvlLimitPosVon.Color { Feldinhalt   }
  else                                                {\ "unsichtbar"}
  if OvlLimitPosBis.Tag>=FocusTag then {falls dieses Feld den Fokus hat}
    OvlLimitPosBis.Font.Color := OvlLimitPosBis.Color { Feldinhalt   }
  else                                                {\ "unsichtbar"}
  if OvlLimitKValVon.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitKValVon.Font.Color := OvlLimitKValVon.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitKValBis.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitKValBis.Font.Color := OvlLimitKValBis.Color;{ Feldinhalt   }
end;                                                    {\ "unsichtbar"}

procedure TFMain.OvlLimitOValVonMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseDown(OvlLimitOValVon,OvlLimitVonLabel);
end;

procedure TFMain.OvlLimitOValVonMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseUp(OvlLimitOValVon);
end;

procedure TFMain.OvlLimitOValBisMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
 if OvlLimitOValBis.Tag>=FocusTag then { falls das Feld den Fokus hat }
   ShowHideContents(OvlLimitOValBis,OvlLimitBisLabel,X,Y,1,1,1,7)
 else
  if OvlLimitOValVon.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitOValVon.Font.Color := OvlLimitOValVon.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitPosVon.Tag>=FocusTag then {falls dieses Feld den Fokus hat}
    OvlLimitPosVon.Font.Color := OvlLimitPosVon.Color { Feldinhalt   }
  else                                                {\ "unsichtbar"}
  if OvlLimitPosBis.Tag>=FocusTag then {falls dieses Feld den Fokus hat}
    OvlLimitPosBis.Font.Color := OvlLimitPosBis.Color { Feldinhalt   }
  else                                                {\ "unsichtbar"}
  if OvlLimitKValVon.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitKValVon.Font.Color := OvlLimitKValVon.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitKValBis.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitKValBis.Font.Color := OvlLimitKValBis.Color;{ Feldinhalt   }
end;                                                    {\ "unsichtbar"}

procedure TFMain.OvlLimitOValBisMouseDown(Sender: TOBject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseDown(OvlLimitOValBis,OvlLimitBisLabel);
end;

procedure TFMain.OvlLimitOValBisMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseUp(OvlLimitOValBis);
end;

procedure TFMain.OvlLimitKValVonEnter(Sender: TObject);
begin
  EnterHidedField(OvlLimitKValVon,OvlLimitKValVonS);
end;

procedure TFMain.OvlLimitKValBisEnter(Sender: TObject);
begin
  EnterHidedField(OvlLimitKValBis,OvlLimitKValBisS);
end;

procedure TFMain.OvlLimitKValVonExit(Sender: TObject);
var
 I: longint;
begin
 if (not ExitOvlLimitKVal) and {falls noch keine Exit-Routine fr diese
                                Feld-Gruppe aktiv ist  u n d   }
    (OvlLimitKValVon.Tag>=FocusTag) then {das Feld den Fokus hat}
  begin
   ExitOvlLimitKVal := true; {anzeigen, dass fr diese Feld-Gruppe}
   I := 0;                   {jetzt eine Exit-Routine aktiv ist   }
   if (not numLongint(OvlLimitKValVon.Text,P.USWert)) or
      ((P.USWert<I) or (P.USWert>P.OSWert)) then
    begin
     with MG[Sprache] do
      if not numLongint(OvlLimitKValVon.Text,P.USWert) then
        Application.MessageBox(PChar(FormatLE(OvlUSWertNErr)),
          PChar(OvlHdUSWertErr),16)
      else
       Application.MessageBox(PChar(FormatLE(OvlUSWertRErr,
         [I,P.OSWert])),PChar(OvlHdUSWertErr),16);
     P.USWert  := I;
     OvlLimitKValVon.Text := Format('%.0D',[I]);
     MessageBoxCall := true;
    end
   else
     ExitHidedField(OvlLimitKValVon,OvlLimitVonLabel,
                    OvlLimitKValVonS,lgKA);
   ExitOvlLimitKVal := false;
  end;
end;

procedure TFMain.OvlLimitKValBisExit(Sender: TObject);
begin
 if (not ExitOvlLimitKVal) and {falls noch keine Exit-Routine fr diese
                                Feld-Gruppe aktiv ist  u n d   }
    (OvlLimitKValBis.Tag>=FocusTag) then {das Feld den Fokus hat}
  begin
   ExitOvlLimitKVal := true; {anzeigen, dass fr diese Feld-Gruppe}
                             {jetzt eine Exit-Routine aktiv ist   }
   if (not numLongint(OvlLimitKValBis.Text,P.OSWert)) or
      ((P.OSWert<P.USWert) or (P.OSWert>KeyAnzahlS1)) then
    begin
     with MG[Sprache] do
      if not numLongint(OvlLimitKValBis.Text,P.OSWert) then
        Application.MessageBox(PChar(FormatLE(OvlOSWertNErr)),
          PChar(OvlHdOSWertErr),16)
      else
        Application.MessageBox(PChar(FormatLE(OvlOSWertRErr,
          [P.USWert,KeyAnzahlS1])),PChar(OvlHdOSWertErr),16);
     P.OSWert  := KeyAnzahl;
     OvlLimitKValBis.Text := Format('%.0D',[KeyAnzahlS1]);
     MessageBoxCall := true;
    end
   else
     ExitHidedField(OvlLimitKValBis,OvlLimitBisLabel,
                    OvlLimitKValBisS,lgKA);
   ExitOvlLimitKVal := false;
  end;
end;

procedure TFMain.OvlLimitKValVonMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
 if OvlLimitKValVon.Tag>=FocusTag then { falls das Feld den Fokus hat }
   ShowHideContents(OvlLimitKValVon,OvlLimitVonLabel,X,Y,1,7,5,1)
 else
  if OvlLimitKValBis.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitKValBis.Font.Color := OvlLimitKValBis.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitOValVon.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitOValVon.Font.Color := OvlLimitOValVon.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitOValBis.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitOValBis.Font.Color := OvlLimitOValBis.Color;{ Feldinhalt   }
end;                                                    {\ "unsichtbar"}

procedure TFMain.OvlLimitKValVonMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseDown(OvlLimitKValVon,OvlLimitVonLabel);
end;

procedure TFMain.OvlLimitKValVonMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseUp(OvlLimitKValVon);
end;

procedure TFMain.OvlLimitKValBisMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
 if OvlLimitKValBis.Tag>=FocusTag then { falls das Feld den Fokus hat }
   ShowHideContents(OvlLimitKValBis,OvlLimitBisLabel,X,Y,1,7,1,7)
 else
  if OvlLimitKValVon.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitKValVon.Font.Color := OvlLimitKValVon.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitOValVon.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitOValVon.Font.Color := OvlLimitOValVon.Color { Feldinhalt   }
  else                                                  {\ "unsichtbar"}
  if OvlLimitOValBis.Tag>=FocusTag then{falls dieses Feld den Fokus hat}
    OvlLimitOValBis.Font.Color := OvlLimitOValBis.Color;{ Feldinhalt   }
end;                                                    {\ "unsichtbar"}

procedure TFMain.OvlLimitKValBisMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseDown(OvlLimitKValBis,OvlLimitBisLabel);
end;

procedure TFMain.OvlLimitKValBisMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseUp(OvlLimitKValBis);
end;

procedure TFMain.OvlSyntaxB1Change(Sender: TObject);
begin
 if OvlSyntaxB1.Checked then
  begin
   OvlSyntaxHinweis1.Enabled := true;
   OvlPosArt.Enabled := true;
   OvlValArt.Enabled := true;
   OvlIterationLabel.Visible := false;
   OvlIteration.Visible := false;
   OvlInfoSave.Caption :=FormatLE(MG[Sprache].OvlInfS
                                  +' '+MG[Sprache].OvlInfS2);
   OvlInfoSLbl.Caption := '';
   OvlInfoChecked := false;
   OvlInfoArtReply := 0;
   if OvlInfoHandling.Checked then
     OvlInfo.HelpKeyword := 'COD/OvlDataset.html'
   else
     OvlInfo.HelpKeyword := 'COD/DirectOvl.html';
   if OvlInfoOK.Visible then
    begin
     OvlInfoOK.Visible := false;
     OvlInfoCheck.Visible := true;
     OvlInfoImage := 0;
    end;
  end;
end;

procedure TFMain.OvlSyntaxB2Change(Sender: TObject);
begin
 if OvlSyntaxB2.Checked then
  begin
   OvlSyntaxHinweis1.Enabled := false;
   OvlPosArt.Enabled := false;
   OvlValArt.Enabled := false;
   OvlInfoHandlingReply := 0; { vorsorglich im Direkt-Modus }
   OvlInfoChecked := false;
   if OvlInfoHandling.Checked then
    begin
     OvlIterationLabel.Visible := true;
     OvlIteration.Visible := true;
     OvlInfoSave.Caption := FormatLE(MG[Sprache].OvlInfS);
     OvlInfoSLbl.Caption := '\'+FormatLE(MG[Sprache].OvlInfS2);
     OvlInfo.HelpKeyword := 'COD/DirectOvlDat.html';
     if Length(OvlInfo.Text)>=1 then
      case OvlInfo.Text[1] of
       '(': OvlInfoArtReply := 1;{Dateinamen-Datei}
       '[': OvlInfoArtReply := 2;{Verzeichnis-Dateien}
       '{': OvlInfoArtReply := 3;{Verzeichnis+Unterverzeichnis -Dateien}
      else
        OvlInfoArtReply := 0; {Dateiitem}
      end
     else
       OvlInfoArtReply := 0; {Dateiitem}
{$if Test=1}
     StatusBar.Panels.Items[1].Text :=
       'OvlInfoArtReply ='+Format('%.0N',[int(OvlInfoArtReply)]);
{$endif Test=1}
    end
   else
     OvlInfo.HelpKeyword := 'COD/DirectOvl.html';
   if OvlInfoOK.Visible then
    begin
     OvlInfoOK.Visible := false;
     OvlInfoCheck.Visible := true;
     OvlInfoImage := 0;
    end;
  end;
end;

procedure TFMain.OvlSyntaxDblClick(Sender: TObject);
begin
  ShowHelpFile(OvlSyntax.HelpKeyword);
end;

procedure TFMain.OvlInfoHandlingChange(Sender: TObject);
begin
 OvlInfo.Text := '';
 OvlInfoArtReply := 0;
 if OvlInfoHandling.Checked then
  begin
   OvlInfoOK.Visible := false;
   OvlInfoCheck.Visible := false;
   OvlInfoDialog.Visible := true;
   OvlInfoImage := 1;
   if OvlSyntaxB2.Checked then
    begin
     OvlIterationLabel.Visible := true;
     OvlIteration.Visible := true;
     OvlInfoSave.Caption := FormatLE(MG[Sprache].OvlInfS);
     OvlInfoSLbl.Caption := '\'+FormatLE(MG[Sprache].OvlInfS2);
     OvlInfo.HelpKeyword := 'COD/DirectOvlDat.html';
    end
   else
     OvlInfo.HelpKeyword := 'COD/OvlDataset.html';
   OvlInfoLabel.Caption := FormatLE(MG[Sprache].OvlILblDat);
  {OvlInfo.PasswordChar := #0;
   OvlInfo.EchoMode := emNormal;}
  end
 else
  begin
   OvlInfoDialog.Visible := false;
  {OvlInfoOK.Visible := false;}
   OvlInfoCheck.Visible := true;
   OvlInfoImage := 0;
   OvlIterationLabel.Visible := false;
   OvlIteration.Visible := false;
   OvlInfoSave.Caption :=FormatLE(MG[Sprache].OvlInfS
                                  +' '+MG[Sprache].OvlInfS2);
   OvlInfoSLbl.Caption := '';
   OvlInfo.HelpKeyword := 'COD/DirectOvl.html';
   OvlInfoLabel.Caption := FormatLE(MG[Sprache].OvlILblInf);
   if OvlSyntaxB2.Checked then {Passwort-Modus nur,falls im Direktmodus}
    begin
     OvlInfo.PasswordChar := '*';
     OvlInfo.EchoMode := emPassword;
    end;
  end;
end;

procedure TFMain.OvlInfoClick(Sender: TObject);
begin
 if OvlInfo.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   OvlInfoEnter(Sender);      { dann dies jetzt nachholen         }
 ShowCursorPos(OvlInfo);
end;

procedure TFMain.OvlInfoKeyDown(Sender: TObject; var Key: Word;
                                Shift: TShiftState);
begin
 if OvlInfo.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   OvlInfoEnter(Sender);      { dann dies jetzt nachholen         }
 if not OvlInfoHandling.Checked then {falls nicht im Datei-Modus}
  if Key=13 then
    OvlInfoExit(Sender);  {"Return"-Taste als Feld-Exit annehmen}
end;

procedure TFMain.OvlInfoKeyUp(Sender: TObject; var Key: Word;
                              Shift: TShiftState);
begin
 ShowCursorPos(OvlInfo);
 if OvlInfoHandling.Checked and OvlSyntaxB2.Checked then{im Direktdatei}
  if OvlInfo.SelStart<2 then                                  {\ -Modus}
   begin
    if Length(OvlInfo.Text)>=1 then
     case OvlInfo.Text[1] of
      '(': OvlInfoArtReply := 1; {Dateinamen-Datei}
      '[': OvlInfoArtReply := 2; {Verzeichnis-Dateien}
      '{': OvlInfoArtReply := 3; {Verzeichnis+Unterverzeichnis -Dateien}
     else
       OvlInfoArtReply := 0; {Dateiitem}
     end
    else
      OvlInfoArtReply := 0; {Dateiitem}
{$if Test=1}
    StatusBar.Panels.Items[1].Text :=
      'OvlInfoArtReply ='+Format('%.0N',[int(OvlInfoArtReply)]);
{$endif Test=1}
   end
end;

procedure TFMain.OvlInfoLabelClick(Sender: TObject);
begin
  ShowHelpFile(OvlInfo.HelpKeyword);
end;

procedure TFMain.OvlInfoDialogClick(Sender: TObject);
begin
  case OvlInfoArtReply of
   0: begin
       OpenDialogOvl.FileName := '*.*';
       if OpenDialogOvl.Execute then
         OvlInfo.Text := OpenDialogOvl.FileName;
      end;
   1: begin
       OpenDialogDtn.FileName := '*.dtn';
       if OpenDialogDtn.Execute then
         OvlInfo.Text := '('+OpenDialogDtn.FileName+')';
      end;
   2: begin
        OpenDialogDir.Title := FormatLE(MG[Sprache].OpnDirTit);
        if OpenDialogDir.Execute then
          OvlInfo.Text := '['+OpenDialogDir.FileName+']';
      end;
   3: begin
        OpenDialogDir.Title := FormatLE(MG[Sprache].OpnDirSubTit);
        if OpenDialogDir.Execute then
          OvlInfo.Text := '{'+OpenDialogDir.FileName+'}';
      end;
  end;
end;

procedure TFMain.OvlInfoEnter(Sender: TObject);
begin
 OvlInfo.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
 if OvlInfoHandling.Checked or { falls im Datei- oder Sytax-Modus }
    OvlSyntaxB1.Checked then
   EnterHidedField(OvlInfo);
end;

procedure TFMain.OvlInfoChange(Sender: TObject);
begin
 if not OvlInfoHandling.Checked then
  begin
   OvlInfoChecked := false;
   if not OvlInfoCheck.Visible then
    begin
     OvlInfoOK.Visible := false;
     OvlInfoCheck.Visible := true;
     OvlInfoImage := 0;
    end
  end
end;

procedure TFMain.OvlInfoCheckClick(Sender: TObject);
begin
  OvlInfo.Tag := FocusTag; { anzeigen, dass das Feld den Fokus hat }
  OvlInfoChecked := false;
  OvlInfoExit(Sender);
end;

function SynCheck(Str: string; var endSt: longint;
                  art: longint; var err, errL: longint): longint;
var           {Return: 0 - alles OK, 1 - Warnung, 2 - Fehler}
 Zeichen: char;
 ZByte: byte absolute Zeichen;
 SWert, BWert, anf, I, J, M: longint;
 ready: boolean;
begin
 I := 0;
 while I<Length(Str) do
  begin        { Schleife ber alle berlade-Info's }
   SWert := 0;     { Stellen-Info behandeln }
   ready := false;
   anf := I;
   while (I<Length(Str)) and (not ready) do
    begin  { Bytenummer-Hexa-/Dezimalzeichen + ':' einlesen }
     I := I + 1;
     Zeichen := UpCase(Str[I]);
     if (ZByte in [d0..d9]) or
        ((art in [4..6]) and (ZByte in [cA..cF])) then
      begin
       if ZByte in [d0..d9] then
        if art in [4..6] then
         SWert := SWert*16 + ZByte - d0
        else
         SWert := SWert*10 + ZByte - d0
       else
         SWert := SWert*16 + ZByte - cAS10;
       if SWert>KeyAnzahl then  { Bytenummer zu gro }
        begin
         endSt := I;
         err := 1;
         errL := I - anf;
         SynCheck := 2;
         exit
        end
       else
        if (SWert>P.OPosi) and  { Bytenummer zu gro }
           (I>endSt) then       {  und Warnung noch nicht ausgegeben }
         begin
          endSt := I;
          err := 1;
          errL := I - anf;
          SynCheck := 1;
          exit
         end
      end
     else
      if Zeichen=':' then { Wert-Info-Trenner gefunden }
        ready := true
      else       { falscher Wert-Info-Trenner }
       begin
        endSt := I;
        err := 3;
        errL := 1;
        SynCheck := 2;
        exit
       end
    end;
   if SWert<1 then  { Bytenummer zu klein }
    begin
     endSt := I - 1;
     err := 2;
     errL := I - anf - 1;
     SynCheck := 2;
     exit
    end
   else
    if (SWert<P.UPosi) and  { Bytenummer zu klein }
       ((I-1)>endSt) then   {  und Warnung noch nicht ausgegeben }
     begin
      endSt := I - 1;
      err := 2;
      errL := I - anf - 1;
      SynCheck := 1;
      exit
     end;
   if I>=Length(Str) then  { keine Wert-Info }
    begin
     endSt := I;
     err := 4;
     errL := 1;
     SynCheck := 2;
     exit
    end;
   if not ready then  { kein Trenner }
    begin
     endSt := I;
     err := 5;
     errL := I - anf;
     SynCheck := 2;
     exit
    end;
   anf := I;
   case art of    { Wert-Info behandeln }
    1,4: {---- Zeichen als Wert-Info ----}
     begin
      BWert := 0;
      for M := 1 to ElemBytes do
       begin
        if I<Length(Str) then
         begin
          I := I + 1;
          Zeichen := Str[I];
          BWert := BWert*256 + ZByte
         end
        else
         begin
          endSt := I;
          err := 6;
          errL := M;
          SynCheck := 2;
          exit
         end
       end;
      if I<Length(Str) then
       begin
        I := I + 1;
        Zeichen := Str[I];
        if Zeichen<>',' then  { falscher berlade-Info-Trenner }
         begin
          endSt := I;
          err := 9;
          errL := 1;
          SynCheck := 2;
          exit
         end
       end
     end;
    2,3,5,6: {---- Hexa-/Dezimalwert als Wert-Info ----}
     begin
      BWert := 0;
      ready := false;
      while (I<Length(Str)) and (not ready) do
       begin   { Hexa-/Dezimalwert-Zeichen + ',' einlesen }
        I := I + 1;
        Zeichen := UpCase(Str[I]);
        if (ZByte in [d0..d9]) or
           ((art in [2,5]) and (ZByte in [cA..cF]))
        then
         begin
          if ZByte in [d0..d9] then
           if art in [2,5] then
            BWert := BWert*16 + ZByte - d0
           else
            BWert := BWert*10 + ZByte - d0
          else
            BWert := BWert*16 + ZByte - cAS10;
          if BWert>KeyAnzahlS1 then  { Dezimalwert zu gro }
           begin
            endSt := I;
            err := 7;
            errL := I - anf;
            SynCheck := 2;
            exit
           end
          else
           if (BWert>P.OWert) and { Dezimalwert zu gro }
              (I>endSt) then      {  und Warnung noch nicht ausgegeben }
            begin
             endSt := I;
             err := 7;
             errL := I - anf;
             SynCheck := 1;
             exit
            end
         end
        else
         if Zeichen=',' then { berlade-Info-Trenner }
           ready := true
         else       { falscher berlade-Info-Trenner }
          begin
           endSt := I;
           err := 10;
           errL := 1;
           SynCheck := 2;
           exit
          end
       end
     end
   end;
   J := I;
   if ready then
    J := J - 1;
   if (BWert<P.UWert) and  { Dezimalwert zu klein }
      (J>endSt) then       {  und Warnung noch nicht ausgegeben }
    begin
     endSt := J;
     err := 8;
     errL := J - anf;
     SynCheck := 1;
     exit
    end
  end;
 SynCheck := 0;
end;

procedure TFMain.OvlInfoExit(Sender: TObject);
var
 IStr, eStr: string;
 aw, endStelle, artWert, errno, errLength, I, J: longint;
begin
 DelCursorPos;
 if OvlInfo.Tag>=FocusTag then {falls das Feld den Fokus hat}
  if OvlInfoHandling.Checked or { falls im Datei- oder Sytax-Modus }
     OvlSyntaxB1.Checked then
   begin
    if not OvlInfoHandling.Checked then { falls nicht im Datei-Modus }
     if (not ExitOvlInfo) and {falls noch keine Exit-Routine fr dieses}
        (not OvlInfoChecked) then    { Feld aktiv ist  u n d  noch kein}
      begin                    { erfolgreicher Check durchgefhrt wurde}
       ExitOvlInfo := true; {anzeigen, dass fr dieses Feld   }
                            {jetzt eine Exit-Routine aktiv ist}
       with MG[Sprache] do
         aw :=Application.MessageBox(PChar(FormatLE(OvlQChk)),
                PChar(OvlHdChk),36);
       MessageBoxCall := true;
       if aw=6 then { Ja. --> berladeinformation-Prfung }
        begin
         I := 0;
         aw := 0;
         IStr := OvlInfo.Text;
         artWert := Longint(OvlPosArtB2.Checked)*3+1
                    +Longint(OvlValArtB3.Checked)
                    +Longint(OvlValArtB2.Checked)*2;
         endStelle := 0;  {plus 1 ist Anfangsstelle des Prfaufrufs}
         J := SynCheck(IStr,endStelle,artWert,errno,errLength);
{$if Test=1}
         Application.MessageBox(PChar('J='+Format('%d',[J])
           +', IStr='+IStr+', endStelle='+Format('%d',[endStelle])
           +', artWert='+Format('%d',[artWert])+', errno='
           +Format('%d',[errno])+', errLength='
           +Format('%d',[errLength])),PChar('Test'),0);
{$endif Test=1}
         with MG[Sprache] do
          while J=1 do {solange weitere  W a r n u n g e n  vorliegen}
           begin
            I := endStelle+1-errLength;
            case errno of
             1: eStr := FormatLE(OvlPosOLimErr,[endStelle]);
             2: eStr := FormatLE(OvlPosULimErr,[endStelle]);
             7: eStr := FormatLE(OvlValOLimErr,[endStelle]);
             8: eStr := FormatLE(OvlValULimErr,[endStelle]);
            else
              eStr := FormatLE(OvlUndefWar,[errno,I,errLength])
            end;
            aw:=Application.MessageBox(PChar(eStr+FormatLE(OvlTermIgn)),
                                       PChar(OvlHdSWar),49);
            MessageBoxCall := true;                        {/ besorgen}
            if aw=1 then {falls kein Abbruch, nchste Problem-Stelle  }
              J := SynCheck(IStr,endStelle,artWert,errno,errLength)
            else {aw=2}
              J := 3;   {Abbruch}
           end;
         if J=2 then {es liegt ein  F e h l e r  vor}
          with MG[Sprache] do
           begin
            I := endStelle+1-errLength;
            case errno of
             1: eStr := FormatLE(OvlPosOErr,[endStelle,KeyAnzahl]);
             2: eStr := FormatLE(OvlPosUErr,[endStelle]);
             3: if artWert in [4..6] then
                  eStr := FormatLE(OvlPosHexErr,[endStelle])
                else
                  eStr := FormatLE(OvlPosDecErr,[endStelle]);
             4: eStr := FormatLE(OvlValMisAS,[endStelle]);
             5: eStr := FormatLE(OvlInfErr,[endStelle]);
             6: eStr := FormatLE(OvlValMis,[endStelle]);
             7: eStr := FormatLE(OvlValOErr,[endStelle,KeyAnzahlS1]);
             9: eStr := FormatLE(OvlSepCErr,[endStelle]);
            10: if artWert in [2,5] then
                  eStr := FormatLE(OvlValHexErr,[endStelle])
                else
                  eStr := FormatLE(OvlValDecErr,[endStelle]);
            else
              eStr := FormatLE(OvlUndefErr,[errno,I,errLength])
            end;
            Application.MessageBox(PChar(eStr),PChar(OvlHdSErr),16);
            MessageBoxCall := true;
           end
         else
          if J=0 then
           begin
            OvlInfoCheck.Visible := false;
            OvlInfoOK.Visible := true;
            OvlInfoImage := 2;
           end;
         if I>0 then {Markierung einer Stelle erst nach letzter}
          begin                                 {\ 'MessageBox'}
           OvlInfoEnter(Sender); {falls Aufruf via 'OvlInfoCheckClick'}
           OvlInfo.SetFocus;
           OvlInfo.SelStart := I-1;
           OvlInfo.SelLength := errLength;
           ShowCursorPos(OvlInfo);
          end
         else
           OvlInfo.SelLength := 0;
        end;
       OvlInfoChecked := true; {es hat eine Bearbeitung durch
                                   den Benutzer stattgefunden}
       ExitOvlInfo := false; {Exit-Routine nicht mehr aktiv}
      end;
    if (not ExitOvlInfo) and      {keine Exit-Routine fr Feld aktiv}
       (not OvlInfo.Focused) then { u n d  das Feld hat keinen Fokus}
      ExitHidedField(OvlInfo,OvlInfoLabel);
   end
  else  {im Direkt-Modus}
   if (not ExitOvlInfo) and  {falls noch keine Exit-Routine fr Feld}
      (not OvlInfoChecked) then    { aktiv ist  u n d  noch kein    }
    begin                   { erfolgreicher Check durchgefhrt wurde}
     ExitOvlInfo := true; {anzeigen, dass fr dieses Feld   }
                          {jetzt eine Exit-Routine aktiv ist}
     if OvlInfoHandlingReply=0 then { falls im Direkt-Modus }
      begin
       with MG[Sprache] do
         aw := Application.MessageBox(PChar(FormatLE(OvlQRep)),
                 PChar(OvlHdRep),36);
       MessageBoxCall := true;
       if aw=6 then { Ja. --> berladeinformation-Wiederholung }
        begin
         OvlInfoHandlingReply := 4; {Wiederholungs-Modus}
         OvlInfoLabel.Caption := FormatLE(MG[Sprache].OvlILblRep);
         OvlInfoS := OvlInfo.Text;
         OvlInfo.Text := '';
         OvlInfoHandling.Enabled := false;
         OvlLimitBox.Enabled := false;
         OvlSyntax.Enabled := false;
         OvlPosArt.Enabled := false;
         OvlValArt.Enabled := false;
         { alle sonstigen Elemente als nicht auswhlbar kennzeichnen }
         SprachBox.Enabled := false;
         AusDateiDialog.Visible := false;
         AusDatei.Enabled := false;
         AusDateiHandling.Enabled := false;
         OperClear.Enabled := false;
         OperStart.Enabled := false;
         OperExit.Enabled := false;
         ActionPanel.Enabled := false;
         ActionHandlingLabel.Enabled := false;
         InitialKeyPanel.Enabled := false;
         InitialKeyKopfLabel.Enabled := false;
         case InitialKeyImage of
          0: InitialKeyCheck.Visible := false;
          1: InitialKeyDialog.Visible := false;
          2: InitialKeyOK.Visible := false;
          3: InitialKeyMaus.Visible := false;
         end;
         CodDateiPanel.Enabled := false;
         CodArtKopfLabel.Enabled := false;
         CodDateiDialog.Visible := false;
         ExpDateiDialog.Visible := false;
{$if Safety>1}
         if CodStream.Checked then
          begin
           CompDateiDialog.Visible := false;
           case CompDateiKeyImage of
            0: CompDateiKeyCheck.Visible := false;
            1: CompDateiKeyDialog.Visible := false;
            2: CompDateiKeyOK.Visible := false;
           end
          end;
{$endif Safety>1}
         ParDateiPanel.Enabled := false;
         ParDateiKopfLabel.Enabled := false;
         ParDateiDialog.Visible := false;
         case ParDateiOpKeyImage of
          0: ParDateiOpKeyCheck.Visible := false;
          1: ParDateiOpKeyDialog.Visible := false;
          2: ParDateiOpKeyOK.Visible := false;
         end;
         case ParDateiClsKeyImage of
          0: ParDateiClsKeyCheck.Visible := false;
          1: ParDateiClsKeyDialog.Visible := false;
          2: ParDateiClsKeyOK.Visible := false;
         end;
       { ActiveControl := OvlInfo;  }
        end
       else  { Nein. }
         OvlInfoChecked := true; {es hat eine Bearbeitung durch
                                  den Benutzer stattgefunden}
      end
     else { falls im Wiederholungs-Modus }
      begin
       if OvlInfoS=OvlInfo.Text then {Ausgangs- und Wiederholungs-     }
        begin                       {berladeinformation sind identisch}
         OvlInfoCheck.Visible := false;
         OvlInfoOK.Visible := true;
         OvlInfoImage := 2;
        end
       else
        begin
       { OvlInfoOK.Visible := false;
         OvlInfoCheck.Visible := true;
         OvlInfoImage := 0; }
         IStr := OvlInfo.Text; {1. Unterschiedsstelle ermitteln}
         I := Length(IStr);
         if I<>Length(OvlInfoS) then
          if I>Length(OvlInfoS) then
            I := Length(OvlInfoS);
         for aw := 1 to I do
          begin
           if OvlInfoS[aw]<>IStr[aw] then
             break;
          end;
         if (I>0) and
            ((aw<I) or
             (OvlInfoS[aw]<>IStr[aw])) then
           I := aw
         else
           I := I + 1;
         OvlInfo.Text := OvlInfoS;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(OvlDifErr,[I])),
             PChar(OvlHdRErr),48);
         MessageBoxCall := true;
         OvlInfo.SetFocus;
         if I<=Length(OvlInfoS) then
          begin
           OvlInfo.SelStart := I-1;
           OvlInfo.SelLength := 1;
          end
         else
          begin
           OvlInfo.SelStart := 0;
           OvlInfo.SelLength := Length(OvlInfoS);
          end;
         ShowCursorPos(OvlInfo);
        end;
       OvlInfoChecked := true; {es hat eine Bearbeitung durch
                                den Benutzer stattgefunden}
       OvlInfoHandlingReply := 0; {Wiederholungs-Modus aufheben}
       OvlInfoLabel.Caption := FormatLE(MG[Sprache].OvlILblInf);
       {alle Felder "entsperren"}
       OvlInfoHandling.Enabled := true;
       OvlLimitBox.Enabled := true;
       OvlSyntax.Enabled := true;
       if OvlSyntaxB1.Checked then
        begin
         OvlPosArt.Enabled := true;
         OvlValArt.Enabled := true;
        end;
       { alle sonstigen Elemente }
       SprachBox.Enabled := true;
       AusDateiDialog.Visible := true;
       AusDatei.Enabled := true;
       AusDateiHandling.Enabled := true;
       OperClear.Enabled := true;
       OperStart.Enabled := true;
       OperExit.Enabled := true;
       ActionPanel.Enabled := true;
       ActionHandlingLabel.Enabled := true;
       InitialKeyPanel.Enabled := true;
       InitialKeyKopfLabel.Enabled := true;
       case InitialKeyImage of
        0: InitialKeyCheck.Visible := true;
        1: InitialKeyDialog.Visible := true;
        2: InitialKeyOK.Visible := true;
        3: InitialKeyMaus.Visible := true;
       end;
       if (Aktion=0) or (Aktion=3) then  {Aktion=4 nicht mglich}
        begin
         CodDateiPanel.Enabled := true;
         CodArtKopfLabel.Enabled := true;
         CodDateiDialog.Visible := true;
         ExpDateiDialog.Visible := true;
{$if Safety>1}
         if CodStream.Checked then
          begin
           CompDateiDialog.Visible := true;
           case CompDateiKeyImage of
            0: CompDateiKeyCheck.Visible := true;
            1: CompDateiKeyDialog.Visible := true;
            2: CompDateiKeyOK.Visible := true;
           end
          end;
{$endif Safety>1}
        end;
       if Aktion<>0 then
        begin
         ParDateiPanel.Enabled := true;
         ParDateiKopfLabel.Enabled := true;
         ParDateiDialog.Visible := true;
         if ParDateiOpKeyHandling.Enabled then
           case ParDateiOpKeyImage of
            0: ParDateiOpKeyCheck.Visible := true;
            1: ParDateiOpKeyDialog.Visible := true;
            2: ParDateiOpKeyOK.Visible := true;
           end;
         if ParDateiClsKeyHandling.Enabled then
           case ParDateiClsKeyImage of
            0: ParDateiClsKeyCheck.Visible := true;
            1: ParDateiClsKeyDialog.Visible := true;
            2: ParDateiClsKeyOK.Visible := true;
           end;
        end;
      end;
     OvlInfo.Tag := 0;
     ExitOvlInfo := false; {Exit-Routine nicht mehr aktiv}
    end
   else
    if not ExitOvlInfo then  {keine Exit-Routine fr dieses Feld aktiv}
      OvlInfo.Tag := 0;
end;

procedure TFMain.OvlInfoMouseMove(Sender: TObject; Shift: TShiftState;
                                  X, Y: Integer);
begin
  ShowCursorPos(OvlInfo);
  if OvlInfoHandling.Checked or  { falls im Datei- oder Syntax-Modus }
     OvlSyntaxB1.Checked then
    ShowHideContents(OvlInfo,OvlInfoLabel,X,Y);
  if OvlIteration.Tag>=FocusTag then { falls dieses Feld den Fokus hat }
    OvlIteration.Font.Color := OvlIteration.Color; { Feldinhalt   }
end;                                               {\ "unsichtbar"}

procedure TFMain.OvlInfoMouseDown(Sender: TOBject; Button: TMouseButton;
                                  Shift: TShiftState; X, Y: Integer);
begin
 if OvlInfoHandling.Checked or  { falls im Datei- oder Sytax-Modus}
    OvlSyntaxB1.Checked then
   ClearMesBoxMouseDown(OvlInfo,OvlInfoLabel);
end;

procedure TFMain.OvlInfoMouseUp(Sender: TOBject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
begin
 if OvlInfoHandling.Checked or  { falls im Datei- oder Sytax-Modus}
    OvlSyntaxB1.Checked then
   ClearMesBoxMouseUp(OvlInfo);
 MessageBoxCall := false;
end;

procedure TFMain.OvlInfoSLblClick(Sender: TObject);
begin
  if OvlInfoSave.Checked then
    OvlInfoSave.Checked := false
  else
    OvlInfoSave.Checked := true;
end;

procedure TFMain.OvlInfoSLblDblClick(Sender: TObject);
begin
  ShowHelpFile(OvlInfoSave.HelpKeyword);
end;

procedure TFMain.OvlIterationEnter(Sender: TObject);
begin
  EnterHidedField(OvlIteration,OvlIterationS);
end;

procedure TFMain.OvlIterationExit(Sender: TObject);
var
 I: longint;
begin
 if OvlIteration.Tag>=FocusTag then {falls das Feld den Fokus hat}
  begin
   I := 0;
   if (not numLongint(OvlIteration.Text,P.OvlIteration)) or
      ((P.OvlIteration<I) or (P.OvlIteration>MaxIteration)) then
    begin
     with MG[Sprache] do
      if not numLongint(OvlIteration.Text,P.OvlIteration) then
        Application.MessageBox(PChar(FormatLE(OvlItNumErr)),
          PChar(OvlHdItErr),16)
      else
        Application.MessageBox(PChar(FormatLE(OvlItRanErr,
          [I,MaxIteration])),PChar(OvlHdItErr),16);
     P.OvlIteration  := I;
     OvlIteration.Text := Format('%.0D',[I]);
     MessageBoxCall := true;
    end
   else
     ExitHidedField(OvlIteration,OvlIterationLabel,OvlIterationS,lgMI);
  end;
end;

procedure TFMain.OvlIterationLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(OvlIterationLabel.HelpKeyword);
end;

procedure TFMain.OvlIterationMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
  ShowHideContents(OvlIteration,OvlIterationLabel,X,Y,5,7,5,1);
end;

procedure TFMain.OvlIterationMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseDown(OvlIteration,OvlIterationLabel);
end;

procedure TFMain.OvlIterationMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 ClearMesBoxMouseUp(OvlIteration);
end;

procedure TFMain.OvlKopfLabelClick(Sender: TObject);
begin
  ShowHelpFile(OvlKopfLabel.HelpKeyword);
end;

procedure TFMain.OvlLimitBoxDblClick(Sender: TObject);
begin
  ShowHelpFile(OvlLimitBox.HelpKeyword);
end;

procedure TFMain.ParDateiDialogClick(Sender: TObject);
begin
  OpenDialogPar.FileName := '*.par';
  if OpenDialogPar.Execute then
    ParDatei.Text := OpenDialogPar.FileName;
end;

procedure TFMain.ParDateiEnter(Sender: TObject);
begin
  EnterHidedField(ParDatei);
end;

procedure TFMain.ParDateiClick(Sender: TObject);
begin
 if ParDatei.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   ParDateiEnter(Sender);      { dann dies jetzt nachholen         }
 ShowCursorPos(ParDatei);
end;

procedure TFMain.ParDateiKeyUp(Sender: TObject; var Key: Word;
                               Shift: TShiftState);
begin
  ShowCursorPos(ParDatei);
end;

procedure TFMain.ParDateiKopfLabelClick(Sender: TObject);
begin
  ShowHelpFile(ParDateiKopfLabel.HelpKeyword);
end;

procedure TFMain.ParDateiLabelClick(Sender: TObject);
begin
  ShowHelpFile(ParDateiLabel.HelpKeyword);
end;

procedure TFMain.ParDateiExit(Sender: TObject);
begin
  DelCursorPos;
  ExitHidedField(ParDatei,ParDateiLabel);
end;

procedure TFMain.ParDateiKeyDown(Sender: TObject; var Key: Word;
                                 Shift: TShiftState);
begin
 if ParDatei.Tag<FocusTag then {falls das Feld den Fokus nicht hat,}
   ParDateiEnter(Sender);      { dann dies jetzt nachholen         }
end;

procedure TFMain.ParDateiMouseMove(Sender: TObject; Shift: TShiftState;
                                   X, Y: Integer);
begin
  ShowCursorPos(ParDatei);
  ShowHideContents(ParDatei,ParDateiLabel,X,Y);
end;

procedure TFMain.ParDateiMouseDown(Sender: TOBject; Button:TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
begin
  ClearMesBoxMouseDown(ParDatei,ParDateiLabel);
end;

procedure TFMain.ParDateiMouseUp(Sender: TOBject; Button: TMouseButton;
                                 Shift: TShiftState; X, Y: Integer);
begin
  ClearMesBoxMouseUp(ParDatei);
end;

procedure TFMain.ParDateiUseB1Change(Sender: TObject);
begin
 if ParDateiUseB1.Checked then
  begin
   ParDateiUseReply := 0;
   ParDateiUseB1Memo.Color := clWindow;
   case Aktion of
   {0: ; (* nicht mglich *)}
   {1: ; (* nichts zu tun *)}
    2: ActionHandlingB2.Checked := true; {auf Aktion=1 umsetzen}
   {3: ; (* nichts zu tun *)}
    4: ActionHandlingB4.Checked := true; {auf Aktion=3 umsetzen}
   end; {der Rest wird von 'ActionHandlingB_Change' erledigt}
  end
 else
   ParDateiUseB1Memo.Color := clActiveBorder;
end;

procedure TFMain.ParDateiUseB2Change(Sender: TObject);
begin
 if ParDateiUseB2.Checked then
  begin
   ParDateiUseReply := 1;
   ParDateiUseB2Memo.Color := clWindow;
   case Aktion of
   {0: ; (* nicht mglich *)}
    1: ActionHandlingB3.Checked := true; {auf Aktion=2 umsetzen}
   {2: ; (* nichts zu tun *)}
    3: ActionHandlingB5.Checked := true; {auf Aktion=4 umsetzen}
   {4: ; (* nichts zu tun *)}
   end; {der Rest wird von 'ActionHandlingB_Change' erledigt !}
  end
 else
   ParDateiUseB2Memo.Color := clActiveBorder;
end;

procedure TFMain.ParDateiUseB1MemoEnter(Sender: TObject);
begin
  ParDateiUseB1.Checked := true; {siehe 'ParDateiUseB1Change'}
end;

procedure TFMain.ParDateiUseB1MemoExit(Sender: TObject);
begin
  ParDateiUseB1Memo.WordWrap := true;    {um die Zeile wieder sichtbar}
    ParDateiUseB1Memo.WordWrap := false; { zu machen, falls verschoben}
end;

procedure TFMain.ParDateiUseB2MemoEnter(Sender: TObject);
begin
  ParDateiUseB2.Checked := true; {siehe 'ParDateiUseB2Change'}
end;

procedure TFMain.ParDateiUseB2MemoExit(Sender: TObject);
begin
  ParDateiUseB2Memo.Lines.Strings[0] := {um alle Zeilen wieder sichtbar}
    ParDateiUseB2Memo.Lines.Strings[0]; {   zu machen, falls verschoben}
end;

procedure TFMain.ParDateiOpKeyHandlingB1Change(Sender: TObject);
begin
 if ParDateiOpKeyHandlingB1.Checked then
  begin
   ParDateiOpKey.Text := '';
   ParDateiOpKey.HelpKeyword := 'COD/DirectKey.html';
   if ParDateiOpKeyHandlingReply=2 then
    begin
     ParDateiOpKey.Enabled := true;
     ParDateiOpKeyLabel.Visible := true;
     ParDateiOpKeyHexPanel.Visible := true;
     ParDateiOpKeyHexLabel.Visible := true;
    end;
   ParDateiOpKeyHandlingReply := 0;
   ParDateiOpKeyDialog.Visible := false;
   ParDateiOpKeyOK.Visible := false;
   ParDateiOpKeyCheck.Visible := true;
   ParDateiOpKeyImage := 0;
   ParDateiOpKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
   ParDateiOpKey.PasswordChar := '*';
   ParDateiOpKey.EchoMode := emPassword;
  end;
end;

procedure TFMain.ParDateiOpKeyHandlingB2Change(Sender: TObject);
begin
 if ParDateiOpKeyHandlingB2.Checked then
  begin
   ParDateiOpKey.Text := '';
   ParDateiOpKey.HelpKeyword := 'COD/KeyDataset.html';
   if ParDateiOpKeyHandlingReply=2 then
    begin
     ParDateiOpKey.Enabled := true;
     ParDateiOpKeyLabel.Visible := true;
     ParDateiOpKeyHexPanel.Visible := true;
     ParDateiOpKeyHexLabel.Visible := true;
    end;
   ParDateiOpKeyHandlingReply := 1;
   ParDateiOpKeyOK.Visible := false;
   ParDateiOpKeyCheck.Visible := false;
   ParDateiOpKeyDialog.Visible := true;
   ParDateiOpKeyImage := 1;
   ParDateiOpKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR1);
  {ParDateiOpKey.PasswordChar := #0;
   ParDateiOpKey.EchoMode := emNormal;}
  end;
end;

procedure TFMain.ParDateiOpKeyHandlingB3Change(Sender: TObject);
begin
 if ParDateiOpKeyHandlingB3.Checked then
  begin
   ParDateiOpKey.Text := FormatLE(MG[Sprache].PdatKeyTxtR2);
   ParDateiOpKey.PasswordChar := #0;
   ParDateiOpKey.EchoMode := emNormal;
   ParDateiOpKeyHandlingReply := 2;
   ParDateiOpKeyDialog.Visible := false;
   ParDateiOpKeyCheck.Visible := false;
   ParDateiOpKeyOK.Visible := false;
   ParDateiOpKeyImage := 3;
   ParDateiOpKey.Enabled := false;
   ParDateiOpKeyLabel.Visible := false;
   ParDateiOpKeyHexPanel.Visible := false;
   ParDateiOpKeyHexLabel.Visible := false;
  end;
end;

procedure TFMain.ParDateiOpKeyHandlingDblClick(Sender: TObject);
begin
  ShowHelpFile(ParDateiOpKeyHandling.HelpKeyword);
end;

procedure TFMain.ParDateiOpKeyHexChange(Sender: TObject);
var
 aw: longint;
 IStr: string;
begin
 if ParDateiOpKeyHandlingB1.Checked and {falls fr Direktkey noch keine}
    (not ExitParDateiOpKey) then {Exit-Routine fr'ParDateiOpKey' aktiv}
  begin {Werte sichern,die durch 'ParDateiOpKeyChange' verndert werden}
   ExitParDateiOpKey := true;
   ParDateiOpKeyCheckedS := ParDateiOpKeyChecked;
   ParDateiOpKeyOK_Visible := ParDateiOpKeyOK.Visible;
   ParDateiOpKeyCheck_Visible := ParDateiOpKeyCheck.Visible;
   ParDateiOpKeyImageS := ParDateiOpKeyImage;
   if ParDateiOpKeyHex.Checked then
    begin
     IStr := ParDateiOpKey.Text;
     CharToHex(IStr); {Schlssel-Zeichen in Hex-Werte umwandeln}
     ParDateiOpKey.Text := IStr;{fhrt zum'ParDateiOpKeyChange'-Aufruf!}
     if ParDateiOpKey.Tag>=FocusTag then
      begin { verdoppeln }
       ParDateiOpKey.SetFocus;  {'SelStart'/'SelLength' nur falls Focus}
       ParDateiOpKey.SelStart := ParDateiOpKey.SelStart shl 1;{\gesetzt}
       ParDateiOpKey.SelLength := ParDateiOpKey.SelLength shl 1;
      end;
    end
   else
    begin
     IStr := ParDateiOpKey.Text;
     aw := HexToChar(IStr);
     if aw=0 then {Schlssel-Hex-Wert in Zeichen umwandeln, }
      begin       {         falls machbar (d.h. auer #00 !)}
       ParDateiOpKey.Text := IStr;{fhrt zu'ParDateiOpKeyChange'-Aufruf}
       if ParDateiOpKey.Tag>=FocusTag then
        begin { halbieren }
         ParDateiOpKey.SetFocus;{'SelStart'/'SelLength' nur falls Focus}
         ParDateiOpKey.SelStart := ParDateiOpKey.SelStart shr 1;{geset.}
         ParDateiOpKey.SelLength := (ParDateiOpKey.SelLength+1) shr 1;
        end;
      end
     else
      begin
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(KeyConvErr,[aw])),
           PChar(KeyHdCErr),16);
     { MessageBoxCall := true; }
       ParDateiOpKeyHex.Checked:=true;{weiterer}
      end                             {\'ParDateiOpKeyHexChange'-Aufruf}
    end;
   ParDateiOpKeyChecked := ParDateiOpKeyCheckedS;{'ParDateiOpKeyChange'}
   ParDateiOpKeyOK.Visible := ParDateiOpKeyOK_Visible;{Werte zurckset.}
   ParDateiOpKeyCheck.Visible := ParDateiOpKeyCheck_Visible;
   ParDateiOpKeyImage := ParDateiOpKeyImageS;
   ExitParDateiOpKey := false;
  end;
end;

procedure TFMain.ParDateiOpKeyHexLabelClick(Sender: TObject);
begin
  if ParDateiOpKeyHex.Checked then
    ParDateiOpKeyHex.Checked := false
  else
    ParDateiOpKeyHex.Checked := true;
end;

procedure TFMain.ParDateiOpKeyDialogClick(Sender: TObject);
begin
  OpenDialogKey.FileName := '*.*';
  if OpenDialogKey.Execute then
    ParDateiOpKey.Text := OpenDialogKey.FileName;
end;

procedure TFMain.ParDateiOpKeyCheckClick(Sender: TObject);
begin
  ParDateiOpKey.Tag := FocusTag; {anzeigen, dass das Feld den Fokus hat}
  ParDateiOpKeyChecked := false;
  Exit2ParDateiOpKey := false;
  ClickParDateiOpKey := true; { nachtrgliche berprfung -Flag setzen }
  ParDateiOpKeyExit(Sender);
end;

procedure TFMain.ParDateiOpKeyEnter(Sender: TObject);
begin
  ParDateiOpKey.Tag := FocusTag; {anzeigen, dass das Feld den Fokus hat}
  if ParDateiOpKeyHandlingReply=1 then { falls im Datei-Modus }
    EnterHidedField(ParDateiOpKey)
  else
    Exit2ParDateiOpKey := false;
end;

procedure TFMain.ParDateiOpKeyChange(Sender: TObject);
begin
 if ParDateiOpKeyHandlingB1.Checked then
  begin
   ParDateiOpKeyChecked := false;
   if not ParDateiOpKeyCheck.Visible then
    begin
     ParDateiOpKeyOK.Visible := false;
     ParDateiOpKeyCheck.Visible := true;
     ParDateiOpKeyImage := 0;
    end
  end
end;

procedure TFMain.ParDateiOpKeyClick(Sender: TObject);
begin
 if ParDateiOpKey.Tag<FocusTag then {falls Feld den Fokus nicht hat,}
   ParDateiOpKeyEnter(Sender);      { dann dies jetzt nachholen     }
 ShowCursorPos(ParDateiOpKey);
end;

procedure TFMain.ParDateiOpKeyKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if ParDateiOpKey.Tag<FocusTag then {falls Feld den Fokus nicht hat,}
   ParDateiOpKeyEnter(Sender);      { dann dies jetzt nachholen     }
 if ParDateiOpKeyHandlingB1.Checked then {falls im Direkt-Key-Modus}
  if Key=13 then
    ParDateiOpKeyExit(Sender);  {"Return"-Taste als Feld-Exit annehmen}
end;

procedure TFMain.ParDateiOpKeyKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ShowCursorPos(ParDateiOpKey);
end;

procedure TFMain.ParDateiOpKeyLabelDblClick(Sender: TObject);
begin
 if ParDateiOpKeyHandlingB1.Checked then
   ShowHelpFile('COD/DirectKey.html')
 else
  if ParDateiOpKeyHandlingB2.Checked then
    ShowHelpFile('COD/KeyDataset.html')
  else
    ShowHelpFile('COD/ParKey.html');
end;

procedure TFMain.ParDateiOpKeyExit(Sender: TObject);
var
  aw, I: longint;
  IStr: string;
begin
 DelCursorPos;
 if ParDateiOpKey.Tag>=FocusTag then {falls das Feld den Fokus hat}
  if ParDateiOpKeyHandlingReply=1 then { falls im Datei-Modus }
   begin
    MessageBoxCall := false;
    ExitHidedField(ParDateiOpKey,ParDateiOpKeyLabel)
   end
  else
   if (not ParDateiOpKeyHex.Focused) and
      (not ExitParDateiOpKey) and {falls noch keine Exit-Routine fr   }
      (not ParDateiOpKeyChecked) then {Feld aktiv ist  u n d  noch kein}
    begin                      { erfolgreicher Check durchgefhrt wurde}
     ExitParDateiOpKey := true; {anzeigen, dass fr dieses Feld   }
                                {jetzt eine Exit-Routine aktiv ist}
     MessageBoxCall := false;
     if ParDateiOpKeyHandlingReply=0 then {falls im Direkt-Key-Modus}
      begin
       aw := 0;
       I := 0;
       if ParDateiOpKeyHex.Checked then {Hexzeichen}
        begin
         IStr := ParDateiOpKey.Text;
         aw := HexCheck(IStr);
         if aw<>0 then  {'HexCheck' hat ein Problem entdeckt}
          if aw>0 then {ein Zeichen ist kein Hexzeichen}
           begin
            I := aw;
            with MG[Sprache] do
              Application.MessageBox(PChar(FormatLE(KeyHexErr,[I])),
                PChar(KeyHdSErr),16);
            MessageBoxCall := true;
           end
          else    {Hexzeichen-Anzahl nicht durch ElemBytes*2 teilbar}
           begin
            aw := -aw;  {Anzahl ergnzter Hexzeichen}
            I := Length(ParDateiOpKey.Text); {Stelle im Text}
            with MG[Sprache] do
              Application.MessageBox(PChar(FormatLE(KeyHNumErr,[I,aw])),
                PChar(KeyHdSWar),48);
            aw := 0;
            MessageBoxCall := true;
           end;
        end
       else      {keine Hexzeichen}
        begin
         I := Length(ParDateiOpKey.Text);
         if (I mod ElemBytes)<>0 then
          begin {Lnge ist nicht durch ElemBytes teilbar}
           with MG[Sprache] do
             Application.MessageBox(PChar(FormatLE(KeyNulCom,[I])),
               PChar(KeyHdSWar),48);
           MessageBoxCall := true;
          end
         else
           I := 0;
        end;
       if aw=0 then
        begin
         with MG[Sprache] do
           aw := Application.MessageBox(PChar(FormatLE(KeyQRep)),
                   PChar(KeyHdRep),36);
         if I>0 then {Markierung einer Stelle erst nach letzter}
          begin                                 {\ 'MessageBox'}
           ParDateiOpKey.SelStart := I-1;
           ParDateiOpKey.SelLength := 1;
          end
         else
           ParDateiOpKey.SelLength := 0;
         MessageBoxCall := true;
         if aw=6 then { Ja. --> Direktschlssel-Wiederholung }
          begin
         { Fr den Fall, dass der 'MessageBox'-Aufruf ggf. ein zweites
           ge"queue"tes 'ParDateiOpKeyExit'-Ereignis verursacht hat: }
           if not ClickParDateiOpKey then {keine nachtrgl. berprfung}
             Exit2ParDateiOpKey := true;
           ParDateiOpKeyHandlingReply := 4; {Wiederholungs-Key-Modus}
           ParDateiOpKeyLabel.Caption :=
                       FormatLE(MG[Sprache].KeyLblR0rep);
           ParDateiOpKeyS := ParDateiOpKey.Text;
           ParDateiOpKeyHexS := ParDateiOpKeyHex.Checked;
           ParDateiOpKey.Text := '';
           ParDateiOpKeyHandling.Enabled := false;
           { alle sonstigen Elemente als nicht auswhlbar kennzeichnen }
           SprachBox.Enabled := false;
           AusDateiDialog.Visible := false;
           AusDatei.Enabled := false;
           AusDateiHandling.Enabled := false;
           OperClear.Enabled := false;
           OperStart.Enabled := false;
           OperExit.Enabled := false;
           ActionPanel.Enabled := false;
           ActionHandlingLabel.Enabled := false;
           CodDateiPanel.Enabled := false;
           CodArtKopfLabel.Enabled := false;
           CodDateiDialog.Visible := false;
           ExpDateiDialog.Visible := false;
{$if Safety>1}
           if CodStream.Checked then
            begin
             CompDateiDialog.Visible := false;
             case CompDateiKeyImage of
              0: CompDateiKeyCheck.Visible := false;
              1: CompDateiKeyDialog.Visible := false;
              2: CompDateiKeyOK.Visible := false;
             end
            end;
{$endif Safety>1}
           ParDatei.Enabled := false;
           ParDateiDialog.Enabled := false;
           ParDateiUseBox.Enabled := false;
           TimeOutUse.Enabled := false;
           TimeOutUseB1Mask.Enabled := false;
           TimeOutHandling.Enabled := false;
           ParDateiClsKeyGroup.Enabled := false;
           case ParDateiClsKeyImage of
            0: ParDateiClsKeyCheck.Visible := false;
            1: ParDateiClsKeyDialog.Visible := false;
            2: ParDateiClsKeyOK.Visible := false;
           end;
         { ActiveControl := ParDateiOpKey; }
          end
         else  { Nein. --> keine Direktschlssel-Wiederholung }
           ParDateiOpKeyChecked := true; {es hat eine Bearbeitung durch
                                          den Benutzer stattgefunden}
        end
       else  {'HexCheck'-Fehler, keine -Warnung}
        begin
         ParDateiOpKey.SetFocus;
         ParDateiOpKey.SelStart := I-1;
         ParDateiOpKey.SelLength := 1;
         ShowCursorPos(ParDateiOpKey);
        end;
      end
     else { falls im Wiederholungs-Schlssel-Modus }
      begin
       ExitParDateiOpKey := false;{lst ggf 'ParDateiOpKeyHexChange'aus}
       ParDateiOpKeyHex.Checked := ParDateiOpKeyHexS;
       ExitParDateiOpKey := true;  {knnte 'HexToChar'-Fehler ausgelst}
       if (ParDateiOpKeyHex.Checked=ParDateiOpKeyHexS) and     {\ haben}
          (ParDateiOpKeyS=ParDateiOpKey.Text) then
        begin  { Ausgangs- und Wiederholungs-Schlssel sind identisch }
         ParDateiOpKeyCheck.Visible := false;
         ParDateiOpKeyOK.Visible := true;
         ParDateiOpKeyImage := 2;
        end
       else
        begin
       { ParDateiOpKeyOK.Visible := false;
         ParDateiOpKeyCheck.Visible := true;
         ParDateiOpKeyImage := 0; }
         IStr := ParDateiOpKey.Text; {1. Unterschiedsstelle ermitteln}
         I := Length(IStr);
         if I<>Length(ParDateiOpKeyS) then
          if I>Length(ParDateiOpKeyS) then
            I := Length(ParDateiOpKeyS);
         for aw := 1 to I do  {Schleife ber gemeinsame Stellen}
          begin
           if ParDateiOpKeyS[aw]<>IStr[aw] then
             break;
          end;
         if (I>0) and
            ((aw<I) or
             (ParDateiOpKeyS[aw]<>IStr[aw])) then
           I := aw
         else  {gemeinsame Stellen sind identisch}
           I := I + 1;                                      {/ mglich}
         ParDateiOpKey.Text := '';{damit ist kein 'HexToChar'-Fehler  }
         ExitParDateiOpKey := false;{--> ggf.'ParDateiOpKeyHexChange'}
         ParDateiOpKeyHex.Checked := ParDateiOpKeyHexS;
         ExitParDateiOpKey := true;
         ParDateiOpKey.Text := ParDateiOpKeyS;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(KeyDifErr,[I])),
             PChar(KeyHdRErr),48);
         MessageBoxCall := true;
         ParDateiOpKey.SetFocus;
         if I<=Length(ParDateiOpKeyS) then
          begin {falls Differenzstelle im Ausgangs-Schlssel anzeigbar}
           ParDateiOpKey.SelStart := I-1;
           ParDateiOpKey.SelLength := 1;
          end
         else
          begin  {sonst den gesamten Ausgangs-Schlssel markieren}
           ParDateiOpKey.SelStart := 0;
           ParDateiOpKey.SelLength := Length(ParDateiOpKeyS);
          end;
         ShowCursorPos(ParDateiOpKey);
        end;
       ParDateiOpKeyChecked := true; {es hat eine Bearbeitung durch
                                      den Benutzer stattgefunden}
       ParDateiOpKeyHandlingReply := 0;{Wiederholungskey-Modus aufheben}
       ParDateiOpKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
       {alle Felder "entsperren"}
       ParDateiOpKeyHandling.Enabled := true;
       { alle sonstigen Elemente }
       SprachBox.Enabled := true;
       AusDateiDialog.Visible := true;
       AusDatei.Enabled := true;
       AusDateiHandling.Enabled := true;
       OperClear.Enabled := true;
       OperStart.Enabled := true;
       OperExit.Enabled := true;
       ActionPanel.Enabled := true;
       ActionHandlingLabel.Enabled := true;
       if Aktion=4 then  {Aktion=0/3 nicht mglich}
        begin
         CodDateiPanel.Enabled := true;
         CodArtKopfLabel.Enabled := true;
         CodDateiDialog.Visible := true;
         ExpDateiDialog.Visible := true;
{$if Safety>1}
         if CodStream.Checked then
          begin
           CompDateiDialog.Visible := true;
           case CompDateiKeyImage of
            0: CompDateiKeyCheck.Visible := true;
            1: CompDateiKeyDialog.Visible := true;
            2: CompDateiKeyOK.Visible := true;
           end
          end;
{$endif Safety>1}
        end;
       ParDatei.Enabled := true;
       ParDateiDialog.Enabled := true;
       ParDateiUseBox.Enabled := true;
       TimeOutUse.Enabled := true;
       TimeOutUseB1Mask.Enabled := true;
       TimeOutHandling.Enabled := true;
       if Aktion=2 then  {Aktion=1 nicht mglich}
        begin
         ParDateiClsKeyGroup.Enabled := true;
         case ParDateiClsKeyImage of
          0: ParDateiClsKeyCheck.Visible := true;
          1: ParDateiClsKeyDialog.Visible := true;
          2: ParDateiClsKeyOK.Visible := true;
         end;
        end;
      end;
     if not ParDateiOpKey.Focused then {falls das Feld keinen Fokus hat}
       ParDateiOpKey.Tag := 0
   { else
       ClearMessageQueue(Sender) } ;
     if not Exit2ParDateiOpKey then
      begin
       ExitParDateiOpKey := false; {Exit-Routine nicht mehr aktiv}
       ClickParDateiOpKey := false;{nachtrgliche berprfung-Flag}
      end                                          {\ zurcksetzen}
    end
   else
    if not ExitParDateiOpKey then  {keine Exit-Routine fr Feld aktiv}
      ParDateiOpKey.Tag := 0
    else
     if Exit2ParDateiOpKey then  {ge"queue"te Exit-Routine berlesen}
      begin
       ExitParDateiOpKey := false;
       Exit2ParDateiOpKey := false;
       if not ParDateiOpKey.Focused then {falls Feld keinen Fokus hat}
         ParDateiOpKey.Tag := 0
      end;
end;

procedure TFMain.ParDateiOpKeyMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
  ShowCursorPos(ParDateiOpKey);
  if ParDateiOpKeyHandlingReply=1 then    { falls im Datei-Modus }
    ShowHideContents(ParDateiOpKey,ParDateiOpKeyLabel,X,Y);
end;

procedure TFMain.ParDateiOpKeyMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if ParDateiOpKeyHandlingReply=1 then  { falls im Datei-Modus}
   ClearMesBoxMouseDown(ParDateiOpKey,ParDateiOpKeyLabel);
end;

procedure TFMain.ParDateiOpKeyMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if ParDateiOpKeyHandlingReply=1 then  { falls im Datei-Modus}
   ClearMesBoxMouseUp(ParDateiOpKey);
 MessageBoxCall := false;
end;

procedure TFMain.TimeOutUseB1Change(Sender: TObject);
begin
  if TimeOutUseB1.Checked then
   begin
    TimeOutUseB1Mask.Color := clWindow;
    TimeOutUseB1Mask.Enabled := true;
    SetTimeOut(TimeOutUseB1Mask,TimeOutWarnLim);
    TimeOutHandling.Enabled := true;
   end;
end;

procedure TFMain.TimeOutUseB1MaskExit(Sender: TObject);
begin
 if (not ExitTimeOutMask) and   {falls noch keine Exit-Routine}
     TimeOutUseB1.Checked then  {fr dieses Feld aktiv ist    }
  begin
   ExitTimeOutMask := true; {anzeigen, dass fr dieses Feld   }
                            {jetzt eine Exit-Routine aktiv ist}
   ChkTimeOut(TimeOutUseB1Mask,TimeOutWarnLim);
   ExitTimeOutMask := false;
  end;
end;

procedure TFMain.TimeOutUseB2Change(Sender: TObject);
begin
 if TimeOutUseB2.Checked then
  begin
   TimeOutUseB1Mask.Color := clActiveBorder;
   TimeOutUseB1Mask.Enabled := false;
   TimeOutUseB1Mask.Text := makeDateS('9999','99','99')
                            +','+makeTimeS('99','99');
   TimeOutHandling.Enabled := false;
  end;
end;

procedure TFMain.ParDateiClsKeyHandlingB1Change(Sender: TObject);
begin
 if ParDateiClsKeyHandlingB1.Checked then
  begin
   ParDateiClsKey.Text := '';
   ParDateiClsKey.HelpKeyword := 'COD/DirectKey.html';
   if ParDateiClsKeyHandlingReply=2 then
    begin
     ParDateiClsKey.Enabled := true;
     ParDateiClsKeyLabel.Visible := true;
     ParDateiClsKeyHexPanel.Visible := true;
     ParDateiClsKeyHexLabel.Visible := true;
    end;
   ParDateiClsKeyHandlingReply := 0;
   ParDateiClsKeyDialog.Visible := false;
   ParDateiClsKeyOK.Visible := false;
   ParDateiClsKeyCheck.Visible := true;
   ParDateiClsKeyImage := 0;
   ParDateiClsKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
   ParDateiClsKey.PasswordChar := '*';
   ParDateiClsKey.EchoMode := emPassword;
  end;
end;

procedure TFMain.ParDateiClsKeyHandlingB2Change(Sender: TObject);
begin
 if ParDateiClsKeyHandlingB2.Checked then
  begin
   ParDateiClsKey.Text := '';
   ParDateiClsKey.HelpKeyword := 'COD/KeyDataset.html';
   if ParDateiClsKeyHandlingReply=2 then
    begin
     ParDateiClsKey.Enabled := true;
     ParDateiClsKeyLabel.Visible := true;
     ParDateiClsKeyHexPanel.Visible := true;
     ParDateiClsKeyHexLabel.Visible := true;
    end;
   ParDateiClsKeyHandlingReply := 1;
   ParDateiClsKeyOK.Visible := false;
   ParDateiClsKeyCheck.Visible := false;
   ParDateiClsKeyDialog.Visible := true;
   ParDateiClsKeyImage := 1;
   ParDateiClsKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR1);
  {ParDateiClsKey.PasswordChar := #0;
   ParDateiClsKey.EchoMode := emNormal;}
  end;
end;

procedure TFMain.ParDateiClsKeyHandlingB3Change(Sender: TObject);
begin
 if ParDateiClsKeyHandlingB3.Checked then
  begin
   ParDateiClsKey.Text := FormatLE(MG[Sprache].PdatKeyTxtR2);
   ParDateiClsKey.PasswordChar := #0;
   ParDateiClsKey.EchoMode := emNormal;
   ParDateiClsKeyHandlingReply := 2;
   ParDateiClsKeyDialog.Visible := false;
   ParDateiClsKeyCheck.Visible := false;
   ParDateiClsKeyOK.Visible := false;
   ParDateiClsKeyImage := 3;
   ParDateiClsKey.Enabled := false;
   ParDateiClsKeyLabel.Visible := false;
   ParDateiClsKeyHexPanel.Visible := false;
   ParDateiClsKeyHexLabel.Visible := false;
  end;
end;

procedure TFMain.ParDateiClsKeyHexChange(Sender: TObject);
var
 aw: longint;
 IStr: string;
begin
 if ParDateiClsKeyHandlingB1.Checked and{falls fr Direktkey noch keine}
    (not ExitParDateiClsKey) then{Exit-Routine f.'ParDateiClsKey' aktiv}
  begin{Werte sichern,die durch 'ParDateiClsKeyChange' verndert werden}
   ExitParDateiClsKey := true;
   ParDateiClsKeyCheckedS := ParDateiClsKeyChecked;
   ParDateiClsKeyOK_Visible := ParDateiClsKeyOK.Visible;
   ParDateiClsKeyCheck_Visible := ParDateiClsKeyCheck.Visible;
   ParDateiClsKeyImageS := ParDateiClsKeyImage;
   if ParDateiClsKeyHex.Checked then
    begin
     IStr := ParDateiClsKey.Text;
     CharToHex(IStr); {Schlssel-Zeichen in Hex-Werte umwandeln}
     ParDateiClsKey.Text := IStr;{fhrt zu'ParDateiClsKeyChange'-Aufruf}
     if ParDateiClsKey.Tag>=FocusTag then
      begin { verdoppeln }
       ParDateiClsKey.SetFocus; {'SelStart'/'SelLength' nur falls Focus}
       ParDateiClsKey.SelStart := ParDateiClsKey.SelStart shl 1;{geset.}
       ParDateiClsKey.SelLength := ParDateiClsKey.SelLength shl 1;
      end;
    end
   else
    begin
     IStr := ParDateiClsKey.Text;
     aw := HexToChar(IStr);
     if aw=0 then {Schlssel-Hex-Wert in Zeichen umwandeln, }
      begin       {         falls machbar (d.h. auer #00 !)}
       ParDateiClsKey.Text :=IStr;{fhrt zu'ParDateiClsKeyChange'Aufruf}
       if ParDateiClsKey.Tag>=FocusTag then
        begin { halbieren }
         ParDateiClsKey.SetFocus;{ 'SelStart/SelLength' nur falls Focus}
         ParDateiClsKey.SelStart := ParDateiClsKey.SelStart shr 1;{ges.}
         ParDateiClsKey.SelLength := (ParDateiClsKey.SelLength+1) shr 1;
        end;
      end
     else
      begin
       with MG[Sprache] do
         Application.MessageBox(PChar(FormatLE(KeyConvErr,[aw])),
           PChar(KeyHdCErr),16);
     { MessageBoxCall := true; }
       ParDateiClsKeyHex.Checked := true;  {weiterer                   }
      end                           {  'ParDateiClsKeyHexChange'-Aufruf}
    end;
   ParDateiClsKeyChecked:=ParDateiClsKeyCheckedS;{'ParDateiClsKeyChange}
   ParDateiClsKeyOK.Visible:=ParDateiClsKeyOK_Visible;{Werte zurckset.}
   ParDateiClsKeyCheck.Visible := ParDateiClsKeyCheck_Visible;
   ParDateiClsKeyImage := ParDateiClsKeyImageS;
   ExitParDateiClsKey := false;
  end;
end;

procedure TFMain.ParDateiClsKeyHexLabelClick(Sender: TObject);
begin
  if ParDateiClsKeyHex.Checked then
    ParDateiClsKeyHex.Checked := false
  else
    ParDateiClsKeyHex.Checked := true;
end;

procedure TFMain.ParDateiClsKeyDialogClick(Sender: TObject);
begin
  OpenDialogKey.FileName := '*.*';
  if OpenDialogKey.Execute then
    ParDateiClsKey.Text := OpenDialogKey.FileName;
end;

procedure TFMain.ParDateiClsKeyCheckClick(Sender: TObject);
begin
  ParDateiClsKey.Tag := FocusTag; { anzeigen, dass Feld den Fokus hat }
  ParDateiClsKeyChecked := false;
  Exit2ParDateiClsKey := false;
  ClickParDateiClsKey := true; { nachtrgliche berprfung-Flag setzen }
  ParDateiClsKeyExit(Sender);
end;

procedure TFMain.ParDateiClsKeyEnter(Sender: TObject);
begin
  ParDateiClsKey.Tag := FocusTag; { anzeigen, dass Feld den Fokus hat }
  if ParDateiClsKeyHandlingReply=1 then { falls im Datei-Modus }
    EnterHidedField(ParDateiClsKey)
  else
    Exit2ParDateiClsKey := false;
end;

procedure TFMain.ParDateiClsKeyChange(Sender: TObject);
begin
 if ParDateiClsKeyHandlingB1.Checked then
  begin
   ParDateiClsKeyChecked := false;
   if not ParDateiClsKeyCheck.Visible then
    begin
     ParDateiClsKeyOK.Visible := false;
     ParDateiClsKeyCheck.Visible := true;
     ParDateiClsKeyImage := 0;
    end
  end
end;

procedure TFMain.ParDateiClsKeyClick(Sender: TObject);
begin
 if ParDateiClsKey.Tag<FocusTag then {falls Feld den Fokus nicht hat,}
   ParDateiClsKeyEnter(Sender);      { dann dies jetzt nachholen     }
 ShowCursorPos(ParDateiClsKey);
end;

procedure TFMain.ParDateiClsKeyKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if ParDateiClsKey.Tag<FocusTag then {falls Feld den Fokus nicht hat,}
   ParDateiClsKeyEnter(Sender);      { dann dies jetzt nachholen     }
 if ParDateiClsKeyHandlingB1.Checked then { falls im Direkt-Key-Modus }
  if Key=13 then
    ParDateiClsKeyExit(Sender);  {"Return"-Taste als Feld-Exit annehmen}
end;

procedure TFMain.ParDateiClsKeyKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ShowCursorPos(ParDateiClsKey);
end;

procedure TFMain.ParDateiClsKeyExit(Sender: TObject);
var
  aw, I: longint;
  IStr: string;
begin
 DelCursorPos;
 if ParDateiClsKey.Tag>=FocusTag then {falls das Feld den Fokus hat}
  if ParDateiClsKeyHandlingReply=1 then { falls im Datei-Modus }
   begin
    MessageBoxCall := false;
    ExitHidedField(ParDateiClsKey,ParDateiClsKeyLabel)
   end
  else
   if (not ParDateiClsKeyHex.Focused) and
      (not ExitParDateiClsKey) and   {falls noch keine Exit-Routine fr}
      (not ParDateiClsKeyChecked) then {Feld aktiv ist  u n d noch kein}
    begin                      { erfolgreicher Check durchgefhrt wurde}
     ExitParDateiClsKey := true; {anzeigen, dass fr dieses Feld   }
                                 {jetzt eine Exit-Routine aktiv ist}
     MessageBoxCall := false;
     if ParDateiClsKeyHandlingReply=0 then { falls im Direkt-Key-Modus }
      begin
       aw := 0;
       I := 0;
       if ParDateiClsKeyHex.Checked then {Hexzeichen}
        begin
         IStr := ParDateiClsKey.Text;
         aw := HexCheck(IStr);
         if aw<>0 then  {'HexCheck' hat ein Problem entdeckt}
          if aw>0 then {ein Zeichen ist kein Hexzeichen}
           begin
            I := aw;
            with MG[Sprache] do
              Application.MessageBox(PChar(FormatLE(KeyHexErr,[I])),
                PChar(KeyHdSErr),16);
            MessageBoxCall := true;
           end
          else    {Hexzeichen-Anzahl nicht durch ElemBytes*2 teilbar}
           begin
            aw := -aw;  {Anzahl ergnzter Hexzeichen}
            I := Length(ParDateiClsKey.Text); {Stelle im Text}
            with MG[Sprache] do
              Application.MessageBox(PChar(FormatLE(KeyHNumErr,[I,aw])),
                PChar(KeyHdSWar),48);
            aw := 0;
            MessageBoxCall := true;
           end;
        end
       else      {keine Hexzeichen}
        begin
         I := Length(ParDateiClsKey.Text);
         if (I mod ElemBytes)<>0 then
          begin {Lnge ist nicht durch ElemBytes teilbar}
           with MG[Sprache] do
             Application.MessageBox(PChar(FormatLE(KeyNulCom,[I])),
               PChar(KeyHdSWar),48);
           MessageBoxCall := true;
          end
         else
           I := 0;
        end;
       if aw=0 then
        begin
         with MG[Sprache] do
           aw := Application.MessageBox(PChar(FormatLE(KeyQRep)),
                   PChar(KeyHdRep),36);
         if I>0 then {Markierung einer Stelle erst nach letzter}
          begin                                 {\ 'MessageBox'}
           ParDateiClsKey.SelStart := I-1;
           ParDateiClsKey.SelLength := 1;
          end
         else
           ParDateiClsKey.SelLength := 0;
         MessageBoxCall := true;
         if aw=6 then { Ja. --> Direktschlssel-Wiederholung }
          begin
         { Fr den Fall, dass der 'MessageBox'-Aufruf ggf. ein zweites
           ge"queue"tes 'ParDateiOpKeyExit'-Ereignis verursacht hat: }
           if not ClickParDateiClsKey then {keine nachtrgliche}
             Exit2ParDateiClsKey := true;        {\ berprfung}
           ParDateiClsKeyHandlingReply := 4; {Wiederholungs-Key-Modus}
           ParDateiClsKeyLabel.Caption :=
                                      FormatLE(MG[Sprache].KeyLblR0rep);
           ParDateiClsKeyS := ParDateiClsKey.Text;
           ParDateiClsKeyHexS := ParDateiClsKeyHex.Checked;
           ParDateiClsKey.Text := '';
           ParDateiClsKeyHandling.Enabled := false;
           { alle sonstigen Elemente als nicht auswhlbar kennzeichnen }
           SprachBox.Enabled := false;
           AusDateiDialog.Visible := false;
           AusDatei.Enabled := false;
           AusDateiHandling.Enabled := false;
           OperClear.Enabled := false;
           OperStart.Enabled := false;
           OperExit.Enabled := false;
           ActionPanel.Enabled := false;
           ActionHandlingLabel.Enabled := false;
           InitialKeyPanel.Enabled := false;
           InitialKeyKopfLabel.Enabled := false;
           case InitialKeyImage of
            0: InitialKeyCheck.Visible := false;
            1: InitialKeyDialog.Visible := false;
            2: InitialKeyOK.Visible := false;
            3: InitialKeyMaus.Visible := false;
           end;
           OverlayPanel.Enabled := false;
           OvlKopfLabel.Enabled := false;
           case OvlInfoImage of
            0: OvlInfoCheck.Visible := false;
            1: OvlInfoDialog.Visible := false;
            2: OvlInfoOK.Visible := false;
           end;
           ParDatei.Enabled := false;
           ParDateiDialog.Enabled := false;
           ParDateiUseBox.Enabled := false;
           ParDateiOpKeyGroup.Enabled := false;
           case ParDateiOpKeyImage of
            0: ParDateiOpKeyCheck.Visible := false;
            1: ParDateiOpKeyDialog.Visible := false;
            2: ParDateiOpKeyOK.Visible := false;
           end;
           TimeOutUse.Enabled := false;
           TimeOutUseB1Mask.Enabled := false;
           TimeOutHandling.Enabled := false;
         { ActiveControl := ParDateiClsKey;  }
          end
         else  { Nein. --> keine Direktschlssel-Wiederholung }
           ParDateiClsKeyChecked := true;{es hat eine Bearbeitung durch}
        end                              {\  den Benutzer stattgefunden}
       else  {'HexCheck'-Fehler, keine -Warnung}
        begin
         ParDateiClsKey.SetFocus;
         ParDateiClsKey.SelStart := I-1;
         ParDateiClsKey.SelLength := 1;
         ShowCursorPos(ParDateiClsKey);
        end;
      end
     else { falls im Wiederholungs-Schlssel-Modus }
      begin
       ExitParDateiClsKey := false; {--> ggf. 'ParDateiClsKeyHexChange'}
       ParDateiClsKeyHex.Checked := ParDateiClsKeyHexS;
       ExitParDateiClsKey := true; {knnte 'HexToChar'-Fehler ausgelst}
       if (ParDateiClsKeyHex.Checked=ParDateiClsKeyHexS) and   {\ haben}
          (ParDateiClsKeyS=ParDateiClsKey.Text) then
        begin  { Ausgangs- und Wiederholungs-Schlssel sind identisch }
         ParDateiClsKeyCheck.Visible := false;
         ParDateiClsKeyOK.Visible := true;
         ParDateiClsKeyImage := 2;
        end
       else
        begin
       { ParDateiClsKeyOK.Visible := false;
         ParDateiClsKeyCheck.Visible := true;
         ParDateiClsKeyImage := 0; }
         IStr := ParDateiClsKey.Text; {1. Unterschiedsstelle ermitteln}
         I := Length(IStr);
         if I<>Length(ParDateiClsKeyS) then
          if I>Length(ParDateiClsKeyS) then
            I := Length(ParDateiClsKeyS);
         for aw := 1 to I do
          begin
           if ParDateiClsKeyS[aw]<>IStr[aw] then
             break;
          end;
         if (I>0) and
            ((aw<I) or
             (ParDateiClsKeyS[aw]<>IStr[aw])) then
           I := aw
         else  {gemeinsame Stellen sind identisch}
           I := I + 1;                                       {/ mglich}
         ParDateiClsKey.Text := '';{damit ist kein 'HexToChar'-Fehler  }
         ExitParDateiClsKey := false;{-->ggf.'ParDateiClspKeyHexChange'}
         ParDateiClsKeyHex.Checked := ParDateiClsKeyHexS;
         ExitParDateiClsKey := true;
         ParDateiClsKey.Text := ParDateiClsKeyS;
         with MG[Sprache] do
           Application.MessageBox(PChar(FormatLE(KeyDifErr,[I])),
             PChar(KeyHdRErr),48);
         MessageBoxCall := true;
         ParDateiClsKey.SetFocus;
         if I<=Length(InitialKeyS) then
          begin {falls Differenzstelle im Ausgangs-Schlssel anzeigbar}
           ParDateiClsKey.SelStart := I-1;
           ParDateiClsKey.SelLength := 1;
          end
         else
          begin  {sonst den gesamten Ausgangs-Schlssel markieren}
           ParDateiClsKey.SelStart := 0;
           ParDateiClsKey.SelLength := Length(ParDateiClsKeyS);
          end;
         ShowCursorPos(ParDateiClsKey);
        end;
       ParDateiClsKeyChecked := true; {es hat eine Bearbeitung durch
                                       den Benutzer stattgefunden}
       ParDateiClsKeyHandlingReply := 0;{Wiederholungskey-Modus aufhebn}
       ParDateiClsKeyLabel.Caption := FormatLE(MG[Sprache].KeyLblR0);
       {alle Felder "entsperren"}
       ParDateiClsKeyHandling.Enabled := true;
       { alle sonstigen Elemente }
       SprachBox.Enabled := true;
       AusDateiDialog.Visible := true;
       AusDatei.Enabled := true;
       AusDateiHandling.Enabled := true;
       OperClear.Enabled := true;
       OperStart.Enabled := true;
       OperExit.Enabled := true;
       ActionPanel.Enabled := true;
       ActionHandlingLabel.Enabled := true;
       if Aktion=1 then  {Aktion=3 nicht mglich}
        begin
         InitialKeyPanel.Enabled := true;
         InitialKeyKopfLabel.Enabled := true;
         case InitialKeyImage of
          0: InitialKeyCheck.Visible := true;
          1: InitialKeyDialog.Visible := true;
          2: InitialKeyOK.Visible := true;
          3: InitialKeyMaus.Visible := true;
         end;
        end;
       if InitialKeyOvl.Checked then
        begin
         OverlayPanel.Enabled := true;
         OvlKopfLabel.Enabled := true;
         case OvlInfoImage of
          0: OvlInfoCheck.Visible := true;
          1: OvlInfoDialog.Visible := true;
          2: OvlInfoOK.Visible := true;
         end;
        end;
       ParDatei.Enabled := true;
       ParDateiDialog.Enabled := true;
       ParDateiUseBox.Enabled := true;
       if Aktion=2 then  {Aktion=4 nicht mglich}
        begin
         ParDateiOpKeyGroup.Enabled := true;
         case ParDateiOpKeyImage of
          0: ParDateiOpKeyCheck.Visible := true;
          1: ParDateiOpKeyDialog.Visible := true;
          2: ParDateiOpKeyOK.Visible := true;
         end;
        end;
       TimeOutUse.Enabled := true;
       TimeOutUseB1Mask.Enabled := true;
       TimeOutHandling.Enabled := true;
      end;
     if not ParDateiClsKey.Focused then {falls Feld keinen Fokus hat}
       ParDateiClsKey.Tag := 0
   { else
       ClearMessageQueue(Sender) } ;
     if not Exit2ParDateiClsKey then
      begin
       ExitParDateiClsKey := false; {Exit-Routine nicht mehr aktiv}
       ClickParDateiClsKey :=false; {nachtrgliche berprfung-Flag}
      end                                           {\ zurcksetzen}
    end
   else
    if not ExitParDateiClsKey then  {keine Exit-Routine fr Feld aktiv}
      ParDateiClsKey.Tag := 0
    else
     if Exit2ParDateiClsKey then  {ge"queue"te Exit-Routine berlesen}
      begin
       ExitParDateiClsKey := false;
       Exit2ParDateiClsKey := false;
       if not ParDateiClsKey.Focused then {falls Feld keinen Fokus hat}
         ParDateiClsKey.Tag := 0
      end;
end;

procedure TFMain.ParDateiClsKeyMouseMove(Sender: TObject;
                                     Shift: TShiftState; X, Y: Integer);
begin
  ShowCursorPos(ParDateiClsKey);
  if ParDateiClsKeyHandlingReply=1 then    { falls im Datei-Modus }
    ShowHideContents(ParDateiClsKey,ParDateiClsKeyLabel,X,Y);
end;

procedure TFMain.ParDateiClsKeyMouseDown(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if ParDateiClsKeyHandlingReply=1 then  { falls im Datei-Modus}
   ClearMesBoxMouseDown(ParDateiClsKey,ParDateiClsKeyLabel);
end;

procedure TFMain.ParDateiClsKeyMouseUp(Sender: TOBject;
               Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if ParDateiClsKeyHandlingReply=1 then  { falls im Datei-Modus}
   ClearMesBoxMouseUp(ParDateiClsKey);
 MessageBoxCall := false;
end;

procedure TFMain.ParDateiClsKeyStwChange(Sender: TObject);
begin
  if ParDateiClsKeyStw.Checked then
    ParDateiClsKeyStwLabel.Font.Color := clBlue
  else
    ParDateiClsKeyStwLabel.Font.Color := clWindowText;
end;

procedure TFMain.ParDateiClsKeyStwLabelClick(Sender: TObject);
begin
  if ParDateiClsKeyStw.Checked then
    ParDateiClsKeyStw.Checked := false
  else
    ParDateiClsKeyStw.Checked := true;
end;

procedure TFMain.ParDateiClsKeyStwLabelDblClick(Sender: TObject);
begin
  ShowHelpFile(ParDateiClsKeyStwLabel.HelpKeyword);
end;

initialization
  {$I ucoding.lrs}
end.
// ======================
// Entwicklungs-Hinweise:
// ======================
{ function Application.MessageBox(Text,Caption: PChar; Flags: Longint):
                                                                Integer;
Flags=0: >'OK';  1: >'OK'+'Cancel';  2: 'Abort'+>'Retry'+'Ignore'
   Return: +->1       +->1   +->2         +->3     +->4    +->5
      3: >'Yes'+'No'+'Cancel';  4,6: >'Yes'+'No';  5,7:'Cancel'+>'Retry'
   Return: +->6  +->7  +->2            +->6  +->7       +->2      +->4
 + 0: weie Wolke mit blauem 'i'
 +16: rotes Andreas-Kreuz
 +32: weie Wolke mit blauem '?'
 +48: gelbes Dreieck mit schwarzem '!' }
// ======================
{ Mit z.B.
       var TestDia1: TFMain;
       ...
       Application.CreateForm(TFMain, TestDia1);
   kann eine 2. TFMain-Struktur erzeugt werden.
   Ein (/mehrere) TFMain-Feld(er) dieser Struktur knnen danach mit z.B.
       TestDia1.AusDatei.Text := 'abcdefg.123';
   gefllt werden, bevor die Struktur mit z.B.
       TestDia1.Show;
   oder mit
       TestDia1.ShowModal;
   aufgerufen und ausgefhrt wird.
     Bei "Show" wird die Struktur(hier:"TestDia1") beim Verlassen wieder
   freigegeben ("Destroy"), so dass danach keine TFMain-Variablen dieser
   Struktur mehr ansprechbar sind(!).
     Bei "ShowModal" kann ein Interger-Wert zurckgegeben werden  u n d
   es kann noch nach dem "ShowModal"-Aufruf auf die "TestDia1"-TFMain-
   Felder zugegriffen werden (kein "Destroy"!):
        Test := TestDia1.AusDatei.Text;
   Falls FMAIN die TFMain-Struktur "TestDia1" aufgerufen hat, so kann
   "TestDia1" mit z.B.
       FMAIN.AusDatei.Text := TestDia1.AusDatei.Text;
   oder auch
       FMAIN.AusDatei.Text := AusDatei.Text;
   auf jeden Fall einen Wert in ein Feld der aufrufenden Struktur
   (hier: FMAIN-Feld) bertragen. }
